# OrdinaryDiffEq.jl

[![Join the chat at https://julialang.zulipchat.com #sciml-bridged](https://img.shields.io/static/v1?label=Zulip&message=chat&color=9558b2&labelColor=389826)](https://julialang.zulipchat.com/#narrow/stream/279055-sciml-bridged)
[![Global Docs](https://img.shields.io/badge/docs-SciML-blue.svg)](https://docs.sciml.ai/OrdinaryDiffEq/stable/)

[![codecov](https://codecov.io/gh/SciML/OrdinaryDiffEq.jl/branch/master/graph/badge.svg)](https://app.codecov.io/gh/SciML/OrdinaryDiffEq.jl)
[![Build Status](https://github.com/SciML/OrdinaryDiffEq.jl/workflows/CI/badge.svg)](https://github.com/SciML/OrdinaryDiffEq.jl/actions?query=workflow%3ACI)
[![Build status](https://badge.buildkite.com/5f39777d009ce94ef1dcf2a4881c68b9fbcaf6f69f1d8b8df2.svg?branch=master)](https://buildkite.com/julialang/ordinarydiffeq-dot-jl)

[![ColPrac: Contributor's Guide on Collaborative Practices for Community Packages](https://img.shields.io/badge/ColPrac-Contributor%27s%20Guide-blueviolet)](https://github.com/SciML/ColPrac)
[![SciML Code Style](https://img.shields.io/static/v1?label=code%20style&message=SciML&color=9558b2&labelColor=389826)](https://github.com/SciML/SciMLStyle)

OrdinaryDiffEq.jl is a component package in the DifferentialEquations ecosystem. It holds the
ordinary differential equation solvers and utilities. While completely independent
and usable on its own, users interested in using this
functionality should check out [DifferentialEquations.jl](https://github.com/SciML/DifferentialEquations.jl).

## Installation

Assuming that you already have Julia correctly installed, it suffices to import
OrdinaryDiffEq.jl in the standard way:

```julia
import Pkg;
Pkg.add("OrdinaryDiffEq");
```

## API

OrdinaryDiffEq.jl is part of the SciML common interface, but can be used independently of DifferentialEquations.jl. The only requirement is that the user passes an OrdinaryDiffEq.jl algorithm to `solve`. For example, we can solve the [ODE tutorial from the docs](https://docs.sciml.ai/DiffEqDocs/stable/getting_started/#ode_example) using the `Tsit5()` algorithm:

```julia
using OrdinaryDiffEq
f(u, p, t) = 1.01 * u
u0 = 1 / 2
tspan = (0.0, 1.0)
prob = ODEProblem(f, u0, tspan)
sol = solve(prob, Tsit5(), reltol = 1e-8, abstol = 1e-8)
using Plots
plot(sol, linewidth = 5, title = "Solution to the linear ODE with a thick line",
    xaxis = "Time (t)", yaxis = "u(t) (in μm)", label = "My Thick Line!") # legend=false
plot!(sol.t, t -> 0.5 * exp(1.01t), lw = 3, ls = :dash, label = "True Solution!")
```

That example uses the out-of-place syntax `f(u,p,t)`, while the inplace syntax (more efficient for systems of equations) is shown in the Lorenz example:

```julia
using OrdinaryDiffEq
function lorenz!(du, u, p, t)
    du[1] = 10.0(u[2] - u[1])
    du[2] = u[1] * (28.0 - u[3]) - u[2]
    du[3] = u[1] * u[2] - (8 / 3) * u[3]
end
u0 = [1.0; 0.0; 0.0]
tspan = (0.0, 100.0)
prob = ODEProblem(lorenz!, u0, tspan)
sol = solve(prob, Tsit5())
using Plots;
plot(sol, idxs = (1, 2, 3))
```

Very fast static array versions can be specifically compiled to the size of your model. For example:

```julia
using OrdinaryDiffEq, StaticArrays
function lorenz(u, p, t)
    SA[10.0(u[2] - u[1]), u[1] * (28.0 - u[3]) - u[2], u[1] * u[2] - (8 / 3) * u[3]]
end
u0 = SA[1.0; 0.0; 0.0]
tspan = (0.0, 100.0)
prob = ODEProblem(lorenz, u0, tspan)
sol = solve(prob, Tsit5())
```

For "refined ODEs", like dynamical equations and `SecondOrderODEProblem`s, refer to the [DiffEqDocs](https://diffeq.sciml.ai/dev/types/ode_types/). For example, in [DiffEqTutorials.jl](https://github.com/SciML/SciMLTutorials.jl) we show how to solve equations of motion using symplectic methods:

```julia
function HH_acceleration!(dv, v, u, p, t)
    x, y = u
    dx, dy = dv
    dv[1] = -x - 2x * y
    dv[2] = y^2 - y - x^2
end
initial_positions = [0.0, 0.1]
initial_velocities = [0.5, 0.0]
prob = SecondOrderODEProblem(HH_acceleration!, initial_velocities, initial_positions, tspan)
sol2 = solve(prob, KahanLi8(), dt = 1 / 10);
```

Other refined forms are IMEX and semi-linear ODEs (for exponential integrators).

## Available Solvers

For the list of available solvers, please refer to the [DifferentialEquations.jl ODE Solvers](https://diffeq.sciml.ai/dev/solvers/ode_solve/), [Dynamical ODE Solvers](https://diffeq.sciml.ai/dev/solvers/dynamical_solve/), and the [Split ODE Solvers](https://diffeq.sciml.ai/dev/solvers/split_ode_solve/) pages.

pages = [
    "OrdinaryDiffEq.jl: ODE solvers and utilities" => "index.md",
    "Usage" => "usage.md",
    "Explicit Solvers" => [
        "explicit/Tsit5.md",
        "explicit/Verner.md",
        "explicit/AdamsBashforthMoulton.md",
        "explicit/LowStorageRK.md",
        "explicit/SSPRK.md",
        "explicit/LowOrderRK.md",
        "explicit/HighOrderRK.md",
        "explicit/Feagin.md",
        "explicit/PRK.md",
        "explicit/QPRK.md",
        "explicit/TaylorSeries.md",
        "explicit/Extrapolation.md"
    ],
    "Semi-Implicit Solvers" => [
        "semiimplicit/Rosenbrock.md",
        "semiimplicit/StabilizedRK.md",
        "semiimplicit/ExponentialRK.md"
    ],
    "Implicit Solvers" => [
        "implicit/SDIRK.md",
        "implicit/FIRK.md",
        "implicit/BDF.md",
        "implicit/Extrapolation.md",
        "implicit/PDIRK.md",
        "implicit/Nordsieck.md"
    ],
    "IMEX Solvers" => [
        "imex/IMEXMultistep.md",
        "imex/StabilizedIRK.md",
        "imex/IMEXBDF.md"
    ],
    "Dynamical ODE Explicit Solvers" => [
        "dynamicalodeexplicit/RKN.md",
        "dynamicalodeexplicit/SymplecticRK.md"
    ],
    "Semilinear ODE Solvers" => [
        "semilinear/ExponentialRK.md",
        "semilinear/Linear.md"
    ],
    "Mass Matrix DAE Solvers" => [
        "massmatrixdae/Rosenbrock.md",
        "massmatrixdae/BDF.md"
    ],
    "Fully Implicit DAE Solvers" => [
        "fullyimplicitdae/BDF.md"
    ],
    "Misc Solvers" => [
        "misc.md"
    ]
]

using OrdinaryDiffEq, Test

function test_ode(u, p, t)
    [p[1] - (1 - p[1]) * u[1]]
end

function test_ode(du, u, p, t)
    du[1] = p[1] - (1 - p[1]) * u[1]
    return nothing
end

test_solution(t) = t <= 5 ? t : 5.0 * exp(-(t - 5))

tspan = (0.0, 10.0)
testtimes = range(tspan[1], stop = tspan[2], length = 1001)
pullback_condition(u, t, i) = t - 5
pullback_affect!(i) = i.p[1] = abs(1 - i.p[1])
cb = ContinuousCallback(pullback_condition, pullback_affect!)

# DPRKN6 is left out because second order ODE
algs = [Tsit5, Rosenbrock23, DP5, DP8, SSPRK43, SSPRK432, OwrenZen3, SSPRK22, SSPRK33,
    OwrenZen4, OwrenZen5, Rosenbrock32, Rodas5, Rodas4, Rodas42, Rodas5P] ## Works for these
lazy_alg = [BS5, Vern6, Vern7, Vern8, Vern9]
bad_algs = []

nonstandard_interp_algs = union(algs, bad_algs, lazy_alg)

passed = fill(false, 2length(nonstandard_interp_algs))

cur_itr = 0
for inplace in [false, true], alg in algs
    global cur_itr
    prob = ODEProblem{inplace}(test_ode, [0.0], tspan, [1.0])
    sol = solve(prob, alg(); callback = cb, dt = 0.0013)
    pass = all(isapprox(sol(t)[1], test_solution(t); atol = 0.05) for t in testtimes)
    x = maximum(sol(t)[1] - test_solution(t) for t in testtimes)
    cur_itr += 1
    passed[cur_itr] = pass
end

for inplace in [false, true], alg in lazy_alg
    global cur_itr
    prob = ODEProblem{inplace}(test_ode, [0.0], tspan, [1.0])
    sol = solve(prob, alg(); callback = cb, dt = 0.0013)
    fail = all(isapprox(sol(t)[1], test_solution(t); atol = 0.05) for t in testtimes)

    prob = ODEProblem{inplace}(test_ode, [0.0], tspan, [1.0])
    sol = solve(prob, alg(lazy = false); callback = cb, dt = 0.0013)
    pass = all(isapprox(sol(t)[1], test_solution(t); atol = 0.05) for t in testtimes)

    cur_itr += 1
    passed[cur_itr] = pass && !fail
end

any(.!(passed)) &&
    @warn("The following algorithms failed the continuous callback test: $(vcat(algs,algs,lazy_alg,lazy_alg)[.!(passed)])")
@test all(passed)

using OrdinaryDiffEq, Test

f_ec(u, p, t) = exp(u)
u0 = 0.0 # explosion time is 1.0
tspan = (0.0, 10.0)
prob = ODEProblem(f_ec, u0, tspan)
options = [:reltol => 1e-8, :abstol => 1e-8, :verbose => false]
desired_codes = (ReturnCode.MaxIters, ReturnCode.Unstable)

# Test that sol.retcode is set to the correct value by various ways to
# invoke integrator.

sol = solve(prob, Tsit5(); options...)
@test sol.retcode in desired_codes

integrator = init(prob, Tsit5(); options...)
solve!(integrator)
@test integrator.sol.retcode in desired_codes

integrator = init(prob, Tsit5(); options...)
for _ in integrator
end
@test integrator.sol.retcode in desired_codes

integrator = init(prob, Tsit5(); options...)
step!(integrator, 10.0)
@test integrator.sol.retcode in desired_codes

# Test check_error
integrator = init(prob, Tsit5(); options...)
step!(integrator)
@test check_error(integrator) == ReturnCode.Success
ok = false
for i in 1:(integrator.opts.maxiters)
    step!(integrator)
    if check_error(integrator) in desired_codes
        global ok = true
        # @show i
        break
    end
end
@test ok

let
    function f!(out, u, _, t)
        out[1] = u[1] + 1 - sin(t)
    end
    mprob = ODEProblem(ODEFunction(f!, mass_matrix = [0.0;;]), [0.0], (0, 2.0))
    @test solve(mprob, Rosenbrock23()).retcode == ReturnCode.Success
end

@testset "Callbacks shouldn't disable error checking" begin
    callback = ContinuousCallback((u, t, integ) -> t - prevfloat(0.5), Returns(nothing))
    prob = ODEProblem((u, p, t) -> u, 0.0, (0.0, 1); tstops = [0.5], callback)
    sol = solve(prob, FBDF(), maxiters = 30)
    @test sol.stats.naccept + sol.stats.nreject <= 30
    @test_broken sol.retcode = ReturnCode.Success
end

@test_throws ArgumentError solve(prob, Euler(), dt = 0.1, adaptive = true)
@test_throws ArgumentError solve(prob, Euler())

"""
$(DocStringExtensions.README)
"""
module OrdinaryDiffEq

import Reexport: Reexport, @reexport
@reexport using SciMLBase

# Explicit imports for functions that are re-exported
import CommonSolve: init, solve, solve!, step!
import SciMLBase: SciMLBase, addsteps!, savevalues!, terminate!

import OrdinaryDiffEqCore: OrdinaryDiffEqCore,
                           CompositeAlgorithm,
                           ShampineCollocationInit, BrownFullBasicInit, NoInit,
                           du_cache, full_cache, isfsal, ode_interpolant, u_cache,
                           AutoSwitch,
                          
                           @cache

export CompositeAlgorithm, ShampineCollocationInit, BrownFullBasicInit, NoInit,
       AutoSwitch

import OrdinaryDiffEqDifferentiation: OrdinaryDiffEqDifferentiation
using OrdinaryDiffEqDifferentiation: OrdinaryDiffEqDifferentiation
export OrdinaryDiffEqDifferentiation

import OrdinaryDiffEqNonlinearSolve: OrdinaryDiffEqNonlinearSolve
using OrdinaryDiffEqNonlinearSolve: NLNewton, NLAnderson, NLFunctional,
                                    NonlinearSolveAlg
export OrdinaryDiffEqNonlinearSolve, NLNewton, NLAnderson, NLFunctional, NonlinearSolveAlg

import OrdinaryDiffEqExtrapolation: OrdinaryDiffEqExtrapolation
using OrdinaryDiffEqExtrapolation: AitkenNeville, ExtrapolationMidpointDeuflhard,
                                   ExtrapolationMidpointHairerWanner,
                                   ImplicitEulerExtrapolation,
                                   ImplicitDeuflhardExtrapolation,
                                   ImplicitHairerWannerExtrapolation,
                                   ImplicitEulerBarycentricExtrapolation
export OrdinaryDiffEqExtrapolation, AitkenNeville, ExtrapolationMidpointDeuflhard,
       ExtrapolationMidpointHairerWanner,
       ImplicitEulerExtrapolation,
       ImplicitDeuflhardExtrapolation, ImplicitHairerWannerExtrapolation,
       ImplicitEulerBarycentricExtrapolation

import OrdinaryDiffEqStabilizedRK: OrdinaryDiffEqStabilizedRK
using OrdinaryDiffEqStabilizedRK: ROCK2, ROCK4, RKC, ESERK4, ESERK5, SERK2
export OrdinaryDiffEqStabilizedRK, ROCK2, ROCK4, RKC, ESERK4, ESERK5, SERK2

import OrdinaryDiffEqStabilizedIRK: OrdinaryDiffEqStabilizedIRK
using OrdinaryDiffEqStabilizedIRK: IRKC
export OrdinaryDiffEqStabilizedIRK, IRKC

import OrdinaryDiffEqLowStorageRK: OrdinaryDiffEqLowStorageRK
using OrdinaryDiffEqLowStorageRK: ORK256, CarpenterKennedy2N54, SHLDDRK64, HSLDDRK64,
                                  DGLDDRK73_C, DGLDDRK84_C,
                                  DGLDDRK84_F, NDBLSRK124, NDBLSRK134, NDBLSRK144,
                                  CFRLDDRK64, TSLDDRK74, CKLLSRK43_2, CKLLSRK54_3C,
                                  CKLLSRK95_4S, CKLLSRK95_4C,
                                  CKLLSRK95_4M,
                                  CKLLSRK54_3C_3R, CKLLSRK54_3M_3R, CKLLSRK54_3N_3R,
                                  CKLLSRK85_4C_3R, CKLLSRK85_4M_3R,
                                  CKLLSRK85_4P_3R,
                                  CKLLSRK54_3N_4R, CKLLSRK54_3M_4R, CKLLSRK65_4M_4R,
                                  CKLLSRK85_4FM_4R, CKLLSRK75_4M_5R,
                                  ParsaniKetchesonDeconinck3S32,
                                  ParsaniKetchesonDeconinck3S82,
                                  ParsaniKetchesonDeconinck3S53,
                                  ParsaniKetchesonDeconinck3S173,
                                  ParsaniKetchesonDeconinck3S94,
                                  ParsaniKetchesonDeconinck3S184,
                                  ParsaniKetchesonDeconinck3S105,
                                  ParsaniKetchesonDeconinck3S205,
                                  RDPK3Sp35, RDPK3SpFSAL35, RDPK3Sp49, RDPK3SpFSAL49,
                                  RDPK3Sp510, RDPK3SpFSAL510,
                                  RK46NL, SHLDDRK_2N, SHLDDRK52
export OrdinaryDiffEqLowStorageRK, ORK256, CarpenterKennedy2N54, SHLDDRK64, HSLDDRK64,
       DGLDDRK73_C, DGLDDRK84_C,
       DGLDDRK84_F, NDBLSRK124, NDBLSRK134, NDBLSRK144,
       CFRLDDRK64, TSLDDRK74, CKLLSRK43_2, CKLLSRK54_3C, CKLLSRK95_4S, CKLLSRK95_4C,
       CKLLSRK95_4M,
       CKLLSRK54_3C_3R, CKLLSRK54_3M_3R, CKLLSRK54_3N_3R, CKLLSRK85_4C_3R, CKLLSRK85_4M_3R,
       CKLLSRK85_4P_3R,
       CKLLSRK54_3N_4R, CKLLSRK54_3M_4R, CKLLSRK65_4M_4R, CKLLSRK85_4FM_4R, CKLLSRK75_4M_5R,
       ParsaniKetchesonDeconinck3S32, ParsaniKetchesonDeconinck3S82,
       ParsaniKetchesonDeconinck3S53, ParsaniKetchesonDeconinck3S173,
       ParsaniKetchesonDeconinck3S94, ParsaniKetchesonDeconinck3S184,
       ParsaniKetchesonDeconinck3S105, ParsaniKetchesonDeconinck3S205,
       RDPK3Sp35, RDPK3SpFSAL35, RDPK3Sp49, RDPK3SpFSAL49, RDPK3Sp510, RDPK3SpFSAL510,
       RK46NL, SHLDDRK_2N, SHLDDRK52

import OrdinaryDiffEqSSPRK: OrdinaryDiffEqSSPRK
using OrdinaryDiffEqSSPRK: SSPRK53_2N2, SSPRK22, SSPRK53, SSPRK63, SSPRK83, SSPRK43,
                           SSPRK432, SSPRKMSVS32,
                           SSPRK54, SSPRK53_2N1, SSPRK104, SSPRK932, SSPRKMSVS43, SSPRK73,
                           SSPRK53_H,
                           SSPRK33, KYKSSPRK42, KYK2014DGSSPRK_3S2
export OrdinaryDiffEqSSPRK, SSPRK53_2N2, SSPRK22, SSPRK53, SSPRK63, SSPRK83, SSPRK43,
       SSPRK432, SSPRKMSVS32,
       SSPRK54, SSPRK53_2N1, SSPRK104, SSPRK932, SSPRKMSVS43, SSPRK73, SSPRK53_H,
       SSPRK33, KYKSSPRK42, KYK2014DGSSPRK_3S2

import OrdinaryDiffEqFeagin: OrdinaryDiffEqFeagin
using OrdinaryDiffEqFeagin: Feagin10, Feagin12, Feagin14
export OrdinaryDiffEqFeagin, Feagin10, Feagin12, Feagin14

import OrdinaryDiffEqSymplecticRK: OrdinaryDiffEqSymplecticRK
using OrdinaryDiffEqSymplecticRK: SymplecticEuler, VelocityVerlet, VerletLeapfrog,
                                  LeapfrogDriftKickDrift,
                                  PseudoVerletLeapfrog, McAte2, Ruth3, McAte3, CandyRoz4,
                                  McAte4, McAte42, McAte5,
                                  CalvoSanz4, Yoshida6, KahanLi6, McAte8, KahanLi8, SofSpa10
export OrdinaryDiffEqSymplecticRK, SymplecticEuler, VelocityVerlet, VerletLeapfrog,
       LeapfrogDriftKickDrift,
       PseudoVerletLeapfrog, McAte2, Ruth3, McAte3, CandyRoz4, McAte4, McAte42, McAte5,
       CalvoSanz4, Yoshida6, KahanLi6, McAte8, KahanLi8, SofSpa10

import OrdinaryDiffEqRKN: OrdinaryDiffEqRKN
using OrdinaryDiffEqRKN: Nystrom4, FineRKN4, FineRKN5, Nystrom4VelocityIndependent,
                         Nystrom5VelocityIndependent,
                         IRKN3, IRKN4, DPRKN4, DPRKN5, DPRKN6, DPRKN6FM, DPRKN8, DPRKN12,
                         ERKN4, ERKN5, ERKN7,
                         RKN4
export OrdinaryDiffEqRKN, Nystrom4, FineRKN4, FineRKN5, Nystrom4VelocityIndependent,
       Nystrom5VelocityIndependent,
       IRKN3, IRKN4, DPRKN4, DPRKN5, DPRKN6, DPRKN6FM, DPRKN8, DPRKN12, ERKN4, ERKN5, ERKN7,
       RKN4

import OrdinaryDiffEqVerner: OrdinaryDiffEqVerner
using OrdinaryDiffEqVerner: Vern6, Vern7, Vern8, Vern9, AutoVern6, AutoVern7, AutoVern8,
                            AutoVern9 
export OrdinaryDiffEqVerner, Vern6, Vern7, Vern8, Vern9

import OrdinaryDiffEqHighOrderRK: OrdinaryDiffEqHighOrderRK
using OrdinaryDiffEqHighOrderRK: TanYam7, DP8, PFRK87, TsitPap8
export OrdinaryDiffEqHighOrderRK, TanYam7, DP8, PFRK87, TsitPap8

import OrdinaryDiffEqSDIRK: OrdinaryDiffEqSDIRK
using OrdinaryDiffEqSDIRK: ImplicitEuler, ImplicitMidpoint, Trapezoid, TRBDF2, SDIRK2,
                           SDIRK22,
                           Kvaerno3, KenCarp3, Cash4, Hairer4, Hairer42, SSPSDIRK2,
                           Kvaerno4,
                           Kvaerno5, KenCarp4, KenCarp47, KenCarp5, KenCarp58,
                           ESDIRK54I8L2SA, SFSDIRK4,
                           SFSDIRK5, CFNLIRK3, SFSDIRK6, SFSDIRK7, SFSDIRK8,
                           ESDIRK436L2SA2, ESDIRK437L2SA, ESDIRK547L2SA2, ESDIRK659L2SA
export OrdinaryDiffEqSDIRK, ImplicitEuler, ImplicitMidpoint, Trapezoid, TRBDF2, SDIRK2,
       SDIRK22,
       Kvaerno3, KenCarp3, Cash4, Hairer4, Hairer42, SSPSDIRK2, Kvaerno4,
       Kvaerno5, KenCarp4, KenCarp47, KenCarp5, KenCarp58, ESDIRK54I8L2SA, SFSDIRK4,
       SFSDIRK5, CFNLIRK3, SFSDIRK6, SFSDIRK7, SFSDIRK8,
       ESDIRK436L2SA2, ESDIRK437L2SA, ESDIRK547L2SA2, ESDIRK659L2SA

import OrdinaryDiffEqBDF: OrdinaryDiffEqBDF
using OrdinaryDiffEqBDF: ABDF2, QNDF1, QBDF1, QNDF2, QBDF2, QNDF, QBDF, FBDF,
                         SBDF2, SBDF3, SBDF4, MEBDF2, IMEXEuler, IMEXEulerARK,
                         DImplicitEuler, DABDF2, DFBDF
export OrdinaryDiffEqBDF, ABDF2, QNDF1, QBDF1, QNDF2, QBDF2, QNDF, QBDF, FBDF,
       SBDF2, SBDF3, SBDF4, MEBDF2, IMEXEuler, IMEXEulerARK,
       DImplicitEuler, DABDF2, DFBDF

import OrdinaryDiffEqTsit5: OrdinaryDiffEqTsit5
using OrdinaryDiffEqTsit5: Tsit5, AutoTsit5
export OrdinaryDiffEqTsit5, Tsit5, AutoTsit5

import OrdinaryDiffEqRosenbrock: OrdinaryDiffEqRosenbrock
using OrdinaryDiffEqRosenbrock: Rosenbrock23, Rosenbrock32, RosShamp4, Veldd4, Velds4,
                                GRK4T, GRK4A,
                                Ros4LStab, ROS3P, Rodas3, Rodas23W, Rodas3P, Rodas4,
                                Rodas42, Rodas4P, Rodas4P2,
                                Rodas5, Rodas5P, Rodas5Pe, Rodas5Pr,
                                RosenbrockW6S4OS, ROS34PW1a, ROS34PW1b, ROS34PW2, ROS34PW3,
                                ROS34PRw, ROS3PRL,
                                ROS3PRL2, ROK4a,
                                ROS2, ROS2PR, ROS2S, ROS3, ROS3PR, Scholz4_7
export OrdinaryDiffEqRosenbrock, Rosenbrock23, Rosenbrock32, RosShamp4, Veldd4, Velds4,
       GRK4T, GRK4A,
       Ros4LStab, ROS3P, Rodas3, Rodas23W, Rodas3P, Rodas4, Rodas42, Rodas4P, Rodas4P2,
       Rodas5, Rodas5P, Rodas5Pe, Rodas5Pr,
       RosenbrockW6S4OS, ROS34PW1a, ROS34PW1b, ROS34PW2, ROS34PW3, ROS34PRw, ROS3PRL,
       ROS3PRL2, ROK4a,
       ROS2, ROS2PR, ROS2S, ROS3, ROS3PR, Scholz4_7

import OrdinaryDiffEqDefault: OrdinaryDiffEqDefault
using OrdinaryDiffEqDefault: DefaultODEAlgorithm
export OrdinaryDiffEqDefault, DefaultODEAlgorithm

import OrdinaryDiffEqFIRK: OrdinaryDiffEqFIRK
using OrdinaryDiffEqFIRK: RadauIIA3, RadauIIA5, RadauIIA9
export OrdinaryDiffEqFIRK, RadauIIA3, RadauIIA5, RadauIIA9

import OrdinaryDiffEqQPRK: OrdinaryDiffEqQPRK
using OrdinaryDiffEqQPRK: QPRK98
export OrdinaryDiffEqQPRK, QPRK98

import OrdinaryDiffEqPDIRK: OrdinaryDiffEqPDIRK
using OrdinaryDiffEqPDIRK: PDIRK44
export OrdinaryDiffEqPDIRK, PDIRK44

import OrdinaryDiffEqPRK: OrdinaryDiffEqPRK
using OrdinaryDiffEqPRK: KuttaPRK2p5
export OrdinaryDiffEqPRK, KuttaPRK2p5

import OrdinaryDiffEqLowOrderRK: OrdinaryDiffEqLowOrderRK
using OrdinaryDiffEqLowOrderRK: Euler, SplitEuler, Heun, Ralston, Midpoint, RK4,
                                BS3, OwrenZen3, OwrenZen4, OwrenZen5, BS5,
                                DP5, Anas5, RKO65, FRK65, RKM, MSRK5, MSRK6,
                                PSRK4p7q6, PSRK3p5q4, PSRK3p6q5, Stepanov5, SIR54,
                                Alshina2, Alshina3, Alshina6, AutoDP5
export OrdinaryDiffEqLowOrderRK, Euler, SplitEuler, Heun, Ralston, Midpoint, RK4,
       BS3, OwrenZen3, OwrenZen4, OwrenZen5, BS5,
       DP5, Anas5, RKO65, FRK65, RKM, MSRK5, MSRK6,
       PSRK4p7q6, PSRK3p5q4, PSRK3p6q5, Stepanov5, SIR54,
       Alshina2, Alshina3, Alshina6, AutoDP5

import OrdinaryDiffEqFunctionMap: OrdinaryDiffEqFunctionMap
using OrdinaryDiffEqFunctionMap: FunctionMap
export OrdinaryDiffEqFunctionMap, FunctionMap

import OrdinaryDiffEqAdamsBashforthMoulton: OrdinaryDiffEqAdamsBashforthMoulton
using OrdinaryDiffEqAdamsBashforthMoulton: AB3, AB4, AB5, ABM32, ABM43, ABM54, VCAB3,
                                           VCAB4, VCAB5, VCABM3, VCABM4, VCABM5, VCABM
export OrdinaryDiffEqAdamsBashforthMoulton, AB3, AB4, AB5, ABM32, ABM43, ABM54, VCAB3,
       VCAB4, VCAB5, VCABM3, VCABM4, VCABM5, VCABM

import OrdinaryDiffEqNordsieck: OrdinaryDiffEqNordsieck
using OrdinaryDiffEqNordsieck: AN5, JVODE, JVODE_Adams, JVODE_BDF
export OrdinaryDiffEqNordsieck, AN5, JVODE, JVODE_Adams, JVODE_BDF

import OrdinaryDiffEqExplicitRK: OrdinaryDiffEqExplicitRK
using OrdinaryDiffEqExplicitRK: ExplicitRK, constructDormandPrince
export OrdinaryDiffEqExplicitRK, ExplicitRK

import OrdinaryDiffEqLinear: OrdinaryDiffEqLinear
using OrdinaryDiffEqLinear: MagnusMidpoint, LinearExponential, MagnusLeapfrog, LieEuler,
                            CayleyEuler,
                            MagnusGauss4, MagnusNC6, MagnusGL6, MagnusGL8, MagnusNC8,
                            MagnusGL4,
                            MagnusAdapt4, RKMK2, RKMK4, LieRK4, CG2, CG3, CG4a
export OrdinaryDiffEqLinear, MagnusMidpoint, LinearExponential, MagnusLeapfrog, LieEuler,
       CayleyEuler,
       MagnusGauss4, MagnusNC6, MagnusGL6, MagnusGL8, MagnusNC8, MagnusGL4,
       MagnusAdapt4, RKMK2, RKMK4, LieRK4, CG2, CG3, CG4a

import OrdinaryDiffEqIMEXMultistep: OrdinaryDiffEqIMEXMultistep
using OrdinaryDiffEqIMEXMultistep: CNAB2, CNLF2
export OrdinaryDiffEqIMEXMultistep, CNAB2, CNLF2

import OrdinaryDiffEqExponentialRK: OrdinaryDiffEqExponentialRK
using OrdinaryDiffEqExponentialRK: LawsonEuler, NorsettEuler, ETD1, ETDRK2, ETDRK3, ETDRK4,
                                   HochOst4, Exp4, EPIRK4s3A,
                                   EPIRK4s3B,
                                   EPIRK5s3, EXPRB53s3, EPIRK5P1, EPIRK5P2, ETD2, Exprb32,
                                   Exprb43
export OrdinaryDiffEqExponentialRK, LawsonEuler, NorsettEuler, ETD1, ETDRK2, ETDRK3, ETDRK4,
       HochOst4, Exp4, EPIRK4s3A,
       EPIRK4s3B,
       EPIRK5s3, EXPRB53s3, EPIRK5P1, EPIRK5P2, ETD2, Exprb32, Exprb43

import PrecompileTools
import Preferences
import DocStringExtensions

const DEPRECATED_ADDSTEPS = true

#General Functions
export solve, solve!, init, step!

#Callback Necessary
export addsteps!, ode_interpolant, terminate!, savevalues!, isfsal

export constructDormandPrince

# Reexport the Alg Types

export CompositeAlgorithm

export AutoSwitch, AutoVern6, AutoVern7, AutoVern8, AutoVern9

import OrdinaryDiffEqCore: IController, PIController, PIDController
export IController, PIController, PIDController

# Export Reexport and @reexport
export Reexport, @reexport
end # module

using Test, OrdinaryDiffEq, LinearSolve, ADTypes, ForwardDiff, SparseConnectivityTracer,
      SparseMatrixColorings
import ODEProblemLibrary: prob_ode_2Dlinear

ad = AutoSparse(AutoForwardDiff(), sparsity_detector = TracerSparsityDetector(),
    coloring_algorithm = GreedyColoringAlgorithm())

prob = prob_ode_2Dlinear

@test_nowarn solve(prob, Rodas5P(autodiff = ad))

@test_nowarn solve(prob, Rodas5P(autodiff = ad, linsolve = LinearSolve.KrylovJL_GMRES()))

@test_nowarn solve(prob, FBDF(autodiff = ad))

# Test that no dense matrices are made sparse
diag_prob = ODEProblem((du, u, p, t) -> du .= -1.0 .* u, rand(Int(1e7)), (0, 1.0))

@test_nowarn solve(diag_prob, Rodas5P(autodiff = ad, linsolve = LinearSolve.KrylovJL_GMRES()))

using OrdinaryDiffEq, Test, ADTypes
function f(du, u, p, t)
    du[1] = 0.2u[1]
    du[2] = 0.4u[2]
end
u0 = ones(2)
tspan = (0.0, 1.0)
prob = ODEProblem{true, SciMLBase.AutoSpecialize}(f, u0, tspan, Float64[])

function lorenz(du, u, p, t)
    du[1] = 10.0(u[2] - u[1])
    du[2] = u[1] * (28.0 - u[3]) - u[2]
    du[3] = u[1] * u[2] - (8 / 3) * u[3]
end
lorenzprob = ODEProblem(lorenz, [1.0; 0.0; 0.0], (0.0, 1.0), Float64[])

t1 = @elapsed sol1 = solve(lorenzprob, Rosenbrock23())
t2 = @elapsed sol2 = solve(lorenzprob, Rosenbrock23(autodiff = AutoFiniteDiff()))

lorenzprob2 = ODEProblem{true, SciMLBase.FullSpecialize}(lorenz, [1.0; 0.0; 0.0],
    (0.0, 1.0), Float64[])

t3 = @elapsed sol3 = solve(lorenzprob2, Rosenbrock23())
t4 = @elapsed sol4 = solve(lorenzprob2, Rosenbrock23(autodiff = AutoFiniteDiff()))

@test sol1.retcode === ReturnCode.Success
@test sol2.retcode === ReturnCode.Success
@test sol3.retcode === ReturnCode.Success
@test sol4.retcode === ReturnCode.Success

@test t1 < t3
@test t2 < t4
integ = init(lorenzprob, Rosenbrock23())
@test integ.f.f isa FunctionWrappersWrappers.FunctionWrappersWrapper

solve(prob, EPIRK4s3A(), dt = 1e-1)

#=

function f_oop(u, p, t)
    [0.2u[1], 0.4u[2]]
end
u0 = ones(2)
tspan = (0.0, 1.0)
prob = ODEProblem{false}(f_oop, u0, tspan, Float64[])

function lorenz_oop(u, p, t)
    [10.0(u[2] - u[1]), u[1] * (28.0 - u[3]) - u[2], u[1] * u[2] - (8 / 3) * u[3]]
end
lorenzprob = ODEProblem(lorenz_oop, [1.0; 0.0; 0.0], (0.0, 1.0), Float64[])

# This one is fundamentally hard / broken
# Since the equation is not dependent on `t`, the output is not dual of t
# This is problem-dependent, so it is hard to deduce a priori
@test_broken t1 = @elapsed sol = solve(lorenzprob, Rosenbrock23())

t2 = @elapsed sol = solve(lorenzprob, Rosenbrock23(autodiff = AutoFiniteDiff()))

lorenzprob2 = ODEProblem{false, SciMLBase.FullSpecialize}(lorenz_oop, [1.0; 0.0; 0.0], (0.0, 1.0), Float64[])

t3 = @elapsed sol = solve(lorenzprob2, Rosenbrock23())
t4 = @elapsed sol = solve(lorenzprob2, Rosenbrock23(autodiff = AutoFiniteDiff()))

#@test 5t1 < t3
#@test t2 < t4
=#

# Skip Enzyme tests on Julia 1.12+ prerelease versions
if !isempty(VERSION.prerelease)
    @warn "Skipping Enzyme tests on Julia prerelease version $(VERSION)"
    exit(0)
end

using Enzyme, OrdinaryDiffEqTsit5, StaticArrays, DiffEqBase, ForwardDiff, Test

function lorenz!(du, u, p, t)
    du[1] = 10.0(u[2] - u[1])
    du[2] = u[1] * (28.0 - u[3]) - u[2]
    du[3] = u[1] * u[2] - (8 / 3) * u[3]
end

const _saveat =  SA[0.0,0.25,0.5,0.75,1.0,1.25,1.5,1.75,2.0,2.25,2.5,2.75,3.0]

function f_dt(y::Array{Float64}, u0::Array{Float64})
    tspan = (0.0, 3.0)
    prob = ODEProblem{true, SciMLBase.FullSpecialize}(lorenz!, u0, tspan)
    sol = DiffEqBase.solve(prob, Tsit5(), saveat = _saveat, sensealg = DiffEqBase.SensitivityADPassThrough(), abstol=1e-12, reltol=1e-12)
    y .= sol[1,:]
    return nothing
end;

function f_dt(u0)
    tspan = (0.0, 3.0)
    prob = ODEProblem{true, SciMLBase.FullSpecialize}(lorenz!, u0, tspan)
    sol = DiffEqBase.solve(prob, Tsit5(), saveat = _saveat, sensealg = DiffEqBase.SensitivityADPassThrough(), abstol=1e-12, reltol=1e-12)
    sol[1,:]
end;

u0 = [1.0; 0.0; 0.0]
fdj = ForwardDiff.jacobian(f_dt, u0)

ezj = stack(map(1:3) do i
    d_u0 = zeros(3)
    dy = zeros(13)
    y  = zeros(13)
    d_u0[i] = 1.0
    Enzyme.autodiff(Forward, f_dt,  Duplicated(y, dy), Duplicated(u0, d_u0));
    dy
end)

@test ezj ≈ fdj

function f_dt2(u0)
    tspan = (0.0, 3.0)
    prob = ODEProblem{true, SciMLBase.FullSpecialize}(lorenz!, u0, tspan)
    sol = DiffEqBase.solve(prob, Tsit5(), dt=0.1, saveat = _saveat, sensealg = DiffEqBase.SensitivityADPassThrough(), abstol=1e-12, reltol=1e-12)
    sum(sol[1,:])
end

fdg = ForwardDiff.gradient(f_dt2, u0)
d_u0 = zeros(3)
Enzyme.autodiff(Reverse, f_dt2,  Active, Duplicated(u0, d_u0));

@test d_u0 ≈ fdg

using OrdinaryDiffEq, Test
using OrdinaryDiffEqFIRK: AdaptiveRadau, RadauIIA9, RadauIIA5, RadauIIA3

# define the counting variable
const STEP_LIMITER_VAR = Ref(0)
# define the step_limiter! function which just counts the number of step_limiter calls
step_limiter!(u, integrator, p, t) = STEP_LIMITER_VAR[] += 1

# This function tests the step limiter functionality of an ODE solver.
function test_step_limiter(alg_type)
    STEP_LIMITER_VAR[] = 0 # reset the counting variable
    prob = ODEProblem((du, u, p, t) -> du .= u, [1.0], (0.0, 1.0))

    sol = solve(prob, alg_type(; step_limiter!), dt = 0.1)

    n = sol.stats.naccept + sol.stats.nreject
    @test n == STEP_LIMITER_VAR[]
end

@testset "Step_limiter Test" begin
    # it only catches the most basic errors, i.e. if the step_limiter! function is not called
    # or called more then one time

    # test the step_limiter! function 
    alg_types = [
        QNDF1, QNDF2, QNDF, FBDF, ImplicitEuler, ImplicitMidpoint, Trapezoid, TRBDF2,
        SDIRK2, SDIRK22, ABDF2, Feagin10, Feagin12, Feagin14,
        KenCarp3, KenCarp4, KenCarp5, Kvaerno3, Kvaerno4, Kvaerno5,
        Rosenbrock23, Rosenbrock32, ROS3P, Rodas3, Rodas23W, Rodas3P, Rodas4, Rodas42,
        Rodas4P, Rodas4P2, Rodas5, Rodas5P, Rodas5Pe, Rodas5Pr,
        AdaptiveRadau, RadauIIA9, RadauIIA5, RadauIIA3, SIR54,
        Alshina2, Alshina3, Heun, Ralston, Midpoint, RK4,
        OwrenZen3, OwrenZen4, OwrenZen5,
        BS3, DP5, Tsit5, DP8, TanYam7, TsitPap8, FRK65, PFRK87, BS5, Vern6, Vern7,
        Vern8, Vern9, QPRK98, SSPRKMSVS43, SSPRKMSVS32, SSPRK432, SSPRK43,
        RDPK3SpFSAL35, RDPK3Sp35, NDBLSRK124, NDBLSRK134, DGLDDRK73_C,
        DGLDDRK84_C, DGLDDRK84_F, SHLDDRK64, RDPK3Sp49, RDPK3SpFSAL49, RDPK3Sp510, RDPK3SpFSAL510,
        Alshina6, RKM, MSRK5, MSRK6, Anas5, RKO65, RK46NL, ORK256, KYK2014DGSSPRK_3S2,
        SSPRK22, SSPRK104, SSPRK54, SSPRK932, SSPRK83, SSPRK73, SSPRK63, SSPRK53_H,
        SSPRK53_2N2, SSPRK53_2N1, SSPRK53, SSPRK33, SHLDDRK_2N, SHLDDRK52, KYKSSPRK42,
        CarpenterKennedy2N54, CFRLDDRK64, TSLDDRK74, ParsaniKetchesonDeconinck3S32,
        ParsaniKetchesonDeconinck3S82,
        ParsaniKetchesonDeconinck3S53, ParsaniKetchesonDeconinck3S173, ParsaniKetchesonDeconinck3S94,
        ParsaniKetchesonDeconinck3S184, ParsaniKetchesonDeconinck3S105, ParsaniKetchesonDeconinck3S205,
        CKLLSRK43_2, CKLLSRK54_3C, CKLLSRK95_4S, CKLLSRK95_4C, CKLLSRK95_4M, CKLLSRK54_3C_3R,
        CKLLSRK54_3M_3R, CKLLSRK54_3N_3R, CKLLSRK85_4C_3R, CKLLSRK85_4M_3R, CKLLSRK85_4P_3R,
        CKLLSRK54_3N_4R, CKLLSRK54_3M_4R, CKLLSRK65_4M_4R, CKLLSRK85_4FM_4R, CKLLSRK75_4M_5R] #Stepanov5    

    for alg_type in alg_types
        test_step_limiter(alg_type)
    end
end

using OrdinaryDiffEq, OrdinaryDiffEqCore, DiffEqBase, Test, ADTypes
using Random
using OrdinaryDiffEqDefault
using ElasticArrays, LinearSolve
Random.seed!(213)
CACHE_TEST_ALGS = [Euler(), Midpoint(), RK4(), SSPRK22(), SSPRK33(), SSPRK43(), SSPRK104(),
    CarpenterKennedy2N54(), SHLDDRK64(), ORK256(), DGLDDRK73_C(),
    CFRLDDRK64(), TSLDDRK74(), CKLLSRK43_2(), ParsaniKetchesonDeconinck3S32(),
    BS3(), BS5(), DP5(), DP8(), Feagin10(), Feagin12(), Feagin14(), TanYam7(),
    Tsit5(), TsitPap8(), Vern6(), Vern7(), Vern8(), Vern9(), OwrenZen3(), OwrenZen4(),
    OwrenZen5(), AutoTsit5(Rosenbrock23()), TRBDF2(), KenCarp4(), ABDF2(),
    OrdinaryDiffEqDefault.DefaultODEAlgorithm()]
broken_CACHE_TEST_ALGS = [
    QNDF(),
    ExtrapolationMidpointHairerWanner(),
    ImplicitEulerExtrapolation(),
    ImplicitDeuflhardExtrapolation()
]
# AitkenNeville(threading=false) fails Elastic but not normal case

using InteractiveUtils

NON_IMPLICIT_ALGS = filter((x) -> isconcretetype(x) && !OrdinaryDiffEqCore.isimplicit(x()),
    union(subtypes(OrdinaryDiffEqCore.OrdinaryDiffEqAlgorithm),
        subtypes(OrdinaryDiffEqCore.OrdinaryDiffEqAdaptiveAlgorithm)))

f = function (du, u, p, t)
    for i in 1:length(u)
        du[i] = (0.3 / length(u)) * u[i]
    end
end

condition = function (u, t, integrator)
    1 - maximum(u)
end

affect! = function (integrator)
    u = integrator.u
    maxidx = findmax(u)[2]
    resize!(integrator, length(u) + 1)
    Θ = rand() / 5 + 0.25
    u[maxidx] = Θ
    u[end] = 1 - Θ
    nothing
end

callback = ContinuousCallback(condition, affect!)

u0 = [0.2]
tspan = (0.0, 10.0)
prob = ODEProblem(f, u0, tspan)

println("Check for stochastic errors")
for i in 1:10
    @test_nowarn sol = solve(prob, Tsit5(), callback = callback)
end

println("Check some other integrators")
sol = solve(prob, Rosenbrock23(), callback = callback, dt = 1 / 2)
@test length(sol[end]) > 1
sol = solve(prob, Rosenbrock32(), callback = callback, dt = 1 / 2)
@test length(sol[end]) > 1
sol = solve(prob, KenCarp4(), callback = callback, dt = 1 / 2)
@test length(sol[end]) > 1
sol = solve(prob, TRBDF2(), callback = callback, dt = 1 / 2)
@test length(sol[end]) > 1
sol = solve(prob, TRBDF2(linsolve = LinearSolve.KrylovJL_GMRES()),
    callback = callback)
@test length(sol[end]) > 1

for alg in CACHE_TEST_ALGS
    @show alg
    local sol = solve(prob, alg, callback = callback, dt = 1 / 2)
    @test length(sol[end]) > 1
end

for alg in broken_CACHE_TEST_ALGS
    @show alg
    @test_broken length(solve(prob, alg, callback = callback, dt = 1 / 2)[end]) > 1
end

sol = solve(prob, Rodas4(autodiff = AutoForwardDiff(chunksize = 1)),
    callback = callback, dt = 1 / 2)
@test length(sol[end]) > 1
sol = solve(prob, Rodas5(autodiff = AutoForwardDiff(chunksize = 1)),
    callback = callback, dt = 1 / 2)
@test length(sol[end]) > 1

# cache tests resizing multidimensional arrays
println("Check resizing multidimensional arrays")
u0_matrix = ElasticArray(ones(2, 2))
f_matrix = (du, u, p, t) -> du .= u
prob_matrix = ODEProblem(f_matrix, u0_matrix, (0.0, 2.0))
condition_matrix = (u, t, integrator) -> t - 1
affect_matrix! = function (integrator)
    resize!(integrator, (2, 3))
    integrator.u .= 1
    nothing
end
callback_matrix = ContinuousCallback(condition_matrix, affect_matrix!)

for alg in CACHE_TEST_ALGS
    OrdinaryDiffEqCore.isimplicit(alg) && continue # this restriction should be removed in the future
    @show alg
    local sol = solve(prob_matrix, alg, callback = callback_matrix, dt = 1 / 2)
    @test size(sol[end]) == (2, 3)
end

# additional cache tests to find more bugs
println("Additional resize! checks")
u0resize3 = ones(2)
fresize3 = (du, u, p, t) -> du .= u
prob_resize3 = ODEProblem(fresize3, u0resize3, (0.0, 2.0))
condition_resize3 = (u, t, integrator) -> t - 1
affect!_resize3 = function (integrator)
    resize!(integrator, 3)
    integrator.u .= 1
    nothing
end
callback_resize3 = ContinuousCallback(condition_resize3, affect!_resize3)

for alg in CACHE_TEST_ALGS
    (OrdinaryDiffEqCore.isimplicit(alg) || OrdinaryDiffEqCore.alg_order(alg) < 2) &&
        continue
    @show alg
    local sol = solve(prob_resize3, alg, callback = callback_resize3, dt = 0.125)
    @test size(sol[end]) == (3,)
    @test all(sol[end] .== sol[end][1])
    @test sol[end][1]≈exp(1) atol=1.0e-2
end

# additional cache tests to find more bugs
println("Enforced adaptive dt checks")
u0_adapt = zeros(2)
f_adapt = (du, u, p, t) -> du .= t
prob_adapt = ODEProblem(f_adapt, u0_adapt, (0.0, 2.0))
condition_adapt = (u, t, integrator) -> true
affect!_adapt = function (integrator)
    dt = rand((0.0625, 0.125, 0.25))
    set_proposed_dt!(integrator, dt)
    integrator.opts.dtmax = dt
    integrator.dtcache = dt
    u_modified!(integrator, false)
    nothing
end
callback_adapt = DiscreteCallback(condition_adapt, affect!_adapt,
    save_positions = (false, false))

for alg in CACHE_TEST_ALGS
    (OrdinaryDiffEqCore.isimplicit(alg) || OrdinaryDiffEqCore.alg_order(alg) < 2) &&
        continue
    @show alg
    local sol = solve(prob_adapt, alg, callback = callback_adapt, dt = 0.125)
    @test all(idx -> all(isapprox.(sol.u[idx], 0.5 * sol.t[idx]^2, atol = 1.0e-6)),
        eachindex(sol.t))
end

# Force switching

function f2(du, u, p, t)
    @assert length(u)==length(du) "length(u) = $(length(u)), length(du) = $(length(du)) at time $(t)"
    for i in 1:length(u)
        if t > 10
            du[i] = -10000 * u[i]
        else
            du[i] = 0.3 * u[i]
        end
    end
    return du
end

function condition2(u, t, integrator)
    1 - maximum(u)
end

function affect2!(integrator)
    u = integrator.u
    resize!(integrator, length(u) + 1)
    maxidx = findmax(u)[2]
    Θ = rand()
    u[maxidx] = Θ
    u[end] = 1 - Θ
    nothing
end

callback = ContinuousCallback(condition2, affect2!)
u0 = [0.2]
tspan = (0.0, 20.0)
prob = ODEProblem(f2, u0, tspan)
sol = solve(prob, AutoTsit5(Rosenbrock23()), callback = callback)
@test length(sol[end]) > 1

using OrdinaryDiffEq, DiffEqDevTools, DiffEqBase, Test

import ODEProblemLibrary: prob_ode_bigfloatlinear,
                          prob_ode_linear,
                          prob_ode_2Dlinear,
                          prob_ode_bigfloat2Dlinear

probbig = prob_ode_bigfloat2Dlinear
probnum = prob_ode_linear
probnumbig = prob_ode_bigfloatlinear
prob = prob_ode_2Dlinear

dts = (1 / 2) .^ (7:-1:4)
testTol = 0.2
bools = Vector{Bool}(undef, 0)

### BS3()
println("BS3")
sim = test_convergence(dts, probnum, BS3())
@test abs.(sim.𝒪est[:l2] - 3) < testTol
sim = test_convergence(dts, prob, BS3())
@test abs.(sim.𝒪est[:l2] - 3) < testTol

tabalg = ExplicitRK(tableau = constructBogakiShampine3())
sol1 = solve(probnum, BS3(), dt = 1 / 2^1, adaptive = false, save_everystep = false)
sol2 = solve(probnum, tabalg, dt = 1 / 2^1, adaptive = false, save_everystep = false)

@test sol1.u[end] - sol2.u[end] < 1e-10

sol1 = solve(prob, BS3(), dt = 1 / 2^1, adaptive = false, save_everystep = false)
sol2 = solve(prob, tabalg, dt = 1 / 2^1, adaptive = false, save_everystep = false)

@test minimum(sol1.u[end] - sol2.u[end] .< 1e-10)

sol1 = solve(prob, tabalg, dt = 1 / 2^6)
sol2 = solve(prob, BS3(), dt = 1 / 2^6)

@test length(sol1) == length(sol2)
@test SciMLBase.successful_retcode(sol1)
@test SciMLBase.successful_retcode(sol2)

### BS5()
println("BS5")
dts = (1 / 2) .^ (6:-1:3)
sim = test_convergence(dts, probnumbig, BS5())
@test abs.(sim.𝒪est[:l2] - 5) < testTol
sim = test_convergence(dts, probbig, BS5())
@test abs.(sim.𝒪est[:l2] - 5) < testTol

tabalg = ExplicitRK(tableau = constructBogakiShampine5())
sol1 = solve(probnum, BS5(), dt = 1 / 2^6, adaptive = false, save_everystep = false)
sol2 = solve(probnum, tabalg, dt = 1 / 2^6, adaptive = false, save_everystep = false)

@test sol1.u[end] - sol2.u[end] < 1e-10

sol1 = solve(prob, BS5(), dt = 1 / 2^3, adaptive = false, save_everystep = false)
sol2 = solve(prob, tabalg, dt = 1 / 2^3, adaptive = false, save_everystep = false)

@test minimum(sol1.u[end] - sol2.u[end] .< 1e-10)

sol1 = solve(prob, tabalg, dt = 1 / 2^6)
sol2 = solve(prob, BS5(), dt = 1 / 2^6)

@test length(sol1) <= length(sol2) # Dual error estimators is more strict
@test SciMLBase.successful_retcode(sol1)
@test SciMLBase.successful_retcode(sol2)

### Tsit5()

println("Tsit5")
dts = (1 / 2) .^ (7:-1:3)
sim = test_convergence(dts, probnum, Tsit5())
@test abs.(sim.𝒪est[:l2] - 5) < testTol + 0.2
sim = test_convergence(dts, prob, Tsit5())
@test abs.(sim.𝒪est[:l2] - 5) < testTol + 0.2

tabalg = ExplicitRK(tableau = constructTsitouras5())
sol1 = solve(probnum, Tsit5(), dt = 1 / 2^6, adaptive = false, save_everystep = false)
sol2 = solve(probnum, tabalg, dt = 1 / 2^6, adaptive = false, save_everystep = false)

@test sol1.u[end] - sol2.u[end] < 1e-10

sol1 = solve(prob, Tsit5(), dt = 1 / 2^3, adaptive = false, save_everystep = false)
sol2 = solve(prob, tabalg, dt = 1 / 2^3, adaptive = false, save_everystep = false)

@test minimum(sol1.u[end] - sol2.u[end] .< 1e-10)

sol1 = solve(prob, tabalg, dt = 1 / 2^6)
sol2 = solve(prob, Tsit5(), dt = 1 / 2^6)

@test length(sol1) == length(sol2)
@test SciMLBase.successful_retcode(sol1)
@test SciMLBase.successful_retcode(sol2)

### Vern6()

println("Vern6")
dts = (1 / 2) .^ (8:-1:5)
sim = test_convergence(dts, probnumbig, Vern6())
@test abs.(sim.𝒪est[:l2] - 6) < testTol
sim = test_convergence(dts, probbig, Vern6())
@test abs.(sim.𝒪est[:l2] - 6) < testTol

tabalg = ExplicitRK(tableau = constructVernerEfficient6(BigFloat))
sol1 = solve(probnumbig, Vern6(), dt = 1 / 2^6, adaptive = false, save_everystep = false)
sol2 = solve(probnumbig, tabalg, dt = 1 / 2^6, adaptive = false, save_everystep = false)

@test sol1.u[end] - sol2.u[end] < 1e-10

sol1 = solve(probbig, Vern6(), dt = 1 / 2^3, adaptive = false, save_everystep = false)
sol2 = solve(probbig, tabalg, dt = 1 / 2^3, adaptive = false, save_everystep = false)

@test minimum(sol1.u[end] - sol2.u[end] .< 1e-10)

sol1 = solve(probbig, tabalg, dt = 1 / 2^6)
sol2 = solve(probbig, Vern6(), dt = 1 / 2^6)

@test length(sol1) == length(sol2)
@test SciMLBase.successful_retcode(sol1)
@test SciMLBase.successful_retcode(sol2)

### Vern7()

println("Vern7")
dts = (1 / 2) .^ (6:-1:3)
sim = test_convergence(dts, probnumbig, Vern7(), dense_errors = true)
@test abs.(sim.𝒪est[:l2] - 7) < testTol
sim = test_convergence(dts, probbig, Vern7(), dense_errors = true)
@test abs.(sim.𝒪est[:l2] - 7) < testTol

tabalg = ExplicitRK(tableau = constructVerner7(BigFloat))
sol1 = solve(probnumbig, Vern7(), dt = 1 / 2^6, adaptive = false, save_everystep = false)
sol2 = solve(probnumbig, tabalg, dt = 1 / 2^6, adaptive = false, save_everystep = false)

@test sol1.u[end] - sol2.u[end] < 1e-10

sol1 = solve(probbig, Vern7(), dt = 1 / 2^3, adaptive = false, save_everystep = false)
sol2 = solve(probbig, tabalg, dt = 1 / 2^3, adaptive = false, save_everystep = false)

@test minimum(sol1.u[end] - sol2.u[end] .< 1e-10)

sol1 = solve(probbig, tabalg, dt = 1 / 2^6)
sol2 = solve(probbig, Vern7(), dt = 1 / 2^6)

@test length(sol1) == length(sol2)
@test SciMLBase.successful_retcode(sol1)
@test SciMLBase.successful_retcode(sol2)

### TanYam7()

println("TanYam7")
dts = (1 / 2) .^ (6:-1:3)
sim = test_convergence(dts, probnumbig, TanYam7())
@test abs.(sim.𝒪est[:l2] - 7) < testTol
sim = test_convergence(dts, probbig, TanYam7())
@test abs.(sim.𝒪est[:l2] - 7) < testTol

tabalg = ExplicitRK(tableau = constructTanakaYamashitaEfficient7(Float64))
sol1 = solve(probnum, TanYam7(), dt = 1 / 2^6, adaptive = false, save_everystep = false)
sol2 = solve(probnum, tabalg, dt = 1 / 2^6, adaptive = false, save_everystep = false)

@test sol1.u[end] - sol2.u[end] < 2e-9

tabalg = ExplicitRK(tableau = constructTanakaYamashitaEfficient7(BigFloat))
sol1 = solve(probbig, TanYam7(), dt = 1 / 2^3, adaptive = false, save_everystep = false)
sol2 = solve(probbig, tabalg, dt = 1 / 2^3, adaptive = false, save_everystep = false)

@test minimum(sol1.u[end] - sol2.u[end] .< 1e-10)

sol1 = solve(prob, tabalg, dt = 1 / 2^6)
sol2 = solve(prob, TanYam7(), dt = 1 / 2^6)

@test length(sol1) == length(sol2)
@test SciMLBase.successful_retcode(sol1)
@test SciMLBase.successful_retcode(sol2)

### Vern8()

println("Vern8")
dts = (1 / 2) .^ (6:-1:3)
sim = test_convergence(dts, probnumbig, Vern8(), dense_errors = true)
@test abs.(sim.𝒪est[:l2] - 8) < testTol
sim = test_convergence(dts, probbig, Vern8(), dense_errors = true)
@test abs.(sim.𝒪est[:l2] - 8) < testTol

tabalg = ExplicitRK(tableau = constructVerner8(BigFloat))
sol1 = solve(probnumbig, Vern8(), dt = 1 / 2^6, adaptive = false, save_everystep = false)
sol2 = solve(probnumbig, tabalg, dt = 1 / 2^6, adaptive = false, save_everystep = false)

@test sol1.u[end] - sol2.u[end] < 1e-10

sol1 = solve(probbig, Vern8(), dt = 1 / 2^3, adaptive = false, save_everystep = false)
sol2 = solve(probbig, tabalg, dt = 1 / 2^3, adaptive = false, save_everystep = false)

@test minimum(sol1.u[end] - sol2.u[end] .< 1e-10)

sol1 = solve(prob, tabalg, dt = 1 / 2^6)
sol2 = solve(prob, Vern8(), dt = 1 / 2^6)

@test length(sol1) == length(sol2)
@test SciMLBase.successful_retcode(sol1)
@test SciMLBase.successful_retcode(sol2)

### TsitPap8()

println("TsitPap8")
dts = (1 / 2) .^ (6:-1:3)
sim = test_convergence(dts, probnumbig, TsitPap8())
@test abs.(sim.𝒪est[:l2] - 8) < testTol
sim = test_convergence(dts, probbig, TsitPap8())
@test abs.(sim.𝒪est[:l2] - 8) < testTol

tabalg = ExplicitRK(tableau = constructTsitourasPapakostas8(BigFloat))
sol1 = solve(probnumbig, TsitPap8(), dt = 1 / 2^6, adaptive = false, save_everystep = false)
sol2 = solve(probnumbig, tabalg, dt = 1 / 2^6, adaptive = false, save_everystep = false)

@test sol1.u[end] - sol2.u[end] < 1e-10

sol1 = solve(probbig, TsitPap8(), dt = 1 / 2^3, adaptive = false, save_everystep = false)
sol2 = solve(probbig, tabalg, dt = 1 / 2^3, adaptive = false, save_everystep = false)

@test minimum(sol1.u[end] - sol2.u[end] .< 1e-10)

sol1 = solve(prob, tabalg, dt = 1 / 2^6)
sol2 = solve(prob, TsitPap8(), dt = 1 / 2^6)

@test length(sol1) == length(sol2)
@test SciMLBase.successful_retcode(sol1)
@test SciMLBase.successful_retcode(sol2)

### Vern9()

println("Vern9")
dts = (1 / 2) .^ (6:-1:3)
sim = test_convergence(dts, probnumbig, Vern9(), dense_errors = true)
@test abs.(sim.𝒪est[:l2] - 9) < testTol
sim = test_convergence(dts, probbig, Vern9(), dense_errors = true)
@test abs.(sim.𝒪est[:l2] - 9) < testTol

tabalg = ExplicitRK(tableau = constructVernerEfficient9(BigFloat))
sol1 = solve(probnumbig, Vern9(), dt = 1 / 2^6, adaptive = false, save_everystep = false)
sol2 = solve(probnumbig, tabalg, dt = 1 / 2^6, adaptive = false, save_everystep = false)

@test abs.(sol1.u[end] - sol2.u[end]) < 1e-15

sol1 = solve(probbig, Vern9(), dt = 1 / 2^3, adaptive = false, save_everystep = false)
sol2 = solve(probbig, tabalg, dt = 1 / 2^3, adaptive = false, save_everystep = false)

@test minimum(abs.(sol1.u[end] - sol2.u[end]) .< 1e-15)

sol1 = solve(probbig, tabalg, dt = 1 / 2^6)
sol2 = solve(probbig, Vern9(), dt = 1 / 2^6)

@test length(sol1) == length(sol2)
@test SciMLBase.successful_retcode(sol1)
@test SciMLBase.successful_retcode(sol2)

using OrdinaryDiffEq, DiffEqDevTools, Test
import ODEProblemLibrary: prob_ode_linear, prob_ode_2Dlinear

prob = prob_ode_linear
sol = solve(prob, Rosenbrock32())
dt₀ = sol.t[2]

prob = prob_ode_2Dlinear
sol = solve(prob, ExplicitRK(tableau = constructBogakiShampine3()))
dt₀ = sol.t[2]

@test 1e-7 < dt₀ < 0.1
@test_throws ArgumentError local sol = solve(prob, Euler())
#dt₀ = sol.t[2]

sol3 = solve(prob, ExplicitRK(tableau = constructDormandPrince8_64bit()))
dt₀ = sol3.t[2]

@test 1e-7 < dt₀ < 0.3

T = Float32
u0 = T.([1.0; 0.0; 0.0])

tspan = T.((0, 70))
prob = remake(prob, u0 = u0, tspan = tspan)
@test_nowarn solve(prob, Euler(); dt = T(0.0001))

tspan = T.((2000, 2100))
prob = remake(prob, tspan = tspan)
# set maxiters to prevent infinite loop on test failure
@test solve(prob, Euler(); dt = T(0.0001), maxiters = 10).retcode ==
      SciMLBase.ReturnCode.MaxIters

function rober(du, u, p, t)
    y₁, y₂, y₃ = u
    k₁, k₂, k₃ = p
    du[1] = -k₁ * y₁ + k₃ * y₂ * y₃
    du[2] = k₁ * y₁ - k₂ * y₂^2 - k₃ * y₂ * y₃
    du[3] = k₂ * y₂^2
    nothing
end
u0 = Float32[1.0, 0.0, 0.0]
tspan = (0.0f0, 1.0f5)
params = (4.0f-2, 3.0f7, 1.0f4)
prob = ODEProblem(rober, u0, tspan, params)
sol = solve(prob, Rosenbrock23())

# https://github.com/SciML/DifferentialEquations.jl/issues/743

using LinearAlgebra
function f(du, u, p, t)
    du[1] = -p[1] * u[1] + p[2] * u[2] * u[3]
    du[2] = p[1] * u[1] - p[2] * u[2] * u[3] - p[3] * u[2] * u[2]
    du[3] = u[1] + u[2] + u[3] - 1.0
end
M = Diagonal([1, 1, 0])
p = [0.04, 10^4, 3e7]
u0 = [1.0, 0.0, 0.0]
tspan = (0.0, 1e6)
prob = ODEProblem(ODEFunction(f, mass_matrix = M), u0, tspan, p)
sol = solve(prob, Rodas5())
@test sol.t[end] == 1e6

# test that dtmin is set based on timespan
prob = ODEProblem((u, p, t) -> 1e20 * sin(1e20 * t), 0.1, (0, 1e-19))
@test solve(prob, Tsit5()).retcode == ReturnCode.Success

#test that we are robust to u0=0, t0!=0
integ = init(ODEProblem(((u, p, t) -> u), 0.0f0, (20.0f0, 0.0f0)), Tsit5())
@test abs(integ.dt) > eps(integ.t)
integ = init(ODEProblem(((du, u, p, t) -> du .= u), [0.0f0], (20.0f0, 0.0f0)), Tsit5())
@test abs(integ.dt) > eps(integ.t)

using OrdinaryDiffEq, Test
function some_arbitrary_function!(du, u, p, τ)
    du = u / 100
    nothing #function returns nothing
end
NF = Float32                   # Number format 
u = NF[0.0, 100.0, π / 2.0, 0.0] #Initial conditions e.g. t, r θ, ϕ
params = NF[0.1, 3.5f-7]  #Some arbitrary parameters, unused in this example, just a placeholder
tspan = (zero(NF), NF(1e3)) #integrate from t=0 to t = 1000

ode_prob = ODEProblem(some_arbitrary_function!, u, tspan, params)

for alg in [
    Euler(), Midpoint(), Heun(), Ralston(), RK4(), SSPRK104(), SSPRK22(), SSPRK33(),
    SSPRK43(), SSPRK432(), BS3(), BS5(), DP5(), DP8(), Feagin10(), Feagin12(),
    Feagin14(), TanYam7(), Tsit5(), TsitPap8(), Vern6(), Vern7(), Vern8(), Vern9()]
    @test ode_solution = solve(ode_prob, alg, dt = 1.0f-1).retcode === ReturnCode.Success
end

using Mooncake, OrdinaryDiffEq, StaticArrays

function lorenz!(du, u, p, t)
    du[1] = 10.0(u[2] - u[1])
    du[2] = u[1] * (28.0 - u[3]) - u[2]
    du[3] = u[1] * u[2] - (8 / 3) * u[3]
end

const _saveat =  SA[0.0,0.25,0.5,0.75,1.0,1.25,1.5,1.75,2.0,2.25,2.5,2.75,3.0]

function f(u0::Array{Float64})
    tspan = (0.0, 3.0)
    prob = ODEProblem{true, SciMLBase.FullSpecialize}(lorenz!, u0, tspan)
    sol = SciMLBase.solve(prob, Tsit5(), saveat = _saveat, sensealg = SciMLBase.SensitivityADPassThrough())
    sum(sol)
end;
u0 = [1.0; 0.0; 0.0]
mooncake_gradient(f, x) = Mooncake.value_and_gradient!!(Mooncake.build_rrule(f, x), f, x)[2][2]
@test_broken mooncake_gradient(f, u0)

using OrdinaryDiffEq, Test, RecursiveArrayTools
import ODEProblemLibrary: prob_ode_linear, prob_ode_2Dlinear

prob = prob_ode_linear

sol = solve(prob, BS3(); dt = 1 // 2^(4), tstops = [0.5], saveat = 0.01,
    save_everystep = true)
sol(0.9)

integrator = init(prob, BS3(); dt = 1 // 2^(4), tstops = [0.5], saveat = 0.01,
    save_everystep = true)
step!(integrator)
@test integrator.iter == 1
solve!(integrator)
@test integrator.t == 1.0
integrator(0.95)
integrator.tprev
integrator.t

push!(integrator.opts.tstops, 5.0)
integrator.opts.advance_to_tstop = true
step!(integrator)
@test integrator.t == 5.0
integrator.opts.advance_to_tstop = false
step!(integrator)
@test integrator.t > 5

@test integrator.sol(0.9) == sol(0.9)

integrator = init(prob, Tsit5(); dt = 1 // 2^(4), tstops = [0.5], advance_to_tstop = true)
tupint = tuples(integrator)
for (u, t) in tuples(integrator)
    @test t ∈ [0.5, 1.0]
end

integrator = init(prob, Tsit5(); dt = 1 // 2^(4), tstops = [0.5], advance_to_tstop = true,
    stop_at_next_tstop = true)
for (u, t) in tuples(integrator)
    @test t == 0.5
end
integrator([1.0; 2.0])

integrator = init(prob, Tsit5(); dt = 1 // 2^(4), tstops = [0.5])
for (uprev, tprev, u, t) in intervals(integrator)
    @show tprev, t
end
integrator([1.0; 2.0])

integrator = init(prob, RK4(); dt = 1 // 2^(9), adaptive = false)
for i in Base.Iterators.take(integrator, 12)
end
@test integrator.iter == 12
for i in Base.Iterators.take(integrator, 12)
end
@test integrator.iter == 24

integrator = init(prob_ode_2Dlinear, Tsit5(); dt = 1 // 2^(4), tstops = [0.5],
    advance_to_tstop = true, stop_at_next_tstop = true)
for (u, t) in tuples(integrator)
    @test t == 0.5
end
A = integrator([1.0; 2.0])
B = integrator([1.0; 2.0], idxs = 1:2:5)

@test minimum([A[i][1:2:5] ≈ B[i] for i in 1:length(A)])

integrator(A[1], 0.5)
@test A[1] == integrator(0.5)

A = fill(0.0, 3)
integrator(A, 0.6, idxs = 1:2:5)
@test A == integrator(0.6; idxs = 1:2:5)

integrator = init(prob_ode_2Dlinear, Tsit5(); dt = 1 // 2^(4))
ts = range(0, stop = 1, length = 11)
us = Matrix{Float64}[]
for (u, t) in TimeChoiceIterator(integrator, ts)
    push!(us, copy(u))
end
@test VectorOfArray(us) ≈ integrator.sol(ts)

using OrdinaryDiffEq, Test
using OrdinaryDiffEqCore, ADTypes

f(u, p, t) = 0.98u
u0 = 1.0
tspan = (0.0, 1.0)
prob = ODEProblem(f, u0, tspan)
sol = solve(prob, Tsit5())

# Make sure various differentiation forms work on scalars

sol1 = solve(prob, Rosenbrock23(), abstol = 1e-12, reltol = 1e-12)
sol2 = solve(
    prob, Rosenbrock23(autodiff = AutoFiniteDiff()), abstol = 1e-12, reltol = 1e-12)
sol3 = solve(prob, Rosenbrock23(autodiff = AutoFiniteDiff(fdtype = Val(:central))),
    abstol = 1e-12, reltol = 1e-12)
sol4 = solve(prob, Rosenbrock23(autodiff = AutoFiniteDiff(fdtype = Val(:complex))),
    abstol = 1e-12, reltol = 1e-12)
sol5 = solve(prob, KenCarp4(), abstol = 1e-12, reltol = 1e-12)
sol6 = solve(prob, KenCarp4(autodiff = AutoFiniteDiff()), abstol = 1e-12, reltol = 1e-12)
sol7 = solve(
    prob, KenCarp4(autodiff = AutoFiniteDiff(fdtype = Val(:central))), abstol = 1e-12,
    reltol = 1e-12)
sol8 = solve(
    prob, KenCarp4(autodiff = AutoFiniteDiff(fdtype = Val(:complex))), abstol = 1e-12,
    reltol = 1e-12)
sol9 = solve(prob, KenCarp47(), abstol = 1e-12, reltol = 1e-12)
sol10 = solve(prob, KenCarp47(autodiff = AutoFiniteDiff()), abstol = 1e-12, reltol = 1e-12)
sol11 = solve(
    prob, KenCarp47(autodiff = AutoFiniteDiff(fdtype = Val(:central))), abstol = 1e-12,
    reltol = 1e-12)
sol12 = solve(
    prob, KenCarp47(autodiff = AutoFiniteDiff(fdtype = Val(:complex))), abstol = 1e-12,
    reltol = 1e-12)
sol13 = solve(prob, KenCarp58(), abstol = 1e-12, reltol = 1e-12)
sol14 = solve(prob, KenCarp58(autodiff = AutoFiniteDiff()), abstol = 1e-12, reltol = 1e-12)
sol15 = solve(
    prob, KenCarp58(autodiff = AutoFiniteDiff(fdtype = Val(:central))), abstol = 1e-12,
    reltol = 1e-12)
sol16 = solve(
    prob, KenCarp58(autodiff = AutoFiniteDiff(fdtype = Val(:complex))), abstol = 1e-12,
    reltol = 1e-12)

ts = 0.0:0.1:1.0
@test sol1(ts) ≈ sol2(ts)
@test sol1(ts) ≈ sol3(ts)
@test sol1(ts) ≈ sol4(ts)
@test sol1(ts) ≈ sol5(ts)
@test sol5(ts) ≈ sol6(ts)
@test sol5(ts) ≈ sol7(ts)
@test sol5(ts) ≈ sol8(ts)
@test sol1(ts) ≈ sol9(ts)
@test sol9(ts) ≈ sol10(ts)
@test sol9(ts) ≈ sol11(ts)
@test sol9(ts) ≈ sol12(ts)
@test sol1(ts) ≈ sol13(ts)
@test sol13(ts) ≈ sol14(ts)
@test sol13(ts) ≈ sol15(ts)
@test sol13(ts) ≈ sol16(ts)

# Test that in-place and out-of-place gets the same results

function f_ip(du, u, p, t)
    du[1] = -u[1]
    nothing
end
f_scalar(u, p, t) = -u

tspan = (0.0, 10.0)
prob_ip = ODEProblem(f_ip, [1.0], tspan)
prob_scalar = ODEProblem(f_scalar, 1.0, tspan)
ts = 0:0.1:10.0

rk_algs = [Euler(), Midpoint(), Heun(), Ralston(), RK4(), SSPRK104(), SSPRK22(), SSPRK33(),
    SSPRK43(), SSPRK432(), BS3(), BS5(), DP5(), DP8(), Feagin10(), Feagin12(),
    Feagin14(), TanYam7(), Tsit5(), TsitPap8(), Vern6(), Vern7(), Vern8(), Vern9()]

@testset "Algorithm $(nameof(typeof(alg)))" for alg in rk_algs
    println(nameof(typeof(alg)))
    high_order = OrdinaryDiffEqCore.alg_order(alg) > 5
    if high_order
        _prob_ip = remake(prob_ip, tspan = big.(tspan), u0 = [big(1.0)])
        _prob_scalar = remake(prob_scalar, tspan = big.(tspan), u0 = big(1.0))
    else
        _prob_ip = prob_ip
        _prob_scalar = prob_scalar
    end
    sol_ip = solve(_prob_ip, alg, dt = 0.1)
    sol_scalar = solve(_prob_scalar, alg, dt = 0.1)

    @test sol_ip(ts, idxs = 1) ≈ sol_scalar(ts)
    @test sol_ip.t ≈ sol_scalar.t && sol_ip[1, :] ≈ sol_scalar.u
end

working_sdirk_algs = [ImplicitMidpoint(),
    ImplicitEuler(),
    ImplicitMidpoint(autodiff = AutoFiniteDiff()),
    SSPSDIRK2()]

sdirk_algs = [Trapezoid(),
    TRBDF2(), SDIRK2(),
    Kvaerno3(), KenCarp3(),
    Cash4(), Hairer4(), Hairer42(), Kvaerno4(), KenCarp4(),
    Kvaerno5(), KenCarp5(), KenCarp47(), KenCarp58()]

@testset "Algorithm $(nameof(typeof(alg)))" for alg in working_sdirk_algs
    println(nameof(typeof(alg)))
    sol_ip = solve(prob_ip, alg, dt = 0.0125)
    sol_scalar = solve(prob_scalar, alg, dt = 0.0125)

    @test sol_ip(ts, idxs = 1) ≈ sol_scalar(ts)
    @test sol_ip.t ≈ sol_scalar.t && sol_ip[1, :] ≈ sol_scalar.u
end

@testset "Algorithm $(nameof(typeof(alg)))" for alg in sdirk_algs
    println(nameof(typeof(alg)))
    sol_ip = solve(prob_ip, alg, dt = 0.0125)
    sol_scalar = solve(prob_scalar, alg, dt = 0.0125)

    @test_broken sol_ip(ts, idxs = 1) ≈ sol_scalar(ts)
    @test_broken sol_ip.t ≈ sol_scalar.t && sol_ip[1, :] ≈ sol_scalar.u
end

working_rosenbrock_algs = [Rosenbrock23(), ROS3P(), Rodas3(),
    RosShamp4(), Veldd4(), Velds4(), GRK4T(), GRK4A(),
    Ros4LStab(), Rodas4(), Rodas42(), Rodas4P(), Rodas5(),
    Rodas23W(), Rodas3P(), Rodas5Pe(), Rodas5P(),
    ROS2(), ROS2PR(), ROS2S(), ROS3(), ROS3PR(), Scholz4_7(),
    ROS34PW1a(), ROS34PW1b(), ROS34PW2(), ROS34PW3(),
    ROS34PRw(), ROS3PRL(), ROS3PRL2(), ROK4a()]

rosenbrock_algs = [Rosenbrock32()
]

@testset "Algorithm $(nameof(typeof(alg)))" for alg in working_rosenbrock_algs
    println(nameof(typeof(alg)))
    sol_ip = solve(prob_ip, alg, dt = 0.0125)
    sol_scalar = solve(prob_scalar, alg, dt = 0.0125)

    @test sol_ip(ts, idxs = 1) ≈ sol_scalar(ts)
    @test sol_ip.t ≈ sol_scalar.t && sol_ip[1, :] ≈ sol_scalar.u
end

@testset "Algorithm $(nameof(typeof(alg)))" for alg in rosenbrock_algs
    println(nameof(typeof(alg)))
    sol_ip = solve(prob_ip, alg, dt = 0.0125)
    sol_scalar = solve(prob_scalar, alg, dt = 0.0125)

    @test sol_ip(ts, idxs = 1) ≈ sol_scalar(ts)
    @test sol_ip.t ≈ sol_scalar.t && sol_ip[1, :] ≈ sol_scalar.u
end

rkc_algs = [RKC(), ROCK2(), ROCK4(), SERK2()]

@testset "Algorithm $(nameof(typeof(alg)))" for alg in rkc_algs
    println(nameof(typeof(alg)))
    sol_ip = solve(prob_ip, alg)
    sol_scalar = solve(prob_scalar, alg)

    @test sol_ip(ts, idxs = 1) ≈ sol_scalar(ts)
    @test sol_ip.t ≈ sol_scalar.t && sol_ip[1, :] ≈ sol_scalar.u
end

using StaticArrays
using OrdinaryDiffEq
using DiffEqDevTools
using Test

@inbounds @inline function ż(z, p, t)
    A, B, D = p
    p₀, p₂ = z[1:2]
    q₀, q₂ = z[3:4]

    return SVector{4}(-A * q₀ - 3 * B / √2 * (q₂^2 - q₀^2) - D * q₀ * (q₀^2 + q₂^2),
        -q₂ * (A + 3 * √2 * B * q₀ + D * (q₀^2 + q₂^2)),
        A * p₀,
        A * p₂)
end

condition(u, t, integrator) = u
affect!(integrator) = nothing
function cbf(idx)
    ContinuousCallback(condition,
        affect!, nothing, save_positions = (false, true), idxs = idx)
end
z0 = SVector{4}(7.1989885061904335, -0.165912283356219, 0.0, -3.63534900748947)

tspan = (0.0, 300.0)
prob = ODEProblem(ż, z0, tspan, (A = 1, B = 0.55, D = 0.4), callback = cbf(3))
sol = solve(prob, Vern9(), abstol = 1e-14, reltol = 1e-14,
    save_everystep = false, save_start = false, save_end = false, maxiters = 1e6)

@test length(sol) > 100
@test SciMLBase.successful_retcode(sol)

prob = ODEProblem(ż, z0, (0, 400.0), (A = 1, B = 0.55, D = 0.4), callback = cbf(3))
sol = solve(prob, Vern9(), abstol = 1e-14, reltol = 1e-14, save_everystep = false,
    save_start = false, save_end = false, maxiters = 2e4)

@test length(sol) > 100
@test SciMLBase.successful_retcode(sol)

prob = ODEProblem(ż, z0, (0, 5000.0), (A = 1, B = 0.55, D = 0.4), callback = cbf(3))
sol = solve(prob, Vern9(), abstol = 1e-14, reltol = 1e-14, save_everystep = false,
    save_start = false, save_end = false, maxiters = 1e6)

@test length(sol) > 1500
@test SciMLBase.successful_retcode(sol)

@info "Bouncing Ball"

f = function (du, u, p, t)
    du[1] = u[2]
    du[2] = -p[1]
end
function condition(u, t, integrator) # Event when event_f(u,t) == 0
    u[1]
end
function affect!(integrator)
    integrator.u[2] = -integrator.u[2]
end
cb2 = ContinuousCallback(condition, affect!)
tspan = (0.0, 10000.0)
u0 = [50.0, 0.0]
p = 9.8
prob = ODEProblem(f, u0, tspan, p)
sol = solve(prob, Tsit5(), callback = cb2)
@test minimum(Array(sol)) > -40

# https://github.com/SciML/OrdinaryDiffEq.jl/issues/2055
for alg in (Rodas4(), Rodas4P(), Rodas5(), Rodas5P())
    sol2 = solve(prob, alg; callback = cb2)
    sol3 = appxtrue(sol, sol2)
    @test sol3.errors[:L2] < 1e-5
    @test sol3.errors[:L∞] < 5e-5
    @test sol3.errors[:final] < 1e-5
end

function fball(du, u, p, t)
    du[1] = u[2]
    du[2] = -p
    du[3] = u[4]
    du[4] = 0.0
end
u0 = [50.0, 0.0, 0.0, 2.0]
tspan = (0.0, 15.0)
p = 9.8
prob = ODEProblem(fball, u0, tspan, p)

x = Ref(0)
y = Ref(0)
z = Ref(0)

function condition(out, u, t, integrator)
    out[1] = u[1]
    out[2] = (10.0 - u[3])u[3]
end

function affect!(integrator, idx)
    if idx == 1
        x[] += 1
        integrator.u[2] = -0.9integrator.u[2]
    elseif idx == 2
        y[] += 1
        integrator.u[4] = -0.9integrator.u[4]
    end
end

function affect_neg!(integrator, idx)
    z[] += 1
    @show integrator.u[1]
    @show integrator.u[3]
end

cb = VectorContinuousCallback(condition, affect!, 2)
cb2 = VectorContinuousCallback(condition, affect_neg!, affect!, 2)

sol = solve(prob, Tsit5(), callback = cb, dt = 1e-3, adaptive = false)
@test x[] == 3
@test y[] == 2

sol2 = solve(prob, Tsit5(), callback = cb2, dt = 1e-3, adaptive = false)
@test sol.u == sol2.u
@test z[] == 0

# https://github.com/SciML/OrdinaryDiffEq.jl/issues/1273

function du!(du, u, p, t)
    du[1] = 1
end

callback = ContinuousCallback((u, t, integrator) -> 1.0,
    (integrator) -> nothing)

prob = ODEProblem(du!, [0], (0.0, 1.0), callback = callback)

solve(prob, Tsit5())
solve(prob, RadauIIA3())
solve(prob, RadauIIA5())

du(u, p, t) = [1.0]

prob = ODEProblem(du, [0], (0.0, 1.0), callback = callback)

solve(prob, Tsit5())
solve(prob, RadauIIA3())
solve(prob, RadauIIA5())

using OrdinaryDiffEq, SparseArrays, LinearSolve, LinearAlgebra
using ComponentArrays

function enclosethetimedifferential(parameters::NamedTuple)::Function
    @info "Enclosing the time differential"

    (; Δr, r_space, countorderapprox) = parameters.compute
    N = length(r_space)

    function first_deriv(N)
        dx = 1 / (N + 1)
        du = -1 * ones(N - 1) # off diagonal
        du2 = ones(N - 1) # off diagonal
        diag = zeros(N)
        lower = spzeros(Float64, N)
        upper = spzeros(Float64, N)
        lower[1] = -1.0
        upper[end] = 1.0
        M = hcat(lower, sparse(diagm(-1 => du, 0 => diag, 1 => du2)), upper)
        MatrixOperator(1 / dx * M)
    end

    function second_deriv(N)
        dx = 1 / (N + 1)
        du = ones(N - 1) # off diagonal
        du2 = ones(N - 1) # off diagonal
        diag = -2 * ones(N)
        lower = spzeros(Float64, N)
        upper = spzeros(Float64, N)
        lower[1] = 1.0
        upper[end] = 1.0
        M = hcat(lower, sparse(diagm(-1 => du, 0 => diag, 1 => du2)), upper)
        MatrixOperator(1 / dx^2 * M)
    end

    function extender(N)
        dx = 1 / (N + 1)
        diag = ones(N)
        lower = spzeros(Float64, N)
        upper = spzeros(Float64, N)
        lower[1] = 1.0
        upper[end] = 1.0
        M = vcat(transpose(lower),
            sparse(diagm(diag)),
            transpose(upper))
        MatrixOperator(1 / dx^2 * M)
    end

    bc_handler = extender(N)

    ∇ = first_deriv(N) * bc_handler
    Δ = second_deriv(N) * bc_handler

    bc_x = zeros(Real, N)
    bc_xx = zeros(Real, N)

    function timedifferentialclosure!(du, u, p, t)
        (; α, D, v, k_p, V_c, Q_l, Q_r, V_b,
        S, Lm, Dm, V_v) = p

        c = u[1:(end - 3)]
        c_v = u[end - 2]
        c_c = u[end - 1]
        c_b = u[end]

        J_B0 = (Dm / Lm) * (α * c_v - c[1])
        J_BL = (Dm / Lm) * (c[end] - α * c_c)
        grad_0 = (v ./ D) .* c[1] .- J_B0 ./ D
        grad_L = (v ./ D) .* c[end] .- J_BL ./ D

        bc_x[1] = grad_0 / 2
        bc_x[end] = grad_L / 2
        grad_c = ∇ * c + bc_x

        bc_xx[1] = -grad_0 / Δr
        bc_xx[end] = grad_L / Δr
        Lap_c = Δ * c + bc_xx

        C = sum(Δr .* S * (k_p * (c .- c_b)))

        dc_dt = D * Lap_c - v * grad_c .- k_p * (c .- c_b)
        du[1:(end - 3)] = dc_dt[1:end]

        dcv_dt = -S * J_B0 / V_v - (Q_l / V_v) * c_v
        du[end - 2] = dcv_dt

        dcc_dt = S * α * J_BL / V_c + (Q_l / V_c) * c_v - (Q_l / V_c) * c_c
        du[end - 1] = dcc_dt

        dcb_dt = (Q_l / V_b) * c_c + C / V_b
        du[end] = dcb_dt
    end

    return timedifferentialclosure!
end

prior = ComponentArray(;
    α = 0.2,
    D = 0.46,
    v = 0.0,
    k_p = 0.0,
    V_c = 18,
    Q_l = 20,
    Q_r = 3.6,
    V_b = 1490,
    S = 52,
    Lm = 0.05,
    Dm = 0.046,
    V_v = 18.0)

r_space = collect(range(0.0, 2.0, length = 15))
computeparams = (Δr = r_space[2],
    r_space = r_space,
    countorderapprox = 2)
parameters = (prior = prior,
    compute = computeparams)

dudt = enclosethetimedifferential(parameters)
IC = ones(length(r_space) + 3)
odeprob = ODEProblem(dudt,
    IC,
    (0, 2.1),
    parameters.prior);
du0 = copy(odeprob.u0);
# Hardcoded sparsity pattern for 15 spatial points + 3 state variables (18x18 matrix)
# Previously computed using: Symbolics.jacobian_sparsity((du, u) -> dudt(du, u, parameters.prior, 0.0), du0, odeprob.u0)
# This avoids the dependency on Symbolics in tests
I = [1, 2, 16, 18, 1, 2, 3, 18, 2, 3, 4, 18, 3, 4, 5, 18, 4, 5, 6, 18, 5, 6, 7, 18, 6, 7, 8, 18, 7, 8, 9, 18, 8, 9, 10, 18, 9, 10, 11, 18, 10, 11, 12, 18, 11, 12, 13, 18, 12, 13, 14, 18, 13, 14, 15, 18, 14, 15, 17, 18, 1, 16, 17, 15, 17, 18, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 18]
J = [1, 1, 1, 1, 2, 2, 2, 2, 3, 3, 3, 3, 4, 4, 4, 4, 5, 5, 5, 5, 6, 6, 6, 6, 7, 7, 7, 7, 8, 8, 8, 8, 9, 9, 9, 9, 10, 10, 10, 10, 11, 11, 11, 11, 12, 12, 12, 12, 13, 13, 13, 13, 14, 14, 14, 14, 15, 15, 15, 15, 16, 16, 16, 17, 17, 17, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18]
jac_sparsity = sparse(I, J, ones(Bool, length(I)), 18, 18);
f = ODEFunction(dudt;
    jac_prototype = float.(jac_sparsity));
sparseodeprob = ODEProblem(f,
    odeprob.u0,
    (0, 2.1),
    parameters.prior);

solve(odeprob, TRBDF2());
solve(sparseodeprob, TRBDF2());
solve(sparseodeprob, Rosenbrock23(linsolve = KLUFactorization()));
solve(sparseodeprob, KenCarp47(linsolve = KrylovJL_GMRES()));

using OrdinaryDiffEq, Test
f(u, p, t) = 2 * u
u_positive(u, t, integrator) = u > 0
terminate_if_u_pos = DiscreteCallback(u_positive, terminate!)

prob = ODEProblem(f, 1.0, (0.0, 1.0)) # positive initial condition > positive u > ReturnCode.Terminated
integrator = init(prob, Tsit5(), callback = terminate_if_u_pos)
sol1 = solve!(integrator)
@test sol1.retcode == ReturnCode.Terminated

reinit!(integrator, -1.0) # negative initial condition > negative u > Success!
sol2 = solve!(integrator)
@test sol2.retcode == ReturnCode.Success

prob = ODEProblem(f, -1.0, (0.0, 1.0)) # negative initial condition > negative u > Success!
integrator = init(prob, Tsit5(), callback = terminate_if_u_pos)
sol3 = solve!(integrator)
@test sol3.retcode == ReturnCode.Success

# https://github.com/SciML/DifferentialEquations.jl/issues/904
f(u, p, t) = -u
prob = ODEProblem(f, 1.0, (0.0, 1.0), save_on = false, save_start = false)
int = init(prob, Tsit5())

reinit!(int, 0.0)
solve!(int)

using OrdinaryDiffEq, StaticArrays, Test

function dudt!(du, σ, p, t)
    du .= -σ
end

η0 = 1
τ = 1
α = 0.8
p_giesekus = [η0, τ, α]

## Exercise code paths that are in-place but not `<:Array` but not AbstractVector
σ0 = SizedMatrix{3, 3}([1.0 0.0 0.0; 0.0 2.0 0.0; 3.0 0.0 0.0])

prob_giesekus = ODEProblem(dudt!, σ0, (0.0, 2.0), p_giesekus)

solve_giesekus = solve(prob_giesekus, Rodas4(), saveat = 0.2, abstol = 1e-14,
    reltol = 1e-14)
for alg in [
    Rosenbrock23(),
    Rodas4(),
    Rodas4P(),
    Rodas5(),
    Rodas5P(),
    Tsit5(),
    Vern6(),
    Vern7(),
    Vern8(),
    Vern9(),
    DP5()
]
    sol = solve(prob_giesekus, alg, saveat = 0.2, abstol = 1e-14, reltol = 1e-14)
    @test Array(sol) ≈ Array(solve_giesekus)
end

using OrdinaryDiffEq, RecursiveArrayTools, Unitful
using LinearAlgebra, Test, ADTypes

@testset "Algorithms" begin
    algs = [
        Euler(), Midpoint(), Heun(), Ralston(), RK4(), SSPRK104(), SSPRK22(), SSPRK33(),
        SSPRK43(), SSPRK432(), BS3(), BS5(), DP5(), DP8(), Feagin10(), Feagin12(),
        Feagin14(), TanYam7(), Tsit5(), TsitPap8(), Vern6(), Vern7(), Vern8(), Vern9()]

    @testset "Scalar units" begin
        f(y, p, t) = 0.5 * y / 3.0u"s"
        u0 = 1.0u"N"
        prob = ODEProblem(f, u0, (0.0u"s", 1.0u"s"))

        for alg in algs
            @show alg
            sol = solve(prob, alg, dt = 1u"s" / 10)
        end

        sol = solve(prob, ExplicitRK())
    end

    @testset "2D units" begin
        f(dy, y, p, t) = (dy .= 0.5 .* y ./ 3.0u"s")
        u0 = [1.0u"N" 2.0u"N"
              3.0u"N" 1.0u"N"]
        prob = ODEProblem(f, u0, (0.0u"s", 1.0u"s"))

        for alg in algs
            @show alg
            sol = solve(prob, alg, dt = 1u"s" / 10)
        end

        sol = solve(prob, ExplicitRK())
    end
end

@testset "Mixed units" begin
    @testset "With ArrayPartition" begin
        r0 = [1131.340, -2282.343, 6672.423]u"km"
        v0 = [-5.64305, 4.30333, 2.42879]u"km/s"
        Δt = 86400.0 * 365u"s"
        μ = 398600.4418u"km^3/s^2"
        rv0 = ArrayPartition(r0, v0)

        function f(dy, y, μ, t)
            r = norm(y.x[1])
            dy.x[1] .= y.x[2]
            dy.x[2] .= -μ .* y.x[1] / r^3
        end

        prob = ODEProblem(f, rv0, (0.0u"s", 1.0u"s"), μ)
        for alg in [Tsit5()]
            @show alg
            sol = solve(prob, alg)
        end

        for alg in [AutoVern6(Rodas5(autodiff = AutoFiniteDiff())),
            AutoVern7(Rodas5(autodiff = AutoFiniteDiff())),
            AutoVern8(Rodas5(autodiff = AutoFiniteDiff())),
            AutoVern9(Rodas5(autodiff = AutoFiniteDiff()))]
            @show alg
            @test_broken sol = solve(prob, alg)
        end
    end

    @testset "Without ArrayPartition" begin
        # coordinate: u = [position, momentum]
        # parameters: p = [mass, force constant]
        function f_harmonic!(du, u, p, t)
            du[1] = u[2] / p[1]
            du[2] = -p[2] * u[1]
        end

        mass = 1.0u"kg"
        k = 1.0u"N/m"
        p = [mass, k]

        u0 = [1.0u"m", 0.0u"kg*m/s"] # initial values (position, momentum)
        tspan = (0.0u"s", 10.0u"s")
        prob = ODEProblem(f_harmonic!, u0, tspan, p)
        @test solve(prob, Tsit5()).retcode == ReturnCode.Success
    end

    @testset "Unitful time with unitless state" begin
        using OrdinaryDiffEq, Unitful
        u0 = 30.0
        tspan = (0.0u"s", 10.0u"s")
        prob1 = ODEProblem((du, u, t, p) -> (du[1] = -0.2u"1/s" * u[1]), [u0], tspan)
        prob2 = ODEProblem((u, t, p) -> (-0.2u"1/s" * u[1]), u0, tspan)
        prob3 = ODEProblem((u, t, p) -> [-0.2u"1/s" * u[1]], [u0], tspan)
        for prob in [prob1, prob2, prob3]
            @test solve(prob, Tsit5()).retcode == ReturnCode.Success
        end
    end
end

using OrdinaryDiffEq, Test, Statistics
import ODEProblemLibrary: prob_ode_2Dlinear
prob = deepcopy(prob_ode_2Dlinear)
prob2 = ODEProblem(prob.f, prob.u0, (1.0, 0.0), 1.01)

sol = solve(prob2, DP5(), dt = -1 / 4, tstops = [0.5])
@test sol.t == [1.0, 0.75, 0.5, 0]

sol = solve(prob2, RK4(), dt = -1 / 4, adaptive = false)
@test sol.t == [1.00, 0.75, 0.5, 0.25, 0]

sol = solve(prob2, RK4(), dt = -1 / 4, tstops = [0.5, 0.33], adaptive = false)
@test sol.t ≈ [1.00, 0.75, 0.5, 0.33, 0.08, 0]

using Test
using OrdinaryDiffEq
using LinearAlgebra, LinearSolve

import OrdinaryDiffEqCore.dolinsolve

n = 8
dt = 1 / 1000
u0 = ones(n)
tspan = (0.0, 1.0)

M1 = 2ones(n) |> Diagonal #|> Array
M2 = 2ones(n) |> Diagonal #|> Array

f1 = (du, u, p, t) -> du .= M1 * u
f2 = (du, u, p, t) -> du .= M2 * u
prob = SplitODEProblem(f1, f2, u0, tspan)

for algname in (:SBDF2,
    :SBDF3,
    :KenCarp47)
    @testset "$algname" begin
        alg0 = @eval $algname()
        alg1 = @eval $algname(linsolve = LUFactorization())

        kwargs = (dt = dt,)

        solve(prob, alg0; kwargs...)
        @test SciMLBase.__solve(prob, alg0; kwargs...).retcode == ReturnCode.Success
        @test SciMLBase.__solve(prob, alg1; kwargs...).retcode == ReturnCode.Success
    end
end

f1 = M1 |> MatrixOperator
f2 = M2 |> MatrixOperator
prob = SplitODEProblem(f1, f2, u0, tspan)

for algname in (:SBDF2,
    :SBDF3,
    :KenCarp47)
    @testset "$algname" begin
        alg0 = @eval $algname()

        kwargs = (dt = dt,)

        solve(prob, alg0; kwargs...)
        @test SciMLBase.__solve(prob, alg0; kwargs...).retcode == ReturnCode.Success
    end
end

###
# custom linsolve function
###

function linsolve(A, b, u, p, newA, Pl, Pr, solverdata; kwargs...)
    # avoid preconditioner monkeybusiness
    prob = LinearProblem(A, b; u0 = u)
    solve(prob, nothing)
    return u
end

alg = KenCarp47(linsolve = LinearSolveFunction(linsolve))

@test solve(prob, alg).retcode == ReturnCode.Success

using Markdown
function first_steps(name, solver)
    return Markdown.parse(
        """## Installation
        To be able to access the solvers in `$name`, you must first install them use the Julia package manager:

        ```julia
        using Pkg
        Pkg.add("$name")
        ```
        This will only install the solvers listed at the bottom of this page.
        If you want to explore other solvers for your problem,
        you will need to install some of the other libraries listed in the navigation bar on the left.

        ## Example usage

        ```julia
        using $name

        function lorenz!(du, u, p, t)
            du[1] = 10.0 * (u[2] - u[1])
            du[2] = u[1] * (28.0 - u[3]) - u[2]
            du[3] = u[1] * u[2] - (8 / 3) * u[3]
        end
        u0 = [1.0; 0.0; 0.0]
        tspan = (0.0, 100.0)
        prob = ODEProblem(lorenz!, u0, tspan)
        sol = solve(prob, $solver())
        ```"""
    )
end

using ModelingToolkit
using ModelingToolkit: t_nounits as t, D_nounits as D
using NonlinearSolve, OrdinaryDiffEqBDF, OrdinaryDiffEqSDIRK, DiffEqDevTools
using OrdinaryDiffEqNonlinearSolve: NonlinearSolveAlg
using Test

@parameters k₁ k₂ k₃
@variables y₁(t) y₂(t) y₃(t)

eqs = [D(y₁) ~ -k₁ * y₁ + k₃ * y₂ * y₃,
    D(y₂) ~ k₁ * y₁ - k₂ * y₂^2 - k₃ * y₂ * y₃,
    D(y₃) ~ k₂ * y₂^2]
@mtkcompile rober = ODESystem(eqs, t)
prob = ODEProblem(rober, [[y₁, y₂, y₃] .=> [1.0; 0.0; 0.0]; [k₁, k₂, k₃] .=> (0.04, 3e7, 1e4)], (0.0, 1e5), jac = true)
prob2 = ODEProblem(rober, [[y₁, y₂, y₃] .=> [1.0; 0.0; 0.0]; [k₁, k₂, k₃] .=> (0.04, 3e7, 1e4)], (0.0, 1e5), jac = true, nlstep = true)

@test prob2.f.nlstep_data !== nothing

nlalg = NonlinearSolveAlg(NewtonRaphson(autodiff = AutoFiniteDiff()));
nlalgrobust = NonlinearSolveAlg(TrustRegion(autodiff = AutoFiniteDiff()));
sol1 = solve(prob, FBDF(autodiff=AutoFiniteDiff(), nlsolve = nlalg));
sol2 = solve(prob2, FBDF(autodiff=AutoFiniteDiff(), nlsolve = nlalg));

@test sol1.t != sol2.t
@test sol1 != sol2
@test sol1(sol1.t) ≈ sol2(sol1.t) atol=1e-3

sol1 = solve(prob, TRBDF2(autodiff=AutoFiniteDiff(), nlsolve = nlalg));
sol2 = solve(prob2, TRBDF2(autodiff=AutoFiniteDiff(), nlsolve = nlalg));

@test sol1.t != sol2.t
@test sol1.u != sol2.u
@test sol1(sol1.t) ≈ sol2(sol1.t) atol=1e-3

testprob = ODEProblem(rober, [[y₁, y₂, y₃] .=> [1.0; 0.0; 0.0]; [k₁, k₂, k₃] .=> (0.04, 3e7, 1e4)], (0.0, 1.0), nlstep = true)
@test testprob.f.nlstep_data !== nothing
sol2 = solve(testprob, TRBDF2(autodiff=AutoFiniteDiff(), nlsolve = nlalg), adaptive=false, dt= 2.0^-15);

test_setup = Dict(:alg => FBDF(), :reltol => 1e-14, :abstol => 1e-14)
dts = 2.0 .^ (-10:-1:-15)
sim = analyticless_test_convergence(dts, testprob, TRBDF2(autodiff=AutoFiniteDiff(), nlsolve = nlalgrobust), test_setup);
@test_broken abs(sim.𝒪est[:l∞] - 2) < 0.2

dts = 2.0 .^ (-10:-1:-12)
sim = analyticless_test_convergence(dts, testprob, KenCarp4(autodiff=AutoFiniteDiff(), nlsolve = nlalgrobust), test_setup);
@test_broken abs(sim.𝒪est[:l∞] - 4) < 0.2

dts = 2.0 .^ (-12:-1:-15)
sim = analyticless_test_convergence(dts, testprob, ABDF2(autodiff=AutoFiniteDiff(), nlsolve = nlalgrobust), test_setup);
@test abs(sim.𝒪est[:l∞] - 2) < 0.2

dts = 2.0 .^ (-13:-1:-16)
sim = analyticless_test_convergence(dts, testprob, QNDF2(autodiff=AutoFiniteDiff(), nlsolve = nlalgrobust), test_setup);
@test_broken abs(sim.𝒪est[:l∞] - 2.5) < 0.2 # Superconvergence

dts = 2.0 .^ (-15:-1:-18)
sim = analyticless_test_convergence(dts, testprob, FBDF(autodiff=AutoFiniteDiff(), nlsolve = nlalgrobust), test_setup);
@test abs(sim.𝒪est[:l∞] - 1) < 0.3 # Only first order because adaptive order starts with Euler!

eqs_nonaut = [D(y₁) ~ -k₁ * y₁ + (t+1) * k₃ * y₂ * y₃,
    D(y₂) ~ k₁ * y₁ - (t+1) * k₂ * y₂^2 - (t+1) * k₃ * y₂ * y₃,
    D(y₃) ~ (t+1) * k₂ * y₂^2]
@mtkcompile rober_nonaut = ODESystem(eqs_nonaut, t)
prob = ODEProblem(rober_nonaut, [[y₁, y₂, y₃] .=> [1.0; 0.0; 0.0]; [k₁, k₂, k₃] .=> (0.04, 3e7, 1e4)], (0.0, 1e5), jac = true)
prob2 = ODEProblem(rober_nonaut, [[y₁, y₂, y₃] .=> [1.0; 0.0; 0.0]; [k₁, k₂, k₃] .=> (0.04, 3e7, 1e4)], (0.0, 1e5), jac = true, nlstep = true)

sol1 = solve(prob, FBDF(autodiff=AutoFiniteDiff(), nlsolve = nlalg));
sol2 = solve(prob2, FBDF(autodiff=AutoFiniteDiff(), nlsolve = nlalg));

@test sol1.t != sol2.t
@test sol1.u != sol2.u
@test sol1(sol1.t) ≈ sol2(sol1.t) atol=1e-3

sol1 = solve(prob, TRBDF2(autodiff=AutoFiniteDiff(), nlsolve = nlalg));
sol2 = solve(prob2, TRBDF2(autodiff=AutoFiniteDiff(), nlsolve = nlalg));

@test sol1.t != sol2.t
@test sol1 != sol2
@test sol1(sol1.t) ≈ sol2(sol1.t) atol=1e-4

testprob = ODEProblem(rober_nonaut, [[y₁, y₂, y₃] .=> [1.0; 0.0; 0.0]; [k₁, k₂, k₃] .=> (0.04, 3e7, 1e4)], (0.0, 1.0), nlstep = true)
@test testprob.f.nlstep_data !== nothing
sol2 = solve(testprob, TRBDF2(autodiff=AutoFiniteDiff(), nlsolve = nlalg), adaptive=false, dt= 2.0^-15)

test_setup = Dict(:alg => FBDF(), :reltol => 1e-14, :abstol => 1e-14)
dts = 2.0 .^ (-10:-1:-15)
sim = analyticless_test_convergence(dts, testprob, TRBDF2(autodiff=AutoFiniteDiff(), nlsolve = nlalgrobust), test_setup);
@test_broken abs(sim.𝒪est[:l∞] - 2) < 0.2

dts = 2.0 .^ (-10:-1:-12)
sim = analyticless_test_convergence(dts, testprob, KenCarp4(autodiff=AutoFiniteDiff(), nlsolve = nlalgrobust), test_setup);
@test_broken abs(sim.𝒪est[:l∞] - 4) < 0.2

dts = 2.0 .^ (-12:-1:-15)
sim = analyticless_test_convergence(dts, testprob, ABDF2(autodiff=AutoFiniteDiff(), nlsolve = nlalgrobust), test_setup);
@test abs(sim.𝒪est[:l∞] - 2) < 0.2

dts = 2.0 .^ (-13:-1:-16)
sim = analyticless_test_convergence(dts, testprob, QNDF2(autodiff=AutoFiniteDiff(), nlsolve = nlalgrobust), test_setup);
@test_broken abs(sim.𝒪est[:l∞] - 2.5) < 0.2 # Superconvergence

dts = 2.0 .^ (-15:-1:-18)
sim = analyticless_test_convergence(dts, testprob, FBDF(autodiff=AutoFiniteDiff(), nlsolve = nlalgrobust), test_setup);
@test abs(sim.𝒪est[:l∞] - 1) < 0.35 # Only first order because adaptive order starts with Euler!

using OrdinaryDiffEq, Test
import ODEProblemLibrary: prob_ode_linear, prob_ode_2Dlinear

vecarrzero(m::Integer, n) = map(t -> zeros(n), 1:m)

algs_ODE = zip([Tsit5(), Tsit5(), ABM54(), AutoTsit5(Rosenbrock23())],
    [Dict(), Dict(:dense => false), Dict(:dt => 0.1), Dict()],
    ["(normal)", "(not dense)", "(fixed-step)", "(CompositeAlgorithm)"])

tt = 0:0.05:1
ntt = length(tt)
out_VF = zeros(ntt)                                     # Vector{Float64}
out_VVF_1 = vecarrzero(ntt, 1)                           # Vector{Vector{Float64}}
out_VVF_2 = vecarrzero(ntt, 2)                           # Vector{Vector{Float64}}
out_VMF = vecarrzero(ntt, size(prob_ode_2Dlinear.u0))   # Vector{Matrix{Float64}}

@testset verbose=true "ODESolution interpolation $str" for (alg, kwargs, str) in algs_ODE
    sol_ODE = solve(prob_ode_linear, alg; kwargs...)
    sol_ODE_2D = solve(prob_ode_2Dlinear, alg; kwargs...)

    sol_ODE_interp = @inferred sol_ODE(tt)
    sol_ODE_2D_interp = @inferred sol_ODE_2D(tt)

    @testset "1D" begin
        @test_throws Union{MethodError, BoundsError} sol_ODE(out_VF, tt; idxs = 1:1)
        @inferred Vector{Float64} sol_ODE(out_VF, tt)
        @inferred Vector{Vector{Float64}} sol_ODE(out_VVF_1, tt)
        @test sol_ODE_interp.u ≈ out_VF
    end

    @testset "2D" begin
        @test_throws Union{MethodError, BoundsError} sol_ODE_2D(out_VF, tt; idxs = 3:3)
        @inferred Vector{Float64} sol_ODE_2D(out_VF, tt; idxs = 3)
        @inferred Vector{Vector{Float64}} sol_ODE_2D(out_VVF_1, tt; idxs = 3)
        @inferred Vector{Vector{Float64}} sol_ODE_2D(out_VVF_1, tt; idxs = 3:3)
        @inferred Vector{Vector{Float64}} sol_ODE_2D(out_VVF_2, tt; idxs = 2:3)
        @inferred Vector{Matrix{Float64}} sol_ODE_2D(out_VMF, tt)
        @test sol_ODE_2D_interp.u ≈ out_VMF
    end
end

using OrdinaryDiffEq, LinearSolve, Test, IncompleteLU, ModelingToolkit
import AlgebraicMultigrid

# Required due to https://github.com/JuliaSmoothOptimizers/Krylov.jl/pull/477
Base.eltype(::IncompleteLU.ILUFactorization{Tv, Ti}) where {Tv, Ti} = Tv
Base.eltype(::AlgebraicMultigrid.Preconditioner) = Float64

const N = 32
const xyd_brusselator = range(0, stop = 1, length = N)
brusselator_f(x, y, t) = (((x - 0.3)^2 + (y - 0.6)^2) <= 0.1^2) * (t >= 1.1) * 5.0
limit(a, N) = a == N + 1 ? 1 : a == 0 ? N : a

const iter = Ref(0)
function brusselator_2d_loop(du, u, p, t)
    global iter[] += 1
    A, B, alpha, dx = p
    alpha = alpha / dx^2
    @inbounds for I in CartesianIndices((N, N))
        i, j = Tuple(I)
        x, y = xyd_brusselator[I[1]], xyd_brusselator[I[2]]
        ip1, im1, jp1, jm1 = limit(i + 1, N), limit(i - 1, N), limit(j + 1, N),
        limit(j - 1, N)
        du[i, j, 1] = alpha * (u[im1, j, 1] + u[ip1, j, 1] + u[i, jp1, 1] + u[i, jm1, 1] - 4u[i, j, 1]) + B + u[i, j, 1]^2 * u[i, j, 2] - (A + 1) * u[i, j, 1] + brusselator_f(x, y, t)
        du[i, j, 2] = alpha * (u[im1, j, 2] + u[ip1, j, 2] + u[i, jp1, 2] + u[i, jm1, 2] - 4u[i, j, 2]) + A * u[i, j, 1] - u[i, j, 1]^2 * u[i, j, 2]
    end
    nothing
end
p = (3.4, 1.0, 10.0, step(xyd_brusselator))

function init_brusselator_2d(xyd)
    N = length(xyd)
    u = zeros(N, N, 2)
    for I in CartesianIndices((N, N))
        x = xyd[I[1]]
        y = xyd[I[2]]
        u[I, 1] = 22 * (y * (1 - y))^(3 / 2)
        u[I, 2] = 27 * (x * (1 - x))^(3 / 2)
    end
    u
end
u0 = init_brusselator_2d(xyd_brusselator)
prob_ode_brusselator_2d = ODEProblem(brusselator_2d_loop, u0, (0.0, 11.5), p)

du0 = copy(u0)
jac = ModelingToolkit.Symbolics.jacobian_sparsity(
    (du, u) -> brusselator_2d_loop(du, u, p,
        0.0), du0,
    u0)

prob_ode_brusselator_2d_sparse = ODEProblem(
    ODEFunction(brusselator_2d_loop,
        jac_prototype = float.(jac)),
    u0, (0.0, 11.5), p)

function incompletelu(W, du, u, p, t, newW, Plprev, Prprev, solverdata)
    if newW === nothing || newW
        Pl = ilu(convert(AbstractMatrix, W), τ = 50.0)
    else
        Pl = Plprev
    end
    Pl, nothing
end

function algebraicmultigrid(W, du, u, p, t, newW, Plprev, Prprev, solverdata)
    if newW === nothing || newW
        Pl = AlgebraicMultigrid.aspreconditioner(AlgebraicMultigrid.ruge_stuben(convert(
            AbstractMatrix,
            W)))
    else
        Pl = Plprev
    end
    Pl, nothing
end

function algebraicmultigrid2(W, du, u, p, t, newW, Plprev, Prprev, solverdata)
    if newW === nothing || newW
        A = convert(AbstractMatrix, W)
        Pl = AlgebraicMultigrid.aspreconditioner(AlgebraicMultigrid.ruge_stuben(A,
            presmoother = AlgebraicMultigrid.Jacobi(rand(size(A,
                1))),
            postsmoother = AlgebraicMultigrid.Jacobi(rand(size(A,
                1)))))
    else
        Pl = Plprev
    end
    Pl, nothing
end

iter[] = 0
sol1 = solve(prob_ode_brusselator_2d, KenCarp47(linsolve = KrylovJL_GMRES()),
    save_everystep = false);
iter1 = iter[];
iter[] = 0;
sol2 = solve(prob_ode_brusselator_2d_sparse,
    KenCarp47(linsolve = KrylovJL_GMRES(), precs = incompletelu,
        concrete_jac = true), save_everystep = false);
iter2 = iter[];
iter[] = 0;
sol3 = solve(prob_ode_brusselator_2d_sparse,
    KenCarp47(linsolve = KrylovJL_GMRES(), precs = algebraicmultigrid,
        concrete_jac = true), save_everystep = false);
iter3 = iter[];
iter[] = 0;
sol4 = solve(prob_ode_brusselator_2d_sparse,
    KenCarp47(linsolve = KrylovJL_GMRES(), precs = algebraicmultigrid2,
        concrete_jac = true), save_everystep = false);
iter4 = iter[];
iter[] = 0;

@test sol1.retcode === ReturnCode.Success
@test sol2.retcode === ReturnCode.Success
@test sol3.retcode === ReturnCode.Success
@test sol4.retcode === ReturnCode.Success

@test iter2 < iter1
@test iter3 < iter1
@test iter4 < iter1

sol1 = solve(prob_ode_brusselator_2d, Rosenbrock23(linsolve = KrylovJL_GMRES()),
    save_everystep = false);
iter1 = iter[];
iter[] = 0;
sol2 = solve(prob_ode_brusselator_2d_sparse,
    Rosenbrock23(linsolve = KrylovJL_GMRES(), precs = incompletelu,
        concrete_jac = true), save_everystep = false);
iter2 = iter[];
iter[] = 0;
sol3 = solve(prob_ode_brusselator_2d_sparse,
    Rosenbrock23(linsolve = KrylovJL_GMRES(), precs = algebraicmultigrid,
        concrete_jac = true), save_everystep = false);
iter3 = iter[];
iter[] = 0;
sol4 = solve(prob_ode_brusselator_2d_sparse,
    Rosenbrock23(linsolve = KrylovJL_GMRES(), precs = algebraicmultigrid2,
        concrete_jac = true), save_everystep = false);
iter4 = iter[];
iter[] = 0;

@test sol1.retcode === ReturnCode.Success
@test sol2.retcode === ReturnCode.Success
@test sol3.retcode === ReturnCode.Success
@test sol4.retcode === ReturnCode.Success

@test iter2 < iter1
@test iter3 < iter1
@test iter4 < iter1

sol1 = solve(prob_ode_brusselator_2d, Rodas4(linsolve = KrylovJL_GMRES()),
    save_everystep = false);
iter1 = iter[];
iter[] = 0;
sol2 = solve(prob_ode_brusselator_2d_sparse,
    Rodas4(linsolve = KrylovJL_GMRES(), precs = incompletelu, concrete_jac = true),
    save_everystep = false);
iter2 = iter[];
iter[] = 0;
sol3 = solve(prob_ode_brusselator_2d_sparse,
    Rodas4(linsolve = KrylovJL_GMRES(), precs = algebraicmultigrid,
        concrete_jac = true), save_everystep = false);
iter3 = iter[];
iter[] = 0;
sol4 = solve(prob_ode_brusselator_2d_sparse,
    Rodas4(linsolve = KrylovJL_GMRES(), precs = algebraicmultigrid2,
        concrete_jac = true), save_everystep = false);
iter4 = iter[];
iter[] = 0;

@test sol1.retcode === ReturnCode.Success
@test sol2.retcode === ReturnCode.Success
@test sol3.retcode === ReturnCode.Success
@test sol4.retcode === ReturnCode.Success

@test iter2 < iter1
@test iter3 < iter1
@test iter4 < iter1

sol1 = solve(prob_ode_brusselator_2d, Rodas5(linsolve = KrylovJL_GMRES()),
    save_everystep = false);
iter1 = iter[];
iter[] = 0;
sol2 = solve(prob_ode_brusselator_2d_sparse,
    Rodas5(linsolve = KrylovJL_GMRES(), precs = incompletelu, concrete_jac = true),
    save_everystep = false);
iter2 = iter[];
iter[] = 0;
sol3 = solve(prob_ode_brusselator_2d_sparse,
    Rodas5(linsolve = KrylovJL_GMRES(), precs = algebraicmultigrid,
        concrete_jac = true), save_everystep = false);
iter3 = iter[];
iter[] = 0;
sol4 = solve(prob_ode_brusselator_2d_sparse,
    Rodas5(linsolve = KrylovJL_GMRES(), precs = algebraicmultigrid2,
        concrete_jac = true), save_everystep = false);
iter4 = iter[];
iter[] = 0;

@test sol1.retcode === ReturnCode.Success
@test sol2.retcode === ReturnCode.Success
@test sol3.retcode === ReturnCode.Success
@test sol4.retcode === ReturnCode.Success

@test iter2 < iter1
@test iter3 < iter1
@test iter4 < iter1

sol1 = solve(prob_ode_brusselator_2d, TRBDF2(linsolve = KrylovJL_GMRES()),
    save_everystep = false);
iter1 = iter[];
iter[] = 0;
sol2 = solve(prob_ode_brusselator_2d_sparse,
    TRBDF2(linsolve = KrylovJL_GMRES(), precs = incompletelu, concrete_jac = true),
    save_everystep = false);
iter2 = iter[];
iter[] = 0;
sol3 = solve(prob_ode_brusselator_2d_sparse,
    TRBDF2(linsolve = KrylovJL_GMRES(), precs = algebraicmultigrid,
        concrete_jac = true), save_everystep = false);
iter3 = iter[];
iter[] = 0;
sol4 = solve(prob_ode_brusselator_2d_sparse,
    TRBDF2(linsolve = KrylovJL_GMRES(), precs = algebraicmultigrid2,
        concrete_jac = true), save_everystep = false);
iter4 = iter[];
iter[] = 0;

@test sol1.retcode === ReturnCode.Success
@test sol2.retcode === ReturnCode.Success
@test sol3.retcode === ReturnCode.Success
@test sol4.retcode === ReturnCode.Success

@test iter2 < iter1
@test iter3 < iter1
@test iter4 < iter1

sol1 = solve(prob_ode_brusselator_2d, TRBDF2(linsolve = KrylovJL_GMRES()),
    save_everystep = false);
iter1 = iter[];
iter[] = 0;
sol2 = solve(prob_ode_brusselator_2d_sparse,
    TRBDF2(linsolve = KrylovJL_GMRES(), precs = incompletelu,
        concrete_jac = true), save_everystep = false);
iter2 = iter[];
iter[] = 0;
sol3 = solve(prob_ode_brusselator_2d_sparse,
    TRBDF2(linsolve = KrylovJL_GMRES(), precs = algebraicmultigrid,
        concrete_jac = true), save_everystep = false);
iter3 = iter[];
iter[] = 0;
sol4 = solve(prob_ode_brusselator_2d_sparse,
    TRBDF2(linsolve = KrylovJL_GMRES(), precs = algebraicmultigrid2,
        concrete_jac = true), save_everystep = false);
iter4 = iter[];
iter[] = 0;

@test sol1.retcode === ReturnCode.Success
@test sol2.retcode === ReturnCode.Success
@test sol3.retcode === ReturnCode.Success
@test sol4.retcode === ReturnCode.Success

@test iter2 < iter1
@test iter3 < iter1
@test iter4 < iter1

using OrdinaryDiffEq, Test, LinearAlgebra

T = 1000.0;
Ttr = 0.0;
d0 = 1e-9;
threshold = 10^4 * d0;
dt = 0.1;
diff_eq_kwargs = Dict();

@inbounds function eom_lorenz!(du, u, p, t)
    σ = 10.0
    ρ = 28.0
    β = 8 / 3
    du[1] = σ * (u[2] - u[1])
    du[2] = u[1] * (ρ - u[3]) - u[2]
    du[3] = u[1] * u[2] - β * u[3]
end

prob = ODEProblem(eom_lorenz!, [0.0, 10.0, 0], (zero(T), T))
integ1 = init(prob, Tsit5(); diff_eq_kwargs...)
@. prob.u0 = prob.u0 + d0 / sqrt(3)
integ2 = init(prob, Tsit5(); diff_eq_kwargs...)
integ1.opts.advance_to_tstop = true
integ2.opts.advance_to_tstop = true

dist = d0
λ = zero(eltype(integ1.u))
i = 0
tvector = dt:dt:T

for τ in tvector
    # evolve until rescaling:
    push!(integ1.opts.tstops, τ)
    step!(integ1)
    push!(integ2.opts.tstops, τ)
    step!(integ2)
    global dist = norm(integ1.u .- integ2.u)
    # Rescale:
    if dist ≥ threshold
        # Rescale and reset everything:
        integ2.u .= integ1.u #.+ (integ2.u .- integ1.u)./a
        u_modified!(integ2, true)
        set_proposed_dt!(integ2, integ1)
        break
    end
end

τ = tvector[end]
push!(integ1.opts.tstops, τ);
step!(integ1);
push!(integ2.opts.tstops, τ);
step!(integ2);
@test dist = norm(integ1.u .- integ2.u) == 0

using OrdinaryDiffEq, Test, Random
using OrdinaryDiffEqCore, OrdinaryDiffEqExplicitRK

Random.seed!(100)
setprecision(400)

f = (u, p, t) -> (2u)
#(::typeof(f))(::Type{Val{:analytic}},u0,p,t) = u0*exp(t)
prob = ODEProblem(f, 1 / 2, (0.0, 1.0))

sol3 = solve(prob, RK4(), dt = 1 / 2^(6), abstol = 1, reltol = 0)

prob = ODEProblem(f, BigInt(1) // BigInt(2),
    (BigInt(0) // BigInt(1), BigInt(1) // BigInt(1)))

integrator = init(prob, RK4(), dt = BigInt(1) // BigInt(2)^(6), abstol = 1, reltol = 0)

sol = solve(prob, RK4(), dt = BigInt(1) // BigInt(2)^(6), abstol = 1, reltol = 0)
sol2 = solve(prob, RK4(), dt = BigInt(1) / BigInt(2)^(6), abstol = 1, reltol = 0)

sol.u
sol2.u
sol3.u
@test eltype(sol.u) == Rational{BigInt}
@test eltype(sol2.u) == Rational{BigInt}
@test eltype(sol3.u) == Float64

sol4 = solve(prob, DP5(), dt = BigInt(1) // BigInt(2)^(3), adaptive = false)

@test eltype(sol4.u) == Rational{BigInt}

tabalg = ExplicitRK(tableau = OrdinaryDiffEqExplicitRK.constructDormandPrince(Rational{BigInt}))

integrator = init(prob, tabalg, dt = BigInt(1) // BigInt(2)^(3), abstol = 1, reltol = 0,
    adaptive = false)
sol5 = solve(prob, tabalg, dt = BigInt(1) // BigInt(2)^(3), abstol = 1, reltol = 0,
    adaptive = false)

@test typeof(sol5.u[end]) == Rational{BigInt}

prob = ODEProblem(f, 1 / 2 + 1 / 2im, (0.0, 1.0))

using OrdinaryDiffEq,
      RecursiveArrayTools, Test, StaticArrays, DiffEqCallbacks,
      SparseArrays,
      LinearAlgebra

f = function (u, p, t)
    -u + sin(-t)
end

prob = ODEProblem(f, 1.0, (0.0, -10.0))

condition = function (u, t, integrator) # Event when event_f(u,t,k) == 0
    -t - 2.95
end

affect! = function (integrator)
    integrator.u = integrator.u + 2
end

callback = ContinuousCallback(condition, affect!)

sol = solve(prob, Tsit5(), callback = callback)
@test length(sol) < 20

# Force integrator to step on event
sol = solve(prob, Tsit5(), callback = callback, tstops = [-2.95])
@test sol(-2.95, continuity = :right) ≈ sol(-2.95, continuity = :left) + 2

condition = function (out, u, t, integrator) # Event when event_f(u,t,k) == 0
    out[1] = -t - 2.95
end

affect! = function (integrator, idx)
    if idx == 1
        integrator.u = integrator.u + 2
    end
end

callback = VectorContinuousCallback(condition, affect!, 1)

sol = solve(prob, Tsit5(), callback = callback)

# Force integrator to step on event
sol = solve(prob, Tsit5(), callback = callback, tstops = [-2.95])
@test sol(-2.95, continuity = :right) ≈ sol(-2.95, continuity = :left) + 2

f = function (du, u, p, t)
    du[1] = -u[1] + sin(t)
end

prob = ODEProblem(f, [1.0], (0.0, 10.0))

condition = function (u, t, integrator) # Event when event_f(u,t,k) == 0
    t - 2.95
end

affect! = function (integrator)
    integrator.u = integrator.u .+ 2
end

callback = ContinuousCallback(condition, affect!)

sol = solve(prob, Tsit5(), callback = callback, abstol = 1e-8, reltol = 1e-6)

# Force integrator to step on event
sol = solve(prob, Tsit5(), callback = callback, abstol = 1e-8, reltol = 1e-6, tstops = [2.95])
@test sol(2.95, continuity = :right)[1] ≈ sol(2.95, continuity = :left)[1] + 2

condition = function (out, u, t, integrator) # Event when event_f(u,t,k) == 0
    out[1] = t - 2.95
end

affect! = function (integrator, idx)
    if idx == 1
        integrator.u = integrator.u .+ 2
    end
end

callback = VectorContinuousCallback(condition, affect!, 1)

sol = solve(prob, Tsit5(), callback = callback, abstol = 1e-8, reltol = 1e-6)

# Force integrator to step on event
sol = solve(prob, Tsit5(), callback = callback, abstol = 1e-8, reltol = 1e-6, tstops = [2.95])
@test sol(2.95, continuity = :right)[1] ≈ sol(2.95, continuity = :left)[1] + 2

f = function (du, u, p, t)
    du[1] = u[2]
    du[2] = -9.81
end

condition = function (u, t, integrator) # Event when event_f(u,t,k) == 0
    u[1]
end

affect! = nothing
affect_neg! = function (integrator)
    integrator.u[2] = -integrator.u[2]
end

callback = ContinuousCallback(condition, affect!, affect_neg!, interp_points = 100)

u0 = [50.0, 0.0]
tspan = (0.0, 15.0)
prob = ODEProblem(f, u0, tspan)

sol = solve(prob, Tsit5(), callback = callback, adaptive = false, dt = 1 / 4)

condition = function (out, u, t, integrator) # Event when event_f(u,t,k) == 0
    out[1] = u[1]
end

affect! = nothing
affect_neg! = function (integrator, idx)
    if idx == 1
        integrator.u[2] = -integrator.u[2]
    end
end

vcb = VectorContinuousCallback(condition, affect!, 1, interp_points = 100)

sol = solve(prob, Tsit5(), callback = vcb, adaptive = false, dt = 1 / 4)

condition_single = function (u, t, integrator) # Event when event_f(u,t,k) == 0
    u
end

affect! = nothing
affect_neg! = function (integrator)
    integrator.u[2] = -integrator.u[2]
end

callback_single = ContinuousCallback(condition_single, affect!, affect_neg!,
    interp_points = 100, idxs = 1)

u0 = [50.0, 0.0]
tspan = (0.0, 15.0)
prob = ODEProblem(f, u0, tspan)

sol = solve(prob, Tsit5(), callback = callback_single, adaptive = false, dt = 1 / 4)
sol = solve(prob, Tsit5(), callback = callback_single, save_everystep = false)
t = sol.t[end ÷ 2] # this is the callback time point
sol = solve(prob, Tsit5(), callback = callback_single, saveat = t)
@test count(x -> x == t, sol.t) == 2
sol = solve(prob, Tsit5(), callback = callback_single, saveat = t - eps(t))
@test count(x -> x == t, sol.t) == 2
# check interpolation @ discontinuity
@test sol(t, continuity = :right)[2] > 0
@test sol(t, continuity = :left)[2] < 0

#plot(sol,denseplot=true)

condition_single = function (out, u, t, integrator) # Event when event_f(u,t,k) == 0
    out[1] = u[1]
end

affect! = nothing
affect_neg! = function (integrator, idx)
    if idx == 1
        integrator.u[2] = -integrator.u[2]
    end
end

callback_single = VectorContinuousCallback(condition_single, affect!, affect_neg!, 1,
    interp_points = 100)

sol = solve(prob, Tsit5(), callback = callback_single, adaptive = false, dt = 1 / 4)
sol = solve(prob, Tsit5(), callback = callback_single, save_everystep = false)
t = sol.t[end ÷ 2] # this is the callback time point
sol = solve(prob, Tsit5(), callback = callback_single, saveat = t)
@test count(x -> x == t, sol.t) == 2
sol = solve(prob, Tsit5(), callback = callback_single, saveat = t - eps(t))
@test count(x -> x == t, sol.t) == 2
# check interpolation @ discontinuity
@test sol(t, continuity = :right)[2] > 0
@test sol(t, continuity = :left)[2] < 0

sol = solve(prob, Vern6(), callback = callback)
sol = solve(prob, Vern6(), callback = vcb)
#plot(sol,denseplot=true)
sol = solve(prob, BS3(), callback = vcb)
sol = solve(prob, BS3(), callback = callback)

sol33 = solve(prob, Vern7(), callback = callback)
sol33 = solve(prob, Vern7(), callback = vcb)

bounced = ODEProblem(f, sol[8], (0.0, 1.0))
sol_bounced = solve(bounced, Vern6(), callback = callback, dt = sol.t[9] - sol.t[8])
#plot(sol_bounced,denseplot=true)
sol_bounced(0.04) # Complete density
@test maximum(maximum.(map((i) -> sol.k[9][i] - sol_bounced.k[2][i],
    1:length(sol.k[9])))) ==
      0

sol2 = solve(prob, Vern6(), callback = callback, adaptive = false, dt = 1 / 2^4)
#plot(sol2)

sol2 = solve(prob, Vern6())

sol3 = solve(prob, Vern6(), saveat = [0.5])

## Saving callback

condition = function (u, t, integrator)
    true
end
affect! = function (integrator) end

save_positions = (true, false)
saving_callback = DiscreteCallback(condition, affect!, save_positions = save_positions)

sol4 = solve(prob, Tsit5(), callback = saving_callback)

@test sol2(3) ≈ sol(3)

affect! = function (integrator)
    u_modified!(integrator, false)
end
saving_callback2 = DiscreteCallback(condition, affect!, save_positions = save_positions)
sol4 = solve(prob, Tsit5(), callback = saving_callback2)

cbs = CallbackSet(saving_callback, saving_callback2)
sol4_extra = solve(prob, Tsit5(), callback = cbs)

@test length(sol4_extra) == 2length(sol4) - 1

condition = function (u, t, integrator)
    u[1]
end

vcondition = function (out, u, t, integrator)
    out[1] = u[1]
end

affect! = function (integrator, retcode = nothing)
    if retcode === nothing
        terminate!(integrator)
    else
        terminate!(integrator, retcode)
    end
end

vaffect! = function (integrator, idx, retcode = nothing)
    if idx == 1
        if retcode === nothing
            terminate!(integrator)
        else
            terminate!(integrator, retcode)
        end
    end
end

terminate_callback = ContinuousCallback(condition, affect!)
custom_retcode_callback = ContinuousCallback(condition,
    x -> affect!(x, ReturnCode.MaxIters))
vterminate_callback = VectorContinuousCallback(vcondition, vaffect!, 1)
vcustom_retcode_callback = VectorContinuousCallback(vcondition,
    (x, idx) -> vaffect!(x, idx,
        ReturnCode.MaxIters),
    1)

tspan2 = (0.0, Inf)
prob2 = ODEProblem(f, u0, tspan2)

sol5 = solve(prob2, Tsit5(), callback = terminate_callback)
sol5_1 = solve(prob2, Tsit5(), callback = custom_retcode_callback)

@test sol5.retcode == ReturnCode.Terminated
@test sol5_1.retcode == ReturnCode.MaxIters
@test sol5[end][1] < 3e-12
@test sol5.t[end] ≈ sqrt(50 * 2 / 9.81)

sol5 = solve(prob2, Tsit5(), callback = vterminate_callback)
sol5_1 = solve(prob2, Tsit5(), callback = vcustom_retcode_callback)

@test sol5.retcode == ReturnCode.Terminated
@test sol5_1.retcode == ReturnCode.MaxIters
@test sol5[end][1] < 3e-12
@test sol5.t[end] ≈ sqrt(50 * 2 / 9.81)

affect2! = function (integrator)
    if integrator.t >= 3.5
        terminate!(integrator)
    else
        integrator.u[2] = -integrator.u[2]
    end
end

vaffect2! = function (integrator, idx)
    if idx == 1
        if integrator.t >= 3.5
            terminate!(integrator)
        else
            integrator.u[2] = -integrator.u[2]
        end
    end
end

terminate_callback2 = ContinuousCallback(condition, nothing, affect2!, interp_points = 100)
vterminate_callback2 = VectorContinuousCallback(vcondition, nothing, vaffect2!, 1,
    interp_points = 100)

sol5 = solve(prob2, Vern7(), callback = terminate_callback2)

@test sol5[end][1] < 1.3e-10
@test sol5.t[end] ≈ 3 * sqrt(50 * 2 / 9.81)

sol5 = solve(prob2, Vern7(), callback = vterminate_callback2)

@test sol5[end][1] < 1.3e-10
@test sol5.t[end] ≈ 3 * sqrt(50 * 2 / 9.81)

condition = function (u, t, integrator) # Event when event_f(u,t,k) == 0
    t - 4
end

affect! = function (integrator)
    terminate!(integrator)
end

terminate_callback3 = ContinuousCallback(condition, affect!, interp_points = 1000)

bounce_then_exit = CallbackSet(callback, terminate_callback3)

sol6 = solve(prob2, Vern7(), callback = bounce_then_exit)

@test sol6[end][1] > 0
@test sol6[end][1] < 100
@test sol6.t[end] ≈ 4

# Test ContinuousCallback hits values on the steps
t_event = 100.0
f_simple(u, p, t) = 1.00001 * u
event_triggered = false
condition_simple(u, t, integrator) = t_event - t
function affect_simple!(integrator)
    global event_triggered
    event_triggered = true
end
cb = ContinuousCallback(condition_simple, nothing, affect_simple!)
prob = ODEProblem(f_simple, [1.0], (0.0, 2.0 * t_event))
sol = solve(prob, Tsit5(), callback = cb, adaptive = false, dt = 10.0)
@test event_triggered

# https://github.com/JuliaDiffEq/OrdinaryDiffEq.jl/issues/328
ode = ODEProblem((du, u, p, t) -> (@. du .= -u), ones(5), (0.0, 100.0))
sol = solve(ode, AutoTsit5(Rosenbrock23()), callback = TerminateSteadyState())
sol1 = solve(ode, Tsit5(), callback = TerminateSteadyState())
@test sol.u == sol1.u

# DiscreteCallback
f = function (du, u, p, t)
    du[1] = -0.5 * u[1] + 10
    du[2] = -0.5 * u[2]
end

u0 = [10, 10.0]
tstop = [5.0; 8.0]
prob = ODEProblem(f, u0, (0, 10.0))
condition = (u, t, integrator) -> t in tstop
affect! = (integrator) -> integrator.u .= 1.0
save_positions = (true, true)
cb = DiscreteCallback(condition, affect!, save_positions = save_positions)
sol1 = solve(prob, Tsit5(), callback = cb, tstops = tstop, saveat = tstop)
@test count(x -> x == tstop[1], sol1.t) == 2
@test count(x -> x == tstop[2], sol1.t) == 2
sol2 = solve(prob, Tsit5(), callback = cb, tstops = tstop, saveat = prevfloat.(tstop))
@test count(x -> x == tstop[1], sol2.t) == 2
@test count(x -> x == tstop[2], sol2.t) == 2

# check VectorContinuousCallback works for complex valued solutions
# see issue #1222
f = (u, p, t) -> -1.0im * u
prob = ODEProblem(f, complex([1.0]), (0.0, 1.0))
condition = function (out, u, t, integrator)
    out[1] = t - 0.5
end
n = 0
affect! = function (integrator, event_index)
    global n
    n += 1
end
callback = VectorContinuousCallback(condition, affect!, 1)
sol = solve(prob, Tsit5(), callback = callback)
@test n == 1

# case of immutable partitioned state
f = function (u, p, t)
    ArrayPartition(SVector{1}(u[2]), SVector{1}(-9.81))
end

condition = function (u, t, integrator) # Event when event_f(u,t,k) == 0
    u[1]
end

affect! = nothingf = affect_neg! = function (integrator)
    integrator.u = ArrayPartition(SVector{1}(integrator.u[1]), SVector{1}(-integrator.u[2]))
end

callback = ContinuousCallback(condition, affect!, affect_neg!, interp_points = 100)

u0 = ArrayPartition(SVector{1}(50.0), SVector{1}(0.0))
tspan = (0.0, 15.0)
prob = ODEProblem(f, u0, tspan)

sol = solve(prob, Tsit5(), callback = callback, adaptive = false, dt = 1 / 4)

# check that multiple discrete callbacks with save_everystep do not double save
# https://github.com/SciML/DifferentialEquations.jl/issues/711

prob = ODEProblem((u, p, t) -> 1.01u, [1.0], (0.0, 10.0))
savecond1(u, t, integrator) = t == 2.5
savecond2(u, t, integrator) = t == 2.5
saveaffect1!(integrator) = nothing
saveaffect2!(integrator) = nothing
cb1 = DiscreteCallback(savecond1, saveaffect1!, save_positions = (false, false))
cb2 = DiscreteCallback(savecond2, saveaffect2!, save_positions = (false, false))
cb = CallbackSet(cb1, cb2)
sol = solve(prob, Tsit5(), callback = cb, tstops = [2.5])
@test !any(diff(sol.t) .== 0)

# DifferentialEquations 848
prob = ODEProblem((x, p, t) -> -1.01 * x, ones(2), (0.0, 1.0))
integrator = init(prob, Tsit5(), save_everystep = false)
set_u!(integrator, 2 * ones(2))
step!(integrator, 1e-5, true)
@test all(u -> u > 1.5, integrator.u)

# https://github.com/SciML/OrdinaryDiffEq.jl/pull/1777
@testset "Callbacks with LinearExponential" begin
    A = Matrix(sprand(ComplexF64, 100, 100, 0.5))
    A += A'

    t_l = LinRange(0, 1, 100)

    saved_values = SavedValues(Float64, Float64)
    function save_func(u, t, integrator)
        real(u' * A * u)
    end
    cb = SavingCallback(save_func, saved_values, saveat = t_l)

    u0 = normalize(rand(ComplexF64, 100))
    A = MatrixOperator(-1im * A)
    prob = ODEProblem(A, u0, (0, 1.0))
    solve(prob, LinearExponential(), dt = t_l[2] - t_l[1], callback = cb)
    @test length(saved_values.saveval) == length(t_l)
end

using OrdinaryDiffEq, Test
import ODEProblemLibrary: prob_ode_linear, prob_ode_2Dlinear

prob_forward = prob_ode_linear
prob_reverse = remake(prob_forward, tspan = (1.0, 0.0))

for prob in [prob_forward, prob_reverse]
    tdir = sign(prob.tspan[2] - prob.tspan[1])

    sol = solve(prob, DP5(), dt = 1 // 2^(2), save_everystep = false)
    sol2 = solve(prob, DP5(), dt = 1 // 2^(2), save_everystep = false, saveat = [1 / 2])

    @test sort!(symdiff(sol.t, sol2.t)) == [0.0, 1 / 2, 1.0]

    sol2 = solve(prob, DP5(), dt = 1 // 2^(2), save_everystep = false,
        saveat = [0.0, 1 / 2, 1.0])

    @test symdiff(sol.t, sol2.t) == [1 / 2]

    sol2 = solve(prob, DP5(), dt = 1 // 2^(2), save_everystep = false, saveat = 1 / 2)

    @test sort!(symdiff(sol.t, sol2.t)) == [1 / 2]

    sol3 = solve(prob, DP5(), dt = 1 // 2^(2), save_everystep = false, saveat = [1 / 2],
        tstops = [1 / 2])

    @test sol3.t == [1 / 2]

    sol3 = solve(prob, DP5(), dt = 1 // 2^(2), saveat = [0.0, 1 / 2, 1.0], tstops = [1 / 2])

    @test tdir > 0 ? sol3.t == [0.0, 1 / 2, 1.0] : sol3.t == [1.0, 1 / 2, 0.0]

    sol3 = solve(prob, DP5(), dt = 1 // 2^(2), saveat = 1 / 10, tstops = [1 / 2])

    @show tdir > 0
    @test tdir > 0 ? sol3.t == collect(0.0:0.1:1.00) : sol3.t == collect(1.0:-0.1:0.00)
end

sol = solve(prob_forward, RK4(), dt = 1 / 2^(2), save_everystep = true, adaptive = false)
sol2 = solve(prob_forward, RK4(), dt = 1 / 2^(2), save_everystep = true, adaptive = false,
    saveat = [0.125, 0.6, 0.61, 0.8])
@test sol.retcode == sol2.retcode == ReturnCode.Success
@test symdiff(sol.t, sol2.t) == [0.125, 0.6, 0.61, 0.8]

sol = solve(prob_forward, Rosenbrock32(), dt = 1 / 2^(2), save_everystep = true)
sol2 = solve(prob_forward, Rosenbrock32(), dt = 1 / 2^(2), save_everystep = true,
    saveat = [0.125, 0.6, 0.61, 0.8])

@test sol.retcode == sol2.retcode == ReturnCode.Success
@test symdiff(sol.t, sol2.t) == [0.125, 0.6, 0.61, 0.8]

sol = solve(prob_forward, Trapezoid(), dt = 1 / 2^(2), save_everystep = true)
sol2 = solve(prob_forward, Trapezoid(), dt = 1 / 2^(2), save_everystep = true,
    saveat = [0.125, 0.6, 0.61, 0.8])

@test sol.retcode == sol2.retcode == ReturnCode.Success
@test symdiff(sol.t, sol2.t) == [0.125, 0.6, 0.61, 0.8]

sol = solve(prob_reverse, RK4(), dt = 1 / 2^(2), save_everystep = true, adaptive = false)
sol2 = solve(prob_reverse, RK4(), dt = 1 / 2^(2), save_everystep = true, adaptive = false,
    saveat = [0.8, 0.61, 0.6, 0.125])

@test sol.retcode == sol2.retcode == ReturnCode.Success
@test symdiff(sol.t, sol2.t) == [0.8, 0.61, 0.6, 0.125]

sol = solve(prob_reverse, Rosenbrock32(), dt = 1 / 2^(2), save_everystep = true)
sol2 = solve(prob_reverse, Rosenbrock32(), dt = 1 / 2^(2), save_everystep = true,
    saveat = [0.8, 0.61, 0.6, 0.125])

@test sol.retcode == sol2.retcode == ReturnCode.Success
@test symdiff(sol.t, sol2.t) == [0.8, 0.61, 0.6, 0.125]

sol = solve(prob_reverse, Trapezoid(), dt = 1 / 2^(2), save_everystep = true)
sol2 = solve(prob_reverse, Trapezoid(), dt = 1 / 2^(2), save_everystep = true,
    saveat = [0.8, 0.61, 0.6, 0.125])

@test sol.retcode == sol2.retcode == ReturnCode.Success
@test symdiff(sol.t, sol2.t) == [0.8, 0.61, 0.6, 0.125]

prob = prob_ode_2Dlinear

sol = solve(prob, DP5(), dt = 1 // 2^(2), save_everystep = true)
sol2 = solve(prob, DP5(), dt = 1 // 2^(2), save_everystep = true,
    saveat = [0.0, 1 / 2, 1.0])

@test sol.retcode == sol2.retcode == ReturnCode.Success
@test symdiff(sol.t, sol2.t) == [1 / 2]

sol = solve(prob, RK4(), dt = 1 / 2^(2), save_everystep = true, adaptive = false)
sol2 = solve(prob, RK4(), dt = 1 / 2^(2), save_everystep = true, adaptive = false,
    saveat = [0.0, 0.125, 0.6, 0.61, 0.8, 1.0])

@test sol.retcode == sol2.retcode == ReturnCode.Success
@test symdiff(sol.t, sol2.t) == [0.125, 0.6, 0.61, 0.8]

sol = solve(prob, Rosenbrock32(), dt = 1 / 2^(2), save_everystep = true)
sol2 = solve(prob, Rosenbrock32(), dt = 1 / 2^(2), save_everystep = true,
    saveat = [0.125, 0.6, 0.61, 0.8])

@test sol.retcode == sol2.retcode == ReturnCode.Success
@test symdiff(sol.t, sol2.t) == [0.125, 0.6, 0.61, 0.8]

sol = solve(prob, Trapezoid(), dt = 1 / 2^(2), save_everystep = false)
sol2 = solve(prob, Trapezoid(), dt = 1 / 2^(2), saveat = [0.125, 0.6, 0.61, 0.8])

@test sol.retcode == sol2.retcode == ReturnCode.Success
@test sort!(symdiff(sol.t, sol2.t)) == [0.0, 0.125, 0.6, 0.61, 0.8, 1.0]

sol = solve(prob, Trapezoid(), dt = 1 / 2^(2), save_everystep = true, dense = false,
    saveat = [0, 0.125, 0.6, 0.61, 0.8])

@test sol.retcode == ReturnCode.Success
@test !(sol.t[2] ≈ 0)

# Test Iterators

sol2 = solve(prob, DP5(), dt = 1 // 2^(2), save_everystep = false, dense = false,
    saveat = 0:(1 // 100):1)

@test sol2.retcode == ReturnCode.Success
@test sol2.t ≈ collect(0:(1 // 100):1)

sol2 = solve(prob, DP5(), dt = 1 // 2^(2), save_everystep = false, dense = false,
    saveat = range(0, stop = 1, length = 100))

@test sol2.retcode == ReturnCode.Success
@test sol2.t ≈ range(0, stop = 1, length = 100)

f = (du, u, p, t) -> prob.f(du, u, p, t)
prob2 = ODEProblem(f, vec(prob.u0), prob.tspan, 1.01)

sol2 = solve(prob2, DP5(), dt = 1 // 2^(2), saveat = 0.1, save_idxs = 1:2:5)

for u in sol2.u
    @test length(u) == 3
end

sol2 = solve(prob2, DP5(), dt = 1 // 2^(2), saveat = 0.1, save_idxs = 1:2:5,
    save_everystep = true)

sol = solve(prob2, DP5(), dt = 1 // 2^(2), save_start = false)

@test sol.t[1] == 1 // 2^(2)

# Test save_on switch
sol = solve(prob, DP5(), save_on = false, save_start = false, save_end = false)
@test isempty(sol.t) && isempty(sol.u)
sol = solve(prob, DP5(), saveat = 0.2, save_on = false, save_start = false,
    save_end = false)
@test isempty(sol.t) && isempty(sol.u)

small_f(u, p, t) = u
u0 = 1.0
tspan = (0.0, 15.0)
prob = ODEProblem(small_f, u0, tspan)
sol = solve(prob, Tsit5(), saveat = 4.0)
@test sol.t == [0.0, 4, 8, 12, 15]

_saveat = [0.0, 0.25, 0.5, 1.0]
integ = init(ODEProblem((u, p, t) -> u, 0.0, (0.0, 1.0)), Tsit5(), saveat = _saveat)
add_tstop!(integ, 2.0)
solve!(integ)
@test integ.sol.t == _saveat

integ = init(ODEProblem((u, p, t) -> u, 0.0, (0.0, 1.0)), Tsit5(), saveat = _saveat,
    save_end = true)
add_tstop!(integ, 2.0)
solve!(integ)
@test integ.sol.t == [0.0, 0.25, 0.5, 1.0, 2.0]

integ = init(ODEProblem((u, p, t) -> u, 0.0, (0.0, 1.0)), Tsit5(), saveat = _saveat,
    save_end = false)
add_tstop!(integ, 2.0)
solve!(integ)
@test integ.sol.t == _saveat[1:(end - 1)]

# Catch save for maxiters
ode = ODEProblem((u, p, t) -> u, 1.0, (0.0, 1.0))
sol = solve(ode, Tsit5(), save_everystep = false) # okay, as expected
@test length(sol) == 2
@info "Warning Expected"
sol = solve(ode, Tsit5(), save_everystep = false, maxiters = 3) # doesn't save the final solution anymore!
@test length(sol) == 2

# Check that calck is appropriately set with just saveat
# https://discourse.julialang.org/t/dp5-algorithm-failing-to-solve-simple-sir-problem/64835
function SIR!(du, u, pars, t)
    β, γ = pars
    S, I, R = u

    dS = -β * S * I
    dI = β * S * I - γ * I
    dR = γ * I
    du .= [dS, dI, dR]
end

t_obs = collect(0:1.0:218)
prob = ODEProblem(SIR!, [0.99, 0.01, 0.0], (t_obs[1], t_obs[end]), [0.20, 0.15])
sol = solve(prob, DP5(), reltol = 1e-6, abstol = 1e-6, saveat = t_obs)
@test maximum(sol) <= 1
@test minimum(sol) >= 0

@testset "Proper save_start and save_end behavior" begin
    function f2(du, u, p, t)
        du[1] = -cos(u[1]) * u[1]
    end
    prob = ODEProblem(f2, [10], (0.0, 0.4))

    @test solve(prob, Tsit5(); saveat = 0:0.1:0.4).t == [0.0; 0.1; 0.2; 0.3; 0.4]
    @test solve(prob, Tsit5(); saveat = 0:0.1:0.4, save_start = true, save_end = true).t ==
          [0.0; 0.1; 0.2; 0.3; 0.4]
    @test solve(
        prob, Tsit5(); saveat = 0:0.1:0.4, save_start = false, save_end = false).t ==
          [0.1; 0.2; 0.3]

    ts = solve(prob, Tsit5()).t
    @test 0.0 in ts
    @test 0.4 in ts
    ts = solve(prob, Tsit5(); save_start = true, save_end = true).t
    @test 0.0 in ts
    @test 0.4 in ts
    ts = solve(prob, Tsit5(); save_start = false, save_end = false).t
    @test 0.0 ∉ ts
    @test 0.4 ∉ ts

    @test solve(prob, Tsit5(); saveat = [0.2]).t == [0.2]
    @test solve(prob, Tsit5(); saveat = [0.2], save_start = true, save_end = true).t ==
          [0.0; 0.2; 0.4]
    @test solve(prob, Tsit5(); saveat = [0.2], save_start = false, save_end = false).t ==
          [0.2]
end

using LinearAlgebra
using SparseArrays
using CUDA
using CUDA.CUSPARSE
using OrdinaryDiffEq

# Linear exponential solvers
A = MatrixOperator([2.0 -1.0; -1.0 2.0])
u0 = ones(2)

A_gpu = MatrixOperator(cu([2.0 -1.0; -1.0 2.0]))
u0_gpu = cu(ones(2))
prob_gpu = ODEProblem(A_gpu, u0_gpu, (0.0, 1.0))

sol_analytic = exp(1.0 * Matrix(A)) * u0

@test_broken sol1_gpu = solve(prob_gpu, LinearExponential(krylov = :off))(1.0) |> Vector
sol2_gpu = solve(prob_gpu, LinearExponential(krylov = :simple))(1.0) |> Vector
sol3_gpu = solve(prob_gpu, LinearExponential(krylov = :adaptive))(1.0) |> Vector

@test_broken isapprox(sol1_gpu, sol_analytic, rtol = 1e-6)
@test isapprox(sol2_gpu, sol_analytic, rtol = 1e-6)
@test isapprox(sol3_gpu, sol_analytic, rtol = 1e-6)

A2_gpu = MatrixOperator(cu(sparse([2.0 -1.0; -1.0 2.0])))
prob2_gpu = ODEProblem(A2_gpu, u0_gpu, (0.0, 1.0))

@test_broken sol2_1_gpu = solve(prob2_gpu, LinearExponential(krylov = :off))(1.0) |> Vector
sol2_2_gpu = solve(prob2_gpu, LinearExponential(krylov = :simple))(1.0) |> Vector
sol2_3_gpu = solve(prob2_gpu, LinearExponential(krylov = :adaptive))(1.0) |> Vector

@test_broken isapprox(sol2_1_gpu, sol_analytic, rtol = 1e-6)
@test isapprox(sol2_2_gpu, sol_analytic, rtol = 1e-6)
@test isapprox(sol2_3_gpu, sol_analytic, rtol = 1e-6)

using OrdinaryDiffEq, Test, LinearAlgebra, Statistics
using OrdinaryDiffEqCore
using OrdinaryDiffEqNonlinearSolve: NLFunctional, NLAnderson, NLNewton
using LinearAlgebra: Diagonal
using ADTypes: AutoForwardDiff

# create mass matrix problems
function make_mm_probs(mm_A, ::Val{iip}) where {iip}
    # iip
    function mm_f(du, u, p, t)
        update_coefficients!(mm_A, OrdinaryDiffEqCore.constvalue.(u), p, t)
        mm_b = vec(sum(mm_A; dims = 2))
        mul!(du, mm_A, u)
        du .+= t * mm_b
        nothing
    end
    mm_g(du, u, p, t) = (@. du = u + t; nothing)

    # oop
    mm_f(u, p, t) = (update_coefficients!(mm_A, OrdinaryDiffEqCore.constvalue.(u), p, t);
    mm_A * (u .+ t))
    mm_g(u, p, t) = u .+ t

    mm_analytic(u0, p, t) = @. 2 * u0 * exp(t) - t - 1

    u0 = ones(3)
    tspan = (0.0, 1.0)

    prob = ODEProblem(
        ODEFunction{iip, true}(mm_f, analytic = mm_analytic,
            mass_matrix = mm_A), u0, tspan)
    prob2 = ODEProblem(ODEFunction{iip, true}(mm_g, analytic = mm_analytic), u0, tspan)

    prob, prob2
end

function _norm_dsol(alg, prob, prob2, dt = 1 / 10)
    sol = solve(prob, alg, dt = dt, adaptive = false)
    sol2 = solve(prob2, alg, dt = dt, adaptive = false)
    norm(sol .- sol2)
end

function update_func1!(A, u, p, t)
    A[1, 1] = cos(t)
    A[2, 1] = sin(t) * u[1]
    A[3, 1] = t^2
    A[1, 2] = cos(t) * sin(t)
    A[2, 2] = cos(t)^2 + u[3]
    A[3, 2] = sin(t) * u[2]
    A[1, 3] = sin(t)
    A[2, 3] = t^2
    A[3, 3] = t * cos(t) + 1
end

function update_func1(A, u, p, t)
    A = copy(A)
    update_func1!(A, u, p, t)
    A
end

function update_func2!(A, u, p, t)
    A[1, 1] = cos(t)
    A[2, 1] = sin(t)
    A[3, 1] = t^2
    A[1, 2] = cos(t) * sin(t)
    A[2, 2] = cos(t)^2
    A[3, 2] = sin(t)
    A[1, 3] = sin(t)
    A[2, 3] = t^2
    A[3, 3] = t * cos(t) + 1
end

function update_func2(A, u, p, t)
    A = copy(A)
    update_func2!(A, u, p, t)
    A
end

almost_I = Matrix{Float64}(1.01I, 3, 3)
mm_A = Float64[-2 1 4; 4 -2 1; 2 1 3]
dependent_M1 = MatrixOperator(ones(3, 3), update_func = update_func1,
    update_func! = update_func1!)
dependent_M2 = MatrixOperator(ones(3, 3), update_func = update_func2,
    update_func! = update_func2!)

@testset "Mass Matrix Accuracy Tests" for mm in (almost_I, mm_A)
    # test each method for exactness
    for iip in (false, true)
        prob, prob2 = make_mm_probs(mm, Val(iip))

        println("SDIRKs")
        @test _norm_dsol(ImplicitEuler(), prob, prob2)≈0 atol=1e-12
        @test _norm_dsol(Trapezoid(), prob, prob2)≈0 atol=1e-12
        @test _norm_dsol(RadauIIA5(), prob, prob2)≈0 atol=1e-12
        @test _norm_dsol(ImplicitMidpoint(extrapolant = :constant), prob, prob2)≈0 atol=1e-10

        println("BDFs")
        @test _norm_dsol(ABDF2(), prob, prob2)≈0 atol=1e-12

        @test _norm_dsol(QBDF1(), prob, prob2)≈0 atol=1e-12
        @test _norm_dsol(QBDF2(), prob, prob2)≈0 atol=1e-12
        @test _norm_dsol(QBDF(), prob, prob2)≈0 atol=1e-12
        @test _norm_dsol(FBDF(), prob, prob2)≈0 atol=1e-12

        @test _norm_dsol(QNDF1(), prob, prob2)≈0 atol=1e-12
        @test _norm_dsol(QNDF2(), prob, prob2)≈0 atol=1e-12
        @test _norm_dsol(QNDF(), prob, prob2)≈0 atol=1e-12

        println("Rosenbrocks")
        if mm == almost_I
            @test _norm_dsol(Rosenbrock23(), prob, prob2)≈0 atol=1e-11
            @test _norm_dsol(Rosenbrock32(), prob, prob2)≈0 atol=1e-11
        end
        @test _norm_dsol(ROS3P(), prob, prob2)≈0 atol=1e-11
        @test _norm_dsol(Rodas3(), prob, prob2)≈0 atol=1e-11
        @test _norm_dsol(ROS2(), prob, prob2)≈0 atol=1e-11
        @test _norm_dsol(ROS2PR(), prob, prob2)≈0 atol=1e-11
        @test _norm_dsol(ROS2S(), prob, prob2)≈0 atol=1e-11
        @test _norm_dsol(ROS3(), prob, prob2)≈0 atol=1e-11
        @test _norm_dsol(ROS3PR(), prob, prob2)≈0 atol=1e-11
        @test _norm_dsol(Scholz4_7(), prob, prob2)≈0 atol=1e-11
        @test _norm_dsol(RosShamp4(), prob, prob2)≈0 atol=1e-10
        @test _norm_dsol(Veldd4(), prob, prob2)≈0 atol=1e-10
        @test _norm_dsol(Velds4(), prob, prob2)≈0 atol=1e-10
        @test _norm_dsol(GRK4T(), prob, prob2)≈0 atol=1e-10
        @test _norm_dsol(GRK4A(), prob, prob2)≈0 atol=1e-10
        @test _norm_dsol(Ros4LStab(), prob, prob2)≈0 atol=1e-10
        @test _norm_dsol(RosenbrockW6S4OS(), prob, prob2)≈0 atol=1e-10
        @test _norm_dsol(ROS34PW1a(), prob, prob2)≈0 atol=1e-10
        @test _norm_dsol(ROS34PW1b(), prob, prob2)≈0 atol=1e-10
        @test _norm_dsol(ROS34PW2(), prob, prob2)≈0 atol=1e-10
        @test _norm_dsol(ROS34PW3(), prob, prob2)≈0 atol=1e-10
        @test _norm_dsol(ROS34PRw(), prob, prob2)≈0 atol=1e-11
        @test _norm_dsol(ROS3PRL(), prob, prob2)≈0 atol=1e-11
        @test _norm_dsol(ROS3PRL2(), prob, prob2)≈0 atol=1e-11
        @test _norm_dsol(ROK4a(), prob, prob2)≈0 atol=1e-11
        @test _norm_dsol(Rodas4(), prob, prob2)≈0 atol=1e-9
        @test _norm_dsol(Rodas42(), prob, prob2)≈0 atol=1e-9
        @test _norm_dsol(Rodas4P(), prob, prob2)≈0 atol=1e-9
        @test _norm_dsol(Rodas5(), prob, prob2)≈0 atol=1e-7
        @test _norm_dsol(Rodas23W(), prob, prob2)≈0 atol=1e-11
        @test _norm_dsol(Rodas3P(), prob, prob2)≈0 atol=1e-11
        @test _norm_dsol(Rodas5P(), prob, prob2)≈0 atol=1e-7
        @test _norm_dsol(Rodas5Pe(), prob, prob2)≈0 atol=1e-7
        @test _norm_dsol(Rodas5Pr(), prob, prob2)≈0 atol=1e-7
    end
end

@testset "Mass Matrix Functional Iteration Tests" for mm in (almost_I,) # Requires contraction map
    for iip in (false, true)
        @show iip
        prob, prob2 = make_mm_probs(mm, Val(iip))

        sol = solve(prob, ImplicitEuler(nlsolve = NLFunctional()), dt = 1 / 10,
            adaptive = false, reltol = 1e-7, abstol = 1e-10)
        sol2 = solve(prob2, ImplicitEuler(nlsolve = NLFunctional()), dt = 1 / 10,
            adaptive = false, reltol = 1e-7, abstol = 1e-10)
        @test norm(sol .- sol2)≈0 atol=1e-7

        sol = solve(prob,
            ImplicitMidpoint(extrapolant = :constant,
                nlsolve = NLFunctional()), dt = 1 / 10, reltol = 1e-7,
            abstol = 1e-10)
        sol2 = solve(prob2,
            ImplicitMidpoint(extrapolant = :constant, nlsolve = NLFunctional()),
            dt = 1 / 10, reltol = 1e-7, abstol = 1e-10)
        @test norm(sol .- sol2)≈0 atol=1e-7

        sol = solve(prob, ImplicitEuler(nlsolve = NLAnderson()), dt = 1 / 10,
            adaptive = false)
        sol2 = solve(prob2, ImplicitEuler(nlsolve = NLAnderson()), dt = 1 / 10,
            adaptive = false)
        @test norm(sol .- sol2)≈0 atol=1e-7
        @test norm(sol[end] .- sol2[end])≈0 atol=1e-7

        sol = solve(
            prob, ImplicitMidpoint(extrapolant = :constant, nlsolve = NLAnderson()),
            dt = 1 / 10, reltol = 1e-7, abstol = 1e-10)
        sol2 = solve(prob2,
            ImplicitMidpoint(extrapolant = :constant, nlsolve = NLAnderson()),
            dt = 1 / 10, reltol = 1e-7, abstol = 1e-10)
        @test norm(sol .- sol2)≈0 atol=1e-7
        @test norm(sol[end] .- sol2[end])≈0 atol=1e-7
    end
end

# Singular mass matrices

@testset "Mass Matrix Tests with Singular Mass Matrices" begin
    function f!(du, u, p, t)
        du[1] = u[2]
        du[2] = u[2] - 1.0
        return
    end

    u0 = [0.0, 1.0]
    tspan = (0.0, 1.0)

    M = Diagonal([1.0, 0.0])

    m_ode_prob = ODEProblem(ODEFunction(f!; mass_matrix = M), u0, tspan)
    @test_nowarn sol = @inferred solve(m_ode_prob, Rosenbrock23(autodiff=AutoForwardDiff(chunksize=2)))

    M = [0.637947 0.637947
         0.637947 0.637947]

    function f2!(du, u, p, t)
        du[1] = u[2]
        du[2] = u[1]
        return
    end
    u0 = zeros(2)

    m_ode_prob = ODEProblem(ODEFunction(f2!; mass_matrix = M), u0, tspan)
    println("Rosenbrocks")
    sol1 = @test_nowarn solve(m_ode_prob, Rodas5P(), reltol = 1e-10, abstol = 1e-10)
    sol2 = @test_nowarn solve(m_ode_prob, RadauIIA5(), reltol = 1e-10, abstol = 1e-10)
    sol3 = @test_nowarn solve(m_ode_prob, Cash4(), reltol = 1e-10, abstol = 1e-10)
    println("SDIRKs")
    sol4 = @test_nowarn solve(m_ode_prob, ImplicitEuler(), reltol = 1e-10, abstol = 1e-10)
    sol5 = @test_nowarn solve(
        m_ode_prob, ImplicitMidpoint(), dt = 1 / 1000, reltol = 1e-10,
        abstol = 1e-10)
    sol6 = @test_nowarn solve(m_ode_prob, Trapezoid(), reltol = 1e-10, abstol = 1e-10)
    println("BDFs")
    sol7 = @test_nowarn solve(m_ode_prob, QNDF1(), reltol = 1e-10, abstol = 1e-10)
    sol8 = @test_nowarn solve(m_ode_prob, QBDF1(), reltol = 1e-10, abstol = 1e-10)
    sol9 = @test_nowarn solve(m_ode_prob, QNDF2(), reltol = 1e-10, abstol = 1e-10)
    sol10 = @test_nowarn solve(m_ode_prob, QBDF2(), reltol = 1e-10, abstol = 1e-10)
    sol11 = @test_nowarn solve(m_ode_prob, ABDF2(), reltol = 1e-10, abstol = 1e-10)
    sol12 = @test_nowarn solve(m_ode_prob, QBDF(), reltol = 1e-10, abstol = 1e-10)
    sol13 = @test_nowarn solve(m_ode_prob, QNDF(), reltol = 1e-10, abstol = 1e-10)

    @test sol1[end]≈sol2[end] atol=1e-9
    @test sol1[end]≈sol3[end] atol=1e-9
    @test sol1[end]≈sol4[end] atol=1e-9
    @test sol1[end]≈sol5[end] atol=1e-9
    @test sol1[end]≈sol6[end] atol=1e-9
    @test sol1[end]≈sol7[end] atol=1e-9
    @test sol1[end]≈sol8[end] atol=1e-9
    @test sol1[end]≈sol9[end] atol=1e-9
    @test sol1[end]≈sol10[end] atol=1e-9
    @test sol1[end]≈sol11[end] atol=1e-9
    @test sol1[end]≈sol12[end] atol=1e-9
    @test sol1[end]≈sol13[end] atol=1e-9
end

function _norm_dsol2(alg, prob, prob2; kwargs...)
    sol = solve(prob, alg; kwargs...)
    sol2 = solve(prob2, alg; kwargs...)
    norm(sol.u[end] .- sol2.u[end])
end
@testset "Dependent Mass Matrix Tests" for mm in (dependent_M1, dependent_M2)
    # test each method for exactness
    for iip in (false, true)
        @show iip
        prob, prob2 = make_mm_probs(mm, Val(iip))
        eulersol = solve(prob, ImplicitEuler(nlsolve = NLNewton(κ = 1e-10)), reltol = 1e-10)
        @test _norm_dsol2(ImplicitEuler(nlsolve = NLNewton(κ = 1e-10)), prob, prob2,
            reltol = 1e-10)≈0 atol=5e-4
        @test_skip _norm_dsol2(
            ImplicitMidpoint(nlsolve = NLNewton(κ = 1e-10)), prob, prob2,
            tstops = eulersol.t)≈0 atol=1e-6
        @test_skip _norm_dsol(RadauIIA5(), prob, prob2)≈0 atol=1e-12

        @test_skip _norm_dsol(QNDF1(), prob, prob2)≈0 atol=1e-7
        @test_skip _norm_dsol(QBDF1(), prob, prob2)≈0 atol=1e-7
        @test_skip _norm_dsol(QNDF2(), prob, prob2)≈0 atol=1e-7
        @test_skip _norm_dsol(QBDF2(), prob, prob2)≈0 atol=1e-7
        @test_skip _norm_dsol(ABDF2(), prob, prob2)≈0 atol=1e-7
        @test_skip _norm_dsol(QBDF(), prob, prob2)≈0 atol=1e-7
        @test_skip _norm_dsol(QNDF(), prob, prob2)≈0 atol=1e-7
    end

    # test functional iteration
    @test_skip for iip in (false, true)
        @show iip
        prob, prob2 = make_mm_probs(mm, Val(iip))

        sol = solve(prob, ImplicitEuler(nlsolve = NLFunctional()), dt = 1 / 10,
            adaptive = false, reltol = 1e-7, abstol = 1e-10)
        sol2 = solve(prob2, ImplicitEuler(nlsolve = NLFunctional()), dt = 1 / 10,
            adaptive = false, reltol = 1e-7, abstol = 1e-10)
        @test_broken norm(sol .- sol2)≈0 atol=1e-7

        sol = solve(prob,
            ImplicitMidpoint(extrapolant = :constant,
                nlsolve = NLFunctional()), dt = 1 / 10, reltol = 1e-7,
            abstol = 1e-10)
        sol2 = solve(prob2,
            ImplicitMidpoint(extrapolant = :constant, nlsolve = NLFunctional()),
            dt = 1 / 10, reltol = 1e-7, abstol = 1e-10)
        @test_broken norm(sol .- sol2)≈0 atol=1e-7

        sol = solve(prob, ImplicitEuler(nlsolve = NLAnderson()), dt = 1 / 10,
            adaptive = false)
        sol2 = solve(prob2, ImplicitEuler(nlsolve = NLAnderson()), dt = 1 / 10,
            adaptive = false)
        @test norm(sol .- sol2)≈0 atol=1e-7
        @test norm(sol[end] .- sol2[end])≈0 atol=1e-7

        sol = solve(
            prob, ImplicitMidpoint(extrapolant = :constant, nlsolve = NLAnderson()),
            dt = 1 / 10, reltol = 1e-7, abstol = 1e-10)
        sol2 = solve(prob2,
            ImplicitMidpoint(extrapolant = :constant, nlsolve = NLAnderson()),
            dt = 1 / 10, reltol = 1e-7, abstol = 1e-10)
        @test norm(sol .- sol2)≈0 atol=1e-7
        @test norm(sol[end] .- sol2[end])≈0 atol=1e-7
    end
end

# Check https://github.com/SciML/DifferentialEquations.jl/issues/757
using OrdinaryDiffEq, LinearAlgebra
n = 3
Λ_func = t -> exp(-t) * ones(n) |> Diagonal |> Matrix
τ = 0.2
function dynamics!(du, u, p, t)
    du .= u - Λ_func(t - τ)
    nothing
end
function dynamics(u, p, t)
    u - Λ_func(t - τ)
end

x0 = zeros(n, n)
M = zeros(n * n) |> Diagonal
M[1, 1] = true # zero mass matrix breaks rosenbrock
f = ODEFunction{true, SciMLBase.AutoSpecialize}(dynamics!, mass_matrix = M)
tspan = (0, 10.0)
adalg = AutoForwardDiff(chunksize=n)
prob = ODEProblem(f, x0, tspan)
foop = ODEFunction{false, SciMLBase.AutoSpecialize}(dynamics, mass_matrix = M)
proboop = ODEProblem(f, x0, tspan)
@test_broken sol = @inferred solve(prob, Rosenbrock23(autodiff=adalg))
@test_broken sol = @inferred solve(prob, Rodas4(autodiff=adalg), initializealg = ShampineCollocationInit())
@test_broken sol = @inferred solve(proboop, Rodas5())
@test_broken sol = @inferred solve(proboop, Rodas4(), initializealg = ShampineCollocationInit())

using OrdinaryDiffEq, Test, ADTypes
import ODEProblemLibrary: prob_ode_vanderpol
using ForwardDiff: Dual

# Create Van der Pol problem with same structure as the new ODEProblemLibrary implementation
# New implementation uses: u[1] = x, u[2] = y, p[1] = μ
# Van der Pol equations: dx/dt = y, dy/dt = μ * ((1 - x^2) * y - x)
# Initial conditions: [x, y] = [2.0, 0] (matching the original [sys.x => 2.0, sys.y => 0])
function __van(du, u, p, t)
    x, y = u[1], u[2]
    μ = p[1]
    du[1] = y                           # dx/dt = y
    du[2] = μ * ((1 - x^2) * y - x)     # dy/dt = μ * ((1 - x^2) * y - x)
end
prob1 = ODEProblem(__van, [2.0, 0.0], (0.0, 6), [inv(0.003)])
prob2 = ODEProblem(__van, [2.0, 0.0], (0.0, 6), [inv(0.003)])
# out-of-place test
function _van(u, p, t)
    x, y = u[1], u[2]
    μ = p[1]
    [y,                           # dx/dt = y
     μ * ((1 - x^2) * y - x)]     # dy/dt = μ * ((1 - x^2) * y - x)
end
prob3 = ODEProblem(_van, [2.0, 0.0], (0.0, 6), [inv(0.003)])
probArr = [prob1, prob2, prob3]

for prob in [prob2, prob3], u0 in [prob.u0, Dual.(prob.u0, prob.u0)]
    prob′ = remake(prob3, u0 = u0)
    @test_nowarn solve(prob′, AutoTsit5(Rosenbrock23(autodiff = AutoFiniteDiff())))
end

# Test if switching back and forth
is_switching_fb(sol) = all(i -> count(isequal(i), sol.alg_choice[2:end]) > 5, (1, 2))
for (i, prob) in enumerate(probArr)
    println(i)
    sol = solve(prob, AutoTsit5(Rosenbrock23(autodiff = AutoFiniteDiff())),
        maxiters = 1000)
    @test is_switching_fb(sol)
    alg = AutoTsit5(Rodas5(); maxstiffstep = 5, maxnonstiffstep = 5, stiffalgfirst = true)
    sol = solve(prob, alg, maxiters = 1000)
    sol2 = solve(prob, alg, maxiters = 1000)
    @test sol.t == sol2.t # test reinitialization
    @test length(sol.t) < 280
    @test SciMLBase.successful_retcode(sol)
    @test alg.algs[sol.alg_choice[1]] isa Rodas5
    i == 1 || @test is_switching_fb(sol) # fails due to eigenvalue estimate of J
    sol = solve(prob,
        AutoDP5(Rodas5(); maxstiffstep = 2, maxnonstiffstep = 2,
            stifftol = 11 // 10, nonstifftol = 9 / 10),
        reltol = 1e-5, abstol = 1e-5, maxiters = 1000)
    @test length(sol.t) < 625
    @test SciMLBase.successful_retcode(sol)
    @test is_switching_fb(sol)

    sol = solve(prob, AutoVern6(Kvaerno3(); maxstiffstep = 4, maxnonstiffstep = 2),
        maxiters = 1000)
    @test length(sol.t) < 700
    @test SciMLBase.successful_retcode(sol)
    @test is_switching_fb(sol)
    sol = solve(prob, AutoVern7(Hairer42(); maxstiffstep = 4, maxnonstiffstep = 2),
        maxiters = 1000)
    @test length(sol.t) < 610
    @test_skip SciMLBase.successful_retcode(sol)
    @test is_switching_fb(sol)
    sol = solve(prob, AutoVern8(Rosenbrock23(); maxstiffstep = 4, maxnonstiffstep = 4),
        maxiters = 1000)
    @test length(sol.t) < 910
    @test SciMLBase.successful_retcode(sol)
    @test is_switching_fb(sol)
    sol = solve(prob, AutoVern9(KenCarp3(); maxstiffstep = 4, maxnonstiffstep = 1),
        maxiters = 1000)
    @test length(sol.t) < 570
    @test SciMLBase.successful_retcode(sol)
    @test is_switching_fb(sol)
    sol = solve(prob,
        AutoVern9(KenCarp3(autodiff = AutoFiniteDiff()); maxstiffstep = 4,
            maxnonstiffstep = 1), maxiters = 1000)
    @test length(sol.t) < 570
    @test SciMLBase.successful_retcode(sol)
    @test is_switching_fb(sol)
end

# Version-dependent AD backend selection
# Enzyme/Zygote: Julia <= 1.11 only (see https://github.com/EnzymeAD/Enzyme.jl/issues/2699)
# Mooncake: gradient support for ODE solves is currently broken (see discrete_adjoints.jl)
# ForwardDiff: all versions

const JULIA_VERSION_ALLOWS_ENZYME_ZYGOTE = VERSION < v"1.12" && isempty(VERSION.prerelease)

using SciMLSensitivity
using OrdinaryDiffEq, OrdinaryDiffEqCore, FiniteDiff, Test
using ADTypes
import DifferentiationInterface as DI

# Load version-dependent packages
if JULIA_VERSION_ALLOWS_ENZYME_ZYGOTE
    using Enzyme
    using Zygote
    get_gradient_backends() = [AutoZygote()]
    get_jacobian_backends() = [AutoForwardDiff()]
else
    # On Julia 1.12+, skip gradient tests since Zygote/Enzyme aren't available
    # and Mooncake gradient support for ODE solves is broken
    get_gradient_backends() = []
    get_jacobian_backends() = [AutoForwardDiff()]
end

function f(du, u, p, t)
    du[1] = u[2]
    return du[2] = -p[1]
end

function condition(u, t, integrator) # Event when event_f(u,t) == 0
    return u[1]
end

function affect!(integrator)
    @show integrator.t
    println("bounced.")
    return integrator.u[2] = -integrator.p[2] * integrator.u[2]
end

cb = ContinuousCallback(condition, affect!)
p = [9.8, 0.8]
prob = ODEProblem(f, eltype(p).([1.0, 0.0]), eltype(p).((0.0, 1.0)), copy(p))

function test_f(p)
    _prob = remake(prob, p = p)
    return solve(
        _prob, Tsit5(), abstol = 1.0e-14, reltol = 1.0e-14, callback = cb,
        save_everystep = false
    ).u[end]
end
findiff = FiniteDiff.finite_difference_jacobian(test_f, p)
findiff

# Test jacobians with all available backends
@testset "Jacobian tests" begin
    for backend in get_jacobian_backends()
        @testset "$(typeof(backend))" begin
            ad = DI.jacobian(test_f, backend, p)
            @test ad ≈ findiff
        end
    end
end

# Enzyme fails on ContinuousCallback with "mixed activity for jl_new_struct"
if JULIA_VERSION_ALLOWS_ENZYME_ZYGOTE
    @testset "Enzyme callback limitation (jacobian)" begin
        @test_broken (
            ad = DI.jacobian(test_f, AutoEnzyme(mode = Enzyme.set_runtime_activity(Enzyme.Forward)), p);
            ad ≈ findiff
        )
    end
end

function test_f2(
        p, sensealg = ForwardDiffSensitivity(), controller = nothing,
        alg = Tsit5()
    )
    _prob = remake(prob, p = p)
    u = solve(
        _prob, alg, sensealg = sensealg, controller = controller,
        abstol = 1.0e-14, reltol = 1.0e-14, callback = cb, save_everystep = false
    )
    return u[end][end]
end

@test test_f2(p) == test_f(p)[end]

# Test gradients with all available reverse-mode backends
@testset "Gradient tests with $backend" for backend in get_gradient_backends()
    g1 = DI.gradient(θ -> test_f2(θ, ForwardDiffSensitivity()), backend, p)
    g2 = DI.gradient(θ -> test_f2(θ, ReverseDiffAdjoint()), backend, p)
    g3 = DI.gradient(θ -> test_f2(θ, ReverseDiffAdjoint(), IController()), backend, p)
    g4 = DI.gradient(
        θ -> test_f2(θ, ReverseDiffAdjoint(), PIController(7 // 50, 2 // 25)),
        backend,
        p
    )
    @test_broken g5 = DI.gradient(
        θ -> test_f2(
            θ, ReverseDiffAdjoint(),
            PIDController(1 / 18.0, 1 / 9.0, 1 / 18.0)
        ),
        backend,
        p
    )
    g6 = DI.gradient(
        θ -> test_f2(
            θ, ForwardDiffSensitivity(),
            OrdinaryDiffEqCore.PredictiveController(), TRBDF2()
        ),
        backend,
        p
    )
    @test_broken g7 = DI.gradient(
        θ -> test_f2(
            θ, ReverseDiffAdjoint(),
            OrdinaryDiffEqCore.PredictiveController(),
            TRBDF2()
        ),
        backend,
        p
    )

    @test g1 ≈ findiff[2, 1:2]
    @test g2 ≈ findiff[2, 1:2]
    @test g3 ≈ findiff[2, 1:2]
    @test g4 ≈ findiff[2, 1:2]
    @test_broken g5 ≈ findiff[2, 1:2]
    @test g6 ≈ findiff[2, 1:2]
    @test_broken g7 ≈ findiff[2, 1:2]
end

# Enzyme fails on ContinuousCallback with "mixed activity for jl_new_struct"
if JULIA_VERSION_ALLOWS_ENZYME_ZYGOTE
    @testset "Enzyme callback limitation (gradient)" begin
        @test_broken (
            g = DI.gradient(θ -> test_f2(θ, ForwardDiffSensitivity()), AutoEnzyme(mode = Enzyme.set_runtime_activity(Enzyme.Reverse)), p);
            g ≈ findiff[2, 1:2]
        )
    end
end

using Test, OrdinaryDiffEq

for Alg in (Rosenbrock23, TRBDF2)
    tspan = (0, 10.0)
    u0 = ones(2)
    tstops = range(0, 10, length = 1000)
    sol = solve(ODEProblem((du, u, p, t) -> du .= sin.(u), u0, tspan), Tsit5())
    @test_nowarn solve(ODEProblem((du, u, p, t) -> sol(du, t), u0, tspan), Alg(),
        tstops = tstops)
    @test_nowarn solve(ODEProblem((du, u, p, t) -> sol(du, t), u0, (tspan[2], tspan[1])),
        Alg(), tstops = tstops)

    for u0 in (1.0, ones(2))
        u0 = 1.0
        sol = solve(ODEProblem((u, p, t) -> sin.(u), u0, tspan), Tsit5())
        @test_nowarn solve(ODEProblem((u, p, t) -> sol(t), u0, tspan), Alg(),
            tstops = tstops)
        @test_nowarn solve(
            ODEProblem((u, p, t) -> sol(t), u0, (tspan[2], tspan[1])), Alg(),
            tstops = tstops)
    end
end

using OrdinaryDiffEq, ForwardDiff, Test, ADTypes

function d_alembert(du, u, p, t)
    du[1] = p[1] - p[2] * u[1] + p[3] * t
end

function d_alembert_jac(J, u, p, t)
    J[1] = -p[2]
end

function d_alembert_analytic(u0, p, t::Number)
    a, b, c = p
    ebt = exp(b * t)
    @. exp(-b * t) * (-a * b + c + ebt * (a * b + c * (b * t - 1)) + b^2 * u0) / (b^2)
end

p = (1.0, 2.0, 3.0)
u0 = [1.0]
tspan = (0.0, 10.0)
prob = ODEProblem(
    ODEFunction(d_alembert,
        jac = d_alembert_jac,
        analytic = d_alembert_analytic),
    u0, tspan, p)

sol = solve(prob, Tsit5(), abstol = 1e-10, reltol = 1e-10)
@test sol.errors[:l2] < 1e-7
sol = solve(prob, Rosenbrock23(), abstol = 1e-8, reltol = 1e-8)
@test sol.errors[:l2] < 1e-7
sol = solve(prob, Rodas4(), abstol = 1e-10, reltol = 1e-10)
@test sol.errors[:l2] < 1e-7
sol = solve(prob, Veldd4(), abstol = 1e-10, reltol = 1e-10)
@test sol.errors[:l2] < 1e-7
sol = solve(prob, Rodas5(), abstol = 1e-10, reltol = 1e-10)
@test sol.errors[:l2] < 1e-7
sol = solve(prob, TRBDF2(), abstol = 1e-10, reltol = 1e-10)
@test sol.errors[:l2] < 2e-6
sol = solve(prob, Trapezoid(), abstol = 1e-10, reltol = 1e-10)
@test sol.errors[:l2] < 2e-6
sol = solve(prob, KenCarp3(), abstol = 1e-10, reltol = 1e-10)
@test sol.errors[:l2] < 8e-4
sol = solve(prob, KenCarp4(), abstol = 1e-10, reltol = 1e-10)
@test sol.errors[:l2] < 1e-7
sol = solve(prob, KenCarp47(), abstol = 1e-10, reltol = 1e-10)
@test sol.errors[:l2] < 1e-7
sol = solve(prob, KenCarp58(), abstol = 1e-10, reltol = 1e-10)
@test sol.errors[:l2] < 1e-7

using ModelingToolkit
function lotka(du, u, p, t)
    x = u[1]
    y = u[2]
    du[1] = p[1] * x - p[2] * x * y
    du[2] = -p[3] * y + p[4] * x * y
end

prob = ODEProblem(lotka, [1.0, 1.0], (0.0, 1.0), [1.5, 1.0, 3.0, 1.0])
de = ModelingToolkit.modelingtoolkitize(prob) |> complete
prob2 = ODEProblem(de, [], prob.tspan; jac = true)

sol = solve(prob, TRBDF2())

for Alg in [Rodas5, Rosenbrock23, TRBDF2, KenCarp4]
    @test Array(solve(prob2,
        Alg(),
        tstops = sol.t,
        adaptive = false))≈Array(solve(prob,
        Alg(),
        tstops = sol.t,
        adaptive = false)) atol=1e-4
end

## check chunk_size handling in ForwardDiff Jacobians
const chunksize = 1
function rober(du, u, p, t)
    y₁, y₂, y₃ = u
    k₁, k₂, k₃, check = p
    if check && eltype(u) <: ForwardDiff.Dual && ForwardDiff.npartials(u[1]) != chunksize
        @show ForwardDiff.npartials(u[1]), chunksize
        error("chunk_size is not as specified")
    end

    du[1] = -k₁ * y₁ + k₃ * y₂ * y₃
    du[2] = k₁ * y₁ - k₂ * y₂^2 - k₃ * y₂ * y₃
    du[3] = k₂ * y₂^2
    nothing
end
prob1 = ODEProblem(rober, [1.0, 0.0, 0.0], (0.0, 1e5), (0.04, 3e7, 1e4, true))
sol1 = solve(prob1, TRBDF2(autodiff = AutoForwardDiff(chunksize = chunksize)))
prob = ODEProblem(rober, [1.0, 0.0, 0.0], (0.0, 1e5), (0.04, 3e7, 1e4, false))
sol = solve(prob, TRBDF2())
@test sol.u[end] == sol1.u[end]
@test length(sol.t) == length(sol1.t)

using OrdinaryDiffEq, Test, Random, StaticArrays, DiffEqCallbacks
import ODEProblemLibrary: prob_ode_linear
Random.seed!(100)

@testset "Tstops Tests on the Interval [0, 1]" begin
    prob = prob_ode_linear

    sol = solve(prob, Tsit5(), dt = 1 // 2^(6), tstops = [1 / 2])
    @test 1 // 2 ∈ sol.t

    sol = solve(prob, RK4(), dt = 1 // 3, tstops = [1 / 2], adaptive = false)
    @test sol.t == [0, 1 / 3, 1 / 2, 1 / 3 + 1 / 2, 1]

    sol = solve(
        prob, RK4(), dt = 1 // 3, tstops = [1 / 2],
        d_discontinuities = [-1 / 2, 1 / 2, 3 / 2], adaptive = false
    )
    @test sol.t == [0, 1 / 3, 1 / 2, 1 / 3 + 1 / 2, 1]

    # TODO
    integrator = init(
        prob, RK4(), tstops = [1 / 5, 1 / 4, 1 / 3, 1 / 2, 3 / 4],
        adaptive = false
    )

    sol = solve(prob, RK4(), tstops = [1 / 5, 1 / 4, 1 / 3, 1 / 2, 3 / 4], adaptive = false)
    @test sol.t == [0, 1 / 5, 1 / 4, 1 / 3, 1 / 2, 3 / 4, 1]

    sol = solve(
        prob, RK4(), tstops = [0, 1 / 5, 1 / 4, 1 / 3, 1 / 2, 3 / 4, 1],
        adaptive = false
    )
    @test sol.t == [0, 1 / 5, 1 / 4, 1 / 3, 1 / 2, 3 / 4, 1]

    sol = solve(prob, RK4(), tstops = 0:(1 // 16):1, adaptive = false)
    @test sol.t == collect(0:(1 // 16):1)

    sol = solve(prob, RK4(), tstops = range(0, stop = 1, length = 100), adaptive = false)
    @test sol.t == collect(range(0, stop = 1, length = 100))
end

@testset "Integrator Tstops Tests on the Interval $(["[-1, 0]", "[0, 1]"][i])" for (i, tdir) in enumerate(
        [
            -1.0;
            1.0
        ]
    )
    prob2 = remake(prob_ode_linear, tspan = (0.0, tdir * 1.0))
    integrator = init(prob2, Tsit5())
    tstops = tdir .* [0, 1 / 5, 1 / 4, 1 / 3, 1 / 2, 3 / 4, 1]
    for tstop in tstops
        add_tstop!(integrator, tstop)
    end
    @test_throws ErrorException add_tstop!(integrator, -0.1 * tdir)
    solve!(integrator)
    for tstop in tstops
        @test tstop ∈ integrator.sol.t
    end
end

@testset "Tstops Eps" begin
    function de(du, u, p, t) # specific DE does not impact the issue
        a, b = p
        du[1] = a * u[1]
        du[2] = b * u[2]
    end

    saveat = [0.0, 0.0094777, 1.5574]
    tstop = 0.010823

    affect!(integrator) = integrator.u[1] += 1.0
    condition(u, t, integrator) = t == tstop
    callback = DiscreteCallback(condition, affect!)

    prob = ODEProblem(de, zeros(2), (-1, 3.0), rand(2))
    sol = solve(prob, Tsit5(), saveat = saveat, tstops = tstop, callback = callback)
    @test sol.t[end] == 1.5574
end

@testset "Tstops Type Conversion" begin
    called = Ref(false)
    tval = rand()
    ff(du, u, p, t) = du .= 0
    cb = DiscreteCallback(
        (u, t, integrator) -> t == Float32(tval),
        integrator -> (called[] = true)
    )
    prob = ODEProblem(ff, [0.0], (0.0f0, 1.0f0))
    sol = solve(prob, Tsit5(), tstops = [tval], callback = cb)
end

@testset "Late binding tstops" begin
    function rhs(u, p, t)
        u * p + t
    end
    prob = ODEProblem(rhs, 1.0, (0.0, 1.0), 0.1; tstops = (p, tspan) -> tspan[1]:p:tspan[2])
    sol = solve(prob, Tsit5())
    @test 0.0:0.1:1.0 ⊆ sol.t
    prob2 = remake(prob; p = 0.07)
    sol2 = solve(prob2, Tsit5())
    @test 0.0:0.07:1.0 ⊆ sol2.t
end

# Tests for issue #2752: tstop overshoot errors with StaticArrays

@testset "StaticArrays vs Arrays with extreme precision" begin
    function precise_dynamics(u, p, t)
        x = @view u[1:2]
        v = @view u[3:4]
        dv = -0.01 * x + 1.0e-6 * sin(100 * t) * SVector{2}(1, 1)
        return SVector{4}(v[1], v[2], dv[1], dv[2])
    end

    function precise_dynamics_array!(du, u, p, t)
        x = @view u[1:2]
        v = @view u[3:4]
        dv = -0.01 * x + 1.0e-6 * sin(100 * t) * [1, 1]
        du[1] = v[1]
        du[2] = v[2]
        du[3] = dv[1]
        du[4] = dv[2]
    end

    u0_static = SVector{4}(1.0, -0.5, 0.01, 0.01)
    u0_array = [1.0, -0.5, 0.01, 0.01]
    tspan = (0.0, 2.0)
    tstops = [0.5, 1.0, 1.5]

    prob_static = ODEProblem(precise_dynamics, u0_static, tspan)
    sol_static = solve(
        prob_static, Vern9(); reltol = 1.0e-12, abstol = 1.0e-15,
        tstops = tstops
    )
    @test SciMLBase.successful_retcode(sol_static)
    for tstop in tstops
        @test tstop ∈ sol_static.t
    end

    prob_array = ODEProblem(precise_dynamics_array!, u0_array, tspan)
    sol_array = solve(
        prob_array, Vern9(); reltol = 1.0e-12, abstol = 1.0e-15,
        tstops = tstops
    )
    @test SciMLBase.successful_retcode(sol_array)
    for tstop in tstops
        @test tstop ∈ sol_array.t
    end

    @test isapprox(sol_static(2.0), sol_array(2.0), rtol = 1.0e-10)
end

@testset "Backward integration with tstop flags" begin
    function decay_ode(u, p, t)
        SA[-0.1 * u[1]]
    end

    u0 = SVector{1}(1.0)
    tspan = (2.0, 0.0)
    tstops = [1.5, 1.0, 0.5]

    prob = ODEProblem(decay_ode, u0, tspan)
    sol = solve(prob, Vern9(); tstops = tstops, reltol = 1.0e-12, abstol = 1.0e-15)
    @test SciMLBase.successful_retcode(sol)
    for tstop in tstops
        @test tstop ∈ sol.t
    end
end

@testset "PresetTimeCallback with tstop flags" begin
    callback_times = Float64[]

    function affect_preset!(integrator)
        push!(callback_times, integrator.t)
        integrator.u += 0.1 * integrator.u
    end

    function simple_growth(u, p, t)
        SA[0.1 * u[1]]
    end

    u0 = SA[1.0]
    tspan = (0.0, 3.0)
    critical_times = [0.5, 1.0, 1.5, 2.0, 2.5]

    preset_cb = PresetTimeCallback(critical_times, affect_preset!)

    prob = ODEProblem(simple_growth, u0, tspan)
    sol = solve(
        prob, Vern9(); tstops = critical_times, callback = preset_cb,
        reltol = 1.0e-10, abstol = 1.0e-12
    )

    @test SciMLBase.successful_retcode(sol)
    for time in critical_times
        @test any(abs.(sol.t .- time) .< 1.0e-10)
    end
    @test length(callback_times) == length(critical_times)
end

@testset "Multiple close tstops with StaticArrays" begin
    function oscillator(u, p, t)
        SVector{2}(u[2], -u[1])
    end

    u0 = SVector{2}(1.0, 0.0)
    tspan = (0.0, 4.0)
    close_tstops = [
        1.0, 1.0 + 1.0e-14, 1.0 + 2.0e-14, 1.0 + 5.0e-14,
        2.0, 2.0 + 1.0e-15, 2.0 + 1.0e-14,
        3.0, 3.0 + 1.0e-13,
    ]

    prob = ODEProblem(oscillator, u0, tspan)
    sol = solve(prob, Vern9(); tstops = close_tstops, reltol = 1.0e-12, abstol = 1.0e-15)
    @test SciMLBase.successful_retcode(sol)
    for time in [1.0, 2.0, 3.0]
        @test any(abs.(sol.t .- time) .< 1.0e-10)
    end
end

using OrdinaryDiffEq, DiffEqDevTools, DiffEqBase, Test,
      ODEInterface, ODEInterfaceDiffEq

import ODEProblemLibrary: prob_ode_bigfloatlinear,
                          prob_ode_linear,
                          prob_ode_2Dlinear,
                          prob_ode_bigfloat2Dlinear

probbig = prob_ode_bigfloat2Dlinear
probnum = prob_ode_linear
probnumbig = prob_ode_bigfloatlinear
prob = prob_ode_2Dlinear

dts = (1 / 2) .^ (7:-1:4)
testTol = 0.2
bools = Vector{Bool}(undef, 0)

## DP5()
sim = test_convergence(dts, probnum, DP5())
@test abs.(sim.𝒪est[:l2] - 5) < testTol
sim = test_convergence(dts, prob, DP5())
@test abs.(sim.𝒪est[:l2] - 5) < testTol

tabalg = ExplicitRK()
sol1 = solve(probnum, DP5(), dt = 1 / 2^6, adaptive = false, save_everystep = false)
sol2 = solve(probnum, tabalg, dt = 1 / 2^6, adaptive = false, save_everystep = false)

@test sol1.u[end] - sol2.u[end] < 1e-10

sol1 = solve(prob, DP5(), dt = 1 / 2^6, adaptive = false, save_everystep = false)
sol2 = solve(prob, tabalg, dt = 1 / 2^6, adaptive = false, save_everystep = false)

@test minimum(sol1.u[end] - sol2.u[end] .< 3e-10)

sol1 = solve(probnum, DP5(), dt = 1 / 2^6, beta2 = 0.04)
sol2 = solve(probnum, tabalg, dt = 1 / 2^6, beta2 = 0.04)

# Should be identical
sol1 = solve(probnum, DP5())
sol2 = solve(probnum, tabalg, beta2 = 0.04, beta1 = 0.17)
sol3 = solve(probnum, dopri5())

@test sol1.t ≈ sol2.t
@test sol1.t≈sol3.t atol=1e-6

sol1 = solve(prob, DP5(), dt = 1 / 8)
sol2 = solve(prob, tabalg, beta2 = 0.04, beta1 = 0.17, dt = 1 / 8)
sol3 = solve(prob, dopri5(), dt = 1 / 8)

@test sol1.t ≈ sol2.t
@test sol1.t≈sol3.t atol=1e-5

sol4 = solve(prob, DP5(), dt = 1 / 8, calck = false)

@test sol1.t == sol4.t

### DP8()

dts = (1 / 2) .^ (3:-1:1)
sim = test_convergence(dts, probnumbig, DP8())
@test abs.(sim.𝒪est[:l2] - 8) < testTol
sim = test_convergence(dts, probbig, DP8())
@test abs.(sim.𝒪est[:l2] - 8) < testTol

sol1 = solve(probnum, DP8(), dt = 1 / 2^6, adaptive = false, save_everystep = false)
sol2 = solve(probnum, DP8(), dt = 1 / 2^6)

# Should be identical
sol1 = solve(probnum, DP8())
sol2 = solve(probnum, dop853())

@test sol1.t ≈ sol2.t

# Should be identical
sol1 = solve(prob, DP8(), dt = 1 / 2^6)
sol2 = solve(prob, dop853(), dt = 1 / 2^6)

@test sol1.t ≈ sol2.t

using OrdinaryDiffEq, DiffEqDevTools, Test, Random
testTol = 0.2

Random.seed!(100)

# Test that the infrastructure works

f1 = (u, p, t) -> 2u
f2 = (u, p, t) -> 2u

prob = SplitODEProblem(f1, f2, 1.0, (0.0, 1.0))
sol = solve(prob, SplitEuler(), dt = 1 / 10)
sol2 = solve(prob, Euler(), dt = 1 / 10)
@test sol2[end] == sol[end]
@test sol2(0.345) == sol(0.345)

f3 = (u, p, t) -> 4u
prob2 = ODEProblem(f3, 1.0, (0.0, 1.0))
sol3 = solve(prob2, Euler(), dt = 1 / 10)
@test sol3[end] == sol[end]
@test sol3(0.345) == sol(0.345)

u = rand(4, 2)
f1 = (du, u, p, t) -> du .= 2u
f2 = (du, u, p, t) -> du .= 2u
prob = SplitODEProblem(f1, f2, u, (0.0, 1.0))
sol = solve(prob, SplitEuler(), dt = 1 / 10)
sol2 = solve(prob, Euler(), dt = 1 / 10)

@test sol2[end] == sol[end]
@test sol2(0.345) == sol(0.345)

f3 = (du, u, p, t) -> du .= 4u
prob2 = ODEProblem(f3, u, (0.0, 1.0))
sol3 = solve(prob2, Euler(), dt = 1 / 10)

@test sol3[end] == sol[end]
@test sol3(0.345) == sol(0.345)

println("OOP Tests")
# Now test only the first part
println("Testing only first part of Split ODE")

f1 = (u, p, t) -> 2u
f2 = (u, p, t) -> zero(u)

ff_split = SplitFunction(f1, f2; analytic = (u0, p, t) -> exp(2t) * u0)
prob = SplitODEProblem(ff_split, 1.0, (0.0, 1.0))

sol = solve(prob, KenCarp3())
dts = 1 .// 2 .^ (8:-1:4)
sim = test_convergence(dts, prob, KenCarp3())
@test sim.𝒪est[:l∞]≈3 atol=testTol

dts = 1 .// 2 .^ (8:-1:4)
sim = test_convergence(dts, prob, CFNLIRK3())
@test sim.𝒪est[:l∞]≈3 atol=testTol

sol = solve(
    prob, KenCarp3(nlsolve = OrdinaryDiffEq.OrdinaryDiffEqNonlinearSolve.NLFunctional()))
dts = 1 .// 2 .^ (8:-1:4)
sim = test_convergence(dts, prob, KenCarp3())
@test sim.𝒪est[:l∞]≈3 atol=testTol

sol = solve(prob, KenCarp4())
dts = 1 .// 2 .^ (8:-1:4)
sim = test_convergence(dts, prob, KenCarp4())
@test sim.𝒪est[:l∞]≈4 atol=testTol

sol = solve(prob, KenCarp5())
dts = 1 .// 2 .^ (8:-1:4)
sim = test_convergence(dts, prob, KenCarp5())
@test sim.𝒪est[:l∞]≈5 atol=testTol

sol = solve(prob, KenCarp47())
dts = 1 .// 2 .^ (8:-1:4)
sim = test_convergence(dts, prob, KenCarp47())
@test sim.𝒪est[:l∞]≈4 atol=testTol

sol = solve(prob, KenCarp58())
dts = 1 .// 2 .^ (8:-1:4)
sim = test_convergence(dts, prob, KenCarp58())
@test sim.𝒪est[:l∞]≈5 atol=testTol

# IMEXEuler
dts = 1 .// 2 .^ (8:-1:4)
sim = test_convergence(dts, prob, IMEXEuler())
@test sim.𝒪est[:l∞]≈1 atol=testTol

# IMEXEulerARK
dts = 1 .// 2 .^ (8:-1:4)
sim = test_convergence(dts, prob, IMEXEulerARK())
@test sim.𝒪est[:l∞]≈1 atol=testTol

# CNAB2
dts = 1 .// 2 .^ (8:-1:4)
sim = test_convergence(dts, prob, CNAB2())
@test sim.𝒪est[:l∞]≈2 atol=testTol

# CNLF2
dts = 1 .// 2 .^ (8:-1:4)
sim = test_convergence(dts, prob, CNLF2())
@test sim.𝒪est[:l∞]≈2 atol=testTol

# SBDF2
dts = 1 .// 2 .^ (8:-1:4)
sim = test_convergence(dts, prob, SBDF2())
@test sim.𝒪est[:l∞]≈2 atol=testTol

# SBDF3
dts = 1 .// 2 .^ (8:-1:4)
sim = test_convergence(dts, prob, SBDF3())
@test_broken sim.𝒪est[:l∞]≈3 atol=testTol

# SBDF4
dts = 1 .// 2 .^ (8:-1:4)
sim = test_convergence(dts, prob, SBDF4())
@test_broken sim.𝒪est[:l∞]≈4 atol=testTol

# IRKC
dts = 1 .// 2 .^ (12:-1:8)
sim = test_convergence(dts, prob, IRKC())
@test sim.𝒪est[:l∞]≈1 atol=testTol

# Now test only the second part
println("Testing only second part of Split ODE")

f1 = (u, p, t) -> zero(u)
f2 = (u, p, t) -> 2u

ff_split2 = SplitFunction(f1, f2; analytic = (u0, p, t) -> exp(2t) * u0)
prob = SplitODEProblem(ff_split2, 1.0, (0.0, 1.0))

sol = solve(prob, KenCarp3())
dts = 1 .// 2 .^ (8:-1:4)
sim = test_convergence(dts, prob, KenCarp3())
@test sim.𝒪est[:l∞]≈3 atol=testTol

dts = 1 .// 2 .^ (8:-1:4)
sim = test_convergence(dts, prob, CFNLIRK3())
@test sim.𝒪est[:l∞]≈3 atol=testTol

sol = solve(prob, KenCarp4())
dts = 1 .// 2 .^ (8:-1:4)
sim = test_convergence(dts, prob, KenCarp4())
@test sim.𝒪est[:l∞]≈4 atol=testTol

sol = solve(prob, KenCarp5())
dts = 1 .// 2 .^ (8:-1:4)
sim = test_convergence(dts, prob, KenCarp5())
@test sim.𝒪est[:l∞]≈5 atol=testTol

sol = solve(prob, KenCarp47())
dts = 1 .// 2 .^ (8:-1:4)
sim = test_convergence(dts, prob, KenCarp47())
@test sim.𝒪est[:l∞]≈4 atol=testTol

sol = solve(prob, KenCarp58())
dts = 1 .// 2 .^ (8:-1:4)
sim = test_convergence(dts, prob, KenCarp58())
@test sim.𝒪est[:l∞]≈5 atol=testTol

# IMEXEuler
dts = 1 .// 2 .^ (8:-1:4)
sim = test_convergence(dts, prob, IMEXEuler())
@test sim.𝒪est[:l∞]≈1 atol=testTol

# IMEXEulerARK
dts = 1 .// 2 .^ (8:-1:4)
sim = test_convergence(dts, prob, IMEXEulerARK())
@test sim.𝒪est[:l∞]≈1 atol=testTol

# CNAB2
dts = 1 .// 2 .^ (8:-1:4)
sim = test_convergence(dts, prob, CNAB2())
@test sim.𝒪est[:l∞]≈2 atol=testTol

# CNLF2
dts = 1 .// 2 .^ (8:-1:4)
sim = test_convergence(dts, prob, CNLF2())
@test sim.𝒪est[:l∞]≈2 atol=testTol

# SBDF2
dts = 1 .// 2 .^ (8:-1:4)
sim = test_convergence(dts, prob, SBDF2())
@test sim.𝒪est[:l∞]≈2 atol=testTol

# SBDF3
dts = 1 .// 2 .^ (8:-1:4)
sim = test_convergence(dts, prob, SBDF3())
@test_broken sim.𝒪est[:l∞]≈3 atol=testTol

# SBDF4
dts = 1 .// 2 .^ (8:-1:4)
sim = test_convergence(dts, prob, SBDF4())
@test_broken sim.𝒪est[:l∞]≈4 atol=testTol

# IRKC
dts = 1 .// 2 .^ (12:-1:8)
sim = test_convergence(dts, prob, IRKC())
@test sim.𝒪est[:l∞]≈2 atol=testTol

# Test together
println("Testing both parts of Split ODE together")

f1 = (u, p, t) -> u
f2 = (u, p, t) -> 2u

ff_split3 = SplitFunction(f1, f2; analytic = (u0, p, t) -> exp(3t) * u0)
prob = SplitODEProblem(ff_split3, 1.0, (0.0, 1.0))

sol = solve(prob, KenCarp3())
dts = 1 .// 2 .^ (12:-1:8)
sim = test_convergence(dts, prob, KenCarp3())
@test sim.𝒪est[:l∞]≈3 atol=testTol

dts = 1 .// 2 .^ (12:-1:8)
sim = test_convergence(dts, prob, CFNLIRK3())
@test sim.𝒪est[:l∞]≈3 atol=testTol

sol = solve(prob, KenCarp4())
dts = 1 .// 2 .^ (8:-1:4)
sim = test_convergence(dts, prob, KenCarp4())
@test sim.𝒪est[:l∞]≈4 atol=testTol

sol = solve(prob, KenCarp5())
dts = 1 .// 2 .^ (8:-1:4)
sim = test_convergence(dts, prob, KenCarp5())
@test sim.𝒪est[:l∞]≈5 atol=testTol

sol = solve(prob, KenCarp47())
dts = 1 .// 2 .^ (8:-1:4)
sim = test_convergence(dts, prob, KenCarp47())
@test sim.𝒪est[:l∞]≈4 atol=testTol

sol = solve(prob, KenCarp58())
dts = 1 .// 2 .^ (8:-1:4)
sim = test_convergence(dts, prob, KenCarp58())
@test sim.𝒪est[:l∞]≈5 atol=testTol

# IMEXEuler
dts = 1 .// 2 .^ (8:-1:4)
sim = test_convergence(dts, prob, IMEXEuler())
@test sim.𝒪est[:l∞]≈1 atol=testTol

# IMEXEulerARK
dts = 1 .// 2 .^ (8:-1:4)
sim = test_convergence(dts, prob, IMEXEulerARK())
@test sim.𝒪est[:l∞]≈1 atol=testTol

# CNAB2
dts = 1 .// 2 .^ (8:-1:4)
sim = test_convergence(dts, prob, CNAB2())
@test sim.𝒪est[:l∞]≈2 atol=testTol

# CNLF2
dts = 1 .// 2 .^ (8:-1:4)
sim = test_convergence(dts, prob, CNLF2())
@test sim.𝒪est[:l∞]≈2 atol=testTol

# SBDF2
dts = 1 .// 2 .^ (8:-1:4)
sim = test_convergence(dts, prob, SBDF2())
@test sim.𝒪est[:l∞]≈2 atol=testTol

# SBDF3
dts = 1 .// 2 .^ (8:-1:4)
sim = test_convergence(dts, prob, SBDF3())
@test_broken sim.𝒪est[:l∞]≈3 atol=testTol

# SBDF4
dts = 1 .// 2 .^ (8:-1:4)
sim = test_convergence(dts, prob, SBDF4())
@test_broken sim.𝒪est[:l∞]≈4 atol=testTol

# IRKC
dts = 1 .// 2 .^ (12:-1:8)
sim = test_convergence(dts, prob, IRKC())
@test sim.𝒪est[:l∞]≈1 atol=testTol

println("IIP Tests")
# Now test only the first part
println("Testing only first part of Split ODE")

f1 = (du, u, p, t) -> du .= 2u
f2 = (du, u, p, t) -> du .= 0.0

ff_split4 = SplitFunction(f1, f2; analytic = (u0, p, t) -> exp(2t) * u0)
prob = SplitODEProblem(ff_split4, rand(4, 2), (0.0, 1.0))

sol = solve(prob, KenCarp3())
dts = 1 .// 2 .^ (8:-1:4)
sim = test_convergence(dts, prob, KenCarp3())
@test sim.𝒪est[:l∞]≈3 atol=testTol

dts = 1 .// 2 .^ (8:-1:4)
sim = test_convergence(dts, prob, CFNLIRK3())
@test sim.𝒪est[:l∞]≈3 atol=testTol

sol = solve(prob, KenCarp4())
dts = 1 .// 2 .^ (8:-1:4)
sim = test_convergence(dts, prob, KenCarp4())
@test sim.𝒪est[:l∞]≈4 atol=testTol

sol = solve(prob, KenCarp5())
dts = 1 .// 2 .^ (8:-1:4)
sim = test_convergence(dts, prob, KenCarp5())
@test sim.𝒪est[:l∞]≈5 atol=testTol

sol = solve(prob, KenCarp47())
dts = 1 .// 2 .^ (8:-1:4)
sim = test_convergence(dts, prob, KenCarp47())
@test sim.𝒪est[:l∞]≈4 atol=testTol

sol = solve(prob, KenCarp58())
dts = 1 .// 2 .^ (8:-1:4)
sim = test_convergence(dts, prob, KenCarp58())
@test sim.𝒪est[:l∞]≈5 atol=testTol

# IMEXEuler
dts = 1 .// 2 .^ (8:-1:4)
sim = test_convergence(dts, prob, IMEXEuler())
@test sim.𝒪est[:l∞]≈1 atol=testTol

# IMEXEulerARK
dts = 1 .// 2 .^ (8:-1:4)
sim = test_convergence(dts, prob, IMEXEulerARK())
@test sim.𝒪est[:l∞]≈1 atol=testTol

# CNAB2
dts = 1 .// 2 .^ (8:-1:4)
sim = test_convergence(dts, prob, CNAB2())
@test sim.𝒪est[:l∞]≈2 atol=testTol

# CNLF2
dts = 1 .// 2 .^ (8:-1:4)
sim = test_convergence(dts, prob, CNLF2())
@test sim.𝒪est[:l∞]≈2 atol=testTol

# SBDF2
dts = 1 .// 2 .^ (8:-1:4)
sim = test_convergence(dts, prob, SBDF2())
@test sim.𝒪est[:l∞]≈2 atol=testTol

# SBDF3
dts = 1 .// 2 .^ (8:-1:4)
sim = test_convergence(dts, prob, SBDF3())
@test_broken abs(sim.𝒪est[:l∞] - 3) < testTol

# SBDF4
dts = 1 .// 2 .^ (8:-1:4)
sim = test_convergence(dts, prob, SBDF4())
@test_broken sim.𝒪est[:l∞]≈4 atol=testTol

# IRKC
dts = 1 .// 2 .^ (12:-1:8)
sim = test_convergence(dts, prob, IRKC())
@test sim.𝒪est[:l∞]≈1 atol=testTol

# Now test only the second part
println("Testing only second part of Split ODE")

f1 = (du, u, p, t) -> du .= 0.0
f2 = (du, u, p, t) -> du .= 2u

ff_split5 = SplitFunction(f1, f2; analytic = (u0, p, t) -> exp(2t) * u0)
prob = SplitODEProblem(ff_split5, rand(4, 2), (0.0, 1.0))

sol = solve(prob, KenCarp3())
dts = 1 .// 2 .^ (8:-1:4)
sim = test_convergence(dts, prob, KenCarp3())
@test sim.𝒪est[:l∞]≈3 atol=testTol

dts = 1 .// 2 .^ (8:-1:4)
sim = test_convergence(dts, prob, CFNLIRK3())
@test sim.𝒪est[:l∞]≈3 atol=testTol

sol = solve(prob, KenCarp4())
dts = 1 .// 2 .^ (8:-1:4)
sim = test_convergence(dts, prob, KenCarp4())
@test sim.𝒪est[:l∞]≈4 atol=testTol

sol = solve(prob, KenCarp5())
dts = 1 .// 2 .^ (8:-1:4)
sim = test_convergence(dts, prob, KenCarp5())
@test sim.𝒪est[:l∞]≈5 atol=testTol

sol = solve(prob, KenCarp47())
dts = 1 .// 2 .^ (8:-1:4)
sim = test_convergence(dts, prob, KenCarp47())
@test sim.𝒪est[:l∞]≈4 atol=testTol

sol = solve(prob, KenCarp58())
dts = 1 .// 2 .^ (8:-1:4)
sim = test_convergence(dts, prob, KenCarp58())
@test sim.𝒪est[:l∞]≈5 atol=testTol

# IMEXEuler
dts = 1 .// 2 .^ (8:-1:4)
sim = test_convergence(dts, prob, IMEXEuler())
@test sim.𝒪est[:l∞]≈1 atol=testTol

# IMEXEulerARK
dts = 1 .// 2 .^ (8:-1:4)
sim = test_convergence(dts, prob, IMEXEulerARK())
@test sim.𝒪est[:l∞]≈1 atol=testTol

# CNAB2
dts = 1 .// 2 .^ (8:-1:4)
sim = test_convergence(dts, prob, CNAB2())
@test sim.𝒪est[:l∞]≈2 atol=testTol

# CNLF2
dts = 1 .// 2 .^ (8:-1:4)
sim = test_convergence(dts, prob, CNLF2())
@test sim.𝒪est[:l∞]≈2 atol=testTol

# SBDF2
dts = 1 .// 2 .^ (8:-1:4)
sim = test_convergence(dts, prob, SBDF2())
@test sim.𝒪est[:l∞]≈2 atol=testTol

# SBDF3
dts = 1 .// 2 .^ (8:-1:4)
sim = test_convergence(dts, prob, SBDF3())
@test_broken sim.𝒪est[:l∞]≈3 atol=testTol

# SBDF4
dts = 1 .// 2 .^ (8:-1:4)
sim = test_convergence(dts, prob, SBDF4())
@test_broken sim.𝒪est[:l∞]≈4 atol=testTol

# IRKC
dts = 1 .// 2 .^ (12:-1:8)
sim = test_convergence(dts, prob, IRKC())
@test sim.𝒪est[:l∞]≈2 atol=testTol

# Test together
println("Testing both parts of Split ODE together")

f1 = (du, u, p, t) -> du .= u
f2 = (du, u, p, t) -> du .= 2u

ff_split6 = SplitFunction(f1, f2; analytic = (u0, p, t) -> exp(3t) * u0)
prob = SplitODEProblem(ff_split6, rand(4, 2), (0.0, 1.0))

sol = solve(prob, KenCarp3())
dts = 1 .// 2 .^ (12:-1:8)
sim = test_convergence(dts, prob, KenCarp3())
@test sim.𝒪est[:l∞]≈3 atol=testTol

dts = 1 .// 2 .^ (12:-1:8)
sim = test_convergence(dts, prob, CFNLIRK3())
@test sim.𝒪est[:l∞]≈3 atol=testTol

sol = solve(prob, KenCarp4())
dts = 1 .// 2 .^ (8:-1:4)
sim = test_convergence(dts, prob, KenCarp4())
@test sim.𝒪est[:l∞]≈4 atol=testTol

sol = solve(prob, KenCarp5())
dts = 1 .// 2 .^ (8:-1:4)
sim = test_convergence(dts, prob, KenCarp5())
@test sim.𝒪est[:l∞]≈5 atol=testTol

sol = solve(prob, KenCarp47())
dts = 1 .// 2 .^ (8:-1:4)
sim = test_convergence(dts, prob, KenCarp47())
@test sim.𝒪est[:l∞]≈4 atol=testTol

sol = solve(prob, KenCarp58())
dts = 1 .// 2 .^ (8:-1:4)
sim = test_convergence(dts, prob, KenCarp58())
@test sim.𝒪est[:l∞]≈5 atol=testTol

# IMEXEuler
dts = 1 .// 2 .^ (8:-1:4)
sim = test_convergence(dts, prob, IMEXEuler())
@test sim.𝒪est[:l∞]≈1 atol=testTol

# IMEXEulerARK
dts = 1 .// 2 .^ (8:-1:4)
sim = test_convergence(dts, prob, IMEXEulerARK())
@test sim.𝒪est[:l∞]≈1 atol=testTol

# CNAB2
dts = 1 .// 2 .^ (8:-1:4)
sim = test_convergence(dts, prob, CNAB2())
@test sim.𝒪est[:l∞]≈2 atol=testTol

# CNLF2
dts = 1 .// 2 .^ (8:-1:4)
sim = test_convergence(dts, prob, CNLF2())
@test sim.𝒪est[:l∞]≈2 atol=testTol

# SBDF2
dts = 1 .// 2 .^ (8:-1:4)
sim = test_convergence(dts, prob, SBDF2())
@test sim.𝒪est[:l∞]≈2 atol=testTol

# SBDF3
dts = 1 .// 2 .^ (8:-1:4)
sim = test_convergence(dts, prob, SBDF3())
@test_broken sim.𝒪est[:l∞]≈3 atol=testTol

# SBDF4
dts = 1 .// 2 .^ (8:-1:4)
sim = test_convergence(dts, prob, SBDF4())
@test_broken sim.𝒪est[:l∞]≈4 atol=testTol

# IRKC
dts = 1 .// 2 .^ (12:-1:8)
sim = test_convergence(dts, prob, IRKC())
@test sim.𝒪est[:l∞]≈1 atol=testTol

using OrdinaryDiffEq, Test, Random, StableRNGs

# Simple ODE for testing: du/dt = 2u
f_oop(u, p, t) = 2u
f_iip(du, u, p, t) = (du .= 2 .* u)

@testset "Integrator RNG Interface" begin
    @testset "Default RNG (rng not provided)" begin
        prob = ODEProblem(f_oop, 0.5, (0.0, 1.0))
        integrator = init(prob, Tsit5())

        @test SciMLBase.has_rng(integrator)
        @test SciMLBase.get_rng(integrator) === Random.default_rng()
    end

    @testset "Custom RNG via init (out-of-place)" begin
        prob = ODEProblem(f_oop, 0.5, (0.0, 1.0))
        rng = Random.Xoshiro(42)
        integrator = init(prob, Tsit5(); rng)

        @test SciMLBase.has_rng(integrator)
        @test SciMLBase.get_rng(integrator) === rng
    end

    @testset "Custom RNG via init (in-place)" begin
        prob = ODEProblem(f_iip, [0.5], (0.0, 1.0))
        rng = Random.Xoshiro(123)
        integrator = init(prob, Tsit5(); rng)

        @test SciMLBase.has_rng(integrator)
        @test SciMLBase.get_rng(integrator) === rng
    end

    @testset "Custom RNG via solve propagates to integrator" begin
        rng_from_callback = Ref{Any}(nothing)
        cb = DiscreteCallback(
            (u, t, integrator) -> true,
            integrator -> begin
                rng_from_callback[] = SciMLBase.get_rng(integrator)
                return nothing
            end
        )

        prob = ODEProblem(f_oop, 0.5, (0.0, 1.0))
        rng = Random.Xoshiro(99)
        sol = solve(prob, Tsit5(); rng, callback = cb)

        @test sol.retcode == ReturnCode.Success
        @test rng_from_callback[] === rng
    end

    @testset "set_rng! replaces the RNG" begin
        prob = ODEProblem(f_oop, 0.5, (0.0, 1.0))
        rng1 = Random.Xoshiro(1)
        integrator = init(prob, Tsit5(); rng = rng1)

        @test SciMLBase.get_rng(integrator) === rng1

        rng2 = Random.Xoshiro(2)
        SciMLBase.set_rng!(integrator, rng2)
        @test SciMLBase.get_rng(integrator) === rng2
    end

    @testset "reinit! with rng kwarg" begin
        prob = ODEProblem(f_oop, 0.5, (0.0, 1.0))
        rng1 = Random.Xoshiro(10)
        integrator = init(prob, Tsit5(); rng = rng1)
        @test SciMLBase.get_rng(integrator) === rng1

        # reinit! without rng should keep existing RNG
        reinit!(integrator)
        @test SciMLBase.get_rng(integrator) === rng1

        # reinit! with rng should replace it
        rng2 = Random.Xoshiro(20)
        reinit!(integrator; rng = rng2)
        @test SciMLBase.get_rng(integrator) === rng2
    end

    @testset "reinit! with rng sets RNG before callback initialization" begin
        rng_seen_in_init = Ref{Any}(nothing)
        cb = DiscreteCallback(
            (u, t, integrator) -> true,
            integrator -> nothing;
            initialize = (cb, u, t, integrator) -> begin
                rng_seen_in_init[] = SciMLBase.get_rng(integrator)
                return nothing
            end
        )

        prob = ODEProblem(f_oop, 0.5, (0.0, 1.0))
        rng1 = Random.Xoshiro(10)
        integrator = init(prob, Tsit5(); rng = rng1, callback = cb)

        rng2 = Random.Xoshiro(20)
        reinit!(integrator; rng = rng2, reinit_callbacks = true)

        # The callback's initialize hook should see rng2, not rng1
        @test rng_seen_in_init[] === rng2
    end

    @testset "RNG preserved across solve! cycle" begin
        prob = ODEProblem(f_oop, 0.5, (0.0, 1.0))
        rng = Random.Xoshiro(42)
        integrator = init(prob, Tsit5(); rng)
        solve!(integrator)

        @test SciMLBase.get_rng(integrator) === rng
        @test integrator.sol.retcode == ReturnCode.Success
    end

    @testset "RNG type parameter is concrete" begin
        prob = ODEProblem(f_oop, 0.5, (0.0, 1.0))
        rng = Random.Xoshiro(42)
        integrator = init(prob, Tsit5(); rng)

        # The RNG type should be a concrete type parameter, not Any
        @test fieldtype(typeof(integrator), :rng) === typeof(rng)
    end

    @testset "Callback can access RNG via get_rng" begin
        rng_from_callback = Ref{Any}(nothing)
        cb = DiscreteCallback(
            (u, t, integrator) -> true,
            integrator -> begin
                rng_from_callback[] = SciMLBase.get_rng(integrator)
                return nothing
            end
        )

        prob = ODEProblem(f_oop, 0.5, (0.0, 1.0))
        rng = Random.Xoshiro(42)
        sol = solve(prob, Tsit5(); rng, callback = cb)

        @test rng_from_callback[] === rng
    end

    @testset "set_rng! with incompatible type throws ArgumentError" begin
        prob = ODEProblem(f_oop, 0.5, (0.0, 1.0))
        rng = Random.Xoshiro(42)
        integrator = init(prob, Tsit5(); rng)

        @test_throws ArgumentError SciMLBase.set_rng!(integrator, Random.MersenneTwister(1))
    end

    @testset "Different solvers support rng kwarg" begin
        prob_oop = ODEProblem(f_oop, 0.5, (0.0, 1.0))
        prob_iip = ODEProblem(f_iip, [0.5], (0.0, 1.0))
        rng = Random.Xoshiro(42)

        for (alg, prob) in [
                (Tsit5(), prob_oop),
                (Vern7(), prob_oop),
                (RK4(), prob_iip),
                (Rosenbrock23(), prob_iip),
            ]
            integrator = init(prob, alg; rng)
            @test SciMLBase.has_rng(integrator)
            @test SciMLBase.get_rng(integrator) === rng
            solve!(integrator)
            @test integrator.sol.retcode == ReturnCode.Success
        end
    end

    @testset "Callback rand draws are reproducible with StableRNG" begin
        # A callback that draws from the integrator RNG at every step
        function make_collecting_callback()
            draws = Float64[]
            cb = DiscreteCallback(
                (u, t, integrator) -> true,
                integrator -> begin
                    push!(draws, rand(SciMLBase.get_rng(integrator)))
                    return nothing
                end
            )
            return cb, draws
        end

        prob = ODEProblem(f_oop, 0.5, (0.0, 1.0))

        cb1, draws1 = make_collecting_callback()
        solve(prob, Tsit5(); rng = StableRNG(42), callback = cb1)

        cb2, draws2 = make_collecting_callback()
        solve(prob, Tsit5(); rng = StableRNG(42), callback = cb2)

        @test !isempty(draws1)
        @test draws1 == draws2
    end

    @testset "Callback rand draws differ with different StableRNG seeds" begin
        function make_collecting_callback()
            draws = Float64[]
            cb = DiscreteCallback(
                (u, t, integrator) -> true,
                integrator -> begin
                    push!(draws, rand(SciMLBase.get_rng(integrator)))
                    return nothing
                end
            )
            return cb, draws
        end

        prob = ODEProblem(f_oop, 0.5, (0.0, 1.0))

        cb1, draws1 = make_collecting_callback()
        solve(prob, Tsit5(); rng = StableRNG(42), callback = cb1)

        cb2, draws2 = make_collecting_callback()
        solve(prob, Tsit5(); rng = StableRNG(99), callback = cb2)

        @test !isempty(draws1)
        @test draws1 != draws2
    end

    @testset "reinit! with new StableRNG resets rand sequence" begin
        draws = Float64[]
        cb = DiscreteCallback(
            (u, t, integrator) -> true,
            integrator -> begin
                push!(draws, rand(SciMLBase.get_rng(integrator)))
                return nothing
            end
        )

        prob = ODEProblem(f_oop, 0.5, (0.0, 1.0))
        integrator = init(prob, Tsit5(); rng = StableRNG(42), callback = cb)
        solve!(integrator)
        draws_run1 = copy(draws)

        empty!(draws)
        reinit!(integrator; rng = StableRNG(42))
        solve!(integrator)
        draws_run2 = draws

        @test !isempty(draws_run1)
        @test draws_run1 == draws_run2
    end

    @testset "StableRNG type parameter is concrete" begin
        prob = ODEProblem(f_oop, 0.5, (0.0, 1.0))
        rng = StableRNG(42)
        integrator = init(prob, Tsit5(); rng)

        @test fieldtype(typeof(integrator), :rng) === StableRNG
        @test SciMLBase.get_rng(integrator) === rng
    end

    @testset "set_rng! works with same StableRNG type" begin
        prob = ODEProblem(f_oop, 0.5, (0.0, 1.0))
        rng1 = StableRNG(1)
        integrator = init(prob, Tsit5(); rng = rng1)

        rng2 = StableRNG(2)
        SciMLBase.set_rng!(integrator, rng2)
        @test SciMLBase.get_rng(integrator) === rng2

        # Cross-type should fail
        @test_throws ArgumentError SciMLBase.set_rng!(integrator, Random.Xoshiro(1))
    end
end

using OrdinaryDiffEq, Test
using OrdinaryDiffEqCore

# Setup a simple ODE problem with several callbacks (to test LLVM code gen)
# We will manually trigger the first callback and check its allocations.
function f!(du, u, p, t)
    du .= .-u
end

cond_1(u, t, integrator) = u[1] - 0.5
cond_2(u, t, integrator) = u[2] + 0.5
cond_3(u, t, integrator) = u[2] + 0.6
cond_4(u, t, integrator) = u[2] + 0.7
cond_5(u, t, integrator) = u[2] + 0.8
cond_6(u, t, integrator) = u[2] + 0.9
cond_7(u, t, integrator) = u[2] + 0.1
cond_8(u, t, integrator) = u[2] + 0.11
cond_9(u, t, integrator) = u[2] + 0.12

function cb_affect!(integrator)
    integrator.p[1] += 1
end

cbs = CallbackSet(ContinuousCallback(cond_1, cb_affect!),
    ContinuousCallback(cond_2, cb_affect!),
    ContinuousCallback(cond_3, cb_affect!),
    ContinuousCallback(cond_4, cb_affect!),
    ContinuousCallback(cond_5, cb_affect!),
    ContinuousCallback(cond_6, cb_affect!),
    ContinuousCallback(cond_7, cb_affect!),
    ContinuousCallback(cond_8, cb_affect!),
    ContinuousCallback(cond_9, cb_affect!))

integrator = init(
    ODEProblem{true, SciMLBase.FullSpecialize}(f!, [0.8, 1.0],
        (0.0, 100.0), [0, 0]), Tsit5(), callback = cbs,
    save_on = false);
# Force a callback event to occur so we can call handle_callbacks! directly.
# Step to a point where u[1] is still > 0.5, so we can force it below 0.5 and
# call handle callbacks
step!(integrator, 0.1, true)

function handle_allocs(integrator)
    integrator.u[1] = 0.4
    @allocations OrdinaryDiffEqCore.handle_callbacks!(integrator)
end
handle_allocs(integrator)
@test_skip handle_allocs(integrator) == 0

using OrdinaryDiffEq, ODEProblemLibrary
using Test

@testset "init" begin
    prob = ODEProblemLibrary.prob_ode_linear
    prob2D = ODEProblemLibrary.prob_ode_2Dlinear

    inferred = [BS3(), Tsit5(), RK4(), Vern6()]
    for alg in inferred
        @inferred init(prob, alg)
        @inferred init(prob2D, alg)
    end

    #notinferred = [SDIRK2(), TRBDF2(), KenCarp4(), Rosenbrock23(), Rodas4()]
    #for alg in notinferred
    #    @test_broken @inferred init(prob, alg)
    #    @test_broken @inferred init(prob2D, alg)
    #end
end

# Regression test for https://github.com/SciML/OrdinaryDiffEq.jl/issues/3200
# AutoVern7 + Rodas5P with both autodiff and linsolve should be inferrable
@testset "AutoVern7 + Rodas5P inference with autodiff and linsolve (#3200)" begin
    using StaticArrays, ADTypes, LinearSolve
    f(u, p, t) = SVector(-p.Ka * u[1], p.Ka * u[1] - p.CL * u[2] / p.Vc)
    u0 = SVector(0.0, 0.0)
    prob = ODEProblem(f, u0, (0.0, 10.0), (Ka = 1.0, CL = 1.0, Vc = 1.0))

    @inferred solve(
        prob,
        AutoVern7(
            Rodas5P(
                autodiff = AutoForwardDiff(chunksize = 1),
                linsolve = GenericLUFactorization()
            )
        )
    )
end

using OrdinaryDiffEq, BenchmarkTools, DiffEqBase
using LinearAlgebra, SparseArrays, StaticArrays, StableRNGs

const SUITE = BenchmarkGroup()

# =============================================================================
# Non-Stiff ODE Problems
# =============================================================================

SUITE["nonstiff"] = BenchmarkGroup()

# Lotka-Volterra (Predator-Prey) Problem
function lotka_volterra!(du, u, p, t)
    α, β, γ, δ = p
    x, y = u
    du[1] = α*x - β*x*y  # dx/dt
    du[2] = δ*x*y - γ*y  # dy/dt
    nothing
end

function lotka_volterra_prob()
    p = (1.5, 1.0, 3.0, 1.0)  # α, β, γ, δ
    u0 = [1.0, 1.0]
    tspan = (0.0, 10.0)
    ODEProblem(lotka_volterra!, u0, tspan, p)
end

# Pleiades Problem (7-body celestial mechanics)
function pleiades!(du, u, p, t)
    # u[1:7] = x positions, u[8:14] = y positions
    # u[15:21] = x velocities, u[22:28] = y velocities
    x = @view u[1:7]
    y = @view u[8:14]
    vx = @view u[15:21]
    vy = @view u[22:28]

    # Copy velocities to position derivatives
    du[1:7] .= vx
    du[8:14] .= vy

    # Calculate accelerations
    fill!(du[15:21], 0.0)
    fill!(du[22:28], 0.0)

    for i in 1:7
        for j in 1:7
            if i != j
                dx = x[j] - x[i]
                dy = y[j] - y[i]
                r = sqrt(dx^2 + dy^2)
                r3 = r^3
                du[14 + i] += j * dx / r3  # mass j = j
                du[21 + i] += j * dy / r3
            end
        end
    end
    nothing
end

function pleiades_prob()
    # Initial conditions from literature
    u0 = [3.0, 3.0, -1.0, -3.0, 2.0, -2.0, 2.0, 3.0, -3.0, 2.0, 0, 0, -4.0, 4.0,
        0, 0, 0, 0, 0, 1.75, -1.5, 0, 0, 0, -1.25, 1, 0, 0]
    tspan = (0.0, 3.0)
    ODEProblem(pleiades!, u0, tspan)
end

# FitzHugh-Nagumo Model
function fitzhugh_nagumo!(du, u, p, t)
    a, b, c = p
    v, w = u
    du[1] = c * (v - v^3/3 + w)    # dv/dt
    du[2] = -(v - a + b*w) / c     # dw/dt
    nothing
end

function fitzhugh_nagumo_prob()
    p = (0.7, 0.8, 12.5)
    u0 = [-1.0, 1.0]
    tspan = (0.0, 20.0)
    ODEProblem(fitzhugh_nagumo!, u0, tspan, p)
end

# =============================================================================
# Stiff ODE Problems
# =============================================================================

SUITE["stiff"] = BenchmarkGroup()

# ROBER Problem (Robertson chemical kinetics)
function rober!(du, u, p, t)
    k1, k2, k3 = p
    y1, y2, y3 = u
    du[1] = -k1*y1 + k3*y2*y3         # dy1/dt
    du[2] = k1*y1 - k2*y2^2 - k3*y2*y3   # dy2/dt
    du[3] = k2*y2^2                   # dy3/dt
    nothing
end

function rober_prob()
    p = (0.04, 3e7, 1e4)  # k1, k2, k3
    u0 = [1.0, 0.0, 0.0]
    tspan = (0.0, 1e5)
    ODEProblem(rober!, u0, tspan, p)
end

# Van der Pol Oscillator (stiff)
function van_der_pol!(du, u, p, t)
    μ = p[1]
    x, y = u
    du[1] = y                      # dx/dt
    du[2] = μ * ((1 - x^2)*y - x)  # dy/dt
    nothing
end

function van_der_pol_prob()
    p = [1e6]  # very stiff
    u0 = [1.0, 1.0]
    tspan = (0.0, 6.3)
    ODEProblem(van_der_pol!, u0, tspan, p)
end

# Pollution Problem (atmospheric chemistry, 20D stiff system)
const k1=.35e0
const k2=.266e2
const k3=.123e5
const k4=.86e-3
const k5=.82e-3
const k6=.15e5
const k7=.13e-3
const k8=.24e5
const k9=.165e5
const k10=.9e4
const k11=.22e-1
const k12=.12e5
const k13=.188e1
const k14=.163e5
const k15=.48e7
const k16=.35e-3
const k17=.175e-1
const k18=.1e9
const k19=.444e12
const k20=.124e4
const k21=.21e1
const k22=.578e1
const k23=.474e-1
const k24=.178e4
const k25=.312e1

function pollution!(dy, y, p, t)
    r1 = k1 * y[1]
    r2 = k2 * y[2] * y[4]
    r3 = k3 * y[5] * y[2]
    r4 = k4 * y[7]
    r5 = k5 * y[7]
    r6 = k6 * y[7] * y[6]
    r7 = k7 * y[9]
    r8 = k8 * y[9] * y[6]
    r9 = k9 * y[11] * y[2]
    r10 = k10*y[11]*y[1]
    r11 = k11*y[13]
    r12 = k12*y[10]*y[2]
    r13 = k13*y[14]
    r14 = k14*y[1]*y[6]
    r15 = k15*y[3]
    r16 = k16*y[4]
    r17 = k17*y[4]
    r18 = k18*y[16]
    r19 = k19*y[16]
    r20 = k20*y[17]*y[6]
    r21 = k21*y[19]
    r22 = k22*y[19]
    r23 = k23*y[1]*y[4]
    r24 = k24*y[19]*y[1]
    r25 = k25*y[20]

    dy[1] = -r1-r10-r14-r23-r24 + r2 + r3 + r9 + r11 + r12 + r22 + r25
    dy[2] = -r2-r3-r9-r12+r1+r21
    dy[3] = -r15+r1+r17+r19+r22
    dy[4] = -r2-r16-r17-r23+r15
    dy[5] = -r3+r4+r4+r6+r7+r13+r20
    dy[6] = -r6-r8-r14-r20+r3+r18+r18
    dy[7] = -r4-r5-r6+r13
    dy[8] = r4+r5+r6+r7
    dy[9] = -r7-r8
    dy[10] = -r12+r7+r9
    dy[11] = -r9-r10+r8+r11
    dy[12] = r9
    dy[13] = -r11+r10
    dy[14] = -r13+r12
    dy[15] = r14
    dy[16] = -r18-r19+r16
    dy[17] = -r20
    dy[18] = r20
    dy[19] = -r21-r22-r24+r23+r25
    dy[20] = -r25+r24
    nothing
end

function pollution_prob()
    u0 = zeros(20)
    u0[2] = 0.2
    u0[4] = 0.04
    u0[7] = 0.1
    u0[8] = 0.3
    u0[9] = 0.01
    u0[17] = 0.007
    tspan = (0.0, 60.0)
    ODEProblem(pollution!, u0, tspan)
end

# =============================================================================
# Scaling Problems (different dimensions)
# =============================================================================

SUITE["scaling"] = BenchmarkGroup()

# Linear ODE with varying dimensions
function linear_ode!(du, u, p, t)
    A = p
    mul!(du, A, u)
    nothing
end

function create_linear_prob(N::Int)
    rng = StableRNG(123)  # Fixed seed for reproducibility
    A = randn(rng, N, N)
    A = A - A'  # Make skew-symmetric for bounded solutions
    u0 = randn(rng, N)
    tspan = (0.0, 1.0)
    ODEProblem(linear_ode!, u0, tspan, A)
end

# Brusselator PDE (2D reaction-diffusion from advanced ODE example)
# Forcing function - creates a localized disturbance
brusselator_f(x, y, t) = (((x - 0.3)^2 + (y - 0.6)^2) <= 0.1^2) * (t >= 1.1) * 5.0

# Periodic boundary condition helper
limit(a, N) = a == N + 1 ? 1 : a == 0 ? N : a

function brusselator_2d!(du, u, p, t)
    A, B, α, dx, N = p
    α = α / dx^2

    # Create coordinate arrays for this N
    xyd = range(0, stop = 1, length = N)

    @inbounds for I in CartesianIndices((N, N))
        i, j = Tuple(I)
        x, y = xyd[i], xyd[j]
        ip1, im1, jp1,
        jm1 = limit(i + 1, N), limit(i - 1, N), limit(j + 1, N), limit(j - 1, N)

        # u equation: ∂u/∂t = 1 + u²v - 4.4u + α∇²u + f(x,y,t)
        du[i, j, 1] = α * (u[im1, j, 1] + u[ip1, j, 1] + u[i, jp1, 1] + u[i, jm1, 1] - 4*u[i, j, 1]) + B + u[i, j, 1]^2 * u[i, j, 2] - (A + 1) * u[i, j, 1] + brusselator_f(x, y, t)

        # v equation: ∂v/∂t = 3.4u - u²v + α∇²v  
        du[i, j, 2] = α * (u[im1, j, 2] + u[ip1, j, 2] + u[i, jp1, 2] + u[i, jm1, 2] - 4*u[i, j, 2]) + A * u[i, j, 1] - u[i, j, 1]^2 * u[i, j, 2]
    end
    nothing
end

function init_brusselator_2d(N::Int)
    xyd = range(0, stop = 1, length = N)
    u = zeros(N, N, 2)
    for I in CartesianIndices((N, N))
        x = xyd[I[1]]
        y = xyd[I[2]]
        u[I, 1] = 22 * (y * (1 - y))^(3/2)  # u initial condition
        u[I, 2] = 27 * (x * (1 - x))^(3/2)  # v initial condition  
    end
    u
end

function create_brusselator_2d_prob(N::Int)
    A, B, α = 3.4, 1.0, 10.0
    xyd = range(0, stop = 1, length = N)
    dx = step(xyd)
    u0 = init_brusselator_2d(N)
    tspan = (0.0, 11.5)
    ODEProblem(brusselator_2d!, u0, tspan, (A, B, α, dx, N))
end

# =============================================================================
# Benchmark Definitions
# =============================================================================

# Non-stiff benchmarks with different solvers
lv_prob = lotka_volterra_prob()
pl_prob = pleiades_prob()
fn_prob = fitzhugh_nagumo_prob()

# Explicit RK methods for non-stiff problems
explicit_solvers = [Tsit5(), Vern6(), Vern7(), DP5(), BS3()]

SUITE["nonstiff"]["lotka_volterra"] = BenchmarkGroup()
SUITE["nonstiff"]["pleiades"] = BenchmarkGroup()
SUITE["nonstiff"]["fitzhugh_nagumo"] = BenchmarkGroup()

for solver in explicit_solvers
    solver_name = string(typeof(solver).name.name)
    SUITE["nonstiff"]["lotka_volterra"][solver_name] = @benchmarkable solve(
        $lv_prob, $solver, reltol = 1e-6, abstol = 1e-8)
    SUITE["nonstiff"]["pleiades"][solver_name] = @benchmarkable solve(
        $pl_prob, $solver, reltol = 1e-6, abstol = 1e-8)
    SUITE["nonstiff"]["fitzhugh_nagumo"][solver_name] = @benchmarkable solve(
        $fn_prob, $solver, reltol = 1e-6, abstol = 1e-8)
end

# Stiff benchmarks with different solvers
rober_prob_instance = rober_prob()
vdp_prob = van_der_pol_prob()
pollution_prob_instance = pollution_prob()

# Stiff solvers
stiff_solvers = [Rosenbrock23(), Rodas4(), TRBDF2(), KenCarp4(), FBDF()]

SUITE["stiff"]["rober"] = BenchmarkGroup()
SUITE["stiff"]["van_der_pol"] = BenchmarkGroup()
SUITE["stiff"]["pollution"] = BenchmarkGroup()

for solver in stiff_solvers
    solver_name = string(typeof(solver).name.name)
    SUITE["stiff"]["rober"][solver_name] = @benchmarkable solve(
        $rober_prob_instance, $solver, reltol = 1e-6, abstol = 1e-8)
    SUITE["stiff"]["van_der_pol"][solver_name] = @benchmarkable solve(
        $vdp_prob, $solver, reltol = 1e-6, abstol = 1e-8)
    SUITE["stiff"]["pollution"][solver_name] = @benchmarkable solve(
        $pollution_prob_instance, $solver, reltol = 1e-6, abstol = 1e-8)
end

# Scaling benchmarks
SUITE["scaling"]["linear"] = BenchmarkGroup()
SUITE["scaling"]["brusselator_2d"] = BenchmarkGroup()

# Linear ODE scaling (different problem sizes)
for N in [10, 50, 100]
    prob = create_linear_prob(N)
    SUITE["scaling"]["linear"]["N$N"] = @benchmarkable solve($prob, Tsit5(), reltol = 1e-6, abstol = 1e-8)
end

# Brusselator 2D scaling (different grid sizes)
for N in [8, 16, 32]
    prob = create_brusselator_2d_prob(N)
    SUITE["scaling"]["brusselator_2d"]["$(N)x$(N)"] = @benchmarkable solve($prob, TRBDF2(),
        reltol = 1e-4, abstol = 1e-6, maxiters = 1000)
end

# =============================================================================
# Problem Construction Benchmarks
# =============================================================================

SUITE["construction"] = BenchmarkGroup()

# Test problem construction overhead
SUITE["construction"]["lotka_volterra"] = @benchmarkable lotka_volterra_prob()
SUITE["construction"]["rober"] = @benchmarkable rober_prob()
SUITE["construction"]["linear_N50"] = @benchmarkable create_linear_prob(50)

using OrdinaryDiffEq, StaticArrays, Test, ADTypes

adchoices = if isempty(VERSION.prerelease)
    using Enzyme
end

function time_derivative(du, u, p, t)
    du[1] = -t
end
function time_derivative_static(u, p, t)
    SVector(-t)
end
function time_derivative_analytic(u0, p, t)
    u0 .- t .^ 2 ./ 2
end

adchoices = if isempty(VERSION.prerelease)
    (AutoForwardDiff(), AutoFiniteDiff(),
        AutoEnzyme(mode = Enzyme.Forward, function_annotation = Enzyme.Const))
else
    (AutoForwardDiff(), AutoFiniteDiff())
end

const CACHE_TEST_ALGS = [Euler(), Midpoint(), RK4(), SSPRK22(), SSPRK33(), SSPRK53(),
    SSPRK63(), SSPRK73(), SSPRK83(), SSPRK43(), SSPRK432(), SSPRK932(), SSPRK54(),
    SSPRK104(), CarpenterKennedy2N54(),
    BS3(), BS5(), DP5(), DP8(), Feagin10(), Feagin12(), Feagin14(), TanYam7(),
    Tsit5(), TsitPap8(), Vern6(), Vern7(), Vern8(), Vern9(), OwrenZen3(), OwrenZen4(),
    OwrenZen5()]

tspan = (0.0, 1.0)

for (ff_time_derivative, u0) in (
    (ODEFunction(time_derivative,
            analytic = time_derivative_analytic), [1.0]),
    (ODEFunction(time_derivative_static,
            analytic = time_derivative_analytic),
        SVector(1.0)))
    @info "StaticArrays?: $(u0 isa StaticArray)"

    prob = ODEProblem(ff_time_derivative, u0, tspan)

    for _autodiff in adchoices
        @info "autodiff=$(_autodiff)"

        prec = !(_autodiff == AutoFiniteDiff())

        @show Rosenbrock23
        sol = solve(prob, Rosenbrock32(autodiff = _autodiff), reltol = 1e-9, abstol = 1e-9)
        @test sol.errors[:final] < 1e-5 * 10^(!prec)
        sol = solve(prob, Rosenbrock23(autodiff = _autodiff), reltol = 1e-9, abstol = 1e-9)
        @test sol.errors[:final] < 1e-10 * 10_000^(!prec)

        @show Rodas4
        sol = solve(prob, Rodas4(autodiff = _autodiff), reltol = 1e-9, abstol = 1e-9)
        @test sol.errors[:final] < 1e-10 * 100_000^(!prec)

        @show Rodas5
        sol = solve(prob, Rodas5(autodiff = _autodiff), reltol = 1e-9, abstol = 1e-9)
        @test sol.errors[:final] < 1e-10 * 1_000_000_000^(!prec)

        @show Veldd4
        sol = solve(prob, Veldd4(autodiff = _autodiff), reltol = 1e-9, abstol = 1e-9)
        @test sol.errors[:final] < 1e-10 * 100_000^(!prec)

        @show KenCarp3
        sol = solve(prob, KenCarp3(autodiff = _autodiff), reltol = 1e-12, abstol = 1e-12)
        @test length(sol) > 2
        @test SciMLBase.successful_retcode(sol)
        @test sol.errors[:final] < 1e-10

        @show KenCarp4
        sol = solve(prob, KenCarp4(autodiff = _autodiff), reltol = 1e-12, abstol = 1e-12)
        @test length(sol) > 2
        @test SciMLBase.successful_retcode(sol)
        @test sol.errors[:final] < 1e-10

        @show KenCarp47
        sol = solve(prob, KenCarp47(autodiff = _autodiff), reltol = 1e-12, abstol = 1e-12)
        @test length(sol) > 2
        @test SciMLBase.successful_retcode(sol)
        @test sol.errors[:final] < 1e-10

        @show KenCarp5
        sol = solve(prob, KenCarp5(autodiff = _autodiff), reltol = 1e-12, abstol = 1e-12)
        @test length(sol) > 2
        @test SciMLBase.successful_retcode(sol)
        @test sol.errors[:final] < 1e-10

        @show KenCarp58
        sol = solve(prob, KenCarp58(autodiff = _autodiff), reltol = 1e-12, abstol = 1e-12)
        @test length(sol) > 2
        @test SciMLBase.successful_retcode(sol)
        @test sol.errors[:final] < 1e-10

        @show TRBDF2
        sol = solve(prob, TRBDF2(autodiff = _autodiff), reltol = 1e-9, abstol = 1e-9)
        @test sol.errors[:final] < 1e-10

        @show ImplicitEuler
        sol = solve(prob, ImplicitEuler(autodiff = _autodiff), dt = 1 / 10)
        @test sol.errors[:final] < 1e-1

        @show Trapezoid
        sol = solve(prob, Trapezoid(autodiff = _autodiff), dt = 1 / 10)
        @test sol.errors[:final] < 1e-12
    end

    @show Euler
    sol = solve(prob, Euler(), dt = 1 / 100)
    @test sol.errors[:final] < 6e-3

    for alg in CACHE_TEST_ALGS
        @show alg
        sol = solve(prob, alg, dt = 1 / 10)
        if !(alg isa Euler)
            @test sol.errors[:final] < 4e-14
        end
    end
end

using OrdinaryDiffEq, DiffEqDevTools, Test

function nonauto1(u, p, t)
    x, _ = u
    return [
        t * x
        0
    ]
end

function nonauto2(u, p, t)
    _, y = u
    return [
        y,
        t * y,
    ]
end

function analytic(u0, p, t)
    x0, y0 = u0
    et = exp(t^2 / 2)
    return [
        et * (x0 + t * y0),
        et * y0,
    ]
end

u0 = [1.1, 2.2]
tspan = (0.0, 1.0)
prob1 = ODEProblem(
    ODEFunction{true}(
        (du, u, p, t) -> du .= nonauto1(u, p, t) .+
            nonauto2(u, p, t),
        analytic = analytic
    ),
    u0, tspan
)
prob2 = ODEProblem(
    ODEFunction{false}(
        (u, p, t) -> nonauto1(u, p, t) .+ nonauto2(u, p, t),
        analytic = analytic
    ),
    u0, tspan
)
prob3 = SplitODEProblem(
    SplitFunction{true}(
        (du, u, p, t) -> du .= nonauto1(u, p, t),
        (du, u, p, t) -> du .= nonauto2(u, p, t),
        analytic = analytic
    ),
    u0, tspan
)
prob4 = SplitODEProblem(
    SplitFunction{false}(
        nonauto1,
        nonauto2,
        analytic = analytic
    ),
    u0, tspan
)

testTol = 0.2

kwargs = (reltol = 1.0e-16, abstol = 1.0e-16)
for prob in [prob1, prob2, prob3, prob4]
    dts = 1 .// 2 .^ (12:-1:8)
    sim = test_convergence(dts, prob, KenCarp3(); kwargs...)
    @test sim.𝒪est[:l∞] ≈ 3 atol = testTol
    dts = 1 .// 2 .^ (9:-1:6)
    sim = test_convergence(dts, prob, CFNLIRK3(); kwargs...)
    @test sim.𝒪est[:l∞] ≈ 3 atol = testTol
    sim = test_convergence(dts, prob, KenCarp4(); kwargs...)
    @test sim.𝒪est[:l∞] ≈ 4 atol = testTol
    sim = test_convergence(dts, prob, KenCarp47(); kwargs...)
    @test sim.𝒪est[:l∞] ≈ 4 atol = testTol
    dts = 1 .// 2 .^ (7:-1:4)
    sim = test_convergence(dts, prob, KenCarp5(); kwargs...)
    @test sim.𝒪est[:l∞] ≈ 5 atol = testTol
    sim = test_convergence(dts, prob, KenCarp58(); kwargs...)
    @test sim.𝒪est[:l∞] ≈ 5 atol = testTol
end
for prob in [prob1, prob2]
    dts = 1 .// 2 .^ (7:-1:4)
    sim = test_convergence(dts, prob, ESDIRK54I8L2SA(); kwargs...)
    @test sim.𝒪est[:l∞] ≈ 5 atol = testTol
    dts = 1 .// 2 .^ (8:-1:4)
    sim = test_convergence(dts, prob, Rodas4(); kwargs...)
    @test sim.𝒪est[:l∞] ≈ 4 atol = testTol + 0.1
    dts = 1 .// 2 .^ (7:-1:3)
    sim = test_convergence(dts, prob, Rodas5(); kwargs...)
    @test sim.𝒪est[:l∞] ≈ 5 atol = testTol + 0.1
end

#=
prob = prob2
dts = 1 .//2 .^(9:-1:6)
sim = test_convergence(dts,prob,KenCarp4())
sim.𝒪est[:l∞]

using Plots
plot(sim)
=#

using OrdinaryDiffEq, SparseArrays, LinearAlgebra, Test

function explicit_fun(du, _, _, _)
    du .= 0
    nothing
end

#Capillary leveling in an axisymmetric polar domain
@views function capillary_leveling(du, u, dr, nodes, boundaries)
    #Boundary conditions
    h = similar(u, length(u) + 4)
    h[3:(end - 2)] .= u
    h[2:-1:1] .= u[1:2]
    h[(end - 1):end] .= u[end]
    tmp = similar(h)

    #r*dh/dr
    @. tmp[1:(end - 1)] = (h[2:end] - h[1:(end - 1)]) / dr * boundaries
    #Capillary pressure p=-1/r*d/dr(r*dh/dr)
    @. tmp[2:(end - 1)] = -(tmp[2:(end - 1)] - tmp[1:(end - 2)]) / dr / nodes[2:(end - 1)]
    #Disjoining pressure A/h^3
    @. tmp[2:(end - 1)] -= 1E-3 / h[2:(end - 1)]^3

    #r*h^3*dp/dr
    @. tmp[2:(end - 2)] = (tmp[3:(end - 1)] - tmp[2:(end - 2)]) / dr *
                          boundaries[2:(end - 1)] * (h[2:(end - 2)]^3 + h[3:(end - 1)]^3) /
                          2
    #1/3*1/r*d/dr(r*h^3*dp/dr)
    @. du = (tmp[3:(end - 2)] - tmp[2:(end - 3)]) / dr / nodes[3:(end - 2)] / 3
    nothing
end

#Initial droplet shape
function droplet(r, h_p)
    if r <= 1
        h_p + (2 - h_p) * (1 - r^2)
    else
        h_p
    end
end

tspan = [0, 1E-2]
N = 1000
dr = 4 / N
r = @. dr / 2 + dr * (0:(N - 1))
h0 = map(x -> droplet(x, 1E-4), r)
r = [r[2]; r[1]; r; r[end]; r[end]]
boundaries = @. (r[1:(end - 1)] + r[2:end]) / 2

jac_proto = spdiagm(0 => ones(N), -1 => ones(N - 1), 1 => ones(N - 1), -2 => ones(N - 2),
    2 => ones(N - 2))

fun = ODEFunction((dh, h, p, t) -> capillary_leveling(dh, h, dr, r, boundaries),
    jac_prototype = jac_proto)
prob = ODEProblem(fun, h0, tspan)

#Should be functionally equivalent to above, explicit_fun does nothing
sfun = SplitFunction(fun, explicit_fun, jac_prototype = jac_proto)
sprob = SplitODEProblem(sfun, h0, tspan)

#CFNLIRK3 has same erroneous FSAL logic as KenCarp solvers
#Can't efficiently test with stiff problem (to cause dtmin issue) because it requires constant dt
@test_broken solve(sprob, CFNLIRK3(), reltol = 1E-8, dt = 1E-5).retcode ==
             ReturnCode.Success

for Alg in (KenCarp3, KenCarp4, KenCarp5, KenCarp47, KenCarp58)
    print(Alg)
    sol = solve(prob, Alg(), reltol = 1E-8)
    @test sol.retcode == ReturnCode.Success

    split_sol = solve(sprob, Alg(), reltol = 1E-8)
    @test split_sol.retcode == ReturnCode.Success

    L2 = norm(sol[end] .- split_sol[end]) / sqrt(N)
    println(" ", L2)
    @test L2 < 1E-6
end

using OrdinaryDiffEq, Test

f(u, p, t) = u
prob = ODEProblem(f, 1.0, (0.0, 100eps(1.0)))
dt = 4.7eps(1.0)
cond(u, p, t) = u - exp(70eps(1.0))

c = Ref(0)
function affect!(integrator)
    c[] += 1
end
cb = ContinuousCallback(cond, affect!)
@info "Event Repeat Test 1"
sol = solve(prob, Tsit5(); adaptive = false, callback = cb, dt = dt, save_everystep = false)
@test c[] == 1

function condition_v(out, u, t, integrator)
    out[1] = u - exp(50eps(1.0))
    out[2] = u - exp(60eps(1.0))
    out[3] = u - exp(70eps(1.0))
    out[4] = u - exp(80eps(1.0))
    out[5] = u - exp(90eps(1.0))
end

c1 = Ref(0)
c2 = Ref(0)
c3 = Ref(0)
c4 = Ref(0)
c5 = Ref(0)

function affect_v!(integrator, idx)
    if idx == 1
        c1[] += 1
    elseif idx == 2
        c2[] += 1
    elseif idx == 3
        c3[] += 1
    elseif idx == 4
        c4[] += 1
    elseif idx == 5
        c5[] += 1
    end
end

cb = VectorContinuousCallback(condition_v, affect_v!, 5)
@info "Event Repeat Test 2"
sol = solve(prob, Tsit5(); adaptive = false, callback = cb, dt = dt, save_everystep = false)

@test c1[] == 1
@test c2[] == 1
@test c3[] == 1
@test c4[] == 1
@test c5[] == 1

using OrdinaryDiffEq, ADTypes, Test, Random, LinearAlgebra, SparseArrays

# Parameters
Nc = 22
η = 1.0
κ = 1.0
T = (0.0, 100.0)

# Matrix definitions
A = sparse(diagm(1 => sqrt.(Complex[1:Nc;])))
H = η * (A + A') - 1.0im * κ * A' * A

u0 = zeros(ComplexF64, Nc + 1)
u0[1] = 1.0
function f_psos(du, u, t, p)
    du .= -1.0im * H * u
end

# Callback
rng = MersenneTwister(rand(UInt))
jumpnorm = Ref(rand(rng))
djumpnorm(x::Vector{ComplexF64}, t, integrator) = norm(x)^2 - (1 - jumpnorm[])
function dojump(integrator)
    x = integrator.u
    t = integrator.t

    x .= normalize(A * x)
    jumpnorm[] = rand(rng)
end

cb = ContinuousCallback(djumpnorm, dojump)

prob = ODEProblem{true}(f_psos, u0, T)

sol_tot = []
Ntraj = 100
for i in 1:Ntraj
    rng = MersenneTwister(rand(UInt))
    # Tweaking tolerances and dtmax also is not reliable
    sol = solve(prob, DP5(), save_everystep = true, callback = cb,
        abstol = 1e-8, reltol = 1e-6, dtmax = 10)
    push!(sol_tot, sol)
end

# This number has to be η^2/κ^2 in steady-state; all trajectories should converge there
n = [[norm(A * normalize(s.u[j]))^2 for j in 1:length(s.t)] for s in sol_tot]

@test all(η^2 / κ^2 .≈ [k[end] for k in n])

#=
using Plots
gr()

p1 = plot(sol_tot[1].t, n[1], lw = 2)
for i=2:Ntraj
    plot!(p1,sol_tot[i].t, n[i])
end

p2 = plot(sol_tot[1].t, norm.(sol_tot[1].u).^2)
for i=2:Ntraj
    plot!(p2,sol_tot[i].t, norm.(sol_tot[i].u).^2)
end
=#

using OrdinaryDiffEq, NonlinearSolve, DiffEqCallbacks, Test

# Initial state
u0 = [0, -0.25, 0.42081, 0]

function hheom!(du, u, p, t)
    du[1] = u[3]
    du[2] = u[4]
    du[3] = -u[1] - 2u[1] * u[2]
    du[4] = -u[2] - (u[1]^2 - u[2]^2)
    return nothing
end

@inline Vhh(q1, q2) = 1 // 2 * (q1^2 + q2^2 + 2q1^2 * q2 - 2 // 3 * q2^3)
@inline Thh(p1, p2) = 1 // 2 * (p1^2 + p2^2)
@inline Hhh(q1, q2, p1, p2) = Thh(p1, p2) + Vhh(q1, q2)
@inline Hhh(u::AbstractVector) = Hhh(u...)

# Energy
const E = Hhh(u0)

function ghh(resid, u, p)
    resid[1] = -Hhh(u[1], u[2], u[3], u[4]) + E
end

# energy conserving callback:
# important to use save = false, I don't want rescaling points
cb = ManifoldProjection(ghh, resid_prototype = ones(1), nlsolve = TrustRegion(), abstol = 1e-9, save = false, autodiff = AutoForwardDiff())

# Callback for Poincare surface of section
function psos_callback(j, direction = +1, offset::Real = 0,
        callback_kwargs = Dict{Symbol, Any}(:abstol => 1e-9))

    # Prepare callback:
    s = sign(direction)
    cond = (u, t, integrator) -> s * (u - offset)
    affect! = (integrator) -> nothing

    cb = SciMLBase.ContinuousCallback(cond, nothing, affect!; callback_kwargs...,
        save_positions = (true, false), idxs = j)
end

# with this callback, the saved values of variable 1 should be zero
poincarecb = psos_callback(1)

totalcb = CallbackSet(poincarecb, cb)

prob = ODEProblem(hheom!, u0, (0.0, 100.0), callback = totalcb)

extra_kw = Dict(:save_start => false, :save_end => false)
DEFAULT_DIFFEQ_KWARGS = Dict{Symbol, Any}(:abstol => 1e-10, :reltol => 1e-10)

sol = solve(prob, Vern9(); extra_kw..., DEFAULT_DIFFEQ_KWARGS..., save_everystep = false)

Es = [Hhh(sol[:, i]) for i in 1:length(sol)]
Eerror = maximum(@. abs(E - Es))

a = sol[1, :]

@test Eerror < 1e-10
for el in a
    @test abs(el) < 1e-10
end

using OrdinaryDiffEq, Test
import SciMLBase

function lorenz!(du, u, p, t)
    du[1] = 10.0 * (u[2] - u[1])
    du[2] = u[1] * (28.0 - u[3]) - u[2]
    du[3] = u[1] * u[2] - (8 / 3) * u[3]
end

u0 = [1.0; 0.0; 0.0]
tspan = (0.0, 0.5)
prob = ODEProblem(lorenz!, u0, tspan)

rosenbrock_sol = solve(prob, Rosenbrock23())
TRBDF_sol = solve(prob, TRBDF2())
vern_sol = solve(prob, Vern7())
default_sol = solve(prob)
@testset "Interpolation Stripping" begin
    @test isnothing(SciMLBase.strip_interpolation(rosenbrock_sol.interp).f)
    @test isnothing(SciMLBase.strip_interpolation(rosenbrock_sol.interp).cache.jac_config)
    @test isnothing(SciMLBase.strip_interpolation(rosenbrock_sol.interp).cache.grad_config)
end

@testset "Rosenbrock Solution Stripping" begin
    stripped_sol = SciMLBase.strip_solution(rosenbrock_sol)
    @test stripped_sol.prob isa NamedTuple
    @test isnothing(SciMLBase.strip_solution(rosenbrock_sol, strip_alg = true).alg)
    @test isnothing(stripped_sol.interp.f)
    @test isnothing(stripped_sol.interp.cache.jac_config)
    @test isnothing(stripped_sol.interp.cache.grad_config)
    @test isnothing(stripped_sol.interp.cache.uf)
    @test isnothing(stripped_sol.interp.cache.tf)
end

@testset "TRBDF Solution Stripping" begin
    stripped_sol = SciMLBase.strip_solution(TRBDF_sol)
    @test stripped_sol.prob isa NamedTuple
    @test isnothing(SciMLBase.strip_solution(TRBDF_sol, strip_alg = true).alg)
    @test isnothing(stripped_sol.interp.f)
    @test isnothing(stripped_sol.interp.cache.nlsolver)
end

@testset "Default Solution Stripping" begin
    stripped_sol = SciMLBase.strip_solution(default_sol)
    @test isnothing(stripped_sol.interp.cache.args)
end

@test_throws SciMLBase.LazyInterpolationException SciMLBase.strip_solution(vern_sol)

using OrdinaryDiffEq, ADTypes

# https://github.com/JuliaDiffEq/DifferentialEquations.jl/issues/390
solve(ODEProblem((x, p, t) -> -x, 1.0, (0.0, 50.0)),
    Rosenbrock23(autodiff = AutoFiniteDiff()))

using OrdinaryDiffEq, Test
import ODEProblemLibrary: prob_ode_2Dlinear
prob = prob_ode_2Dlinear

integrator = init(prob, Euler(); dt = 1 // 2^(4))
integrator = init(prob, Tsit5(); dt = 1 // 2^(4))

solve!(integrator)

sol = solve(prob, Euler(); dt = 1 // 2^(4), maxiters = Inf)
sol = solve(prob, Tsit5(); dt = 1 // 2^(20), progress = true, adaptive = false,
    maxiters = Inf)

# plot(sol,plot_analytic=true)

sol = solve(prob, ExplicitRK(); dt = 1 // 2^(4))

# out-of-place 2D prob to test vec & reshape
rhs_oop(u, p, t) = u
ft0 = ones(2, 2)
tspan = (0.0, 30.0)
prob = ODEProblem(rhs_oop, ft0, tspan)
@test_nowarn solve(prob, Rosenbrock23())
@test_nowarn solve(prob, Rodas4())
@test_nowarn solve(prob, Kvaerno5())

using OrdinaryDiffEq, Random

# Simple Poisson random number generator using Knuth's algorithm
function pois_rand(λ::Float64)
    L = exp(-λ)
    k = 0
    p = 1.0
    while p > L
        k += 1
        p *= rand()
    end
    return k - 1
end

function rate_to_proportion(r::Float64, t::Float64)
    1 - exp(-r * t)
end;

function sir_abm!(du, u, p, t)
    (β, c, γ, δt) = p
    N = length(u)
    # Initialize du to u
    for i in 1:N
        du[i] = u[i]
    end
    for i in 1:N # loop through agents
        # If recovered
        if u[i] == Recovered
            continue
            # If susceptible
        elseif u[i] == Susceptible
            ncontacts = pois_rand(c * δt)
            while ncontacts > 0
                j = rand(1:N)
                if j == i
                    continue
                end
                a = u[j]
                if a == Infected && rand() < β
                    du[i] = Infected
                    break
                end
                ncontacts -= 1
            end
            # If infected
        else
            u[i] == Infected
            if rand() < γ
                du[i] = Recovered
            end
        end
    end
    nothing
end

δt = 0.1
nsteps = 400
tf = nsteps * δt
tspan = (0.0, nsteps)
t = 0:δt:tf;
β = 0.05
c = 10.0
γ = rate_to_proportion(0.25, δt)
p = [β, c, γ, δt]

@enum InfectionStatus Susceptible Infected Recovered

N = 1000
I0 = 10
u0 = Array{InfectionStatus}(undef, N);
for i in 1:N
    if i <= I0
        s = Infected
    else
        s = Susceptible
    end
    u0[i] = s
end

prob_map = DiscreteProblem(sir_abm!, u0, tspan, p)
sol_map = solve(prob_map, FunctionMap())

using OrdinaryDiffEq, Test, ForwardDiff

# Test problem
# u' = p(t)u; p(t) = p if t <= tstop, 0 otherwise
# Target: du(1.0)/dtstop = exp(tstop)u0

u0 = 1.0
tspan = (0.0, 1.0)
p = 1.0
times_finalize_called = 0
function stopping_cb(tstop)
    condition = (u, t, integrator) -> t == tstop
    affect! = integrator -> (println("Stopped!"); integrator.p = zero(integrator.p))
    DiscreteCallback(
        condition, affect!, finalize = (args...) -> global times_finalize_called += 1)
end

function test_fun(tstop)
    DualT = typeof(tstop)
    prob = ODEProblem((u, p, t) -> p * u, DualT(u0), DualT.(tspan), DualT(p))
    sol = solve(prob, Tsit5(), callback = stopping_cb(tstop), tstops = [tstop])
    sol(1.0)
end

@test ForwardDiff.derivative(test_fun, 0.5) ≈ exp(0.5) * u0 # Analytical solution: exp(tstop)*u0
@test times_finalize_called == 1 # test that finalize callback ran exactly once
test_fun(0.5)
@test times_finalize_called == 2 # test that finalize callback ran again

function test_fun(tstop)
    DualT = typeof(tstop)
    prob = ODEProblem((u, p, t) -> p * u, DualT(u0), DualT.(tspan), DualT(p))
    sol = solve(prob, Tsit5(), callback = stopping_cb(tstop), tstops = [tstop],
        adaptive = false, dt = 0.01)
    sol(1.0)
end

@test ForwardDiff.derivative(test_fun, 0.5) ≈ exp(0.5) * u0 # Analytical solution: exp(tstop)*u0

using OrdinaryDiffEq, Test, ADTypes, SparseMatrixColorings, DiffEqBase, ForwardDiff, SciMLBase, LinearSolve
import OrdinaryDiffEqDifferentiation.DI

f(du, u, p, t) = du .= u
prob = ODEProblem{true, SciMLBase.FullSpecialize}(f, [1.0], (0.0, 1.0))

i = init(prob, Tsit5())
resize!(i, 5)
@test length(i.cache.u) == 5
@test length(i.cache.uprev) == 5
@test length(i.cache.k1) == 5
@test length(i.cache.k2) == 5
@test length(i.cache.k3) == 5
@test length(i.cache.k4) == 5
@test length(i.cache.k5) == 5
@test length(i.cache.k6) == 5
@test length(i.cache.k7) == 5
solve!(i)

i = init(prob, ImplicitEuler())
resize!(i, 5)
@test length(i.cache.atmp) == 5
@test length(i.cache.uprev) == 5
# nlsolver fields
@test length(i.cache.nlsolver.z) == 5
@test length(i.cache.nlsolver.ztmp) == 5
@test length(i.cache.nlsolver.tmp) == 5
# nlsolver cache fields
@test length(i.cache.nlsolver.cache.ustep) == 5
@test length(i.cache.nlsolver.cache.k) == 5
@test length(i.cache.nlsolver.cache.atmp) == 5
@test length(i.cache.nlsolver.cache.dz) == 5
@test size(i.cache.nlsolver.cache.J) == (5, 5)
@test size(i.cache.nlsolver.cache.W) == (5, 5)
@test length(i.cache.nlsolver.cache.du1) == 5
@test length(i.cache.nlsolver.cache.weight) == 5
@test all(size(DI.jacobian(
    (du, u) -> (i.f(du, u, nothing, nothing)), rand(5), i.cache.nlsolver.cache.jac_config[1],
    AutoForwardDiff(tag = ForwardDiff.Tag(DiffEqBase.OrdinaryDiffEqTag(), Float64)), rand(5))) .==
          5)
solve!(i)

i = init(prob, ImplicitEuler(; autodiff = AutoFiniteDiff()))
resize!(i, 5)
@test length(i.cache.atmp) == 5
@test length(i.cache.uprev) == 5
# nlsolver fields
@test length(i.cache.nlsolver.z) == 5
@test length(i.cache.nlsolver.ztmp) == 5
@test length(i.cache.nlsolver.tmp) == 5
# nlsolver cache fields
@test length(i.cache.nlsolver.cache.ustep) == 5
@test length(i.cache.nlsolver.cache.k) == 5
@test length(i.cache.nlsolver.cache.atmp) == 5
@test length(i.cache.nlsolver.cache.dz) == 5
@test size(i.cache.nlsolver.cache.J) == (5, 5)
@test size(i.cache.nlsolver.cache.W) == (5, 5)
@test length(i.cache.nlsolver.cache.du1) == 5
@test length(i.cache.nlsolver.cache.weight) == 5
@test all(size(DI.jacobian(
    (du, u) -> (i.f(du, u, nothing, nothing)), rand(5), i.cache.nlsolver.cache.jac_config[1],
    AutoFiniteDiff(), rand(5))) .== 5)
solve!(i)

i = init(prob, Rosenbrock23())
resize!(i, 5)
@test length(i.cache.u) == 5
@test length(i.cache.uprev) == 5
@test length(i.cache.k₁) == 5
@test length(i.cache.k₂) == 5
@test length(i.cache.k₃) == 5
@test length(i.cache.du1) == 5
@test length(i.cache.du2) == 5
@test length(i.cache.f₁) == 5
@test length(i.cache.fsalfirst) == 5
@test length(i.cache.fsallast) == 5
@test length(i.cache.dT) == 5
@test length(i.cache.tmp) == 5
@test size(i.cache.J) == (5, 5)
@test size(i.cache.W) == (5, 5)
@test length(i.cache.linsolve_tmp) == 5
@test all(size(DI.jacobian(
    (du, u) -> (i.f(du, u, nothing, nothing)), rand(5), i.cache.jac_config[1],
    AutoForwardDiff(tag = ForwardDiff.Tag(DiffEqBase.OrdinaryDiffEqTag(), Float64)), rand(5))) .==
          5)
solve!(i)

i = init(prob, Rosenbrock23(autodiff = AutoForwardDiff(), linsolve = KrylovJL_GMRES()))
resize!(i, 5)
@test length(i.cache.u) == 5
@test length(i.cache.uprev) == 5
@test length(i.cache.k₁) == 5
@test length(i.cache.k₂) == 5
@test length(i.cache.k₃) == 5
@test length(i.cache.du1) == 5
@test length(i.cache.du2) == 5
@test length(i.cache.f₁) == 5
@test length(i.cache.fsalfirst) == 5
@test length(i.cache.fsallast) == 5
@test length(i.cache.dT) == 5
@test length(i.cache.tmp) == 5
@test size(i.cache.J) == (5, 5)
@test size(i.cache.W) == (5, 5)
@test length(i.cache.linsolve_tmp) == 5
solve!(i)

i = init(prob, Rosenbrock23(; autodiff = AutoFiniteDiff()))
resize!(i, 5)
@test length(i.cache.u) == 5
@test length(i.cache.uprev) == 5
@test length(i.cache.k₁) == 5
@test length(i.cache.k₂) == 5
@test length(i.cache.k₃) == 5
@test length(i.cache.du1) == 5
@test length(i.cache.du2) == 5
@test length(i.cache.f₁) == 5
@test length(i.cache.fsalfirst) == 5
@test length(i.cache.fsallast) == 5
@test length(i.cache.dT) == 5
@test length(i.cache.tmp) == 5
@test size(i.cache.J) == (5, 5)
@test size(i.cache.W) == (5, 5)
@test length(i.cache.linsolve_tmp) == 5
@test all(size(DI.jacobian(
    (du, u) -> (i.f(du, u, nothing, nothing)), rand(5), i.cache.jac_config[1],
    AutoFiniteDiff(), rand(5))) .== 5)
solve!(i)

function f(du, u, p, t)
    du[1] = 2.0 * u[1] - 1.2 * u[1] * u[2]
    du[2] = -3 * u[2] + u[1] * u[2]
    for i in 3:length(u)
        du[i] = 0.0
    end
end
function f_jac(J, u, p, t)
    J[1, 1] = 2.0 - 1.2 * u[2]
    J[1, 2] = -1.2 * u[1]
    J[2, 1] = 1 * u[2]
    J[2, 2] = -3 + u[1]
    for i in 3:length(u)
        for j in 3:length(u)
            if i == j
                J[i, j] = 1.0
            else
                J[i, j] = 0.0
            end
        end
    end
    nothing
end
ff = ODEFunction(f; jac = f_jac, jac_prototype = [1.0 1.0; 1.0 1.0])

cb = DiscreteCallback((u, t, integ) -> true, integ -> @views(integ.u[3:5]) .= 0)
prob = ODEProblem(ff, [1.0, 1.0], (0.0, 1.0))
i = init(prob, ImplicitEuler(), callback = cb)
resize!(i, 5)
solve!(i)

function dsdt(ds, s, _, t)
    # state looks like x1,v1, x2,v2, x3,v3,...
    ds[1:2:end] .= s[2:2:end] # velocity changes position
    ds[2:2:end] .= -1.0 # (constant downward acceleration)
end

function splitCheck(s, t, intgr)
    #If any of the position coordinates are negative, we need to bounce (and resize).
    if any(s[1:2:end] .< 0.0)
        return true
    else
        return false
    end
end

function splitMod!(intgr)
    s = intgr.u

    # flip the velocity sign
    for i in 1:2:length(s)
        if s[i] < 0.0
            s[i] = 0.0
            s[i + 1] = -s[i + 1]
        end
    end

    # Add a particle to the system.
    # comment out these lines and it will work with Rosenbrock32.
    resize!(intgr, length(s) + 2) # (resizes s -> intgr.u)
    s[end - 1] = rand() # new position
    s[end] = rand() # new velocity
end

function runSim(method)
    s0 = rand(2)
    tspan = (0.0, 20.0)
    prob = ODEProblem(dsdt, s0, tspan)

    # callback to bounce / split system.
    cb = DiscreteCallback(splitCheck, splitMod!)

    solve(prob, method, callback = cb, dtmax = 0.01)
    # setting dtmax here so the discrete callback doesn't miss the zero-crossing too badly.
    # ...no real reason not to use a continuous callback here, I just chose not to.
end

runSim(BS3())

runSim(Rosenbrock23())
runSim(Rosenbrock23(autodiff = AutoFiniteDiff()))

# https://github.com/SciML/OrdinaryDiffEq.jl/issues/1990
@testset "resize! with SplitODEProblem" begin
    f!(du, u, p, t) = du .= u
    ode = SplitODEProblem(f!, f!, [1.0], (0.0, 1.0))
    integrator = init(ode, Tsit5())
    @test_nowarn step!(integrator)
    @test_nowarn resize!(integrator, 2)
    @test_nowarn step!(integrator)
end

using OrdinaryDiffEq
using Test

function rober_ip(du, u, p, t)
    y₁, y₂, y₃ = u
    k₁, k₂, k₃ = p
    du[1] = -k₁ * y₁ + k₃ * y₂ * y₃
    du[2] = k₁ * y₁ - k₃ * y₂ * y₃ - k₂ * y₂^2
    du[3] = y₁ + y₂ + y₃ - 1
    nothing
end
function rober_op(u, p, t)
    du = similar(u)
    y₁, y₂, y₃ = u
    k₁, k₂, k₃ = p
    du[1] = -k₁ * y₁ + k₃ * y₂ * y₃
    du[2] = k₁ * y₁ - k₃ * y₂ * y₃ - k₂ * y₂^2
    du[3] = y₁ + y₂ + y₃ - 1
    du
end
M = [1.0 0 0
     0 1.0 0
     0 0 0]
fip = ODEFunction(rober_ip, mass_matrix = M)
prob_ip = ODEProblem(fip, [1.0, 0.0, 0.0], (0.0, 1e5), (0.04, 3e7, 1e4))

fop = ODEFunction(rober_op, mass_matrix = M)
prob_op = ODEProblem(fop, [1.0, 0.0, 0.0], (0.0, 1e5), (0.04, 3e7, 1e4))

ref_ip = solve(prob_ip, Rodas5P(), reltol = 1e-8, abstol = 1e-8)
ref_op = solve(prob_op, Rodas5P(), reltol = 1e-8, abstol = 1e-8)

sol_ip = solve(prob_ip, FBDF(), reltol = 1e-8, abstol = 1e-8)
sol_op = solve(prob_op, FBDF(), reltol = 1e-8, abstol = 1e-8)

# make sure interpolation changes don't accidentally break this test suite
# the intention is that ref uses a stiffness-aware interpolation, while sol uses hermite
@test SciMLBase.interp_summary(sol_ip) == "3rd order Hermite"
@test SciMLBase.interp_summary(sol_op) == "3rd order Hermite"
@test occursin("stiffness-aware", SciMLBase.interp_summary(ref_ip))
@test occursin("stiffness-aware", SciMLBase.interp_summary(ref_op))

reltol = 1e-4
abstol = 1e-4
t = 1
tv = [1, 10, 100]
idxs = 3
idxsv = [2, 3]

# primal, no index
@test isapprox(ref_ip(t), sol_ip(t), rtol = reltol, atol = abstol) # ip, t
@test isapprox(ref_ip(tv), sol_ip(tv), rtol = reltol, atol = abstol) # ip, tv
@test isapprox(ref_op(t), sol_op(t), rtol = reltol, atol = abstol) # op, t
@test isapprox(ref_op(tv), sol_op(tv), rtol = reltol, atol = abstol) # op, tv

# primal, scalar index
@test isapprox(ref_ip(t, idxs = idxs), sol_ip(t, idxs = idxs), rtol = reltol, atol = abstol) # ip, t
@test isapprox(
    ref_ip(tv, idxs = idxs), sol_ip(tv, idxs = idxs), rtol = reltol, atol = abstol) # ip, tv
@test isapprox(ref_op(t, idxs = idxs), sol_op(t, idxs = idxs), rtol = reltol, atol = abstol) # op, t
@test isapprox(
    ref_op(tv, idxs = idxs), sol_op(tv, idxs = idxs), rtol = reltol, atol = abstol) # op, tv

# primal, vector index
@test isapprox(
    ref_ip(t, idxs = idxsv), sol_ip(t, idxs = idxsv), rtol = reltol, atol = abstol)
@test isapprox(
    ref_ip(tv, idxs = idxsv), sol_ip(tv, idxs = idxsv), rtol = reltol, atol = abstol)
@test isapprox(
    ref_op(t, idxs = idxsv), sol_op(t, idxs = idxsv), rtol = reltol, atol = abstol)
@test isapprox(
    ref_op(tv, idxs = idxsv), sol_op(tv, idxs = idxsv), rtol = reltol, atol = abstol)

abstol = 1e-3
# derivative, no index
@test isapprox(ref_ip(t, Val{1}), sol_ip(t, Val{1}), rtol = reltol, atol = abstol)
@test isapprox(ref_ip(tv, Val{1}), sol_ip(tv, Val{1}), rtol = reltol, atol = abstol)
@test isapprox(ref_op(t, Val{1}), sol_op(t, Val{1}), rtol = reltol, atol = abstol)
@test isapprox(ref_op(tv, Val{1}), sol_op(tv, Val{1}), rtol = reltol, atol = abstol)

# derivative, scalar index
@test isapprox(ref_ip(t, Val{1}, idxs = idxs),
    sol_ip(t, Val{1}, idxs = idxs), rtol = reltol, atol = abstol)
@test isapprox(ref_ip(tv, Val{1}, idxs = idxs),
    sol_ip(tv, Val{1}, idxs = idxs), rtol = reltol, atol = abstol)
@test isapprox(ref_op(t, Val{1}, idxs = idxs),
    sol_op(t, Val{1}, idxs = idxs), rtol = reltol, atol = abstol)
@test isapprox(ref_op(tv, Val{1}, idxs = idxs),
    sol_op(tv, Val{1}, idxs = idxs), rtol = reltol, atol = abstol)

# derivative, vector index
@test isapprox(ref_ip(tv, Val{1}, idxs = idxsv),
    sol_ip(tv, Val{1}, idxs = idxsv), rtol = reltol, atol = abstol)
@test isapprox(ref_ip(t, Val{1}, idxs = idxsv),
    sol_ip(t, Val{1}, idxs = idxsv), rtol = reltol, atol = abstol)
@test isapprox(ref_op(t, Val{1}, idxs = idxsv),
    sol_op(t, Val{1}, idxs = idxsv), rtol = reltol, atol = abstol)
@test isapprox(ref_op(tv, Val{1}, idxs = idxsv),
    sol_op(tv, Val{1}, idxs = idxsv), rtol = reltol, atol = abstol)

# higher derivatives should be zero
# second derivative, no index
@test (sol_ip(t, Val{2}) .== 0) == [false, false, true]
@test all(map(==([false, false, true]), sol_ip(tv, Val{2}) .== 0))
@test (sol_op(t, Val{2}) .== 0) == [false, false, true]
@test all(map(==([false, false, true]), sol_op(tv, Val{2}) .== 0))

# second derivative, scalar index
@test sol_ip(t, Val{2}, idxs = idxs) == 0
@test all(sol_ip(tv, Val{2}, idxs = idxs) .== 0)
@test sol_op(t, Val{2}, idxs = idxs) == 0
@test all(sol_op(tv, Val{2}, idxs = idxs) .== 0)

# second derivative, vector index
@test (sol_ip(t, Val{2}, idxs = idxsv) .== 0) == [false, true]
@test all(map(==([false, true]), sol_ip(tv, Val{2}, idxs = idxsv) .== 0))
@test (sol_op(t, Val{2}, idxs = idxsv) .== 0) == [false, true]
@test all(map(==([false, true]), sol_op(tv, Val{2}, idxs = idxsv) .== 0))

# third derivative, no index
@test (sol_ip(t, Val{3}) .== 0) == [false, false, true]
@test all(map(==([false, false, true]), sol_ip(tv, Val{3}) .== 0))
@test (sol_op(t, Val{3}) .== 0) == [false, false, true]
@test all(map(==([false, false, true]), sol_op(tv, Val{3}) .== 0))

# third derivative, scalar index
@test sol_ip(t, Val{3}, idxs = idxs) == 0
@test all(sol_ip(tv, Val{3}, idxs = idxs) .== 0)
@test sol_op(t, Val{3}, idxs = idxs) == 0
@test all(sol_op(tv, Val{3}, idxs = idxs) .== 0)

# third derivative, vector index
@test (sol_ip(t, Val{3}, idxs = idxsv) .== 0) == [false, true]
@test all(map(==([false, true]), sol_ip(tv, Val{3}, idxs = idxsv) .== 0))
@test (sol_op(t, Val{3}, idxs = idxsv) .== 0) == [false, true]
@test all(map(==([false, true]), sol_op(tv, Val{3}, idxs = idxsv) .== 0))

using OrdinaryDiffEq, LinearAlgebra, SparseArrays, Random, Test, LinearSolve
using OrdinaryDiffEq: OrdinaryDiffEqDifferentiation
using OrdinaryDiffEq.OrdinaryDiffEqDifferentiation: WOperator, calc_W, calc_W!, jacobian2W!

@testset "calc_W and calc_W!" begin
    A = [-1.0 0.0; 0.0 -0.5]
    mm = [2.0 0.0; 0.0 1.0]
    u0 = [1.0, 1.0]
    tmp = zeros(2)
    tspan = (0.0, 1.0)
    dt = 0.01
    dtgamma = 0.5dt
    concrete_W = A - inv(dtgamma) * mm

    # Out-of-place
    fun = ODEFunction((u, p, t) -> A * u;
        mass_matrix = mm,
        jac = (u, p, t) -> A)
    integrator = init(ODEProblem(fun, u0, tspan), ImplicitEuler(); adaptive = false,
        dt = dt)
    W = calc_W(integrator, integrator.cache.nlsolver, dtgamma, false)
    @test convert(AbstractMatrix, W) == concrete_W
    @test W \ u0 ≈ concrete_W \ u0

    # In-place
    fun = ODEFunction((du, u, p, t) -> mul!(du, A, u);
        mass_matrix = mm,
        jac_prototype = MatrixOperator(A))
    integrator = init(ODEProblem(fun, u0, tspan), ImplicitEuler(); adaptive = false,
        dt = dt)
    calc_W!(integrator.cache.nlsolver.cache.W, integrator, integrator.cache.nlsolver,
        integrator.cache, dtgamma, false)

    # Did not update because it's an array operator
    # We don't want to build Jacobians when we have operators!
    @test convert(AbstractMatrix, integrator.cache.nlsolver.cache.W) != concrete_W
    ldiv!(tmp, lu!(integrator.cache.nlsolver.cache.W), u0)
    @test tmp != concrete_W \ u0

    # But jacobian2W! will update the cache
    jacobian2W!(integrator.cache.nlsolver.cache.W._concrete_form, mm,
        dtgamma, integrator.cache.nlsolver.cache.W.J.A)
    @test convert(AbstractMatrix, integrator.cache.nlsolver.cache.W) == concrete_W
    ldiv!(tmp, lu!(integrator.cache.nlsolver.cache.W), u0)
    @test tmp == concrete_W \ u0
end

@testset "Implicit solver with lazy W" begin
    A = sparse([-1.0 0.0; 0.0 -0.5])
    mm = sparse([2.0 0.0; 0.0 1.0])
    u0 = [1.0, 1.0]
    tspan = (0.0, 1.0)

    _f = (u, p, t) -> t * (A * u)
    _f_ip = (du, u, p, t) -> lmul!(t, mul!(du, A, u))
    fun1 = ODEFunction(_f; mass_matrix = mm)
    fun2 = ODEFunction(_f; mass_matrix = mm, jac = (u, p, t) -> t * A)
    fun1_ip = ODEFunction(_f_ip; mass_matrix = mm)
    fun2_ip = ODEFunction(_f_ip; mass_matrix = mm,
        jac_prototype = MatrixOperator(similar(A);
            update_func! = (J, u, p, t) -> J .= t .* A))

    for Alg in [ImplicitEuler, Rosenbrock23, Rodas5]
        println(Alg)
        sol1 = solve(ODEProblem(fun1, u0, tspan), Alg(); adaptive = false, dt = 0.01)
        sol2 = solve(ODEProblem(fun2, u0, tspan), Alg(); adaptive = false, dt = 0.01)
        @test sol1(1.0)≈sol2(1.0) atol=1e-3

        sol1_ip = solve(ODEProblem(fun1_ip, u0, tspan), Alg(); adaptive = false, dt = 0.01)
        sol2_ip = solve(ODEProblem(fun2_ip, u0, tspan), Alg(); adaptive = false, dt = 0.01)
        @test sol1_ip(1.0)≈sol2_ip(1.0) atol=2e-5
    end
end

using OrdinaryDiffEq, StaticArrays, LinearAlgebra, Test, ADTypes

## Mass Matrix

function rober_oop(u, p, t)
    y₁, y₂, y₃ = u
    k₁, k₂, k₃ = p
    du1 = -k₁ * y₁ + k₃ * y₂ * y₃
    du2 = k₁ * y₁ - k₃ * y₂ * y₃ - k₂ * y₂^2
    du3 = y₁ + y₂ + y₃ - 1
    [du1, du2, du3]
end
M = [1.0 0 0
     0 1.0 0
     0 0 0]
f_oop = ODEFunction(rober_oop, mass_matrix = M)
prob_mm = ODEProblem(f_oop, [1.0, 0.0, 0.0], (0.0, 1e5), (0.04, 3e7, 1e4))
sol = solve(
    prob_mm, Rosenbrock23(autodiff = AutoFiniteDiff()), reltol = 1e-8, abstol = 1e-8)
@test sol[1] == [1.0, 0.0, 0.0] # Ensure initialization is unchanged if it works at the start!
sol = solve(prob_mm, Rosenbrock23(), reltol = 1e-8, abstol = 1e-8,
    initializealg = ShampineCollocationInit())
@test sol[1] == [1.0, 0.0, 0.0] # Ensure initialization is unchanged if it works at the start!

prob_mm = ODEProblem(f_oop, [1.0, 0.0, 0.2], (0.0, 1e5), (0.04, 3e7, 1e4))
sol = solve(prob_mm, Rosenbrock23(), reltol = 1e-8, abstol = 1e-8)
@test sum(sol[1]) ≈ 1
@test sol[1] ≈ [1.0, 0.0, 0.0]
for alg in [Rosenbrock23(autodiff = AutoFiniteDiff()), Trapezoid()]
    local sol
    sol = solve(prob_mm, alg, reltol = 1e-8, abstol = 1e-8,
        initializealg = ShampineCollocationInit())
    @test sum(sol[1]) ≈ 1
end

function rober(du, u, p, t)
    y₁, y₂, y₃ = u
    k₁, k₂, k₃ = p
    du[1] = -k₁ * y₁ + k₃ * y₂ * y₃
    du[2] = k₁ * y₁ - k₃ * y₂ * y₃ - k₂ * y₂^2
    du[3] = y₁ + y₂ + y₃ - 1
    nothing
end
M = [1.0 0 0
     0 1.0 0
     0 0 0]
f = ODEFunction(rober, mass_matrix = M)
prob_mm = ODEProblem(f, [1.0, 0.0, 0.0], (0.0, 1e5), (0.04, 3e7, 1e4))
sol = solve(prob_mm, Rodas5(autodiff = AutoFiniteDiff()), reltol = 1e-8, abstol = 1e-8)
@test sol[1] == [1.0, 0.0, 0.0] # Ensure initialization is unchanged if it works at the start!
sol = solve(prob_mm, Rodas5(), reltol = 1e-8, abstol = 1e-8,
    initializealg = ShampineCollocationInit())
@test sol[1] == [1.0, 0.0, 0.0] # Ensure initialization is unchanged if it works at the start!

prob_mm = ODEProblem(f, [1.0, 0.0, 1.0], (0.0, 1e5), (0.04, 3e7, 1e4))
sol = solve(prob_mm, Rodas5(), reltol = 1e-8, abstol = 1e-8)
@test sum(sol[1]) ≈ 1
@test sol[1] ≈ [1.0, 0.0, 0.0]

for alg in [Rodas5(autodiff = AutoFiniteDiff()), Trapezoid()]
    local sol
    sol = solve(prob_mm, alg, reltol = 1e-8, abstol = 1e-8,
        initializealg = ShampineCollocationInit())
    @test sum(sol[1]) ≈ 1
end

function rober_no_p(du, u, p, t)
    y₁, y₂, y₃ = u
    (k₁, k₂, k₃) = (0.04, 3e7, 1e4)
    du[1] = -k₁ * y₁ + k₃ * y₂ * y₃
    du[2] = k₁ * y₁ - k₃ * y₂ * y₃ - k₂ * y₂^2
    du[3] = y₁ + y₂ + y₃ - 1
    nothing
end

function rober_oop_no_p(du, u, p, t)
    y₁, y₂, y₃ = u
    (k₁, k₂, k₃) = (0.04, 3e7, 1e4)
    du1 = -k₁ * y₁ + k₃ * y₂ * y₃
    du2 = k₁ * y₁ - k₃ * y₂ * y₃ - k₂ * y₂^2
    du3 = y₁ + y₂ + y₃ - 1
    [du1, du2, du3]
end

# test oop and iip ODE initialization with parameters without eltype/length
struct UnusedParam
end
for f in (
    ODEFunction(rober_no_p, mass_matrix = M), ODEFunction(rober_oop_no_p, mass_matrix = M))
    local prob, probp
    prob = ODEProblem(f, [1.0, 0.0, 1.0], (0.0, 1e5))
    probp = ODEProblem(f, [1.0, 0.0, 1.0], (0.0, 1e5), UnusedParam)
    for initializealg in (ShampineCollocationInit(), BrownFullBasicInit())
        isapprox(init(prob, Rodas5(), abstol = 1e-10; initializealg).u,
            init(prob, Rodas5(), abstol = 1e-10; initializealg).u)
    end
end

# to test that we get the right NL solve we need a broken solver.
struct BrokenNLSolve <: SciMLBase.AbstractNonlinearAlgorithm
    BrokenNLSolve(; kwargs...) = new()
end
function SciMLBase.__solve(prob::NonlinearProblem,
        alg::BrokenNLSolve, args...;
        kwargs...)
    u = fill(reinterpret(Float64, 0xDEADBEEFDEADBEEF), 3)
    SciMLBase.build_solution(prob, alg, u, copy(u);
        retcode = ReturnCode.Success)
end
function f2(u, p, t)
    u
end
f = ODEFunction(f2, mass_matrix = Diagonal([1.0, 1.0, 0.0]))
prob = ODEProblem(f, ones(3), (0.0, 1.0))
integrator = init(prob, Rodas5P(),
    initializealg = ShampineCollocationInit(1.0, BrokenNLSolve()))
@test all(isequal(reinterpret(Float64, 0xDEADBEEFDEADBEEF)), integrator.u)

@testset "`reinit!` reruns initialization" begin
    initializeprob = NonlinearProblem(1.0, [0.0]) do u, p
        return u^2 - p[1]^2
    end
    initializeprobmap = function (nlsol)
        return [nlsol.prob.p[1], nlsol.u]
    end
    update_initializeprob! = function (iprob, integ)
        iprob.p[1] = integ.u[1]
    end
    initialization_data = SciMLBase.OverrideInitData(
        initializeprob, update_initializeprob!, initializeprobmap, nothing)
    fn = ODEFunction(; mass_matrix = [1 0; 0 0], initialization_data) do du, u, p, t
        du[1] = u[1]
        du[2] = u[1]^2 - u[2]^2
    end
    prob = ODEProblem(fn, [2.0, 0.0], (0.0, 1.0))
    integ = init(prob, Rodas5P())
    @test integ.u≈[2.0, 2.0] atol=1e-8
    reinit!(integ)
    @test integ.u≈[2.0, 2.0] atol=1e-8
    @test_nowarn step!(integ, 0.01, true)
    reinit!(integ, reinit_dae = false)
    @test integ.u ≈ [2.0, 0.0]
    @test_warn ["dt", "forced below floating point epsilon"] step!(integ, 0.01, true)
end

using ModelingToolkit, OrdinaryDiffEq, NonlinearSolve, Test
using ModelingToolkit: D_nounits as D, t_nounits as t

@parameters g e b
@variables v(t) w(t) F(t)
single_neuron_eqs = [
    D(v) ~ min(max(-2 - v, v), 2 - v) - w + F, # add the flux term
    D(w) ~ e * (v - g * w + b)
]
n1 = System(single_neuron_eqs, t, [v, w, F], [g, e, b], name = :n1)
n2 = System(single_neuron_eqs, t, [v, w, F], [g, e, b], name = :n2)
@parameters Di Dk
connections = [0 ~ n1.F - Di * Dk * max(n1.v - n2.v, 0)
               0 ~ n2.F - Di * max(n2.v - n1.v, 0)]
connected = System(connections, t, [], [Di, Dk], systems = [n1, n2], name = :connected)
connected = complete(connected)

u0 = [
    n1.v => -2,
    n1.w => -2 / 3,
    n1.F => 0,
    n2.v => -2,
    n2.w => -0.7,
    n2.F => 0
]
tspan = (0.0, 1750.0)
p0 = [
    n1.g => 0.8,
    n1.e => 0.04,
    n1.b => 0,
    n2.g => 0.8,
    n2.e => 0.04,
    n2.b => 0.2,
    Di => 0.047,
    Dk => 1
]

prob = ODEProblem(connected, [u0; p0], tspan)
sol = solve(prob, Rodas5(), initializealg = BrownFullBasicInit())
@test prob.u0 == sol[1]
sol = solve(prob, Rodas5(), initializealg = ShampineCollocationInit())
@test prob.u0 == sol[1]
#test initialization when given a specific nonlinear solver
using NonlinearSolve
sol = solve(prob, Rodas5(), initializealg = BrownFullBasicInit(1e-10, RobustMultiNewton()))
@test prob.u0 == sol[1]

# Initialize on ODEs
# https://github.com/SciML/ModelingToolkit.jl/issues/2508

function testsys(du, u, p, t)
    du[1] = -2
end
function initsys(du, u, p)
    du[1] = -1 + u[1]
end
nlprob = NonlinearProblem(initsys, [0.0])
initprobmap(nlprob) = nlprob.u
sol = solve(nlprob)

_f = ODEFunction(testsys; initializeprob = nlprob, initializeprobmap = initprobmap)
prob = ODEProblem(_f, [0.0], (0.0, 1.0))
sol = solve(prob, Tsit5())
@test SciMLBase.successful_retcode(sol)
@test sol.u[1] == [1.0]

prob = ODEProblem(_f, [0.0], (0.0, 1.0))
sol = solve(prob, Tsit5(), dt = 1e-10)
@test SciMLBase.successful_retcode(sol)
@test sol.u[1] == [1.0]
@test sol.u[2] ≈ [0.9999999998]
@test sol.u[end] ≈ [-1.0]

sol = solve(prob, Rodas5P(), dt = 1e-10)
@test SciMLBase.successful_retcode(sol)
@test sol.u[1] == [1.0]
@test sol.u[2] ≈ [0.9999999998]
@test sol.u[end] ≈ [-1.0]

@testset "`reinit!` updates initial parameters" begin
    # https://github.com/SciML/ModelingToolkit.jl/issues/3451
    # https://github.com/SciML/ModelingToolkit.jl/issues/3504
    @variables x(t) y(t)
    @parameters c1 c2
    @mtkcompile sys = System([D(x) ~ -c1 * x + c2 * y, D(y) ~ c1 * x - c2 * y], t)
    prob = ODEProblem(sys, [x => 1.0, y => 2.0, c1 => 1.0, c2 => 2.0], (0.0, 1.0))
    @test prob.ps[Initial(x)] ≈ 1.0
    @test prob.ps[Initial(y)] ≈ 2.0
    integ = init(prob, Tsit5())
    @test integ.ps[Initial(x)] ≈ 1.0
    @test integ.ps[Initial(y)] ≈ 2.0
    new_u0 = ModelingToolkit.get_u0(sys, Dict(x => 2.0, y => 3.0))
    reinit!(integ, new_u0)
    @test integ.ps[Initial(x)] ≈ 2.0
    @test integ.ps[Initial(y)] ≈ 3.0
    @test integ[x] ≈ 2.0
    @test integ[y] ≈ 3.0
end

using OrdinaryDiffEq, OrdinaryDiffEqCore, Test
function lorenz!(du, u, p, t)
    du[1] = 10.0(u[2] - u[1])
    du[2] = u[1] * (28.0 - u[3]) - u[2]
    du[3] = u[1] * u[2] - (8 / 3) * u[3]
end
u0 = [1.0; 0.0; 0.0]
tspan = (0.0, 3.0)
condition(u, t, integrator) = t == 0.2
cache = zeros(3)
affect!(integrator) = cache .= get_du(integrator)
dusave = DiscreteCallback(condition, affect!)
affect2!(integrator) = get_du!(cache, integrator)
dusave_inplace = DiscreteCallback(condition, affect2!)

prob = ODEProblem(lorenz!, u0, tspan)
sol = solve(
    prob, Tsit5(), tstops = [0.2], callback = dusave, abstol = 1e-12, reltol = 1e-12)
res = copy(cache)

for alg in [Vern6(), Vern7(), Vern8(), Vern9(), Rodas4(), Rodas4P(),
    Rodas5(), Rodas5P(), TRBDF2(), KenCarp4(), FBDF(), QNDF()]
    sol = solve(
        prob, alg, tstops = [0.2], callback = dusave, abstol = 1e-12, reltol = 1e-12)
    @test res≈cache rtol=1e-5

    sol = solve(prob, alg, tstops = [0.2], callback = dusave_inplace,
        abstol = 1e-12, reltol = 1e-12)
    @test res≈cache rtol=1e-5
end

using OrdinaryDiffEq, Test, DiffEqBase
using OrdinaryDiffEqCore
using ForwardDiff
import ODEProblemLibrary: prob_ode_linear,
                          prob_ode_2Dlinear,
                          prob_ode_bigfloatlinear, prob_ode_bigfloat2Dlinear
# use `PRINT_TESTS = true` to print the tests, including results
const PRINT_TESTS = false
print_results(x) =
    if PRINT_TESTS
        println(x)
    end

# points and storage arrays used in the interpolation tests
const interpolation_points = 0:(1 // 2^(4)):1
const interpolation_results_1d = fill(zero(prob_ode_linear.u0),
    length(interpolation_points))
const interpolation_results_2d = Vector{typeof(prob_ode_2Dlinear.u0)}(undef,
    length(interpolation_points))
for idx in eachindex(interpolation_results_2d)
    interpolation_results_2d[idx] = zero(prob_ode_2Dlinear.u0)
end

f_linear_inplace = (du, u, p, t) -> begin
    @. du = 1.01 * u
end
prob_ode_linear_inplace = ODEProblem(
    ODEFunction(f_linear_inplace;
        analytic = (u0, p, t) -> exp(1.01 * t) * u0),
    [0.5], (0.0, 1.0))
const interpolation_results_1d_inplace = Vector{typeof(prob_ode_linear_inplace.u0)}(undef,
    length(interpolation_points))
for idx in eachindex(interpolation_results_1d_inplace)
    interpolation_results_1d_inplace[idx] = zero(prob_ode_linear_inplace.u0)
end

const deriv_test_points = range(0, stop = 1, length = 5)

# left continuous derivative \lim{ϵ->0⁺}\frac{f(x)-f(x-ϵ)}{ϵ}
function LeftDeriv(f, x)
    ForwardDiff.derivative(t -> -f(-t), -x)
end
# perform the regression tests
# NOTE: If you want to add new tests (for new algorithms), you have to run the
#       commands below to get numerical values for `tol_ode_linear` and
#       `tol_ode_2Dlinear`.
function regression_test(alg, tol_ode_linear, tol_ode_2Dlinear; test_diff1 = false,
        nth_der = 1, dertol = 1e-6)
    println("\n")
    show(stdout, alg)
    println()

    sol = solve(prob_ode_linear, alg, dt = 1 // 2^(2), dense = true)
    @inferred sol(interpolation_results_1d, interpolation_points)
    @inferred sol(interpolation_points[1])
    sol2 = solve(prob_ode_linear, alg, dt = 1 // 2^(4), dense = true, adaptive = false)
    for i in eachindex(sol2)
        print_results(@test maximum(abs.(sol2[i] - interpolation_results_1d[i])) <
                            tol_ode_linear)
    end
    for N in 1:nth_der
        # prevent CI error
        nth_der != 1 && @show N
        if test_diff1
            sol(interpolation_results_1d, interpolation_points, Val{N})
            der = sol(interpolation_points[1], Val{N})
            @test interpolation_results_1d[1] ≈ der
            for t in deriv_test_points
                deriv = sol(t, Val{N})
                @test deriv≈LeftDeriv(t -> sol(t, Val{N - 1}), t) rtol=dertol
            end
        end
    end

    sol = solve(prob_ode_linear_inplace, alg, dt = 1 // 2^(2), dense = true)
    sol(interpolation_results_1d_inplace, interpolation_points, idxs = 1:1)
    sol(interpolation_results_1d_inplace, interpolation_points)
    sol(interpolation_points[1], idxs = 1:1)
    sol(interpolation_points[1])
    for N in 1:nth_der
        # prevent CI error
        nth_der != 1 && @show N
        if test_diff1
            sol(interpolation_results_1d_inplace, interpolation_points, Val{N}, idxs = 1:1)
            sol(interpolation_results_1d_inplace, interpolation_points, Val{N})
            sol(interpolation_points[1], Val{N}, idxs = 1:1)
            der = sol(interpolation_points[1], Val{N})
            @test interpolation_results_1d_inplace[1] ≈ der
            for t in deriv_test_points
                deriv = sol(t, Val{N}, idxs = 1)
                @test deriv≈LeftDeriv(t -> sol(t, Val{N - 1}; idxs = 1), t) rtol=dertol
            end
        end
    end

    sol = solve(prob_ode_2Dlinear, alg, dt = 1 // 2^(2), dense = true)
    sol(interpolation_results_2d, interpolation_points)
    sol(interpolation_points[1])
    sol2 = solve(prob_ode_2Dlinear, alg, dt = 1 // 2^(4), dense = true, adaptive = false)
    for i in eachindex(sol2)
        print_results(@test maximum(maximum.(abs.(sol2[i] - interpolation_results_2d[i]))) <
                            tol_ode_2Dlinear)
    end
end

# Some extra tests using Euler()
prob = prob_ode_linear
sol = solve(prob, Euler(), dt = 1 // 2^(2), dense = true)
interpd_1d = sol(0:(1 // 2^(4)):1)
sol2 = solve(prob, Euler(), dt = 1 // 2^(4), dense = true)
sol3 = solve(prob, Euler(), dt = 1 // 2^(5), dense = true)

prob = prob_ode_2Dlinear
sol = solve(prob, Euler(), dt = 1 // 2^(2), dense = true)
interpd = sol(0:(1 // 2^(4)):1)

for co in (:right, :left)
    ts = range(0, stop = last(sol.t), length = 3)
    interpdright = sol(last(sol.t), continuity = co)
    interpdrights = sol(ts, continuity = co)
    @test interpdright == sol(similar(sol.u[end]), last(sol.t), continuity = co)
    tmp = [similar(sol.u[end]) for i in 1:3]
    sol(tmp, ts, continuity = co)
    @test all(map((x, y) -> x == y, interpdrights, tmp))
end

interpd_idxs = sol(0:(1 // 2^(4)):1, idxs = 1:2:5)

@test minimum([isapprox(interpd_idxs[i], interpd[i][1:2:5], rtol=1e-14) for i in 1:length(interpd)])

interpd_single = sol(0:(1 // 2^(4)):1, idxs = 1)

@test interpd_single.u isa Vector{Float64}

@test typeof(sol(0.5, idxs = 1)) <: Float64

A = rand(4, 2)
sol(A, 0.777)
A == sol(0.777)
sol2 = solve(prob, Euler(), dt = 1 // 2^(4), dense = true)

@test maximum(map((x) -> maximum(abs.(x)), sol2 - interpd)) < 0.2

sol(interpd, 0:(1 // 2^(4)):1)

@test maximum(map((x) -> maximum(abs.(x)), sol2 - interpd)) < 0.2

sol = solve(prob, Euler(), dt = 1 // 2^(2), dense = false)

@test !(sol(0.6)[4, 2] ≈ 0)

# Euler
regression_test(Euler(), 0.2, 0.2)

# Midpoint
@test Midpoint() == Midpoint(OrdinaryDiffEqCore.trivial_limiter!) # old non-kwarg constructor
regression_test(Midpoint(), 1.5e-2, 2.3e-2)

# RK46NL
@test RK46NL() == RK46NL(OrdinaryDiffEqCore.trivial_limiter!) # old non-kwarg constructor

# Heun
@test Heun() == Heun(OrdinaryDiffEqCore.trivial_limiter!) # old non-kwarg constructor

# Anas5
@test Anas5() == Anas5(OrdinaryDiffEqCore.trivial_limiter!) # old non-kwarg constructor

# Ralston
@test Ralston() == Ralston(OrdinaryDiffEqCore.trivial_limiter!) # old non-kwarg constructor

# FRK65
@test FRK65() == FRK65(OrdinaryDiffEqCore.trivial_limiter!) # old non-kwarg constructor

# PFRK87
@test PFRK87() == PFRK87(OrdinaryDiffEqCore.trivial_limiter!) # old non-kwarg constructor

# RKO65
@test RKO65() == RKO65(OrdinaryDiffEqCore.trivial_limiter!) # old non-kwarg constructor

println("SSPRKs")

# SSPRK22
@test SSPRK22() == SSPRK22(OrdinaryDiffEqCore.trivial_limiter!) # old non-kwarg constructor
regression_test(SSPRK22(), 1.5e-2, 2.5e-2; test_diff1 = true, nth_der = 2, dertol = 1e-15)

# SSPRK33
@test SSPRK33() == SSPRK33(OrdinaryDiffEqCore.trivial_limiter!) # old non-kwarg constructor
regression_test(SSPRK33(), 7.5e-4, 7.5e-3; test_diff1 = true, nth_der = 2, dertol = 1e-15)

# SSPRK53
@test SSPRK53() == SSPRK53(OrdinaryDiffEqCore.trivial_limiter!) # old non-kwarg constructor
regression_test(SSPRK53(), 2.5e-4, 4.0e-4; test_diff1 = true)

# SSPRK53_2N1
@test SSPRK53_2N1() == SSPRK53_2N1(OrdinaryDiffEqCore.trivial_limiter!) # old non-kwarg constructor
regression_test(SSPRK53_2N1(), 3.0e-4, 5.5e-4; test_diff1 = true)

# SSPRK53_2N2
@test SSPRK53_2N2() == SSPRK53_2N2(OrdinaryDiffEqCore.trivial_limiter!) # old non-kwarg constructor
regression_test(SSPRK53_2N2(), 2.5e-4, 5.0e-4; test_diff1 = true)

# SSPRK63
@test SSPRK63() == SSPRK63(OrdinaryDiffEqCore.trivial_limiter!) # old non-kwarg constructor
regression_test(SSPRK63(), 1.5e-4, 3.0e-4; test_diff1 = true)

# SSPRK73
@test SSPRK73() == SSPRK73(OrdinaryDiffEqCore.trivial_limiter!) # old non-kwarg constructor
regression_test(SSPRK73(), 9.0e-5, 2.0e-4; test_diff1 = true)

# SSPRK83
@test SSPRK83() == SSPRK83(OrdinaryDiffEqCore.trivial_limiter!) # old non-kwarg constructor
regression_test(SSPRK83(), 6.5e-5, 1.5e-4; test_diff1 = true)

# SSPRK43
@test SSPRK43() == SSPRK43(OrdinaryDiffEqCore.trivial_limiter!) # old non-kwarg constructor
regression_test(SSPRK43(), 4.0e-4, 8.0e-4; test_diff1 = true, nth_der = 2, dertol = 1e-13)

# SSPRK432
@test SSPRK432() == SSPRK432(OrdinaryDiffEqCore.trivial_limiter!) # old non-kwarg constructor
regression_test(SSPRK432(), 4.0e-4, 8.0e-4; test_diff1 = true, nth_der = 2, dertol = 1e-13)

# SSPRK932
@test SSPRK932() == SSPRK932(OrdinaryDiffEqCore.trivial_limiter!) # old non-kwarg constructor
regression_test(SSPRK932(), 6.0e-5, 1.0e-4; test_diff1 = true)

# SSPRK54
@test SSPRK54() == SSPRK54(OrdinaryDiffEqCore.trivial_limiter!) # old non-kwarg constructor
regression_test(SSPRK54(), 3.5e-5, 5.5e-5)

# SSPRK104
@test SSPRK22() == SSPRK22(OrdinaryDiffEqCore.trivial_limiter!) # old non-kwarg constructor
regression_test(SSPRK104(), 1.5e-5, 3e-5)

# KYKSSPRK42
@test KYKSSPRK42() == KYKSSPRK42(OrdinaryDiffEqCore.trivial_limiter!) # old non-kwarg constructor

# KYK2014DGSSPRK_3S2
@test KYK2014DGSSPRK_3S2() == KYK2014DGSSPRK_3S2(OrdinaryDiffEqCore.trivial_limiter!) # old non-kwarg constructor

println("SSPRKMSs")

# SSPRKMSVS32
@test SSPRKMSVS32() == SSPRKMSVS32(OrdinaryDiffEqCore.trivial_limiter!) # old non-kwarg constructor

# SSPRKMSVS43
@test SSPRKMSVS43() == SSPRKMSVS43(OrdinaryDiffEqCore.trivial_limiter!) # old non-kwarg constructor

println("Low Storage RKs")

# ORK256
@test ORK256() == ORK256(OrdinaryDiffEqCore.trivial_limiter!) # old non-kwarg constructor
regression_test(ORK256(), 3.0e-5, 5.0e-5)

# CarpenterKennedy2N54
@test CarpenterKennedy2N54() == CarpenterKennedy2N54(OrdinaryDiffEqCore.trivial_limiter!) # old non-kwarg constructor
regression_test(CarpenterKennedy2N54(), 3.0e-5, 5.0e-5)

# SHLDDRK64
@test SHLDDRK64() == SHLDDRK64(OrdinaryDiffEqCore.trivial_limiter!) # old non-kwarg constructor
regression_test(SHLDDRK64(), 3.0e-5, 3.0e-5)

# DGLDDRK73_C
@test DGLDDRK73_C() == DGLDDRK73_C(OrdinaryDiffEqCore.trivial_limiter!) # old non-kwarg constructor
regression_test(DGLDDRK73_C(), 3.0e-4, 3.0e-4)

# DGLDDRK84_C
@test DGLDDRK84_C() == DGLDDRK84_C(OrdinaryDiffEqCore.trivial_limiter!) # old non-kwarg constructor
regression_test(DGLDDRK84_C(), 3.0e-5, 5.0e-5)

# DGLDDRK84_F
@test DGLDDRK84_F() == DGLDDRK84_F(OrdinaryDiffEqCore.trivial_limiter!) # old non-kwarg constructor
regression_test(DGLDDRK84_F(), 3.0e-5, 5.0e-5)

# NDBLSRK124
@test NDBLSRK124() == NDBLSRK124(OrdinaryDiffEqCore.trivial_limiter!) # old non-kwarg constructor
regression_test(NDBLSRK124(), 3.0e-5, 3.0e-5)

# NDBLSRK134
@test NDBLSRK134() == NDBLSRK134(OrdinaryDiffEqCore.trivial_limiter!) # old non-kwarg constructor
regression_test(NDBLSRK134(), 3.0e-5, 3.0e-5)

# NDBLSRK144
@test NDBLSRK144() == NDBLSRK144(OrdinaryDiffEqCore.trivial_limiter!) # old non-kwarg constructor
regression_test(NDBLSRK144(), 3.0e-5, 3.0e-5)

# CFRLDDRK64
@test CFRLDDRK64() == CFRLDDRK64(OrdinaryDiffEqCore.trivial_limiter!) # old non-kwarg constructor
regression_test(CFRLDDRK64(), 3.0e-5, 3.0e-5)

# TSLDDRK74
@test TSLDDRK74() == TSLDDRK74(OrdinaryDiffEqCore.trivial_limiter!) # old non-kwarg constructor
regression_test(TSLDDRK74(), 3.0e-5, 3.0e-5)

# CKLLSRK43_2
@test CKLLSRK43_2() == CKLLSRK43_2(OrdinaryDiffEqCore.trivial_limiter!) # old non-kwarg constructor
regression_test(CKLLSRK43_2(), 2.0e-5, 3.1e-5)

# CKLLSRK54_3C
@test CKLLSRK54_3C() == CKLLSRK54_3C(OrdinaryDiffEqCore.trivial_limiter!) # old non-kwarg constructor
regression_test(CKLLSRK54_3C(), 3.0e-5, 6.0e-5)

# CKLLSRK95_4S
@test CKLLSRK95_4S() == CKLLSRK95_4S(OrdinaryDiffEqCore.trivial_limiter!) # old non-kwarg constructor
regression_test(CKLLSRK95_4S(), 5.0e-5, 9.5e-5)

# CKLLSRK95_4C
@test CKLLSRK95_4C() == CKLLSRK95_4C(OrdinaryDiffEqCore.trivial_limiter!) # old non-kwarg constructor
regression_test(CKLLSRK95_4C(), 3.0e-3, 5.5e-3)

# CKLLSRK95_4M
@test CKLLSRK95_4M() == CKLLSRK95_4M(OrdinaryDiffEqCore.trivial_limiter!) # old non-kwarg constructor
regression_test(CKLLSRK95_4M(), 5.0e-5, 9.5e-5)

# CKLLSRK54_3C_3R
@test CKLLSRK54_3C_3R() == CKLLSRK54_3C_3R(OrdinaryDiffEqCore.trivial_limiter!) # old non-kwarg constructor
regression_test(CKLLSRK54_3C_3R(), 3.0e-5, 6.0e-5)

# CKLLSRK54_3M_3R
@test CKLLSRK54_3M_3R() == CKLLSRK54_3M_3R(OrdinaryDiffEqCore.trivial_limiter!) # old non-kwarg constructor
regression_test(CKLLSRK54_3M_3R(), 2.0e-5, 4.0e-5)

# CKLLSRK54_3N_3R
@test CKLLSRK54_3N_3R() == CKLLSRK54_3N_3R(OrdinaryDiffEqCore.trivial_limiter!) # old non-kwarg constructor
regression_test(CKLLSRK54_3N_3R(), 4.0e-5, 7.0e-5)

# CKLLSRK85_4C_3R
@test CKLLSRK85_4C_3R() == CKLLSRK85_4C_3R(OrdinaryDiffEqCore.trivial_limiter!) # old non-kwarg constructor
regression_test(CKLLSRK85_4C_3R(), 8.0e-5, 1.60e-4)

# CKLLSRK85_4M_3R
@test CKLLSRK85_4M_3R() == CKLLSRK85_4M_3R(OrdinaryDiffEqCore.trivial_limiter!) # old non-kwarg constructor
regression_test(CKLLSRK85_4M_3R(), 8.0e-5, 1.5e-4)

# CKLLSRK85_4P_3R
@test CKLLSRK85_4P_3R() == CKLLSRK85_4P_3R(OrdinaryDiffEqCore.trivial_limiter!) # old non-kwarg constructor
regression_test(CKLLSRK85_4P_3R(), 5.5e-5, 1.1e-4)

# CKLLSRK54_3N_4R
@test CKLLSRK54_3N_4R() == CKLLSRK54_3N_4R(OrdinaryDiffEqCore.trivial_limiter!) # old non-kwarg constructor
regression_test(CKLLSRK54_3N_4R(), 3.5e-5, 6.0e-5)

# CKLLSRK54_3M_4R
@test CKLLSRK54_3M_4R() == CKLLSRK54_3M_4R(OrdinaryDiffEqCore.trivial_limiter!) # old non-kwarg constructor
regression_test(CKLLSRK54_3M_4R(), 2.0e-5, 4.0e-5)

# CKLLSRK65_4M_4R
@test CKLLSRK65_4M_4R() == CKLLSRK65_4M_4R(OrdinaryDiffEqCore.trivial_limiter!) # old non-kwarg constructor
regression_test(CKLLSRK65_4M_4R(), 8.0e-5, 1.5e-4)

# CKLLSRK85_4FM_4R
@test CKLLSRK85_4FM_4R() == CKLLSRK85_4FM_4R(OrdinaryDiffEqCore.trivial_limiter!) # old non-kwarg constructor
regression_test(CKLLSRK85_4FM_4R(), 1.0, 1.8)

# CKLLSRK75_4M_5R
@test CKLLSRK75_4M_5R() == CKLLSRK75_4M_5R(OrdinaryDiffEqCore.trivial_limiter!) # old non-kwarg constructor
regression_test(CKLLSRK75_4M_5R(), 8.0e-5, 1.6e-4)

# ParsaniKetchesonDeconinck3S32
@test ParsaniKetchesonDeconinck3S32() ==
      ParsaniKetchesonDeconinck3S32(OrdinaryDiffEqCore.trivial_limiter!) # old non-kwarg constructor
regression_test(ParsaniKetchesonDeconinck3S32(), 1.5e-2, 2.0e-2)

# ParsaniKetchesonDeconinck3S82
@test ParsaniKetchesonDeconinck3S82() ==
      ParsaniKetchesonDeconinck3S82(OrdinaryDiffEqCore.trivial_limiter!) # old non-kwarg constructor
regression_test(ParsaniKetchesonDeconinck3S82(), 1.5e-3, 3.0e-3)

# ParsaniKetchesonDeconinck3S53
@test ParsaniKetchesonDeconinck3S53() ==
      ParsaniKetchesonDeconinck3S53(OrdinaryDiffEqCore.trivial_limiter!) # old non-kwarg constructor
regression_test(ParsaniKetchesonDeconinck3S53(), 2.5e-4, 4.5e-4)

# ParsaniKetchesonDeconinck3S173
@test ParsaniKetchesonDeconinck3S173() ==
      ParsaniKetchesonDeconinck3S173(OrdinaryDiffEqCore.trivial_limiter!) # old non-kwarg constructor
regression_test(ParsaniKetchesonDeconinck3S173(), 3.5e-5, 5.5e-5)

# ParsaniKetchesonDeconinck3S94
@test ParsaniKetchesonDeconinck3S94() ==
      ParsaniKetchesonDeconinck3S94(OrdinaryDiffEqCore.trivial_limiter!) # old non-kwarg constructor
regression_test(ParsaniKetchesonDeconinck3S94(), 1.5e-5, 3.0e-5)

# ParsaniKetchesonDeconinck3S184
@test ParsaniKetchesonDeconinck3S184() ==
      ParsaniKetchesonDeconinck3S184(OrdinaryDiffEqCore.trivial_limiter!) # old non-kwarg constructor
regression_test(ParsaniKetchesonDeconinck3S184(), 1.5e-5, 3.0e-5)

# ParsaniKetchesonDeconinck3S105
@test ParsaniKetchesonDeconinck3S105() ==
      ParsaniKetchesonDeconinck3S105(OrdinaryDiffEqCore.trivial_limiter!) # old non-kwarg constructor
regression_test(ParsaniKetchesonDeconinck3S105(), 1.5e-5, 3.0e-5)

# ParsaniKetchesonDeconinck3S205
@test ParsaniKetchesonDeconinck3S205() ==
      ParsaniKetchesonDeconinck3S205(OrdinaryDiffEqCore.trivial_limiter!) # old non-kwarg constructor
regression_test(ParsaniKetchesonDeconinck3S205(), 1.5e-5, 3.0e-5)

# RDPK3Sp35
@test RDPK3Sp35() == RDPK3Sp35(OrdinaryDiffEqCore.trivial_limiter!) # old non-kwarg constructor
regression_test(RDPK3Sp35(), 7.0e-4, 1.5e-3)

# RDPK3SpFSAL35
@test RDPK3SpFSAL35() == RDPK3SpFSAL35(OrdinaryDiffEqCore.trivial_limiter!) # old non-kwarg constructor
regression_test(RDPK3SpFSAL35(), 8.5e-4, 2.0e-3)

# RDPK3Sp49
@test RDPK3Sp49() == RDPK3Sp49(OrdinaryDiffEqCore.trivial_limiter!) # old non-kwarg constructor
regression_test(RDPK3Sp49(), 7.5e-5, 1.5e-4)

# RDPK3SpFSAL49
@test RDPK3SpFSAL49() == RDPK3SpFSAL49(OrdinaryDiffEqCore.trivial_limiter!) # old non-kwarg constructor
regression_test(RDPK3SpFSAL49(), 8.5e-5, 1.5e-4)

# RDPK3Sp510
@test RDPK3Sp510() == RDPK3Sp510(OrdinaryDiffEqCore.trivial_limiter!) # old non-kwarg constructor
regression_test(RDPK3Sp510(), 2.5e-4, 3.5e-4)

# RDPK3SpFSAL510
@test RDPK3SpFSAL510() == RDPK3SpFSAL510(OrdinaryDiffEqCore.trivial_limiter!) # old non-kwarg constructor
regression_test(RDPK3SpFSAL510(), 2.5e-4, 3.5e-4)

println("RKs")

# RK4
@test RK4() == RK4(OrdinaryDiffEqCore.trivial_limiter!) # old non-kwarg constructor
regression_test(RK4(), 4.5e-5, 1e-4)

# DP5
@test DP5() == DP5(OrdinaryDiffEqCore.trivial_limiter!) # old non-kwarg constructor
regression_test(DP5(), 5e-6, 1e-5; test_diff1 = true, nth_der = 4, dertol = 1e-14)

# BS3
@test BS3() == BS3(OrdinaryDiffEqCore.trivial_limiter!) # old non-kwarg constructor
regression_test(BS3(), 5e-4, 8e-4)

# OwrenZen3
@test OwrenZen3() == OwrenZen3(OrdinaryDiffEqCore.trivial_limiter!) # old non-kwarg constructor
regression_test(OwrenZen3(), 1.5e-4, 2.5e-4; test_diff1 = true, nth_der = 3, dertol = 1e-9)

# OwrenZen4
@test OwrenZen4() == OwrenZen4(OrdinaryDiffEqCore.trivial_limiter!) # old non-kwarg constructor
regression_test(OwrenZen4(), 6.5e-6, 1.5e-5; test_diff1 = true, nth_der = 4, dertol = 1e-10)

# OwrenZen5
@test OwrenZen5() == OwrenZen5(OrdinaryDiffEqCore.trivial_limiter!) # old non-kwarg constructor
regression_test(OwrenZen5(), 1.5e-6, 2.5e-6; test_diff1 = true, nth_der = 5, dertol = 1e-8)

# Tsit5
@test Tsit5() == Tsit5(OrdinaryDiffEqCore.trivial_limiter!) # old non-kwarg constructor
regression_test(Tsit5(), 2e-6, 4e-6; test_diff1 = true, nth_der = 4, dertol = 1e-6)

# TanYam7
@test TanYam7() == TanYam7(OrdinaryDiffEqCore.trivial_limiter!) # old non-kwarg constructor
regression_test(TanYam7(), 4e-4, 6e-4)

# TsitPap8
@test TsitPap8() == TsitPap8(OrdinaryDiffEqCore.trivial_limiter!) # old non-kwarg constructor
regression_test(TsitPap8(), 1e-3, 3e-3)

# Feagin10
regression_test(Feagin10(), 6e-4, 9e-4)

# BS5
@test BS5() == BS5(OrdinaryDiffEqCore.trivial_limiter!) # old non-kwarg constructor
regression_test(BS5(), 4e-8, 6e-8; test_diff1 = true, nth_der = 1, dertol = 1e-12)
regression_test(BS5(lazy = false), 4e-8, 6e-8; test_diff1 = true, nth_der = 1,
    dertol = 1e-12)

prob = prob_ode_linear
sol = solve(prob, BS5(), dt = 1 // 2^(1), dense = true, adaptive = false)
interpd_1d_long = sol(0:(1 // 2^(7)):1)
sol2 = solve(prob, BS5(), dt = 1 // 2^(7), dense = true, adaptive = false)
print_results(@test maximum(map((x) -> maximum(abs.(x)), sol2 - interpd_1d_long)) < 2e-7)

# DP8
@test DP8() == DP8(OrdinaryDiffEqCore.trivial_limiter!) # old non-kwarg constructor
regression_test(DP8(), 2e-7, 3e-7; test_diff1 = true, nth_der = 1, dertol = 1e-15)

prob = prob_ode_linear
sol = solve(prob, DP8(), dt = 1 // 2^(2), dense = true)
sol(interpd_1d_long, 0:(1 // 2^(7)):1) # inplace update
sol2 = solve(prob, DP8(), dt = 1 // 2^(7), dense = true, adaptive = false)
print_results(@test maximum(map((x) -> maximum(abs.(x)), sol2 - interpd_1d_long)) < 2e-7)

println("Verns")

# Vern6
@test Vern6() == Vern6(OrdinaryDiffEqCore.trivial_limiter!) # old non-kwarg constructor
regression_test(Vern6(), 7e-8, 7e-8; test_diff1 = true, nth_der = 1, dertol = 1e-9)
regression_test(Vern6(lazy = false), 7e-8, 7e-8; test_diff1 = true, nth_der = 1,
    dertol = 1e-9)

prob = remake(prob_ode_bigfloatlinear; u0 = big(0.5))

sol = solve(prob, Vern6(), dt = 1 // 2^(2), dense = true)
interpd_1d_big = sol(0:(1 // 2^(7)):1)
sol2 = solve(prob, Vern6(), dt = 1 // 2^(7), dense = true, adaptive = false)
print_results(@test maximum(map((x) -> maximum(abs.(x)), sol2[:] - interpd_1d_big)) < 5e-8)

prob_ode_bigfloatveclinear = ODEProblem((u, p, t) -> p * u, [big(0.5)], (0.0, 1.0),
    big(1.01))
prob = prob_ode_bigfloatveclinear
sol = solve(prob, Vern6(), dt = 1 // 2^(2), dense = true)
interpd_big = sol(0:(1 // 2^(4)):1)
sol2 = solve(prob, Vern6(), dt = 1 // 2^(4), dense = true, adaptive = false)
print_results(@test maximum(map((x) -> maximum(abs.(x)), sol2 - interpd_big)) < 5e-8)

# Vern7
regression_test(Vern7(), 3e-9, 5e-9; test_diff1 = true, nth_der = 1, dertol = 1e-10)
regression_test(Vern7(lazy = false), 3e-9, 5e-9; test_diff1 = true, nth_der = 1,
    dertol = 1e-10)

# Vern8
@test Vern8() == Vern8(OrdinaryDiffEqCore.trivial_limiter!) # old non-kwarg constructor
regression_test(Vern8(), 3e-8, 5e-8; test_diff1 = true, nth_der = 1, dertol = 1e-7)
regression_test(Vern8(lazy = false), 3e-8, 5e-8; test_diff1 = true, nth_der = 1,
    dertol = 1e-7)

# Vern9
@test Vern9() == Vern9(OrdinaryDiffEqCore.trivial_limiter!) # old non-kwarg constructor
regression_test(Vern9(), 1e-9, 2e-9; test_diff1 = true, nth_der = 4, dertol = 5e-2)
regression_test(Vern9(lazy = false), 1e-9, 2e-9; test_diff1 = true, nth_der = 4,
    dertol = 5e-2)

println("Rosenbrocks")

# Rosenbrock23
regression_test(Rosenbrock23(), 3e-3, 6e-3; test_diff1 = true, nth_der = 1, dertol = 1e-14)

# Rosenbrock32
regression_test(Rosenbrock32(), 6e-4, 9e-4; test_diff1 = true, nth_der = 1, dertol = 1e-14)

# Rodas23W
regression_test(Rodas23W(), 2e-3, 4e-3, test_diff1 = true, nth_der = 1, dertol = 1e-14)

# Rodas3P
regression_test(Rodas3P(), 2e-4, 4e-4, test_diff1 = true, nth_der = 1, dertol = 1e-14)

# Rodas4
regression_test(Rodas4(), 8.5e-6, 2e-5, test_diff1 = true, nth_der = 1, dertol = 1e-14)

# Rodas42
regression_test(Rodas42(), 3e-5, 6e-5, test_diff1 = true, nth_der = 1, dertol = 1e-14)

# Rodas4P
regression_test(Rodas4P(), 4e-5, 6e-5, test_diff1 = true, nth_der = 1, dertol = 1e-13)

# Rodas4P2
regression_test(Rodas4P2(), 2e-5, 3e-5, test_diff1 = true, nth_der = 1, dertol = 1e-13)

# Rodas5
regression_test(Rodas5(), 2e-6, 3e-6, test_diff1 = true, nth_der = 3, dertol = 5e-1)

# Rodas5P
regression_test(Rodas5P(), 2e-5, 3e-5, test_diff1 = true, nth_der = 3, dertol = 5e-1)

# Rodas5Pe
regression_test(Rodas5Pe(), 2e-5, 3e-5, test_diff1 = true, nth_der = 3, dertol = 5e-1)

# Rodas5Pr
regression_test(Rodas5Pr(), 2e-5, 3e-5, test_diff1 = true, nth_der = 3, dertol = 5e-1)

# ExplicitRK
regression_test(ExplicitRK(), 7e-5, 2e-4)

prob = prob_ode_linear
sol = solve(prob, ExplicitRK(), dt = 1 // 2^(2), dense = true)
# inplace interp of solution
sol(interpd_1d_long, 0:(1 // 2^(7)):1)
sol2 = solve(prob, ExplicitRK(), dt = 1 // 2^(7), dense = true, adaptive = false)
print_results(@test maximum(map((x) -> maximum(abs.(x)), sol2 - interpd_1d_long)) < 6e-5)

prob = prob_ode_2Dlinear
sol = solve(prob, ExplicitRK(), dt = 1 // 2^(2), dense = true)
sol(interpd, 0:(1 // 2^(4)):1)
sol2 = solve(prob, ExplicitRK(), dt = 1 // 2^(4), dense = true, adaptive = false)
print_results(@test maximum(map((x) -> maximum(abs.(x)), sol2 - interpd)) < 2e-4)

using OrdinaryDiffEq, LinearAlgebra, Test

function dynamics!(dx, x, θ, t)
    zmin, zmax, M, g = θ
    z, dz, p = x

    dx[1] = dz
    dx[2] = -M * g - z + p
    dx[3] = p - w(t) # the last state (algebraic) p has to be equal to w

    if z <= zmin
        dx[2] = max(dx[2], 0.0)
    elseif z >= zmax
        dx[2] = min(dx[2], 0.0)
    end
end

w(t) = 0.1 * (7.0 + 3.0sin(t))
zmin_cond(x, t, integrator) = x[1] - zmin
zmax_cond(x, t, integrator) = zmax - x[1]

function zmin_affect_neg!(integrator)
    integrator.u[1] = zmin
    integrator.u[2] = 0.0
end

function zmax_affect_neg!(integrator)
    integrator.u[1] = zmax
    integrator.u[2] = 0.0
end

cbs = CallbackSet(ContinuousCallback(zmin_cond, zmin_affect_neg!),
    ContinuousCallback(zmax_cond, zmax_affect_neg!))

tf = 20.0
tspan = (0.0, tf)

zmin = 1.0e-3
zmax = 2.0e-2
M = 0.05
g = 9.81
θ = zmin, zmax, M, g

x0 = [(zmin + zmax) / 2, 0.0, w(0.0)]

E = diagm([1.0, M, 0.0])

f = ODEFunction(dynamics!, mass_matrix = E)
prob = ODEProblem(f, x0, tspan, θ)

sol1 = solve(prob, Rodas4(), callback = cbs, reltol = 1e-6)
@test sol1(0.06692341688237893)[3]≈0.72 atol=1e-2
sol1 = solve(prob, Rodas5(), callback = cbs, reltol = 1e-6)
@test sol1(0.06692341688237893)[3]≈0.72 atol=1e-2
sol1 = solve(prob, Rodas5P(), callback = cbs, reltol = 1e-6)
@test sol1(0.06692341688237893)[3]≈0.72 atol=1e-2

#=
sol1 = solve(prob,Rosenbrock23(),callback=cbs, reltol=1e-6)
@test sol1(1.0)[3] ≈ 0.95 atol=1e-2
=#

using Test
using OrdinaryDiffEq
using SparseArrays
using LinearAlgebra
using LinearSolve
import DifferentiationInterface as DI
using SparseConnectivityTracer
using SparseMatrixColorings
using ADTypes

if isempty(VERSION.prerelease)
    using Enzyme
end

## in-place
#https://github.com/JuliaDiffEq/SparseDiffTools.jl/blob/master/test/test_integration.jl
function f_ip(dx, x, p, t)
    for i in 2:(length(x) - 1)
        dx[i] = x[i - 1] - 2x[i] + x[i + 1]
    end
    dx[1] = -2x[1] + x[2]
    dx[end] = x[end - 1] - 2x[end]
    nothing
end

## out-of-place
function f_oop(x, p, t)
    dx = similar(x)
    for i in 2:(length(x) - 1)
        dx[i] = x[i - 1] - 2x[i] + x[i + 1]
    end
    dx[1] = -2x[1] + x[2]
    dx[end] = x[end - 1] - 2x[end]
    return dx
end

function second_derivative_stencil(N)
    A = zeros(N, N)
    for i in 1:N, j in 1:N
        (j - i == -1 || j - i == 1) && (A[i, j] = 1)
        j - i == 0 && (A[i, j] = -2)
    end
    A
end

function generate_sparsity_pattern(N::Integer)
    dl = repeat([1.0], N - 1)
    du = repeat([1.0], N - 1)
    d = repeat([-2.0], N)
    return Tridiagonal(dl, d, du)
end

jac_sp = sparse(generate_sparsity_pattern(10))
#jac = second_derivative_stencil(10)
colors = repeat(1:3, 10)[1:10]
u0 = [1.0, 2.0, 3, 4, 5, 5, 4, 3, 2, 1]
tspan = (0.0, 10.0)

adchoices = if isempty(VERSION.prerelease)
    [AutoForwardDiff(), AutoFiniteDiff(),
        AutoEnzyme(mode = Enzyme.Forward, function_annotation = Enzyme.Const)]
else
    [AutoForwardDiff(), AutoFiniteDiff()]
end

for f in [f_oop, f_ip]
    odefun_std = ODEFunction(f)
    prob_std = ODEProblem(odefun_std, u0, tspan)

    for ad in adchoices, linsolve in [nothing, LinearSolve.KrylovJL_GMRES()]
        for Solver in [Rodas5, Rosenbrock23, Trapezoid, KenCarp4, FBDF]
            for tol in [nothing, 1e-10]
                sol_std = solve(prob_std, Solver(autodiff = ad, linsolve = linsolve), reltol = tol, abstol = tol)
                @test sol_std.retcode == ReturnCode.Success
                for (i, prob) in enumerate(map(f -> ODEProblem(f, u0, tspan),
                    [
                        ODEFunction(f, colorvec = colors,
                            jac_prototype = jac_sp),
                        ODEFunction(f, colorvec = colors,
                            jac_prototype = jac_sp, mass_matrix = I(length(u0))),
                        ODEFunction(f, jac_prototype = jac_sp),
                        ODEFunction(f, colorvec = colors,
                            sparsity = jac_sp)
                    ]))
                    sol = solve(prob, Solver(autodiff = ad, linsolve = linsolve), reltol = tol, abstol = tol)
                    @test sol.retcode == ReturnCode.Success
                    if tol != nothing
                        @test sol_std.u[end]≈sol.u[end] atol=tol
                    else
                        @test sol_std.u[end] ≈ sol.u[end]
                    end
                    @test length(sol_std.t) == length(sol.t)
                end
            end
        end
    end
end

# test for https://github.com/SciML/OrdinaryDiffEq.jl/issues/2653#issuecomment-2778430025

using LinearAlgebra, SparseArrays
using OrdinaryDiffEq

function f(du, u, p, t)
    du[1] = u[1]
    return du
end

function jac(J::SparseMatrixCSC, u, p, t)
    @assert nnz(J) == 1  # mirrors the strict behavior of SparseMatrixColorings
    nonzeros(J)[1] = 1
    return J
end

u0 = ones(10)
jac_prototype = sparse(Diagonal(vcat(1, zeros(9))))

fun = ODEFunction(f; jac, jac_prototype)
prob = ODEProblem(fun, u0, (0.0, 1.0))
@test_nowarn sol = solve(prob, Rodas4(); reltol = 1e-8, abstol = 1e-8)

using Markdown
function imex_first_steps(name, solver)
    return Markdown.parse(
        """## Installation
        To be able to access the solvers in `$name`, you must first install them use the Julia package manager:

        ```julia
        using Pkg
        Pkg.add("$name")
        ```
        This will only install the solvers listed at the bottom of this page.
        If you want to explore other solvers for your problem,
        you will need to install some of the other libraries listed in the navigation bar on the left.

        ## Example usage

        IMEX methods require a `SplitODEProblem` that separates the differential equation into two parts:
        one for stiff (implicit) terms and one for non-stiff (explicit) terms.

        ```julia
        using $name

        # Example: A 1D reaction-diffusion system
        # du/dt = f₁(u,p,t) + f₂(u,p,t)
        # where f₁ contains stiff linear diffusion (implicit)
        # and f₂ contains non-stiff reaction terms (explicit)

        function f1!(du, u, p, t)
            # Stiff diffusion term: D * ∂²u/∂x²
            # Using simple finite differences
            D = 0.01
            N = length(u)
            du[1] = D * (u[2] - 2u[1] + u[end])
            for i in 2:N-1
                du[i] = D * (u[i+1] - 2u[i] + u[i-1])
            end
            du[N] = D * (u[1] - 2u[N] + u[N-1])
        end

        function f2!(du, u, p, t)
            # Non-stiff reaction term: u * (1 - u)
            @. du = u * (1 - u)
        end

        u0 = 0.5 .+ 0.1 * sin.(2π * (0:0.1:0.9))  # Initial condition with perturbation
        tspan = (0.0, 10.0)
        prob = SplitODEProblem(f1!, f2!, u0, tspan)
        sol = solve(prob, $solver(), dt = 0.01)
        ```

        ```"""
    )
end

using OrdinaryDiffEq, DiffEqBase, Test

## Start on Number
f = (u, p, t) -> (2u)
#(::typeof(f))(::Type{Val{:analytic}},u0,p,t) = u0*exp(t)
prob = ODEProblem(f, 1 / 2 + (1 / 4)im, (0.0, 1.0))

sol = solve(prob, Tsit5(), dt = 1 / 2^4)

u0 = rand(ComplexF32, 5, 5, 5)
f = (du, u, p, t) -> (du .= 2u)
#(::typeof(f))(::Type{Val{:analytic}},u0,p,t) = u0*exp(t)
prob = ODEProblem(f, u0, (0.0, 1.0))

sol = solve(prob, Tsit5(), dt = 1 / 2^4)

@test typeof(sol[:, 1]) == Array{ComplexF32, 3}

using OrdinaryDiffEq, RecursiveArrayTools, LinearAlgebra

struct NoIndexArray{T, N} <: AbstractArray{T, N}
    x::Array{T, N}
end
Base.size(x::NoIndexArray) = size(x.x)
Base.axes(x::NoIndexArray) = axes(x.x)
function Base.similar(x::NoIndexArray, dims::Union{Integer, AbstractUnitRange}...)
    NoIndexArray(similar(x.x, dims...))
end
Base.copyto!(x::NoIndexArray, y::NoIndexArray) = NoIndexArray(copyto!(x.x, y.x))
Base.copy(x::NoIndexArray) = NoIndexArray(copy(x.x))
Base.zero(x::NoIndexArray) = NoIndexArray(zero(x.x))
Base.fill!(x::NoIndexArray, y) = NoIndexArray(fill!(x.x, y))
Base.mapreduce(f, op, x::NoIndexArray; kwargs...) = mapreduce(f, op, x.x; kwargs...)
Base.any(f::Function, x::NoIndexArray; kwargs...) = any(f, x.x; kwargs...)
Base.all(f::Function, x::NoIndexArray; kwargs...) = all(f, x.x; kwargs...)
Base.:(==)(x::NoIndexArray, y::NoIndexArray) = x.x == y.x

struct NoIndexStyle{N} <: Broadcast.AbstractArrayStyle{N} end
NoIndexStyle(::Val{N}) where {N} = NoIndexStyle{N}()
NoIndexStyle{M}(::Val{N}) where {N, M} = NoIndexStyle{N}()
Base.BroadcastStyle(::Type{<:NoIndexArray{T, N}}) where {T, N} = NoIndexStyle{N}()
function Base.similar(bc::Base.Broadcast.Broadcasted{NoIndexStyle{N}},
        ::Type{ElType}) where {N, ElType}
    NoIndexArray(similar(Array{ElType, N}, axes(bc)))
end
Base.Broadcast._broadcast_getindex(x::NoIndexArray, i) = x.x[i]
Base.Broadcast.extrude(x::NoIndexArray) = x
using ArrayInterface
ArrayInterface.fast_scalar_indexing(::Type{<:NoIndexArray}) = false

@inline function Base.copyto!(dest::NoIndexArray,
        bc::Base.Broadcast.Broadcasted{<:NoIndexStyle})
    axes(dest) == axes(bc) || throwdm(axes(dest), axes(bc))
    bc′ = Base.Broadcast.preprocess(dest, bc)
    dest′ = dest.x
    @simd for I in eachindex(bc′)
        @inbounds dest′[I] = bc′[I]
    end
    return dest
end
Base.show_vector(io::IO, x::NoIndexArray) = Base.show_vector(io, x.x)

Base.show(io::IO, x::NoIndexArray) = (print(io, "NoIndexArray"); show(io, x.x))
function Base.show(io::IO, ::MIME"text/plain", x::NoIndexArray)
    println(io, Base.summary(x), ":")
    Base.print_array(io, x.x)
end

prob = ODEProblem((du, u, p, t) -> copyto!(du, u), NoIndexArray(ones(10, 10)), (0.0, 10.0))
algs = [Tsit5(), BS3(), Vern9(), DP5()]
for alg in algs
    sol = @test_nowarn solve(prob, alg)
    @test_nowarn sol(0.1)
    @test_nowarn sol(similar(prob.u0), 0.1)
end

struct CustomArray{T, N}
    x::Array{T, N}
end
Base.size(x::CustomArray) = size(x.x)
Base.axes(x::CustomArray) = axes(x.x)
Base.ndims(x::CustomArray) = ndims(x.x)
Base.ndims(::Type{<:CustomArray{T, N}}) where {T, N} = N
Base.zero(x::CustomArray) = CustomArray(zero(x.x))
Base.zero(::Type{<:CustomArray{T, N}}) where {T, N} = CustomArray(zero(Array{T, N}))
function Base.similar(x::CustomArray, dims::Union{Integer, AbstractUnitRange}...)
    CustomArray(similar(x.x, dims...))
end
Base.copyto!(x::CustomArray, y::CustomArray) = CustomArray(copyto!(x.x, y.x))
Base.copy(x::CustomArray) = CustomArray(copy(x.x))
Base.length(x::CustomArray) = length(x.x)
Base.isempty(x::CustomArray) = isempty(x.x)
Base.eltype(x::CustomArray) = eltype(x.x)
Base.zero(x::CustomArray) = CustomArray(zero(x.x))
Base.fill!(x::CustomArray, y) = CustomArray(fill!(x.x, y))
Base.getindex(x::CustomArray, i) = getindex(x.x, i)
Base.setindex!(x::CustomArray, v, idx) = setindex!(x.x, v, idx)
Base.eachindex(x::CustomArray) = eachindex(x.x)
Base.mapreduce(f, op, x::CustomArray; kwargs...) = mapreduce(f, op, x.x; kwargs...)
Base.any(f::Function, x::CustomArray; kwargs...) = any(f, x.x; kwargs...)
Base.all(f::Function, x::CustomArray; kwargs...) = all(f, x.x; kwargs...)
Base.similar(x::CustomArray, t) = CustomArray(similar(x.x, t))
Base.:(==)(x::CustomArray, y::CustomArray) = x.x == y.x
Base.:(*)(x::Number, y::CustomArray) = CustomArray(x * y.x)
Base.:(/)(x::CustomArray, y::Number) = CustomArray(x.x / y)
LinearAlgebra.norm(x::CustomArray) = norm(x.x)

struct CustomStyle{N} <: Broadcast.BroadcastStyle where {N} end
CustomStyle(::Val{N}) where {N} = CustomStyle{N}()
CustomStyle{M}(::Val{N}) where {N, M} = NoIndexStyle{N}()
Base.BroadcastStyle(::Type{<:CustomArray{T, N}}) where {T, N} = CustomStyle{N}()
function Broadcast.BroadcastStyle(
        ::CustomStyle{N}, ::Broadcast.DefaultArrayStyle{0}) where {N}
    CustomStyle{N}()
end
function Base.similar(
        bc::Base.Broadcast.Broadcasted{CustomStyle{N}}, ::Type{ElType}) where {N, ElType}
    CustomArray(similar(Array{ElType, N}, axes(bc)))
end
Base.Broadcast._broadcast_getindex(x::CustomArray, i) = x.x[i]
Base.Broadcast.extrude(x::CustomArray) = x
Base.Broadcast.broadcastable(x::CustomArray) = x

@inline function Base.copyto!(
        dest::CustomArray, bc::Base.Broadcast.Broadcasted{<:CustomStyle})
    axes(dest) == axes(bc) || throwdm(axes(dest), axes(bc))
    bc′ = Base.Broadcast.preprocess(dest, bc)
    dest′ = dest.x
    @simd for I in 1:length(dest′)
        @inbounds dest′[I] = bc′[I]
    end
    return dest
end
@inline function Base.copy(bc::Base.Broadcast.Broadcasted{<:CustomStyle})
    bcf = Broadcast.flatten(bc)
    x = find_x(bcf)
    data = zeros(eltype(x), size(x))
    @inbounds @simd for I in 1:length(x)
        data[I] = bcf[I]
    end
    return CustomArray(data)
end
find_x(bc::Broadcast.Broadcasted) = find_x(bc.args)
find_x(args::Tuple) = find_x(find_x(args[1]), Base.tail(args))
find_x(x) = x
find_x(::Any, rest) = find_x(rest)
find_x(x::CustomArray, rest) = x.x

RecursiveArrayTools.recursive_unitless_bottom_eltype(x::CustomArray) = eltype(x)
RecursiveArrayTools.recursivecopy!(dest::CustomArray, src::CustomArray) = copyto!(dest, src)
RecursiveArrayTools.recursivecopy(x::CustomArray) = copy(x)
RecursiveArrayTools.recursivefill!(x::CustomArray, a) = fill!(x, a)

Base.show_vector(io::IO, x::CustomArray) = Base.show_vector(io, x.x)

Base.show(io::IO, x::CustomArray) = (print(io, "CustomArray"); show(io, x.x))
function Base.show(io::IO, ::MIME"text/plain", x::CustomArray)
    println(io, Base.summary(x), ":")
    Base.print_array(io, x.x)
end

prob = ODEProblem((du, u, p, t) -> copyto!(du, u), CustomArray(ones(10)), (0.0, 10.0))
algs = [Tsit5(), BS3(), Vern9(), DP5()]
for alg in algs
    sol = @test_nowarn solve(prob, alg)
    @test_nowarn sol(0.1)
    @test_nowarn sol(similar(prob.u0), 0.1)
end

using OrdinaryDiffEq, Test, ADTypes

jac_called = Ref(false)
tgrad_called = Ref(false)

function Lotka(du, u, p, t)
    du[1] = u[1] - u[1] * u[2] # REPL[7], line 3:
    du[2] = -3 * u[2] + 1 * u[1] * u[2]
    nothing
end

function Lotka_jac(J, u, p, t)
    jac_called.x = true
    J[1, 1] = 1.0 - u[2]
    J[1, 2] = -u[1]
    J[2, 1] = 1 * u[2]
    J[2, 2] = -3 + u[1]
    nothing
end

function Lotka_tgrad(grad, u, p, t)
    tgrad_called.x = true
    grad[1] = 1 * 0
    grad[2] = 1 * 0
    nothing
end

Lotka_f = ODEFunction(Lotka, jac = Lotka_jac, tgrad = Lotka_tgrad)
prob = ODEProblem(Lotka_f, ones(2), (0.0, 10.0))

good_sol = solve(prob, Rosenbrock23())

@test jac_called[]
@test tgrad_called[]

prob2 = ODEProblem(Lotka, ones(2), (0.0, 10.0))

sol = solve(prob2, Rosenbrock23(autodiff = AutoForwardDiff()))
@test ≈(good_sol[:, end], sol[:, end], rtol = 1e-2)

sol = solve(prob2, Rosenbrock23(autodiff = AutoForwardDiff(chunksize = 1)))
@test ≈(good_sol[:, end], sol[:, end], rtol = 1e-2)

sol = solve(prob2, Rosenbrock23(autodiff = AutoFiniteDiff()))
@test ≈(good_sol[:, end], sol[:, end], rtol = 1e-2)

using OrdinaryDiffEq, Test, LinearAlgebra

function f(du, u, p, t)
    du[1] = dx = p[1] * u[1] - p[2] * u[1] * u[2]
    du[2] = dy = -p[3] * u[2] + p[4] * u[1] * u[2]
end
function foop(u, p, t)
    dx = p[1] * u[1] - p[2] * u[1] * u[2]
    dy = -p[3] * u[2] + p[4] * u[1] * u[2]
    [dx, dy]
end

p = [1.5, 1.0, 3.0, 1.0]
prob = ODEProblem(f, [1.0; 1.0], (0.0, 10.0), p)
proboop = ODEProblem(foop, [1.0; 1.0], (0.0, 10.0), p)

SPECIAL_INTERPS = [Tsit5(), DP5(), SSPRK22(), OwrenZen3(), OwrenZen4(), OwrenZen5(),
    BS5(), Vern6(), Vern7(), Vern8(), Vern9(), DP8(), Rosenbrock23(),
    Rodas4(), Rodas5()]

y1 = zeros(2);
y2 = zeros(2);
for alg in SPECIAL_INTERPS
    @show alg
    sol = solve(prob, alg, dt = 0.0033, abstol = 1e-14, reltol = 1e-14)
    soloop = solve(proboop, alg, adaptive = false, tstops = sol.t, abstol = 1e-14,
        reltol = 1e-14)
    @test maximum(norm(soloop(t) - sol(t)) for t in 0:0.001:10) < 1e-10
    @test maximum(norm(soloop(y1, t) - sol(y2, t)) for t in 0:0.001:10) < 1e-10
end

using OrdinaryDiffEq, OrdinaryDiffEqCore, Test

f(u, p, t) = zero(u)
prob = ODEProblem(f, 1.0, (0.0, 10.0))

# Shouldn't error
sol = solve(prob, Tsit5(), controller = IController())
@test sol.retcode == ReturnCode.Success

sol = solve(prob, Tsit5(), controller = PIController(7 // 50, 2 // 25))
@test sol.retcode == ReturnCode.Success

sol = solve(prob, Tsit5(), controller = PIDController(0.7, -0.4))
@test sol.retcode == ReturnCode.Success

# OrdinaryDiffEq.jl#1703
# https://github.com/SciML/OrdinaryDiffEq.jl/issues/1703
prob = ODEProblem((du, u, p, t) -> du[1] = 1, [0.0], (0.0, 5.0))
sol = solve(prob, RDPK3SpFSAL49())
@test sol.retcode == ReturnCode.Success

# DifferentialEquations.jl#299
# Test that qmax_first_step allows larger step size growth on the first step.
# The initial dt from the automatic step size algorithm is only approximate,
# so the solver should allow larger step size ratios on the first step
# (matching Sundials CVODE behavior: 10^4 on first step vs 10 on later steps).
@testset "qmax_first_step" begin
    # Exponential decay - the auto dt init may pick a very conservative initial dt
    prob_exp = ODEProblem((u, p, t) -> -u, 1.0, (0.0, 100.0))

    # Custom qmax_first_step via New* controller API
    ctrl = OrdinaryDiffEqCore.NewPIController(Tsit5(), qmax_first_step = 500)
    @test ctrl.qmax_first_step == 500.0

    # Verify that qmax_first_step=10000 still produces correct solutions
    for alg in (Tsit5(), Vern7(), RDPK3SpFSAL49())
        sol_default = solve(prob_exp, alg)
        @test sol_default.retcode == ReturnCode.Success
        @test isapprox(sol_default[end], exp(-100.0), atol = 1.0e-6)

        # With a very restrictive qmax_first_step (same as normal qmax),
        # the solution should still be correct
        ctrl_restricted = OrdinaryDiffEqCore.NewPIController(alg, qmax_first_step = 10)
        sol_restricted = solve(prob_exp, alg, controller = ctrl_restricted)
        @test sol_restricted.retcode == ReturnCode.Success
        @test isapprox(sol_restricted[end], exp(-100.0), atol = 1.0e-6)
    end

    # Test get_current_qmax: default 10000 on first step for all controllers
    integrator = init(prob_exp, Tsit5())
    @test integrator.success_iter == 0
    @test OrdinaryDiffEqCore.get_current_qmax(integrator, 10.0) == 10000.0
    # After a successful step, normal qmax is used
    integrator.success_iter = 1
    @test OrdinaryDiffEqCore.get_current_qmax(integrator, 10.0) == 10.0

    # Test get_current_qmax with New* controller (custom qmax_first_step)
    ctrl_new = OrdinaryDiffEqCore.NewPIController(Tsit5(), qmax_first_step = 500)
    integrator_new = init(prob_exp, Tsit5(), controller = ctrl_new)
    @test integrator_new.success_iter == 0
    @test OrdinaryDiffEqCore.get_current_qmax(integrator_new, 10.0) == 500.0
    integrator_new.success_iter = 1
    @test OrdinaryDiffEqCore.get_current_qmax(integrator_new, 10.0) == 10.0

    # Test that all New* controllers have qmax_first_step field
    ctrl_i = OrdinaryDiffEqCore.NewIController(Tsit5(), qmax_first_step = 200)
    @test ctrl_i.qmax_first_step == 200.0

    ctrl_pred = OrdinaryDiffEqCore.NewPredictiveController(Tsit5(), qmax_first_step = 300)
    @test ctrl_pred.qmax_first_step == 300.0
end

using OrdinaryDiffEq, StaticArrays, Test

# More ODE event tests, cf. #201, #199, #198, #197
function test_callback_inplace(alg; kwargs...)
    f = (du, u, p, t) -> @. du = u
    cb = ContinuousCallback((u, t, int) -> u[1] - exp(1), terminate!)
    prob = ODEProblem(f, [5.0], (2.0, 0.0), callback = cb)
    sol = solve(prob, alg; kwargs...)
    sol.u[end][1] ≈ exp(1)
end

function test_callback_outofplace(alg; kwargs...)
    f = (u, p, t) -> copy(u)
    cb = ContinuousCallback((u, t, int) -> u[1] - exp(1), terminate!)
    prob = ODEProblem(f, [5.0], (2.0, 0.0), callback = cb)
    sol = solve(prob, alg; kwargs...)
    sol.u[end][1] ≈ exp(1)
end

function test_callback_scalar(alg; kwargs...)
    f = (u, p, t) -> u
    cb = ContinuousCallback((u, t, int) -> u - exp(1), terminate!)
    prob = ODEProblem(f, 5.0, (2.0, 0.0), callback = cb)
    sol = solve(prob, alg; kwargs...)
    sol.u[end] ≈ exp(1)
end

function test_callback_svector(alg; kwargs...)
    f = (u, p, t) -> u
    cb = ContinuousCallback((u, t, int) -> u[1] - exp(1), terminate!)
    prob = ODEProblem(f, SVector(5.0), (2.0, 0.0), callback = cb)
    sol = solve(prob, alg; kwargs...)
    sol.u[end][1] ≈ exp(1)
end

function test_callback_mvector(alg; kwargs...)
    f = (u, p, t) -> copy(u)
    cb = ContinuousCallback((u, t, int) -> u[1] - exp(1), terminate!)
    prob = ODEProblem(f, MVector(5.0), (2.0, 0.0), callback = cb)
    sol = solve(prob, alg; kwargs...)
    sol.u[end][1] ≈ exp(1)
end

println("inplace")
@test test_callback_inplace(BS3())
@test test_callback_inplace(BS5())
@test test_callback_inplace(SSPRK43())
@test test_callback_inplace(SSPRK432())
@test test_callback_inplace(SSPRK932())
@test test_callback_inplace(OwrenZen3())
@test test_callback_inplace(OwrenZen4())
@test test_callback_inplace(OwrenZen5())
@test test_callback_inplace(DP5())
@test test_callback_inplace(DP8())
@test test_callback_inplace(Feagin10())
@test test_callback_inplace(Feagin12())
@test test_callback_inplace(Feagin14())
@test test_callback_inplace(TanYam7())
@test test_callback_inplace(Tsit5())
@test test_callback_inplace(TsitPap8())
@test test_callback_inplace(Vern6())
@test test_callback_inplace(Vern7())
@test test_callback_inplace(Vern8())
@test test_callback_inplace(Vern9())
@test test_callback_inplace(Rosenbrock23())
@test test_callback_inplace(Rosenbrock32())
@test test_callback_inplace(AB3(); dt = 0.1)
@test test_callback_inplace(ABM32(); dt = 0.1)
@test test_callback_inplace(AB4(); dt = 0.1)
@test test_callback_inplace(ABM43(); dt = 0.1)
@test test_callback_inplace(AB5(); dt = 0.1)
@test test_callback_inplace(ABM54(); dt = 0.1)
@test test_callback_inplace(VCAB3())
@test test_callback_inplace(VCAB4())
@test test_callback_inplace(VCAB5())
@test test_callback_inplace(VCABM3())
@test test_callback_inplace(VCABM4())
@test test_callback_inplace(VCABM5())

println("outofplace")
@test test_callback_outofplace(BS3())
@test test_callback_outofplace(BS5())
@test test_callback_outofplace(SSPRK43())
@test test_callback_outofplace(SSPRK432())
@test test_callback_outofplace(SSPRK932())
@test test_callback_outofplace(OwrenZen3())
@test test_callback_outofplace(OwrenZen4())
@test test_callback_outofplace(OwrenZen5())
@test test_callback_outofplace(DP5())
@test test_callback_outofplace(DP8())
@test test_callback_outofplace(Feagin10())
@test test_callback_outofplace(Feagin12())
@test test_callback_outofplace(Feagin14())
@test test_callback_outofplace(TanYam7())
@test test_callback_outofplace(Tsit5())
@test test_callback_outofplace(TsitPap8())
@test test_callback_outofplace(Vern6())
@test test_callback_outofplace(Vern7())
@test test_callback_outofplace(Vern8())
@test test_callback_outofplace(Vern9())
@test test_callback_outofplace(Rosenbrock23())
@test test_callback_outofplace(Rosenbrock32())
@test test_callback_outofplace(AB3(); dt = 0.1)
@test test_callback_outofplace(ABM32(); dt = 0.1)
@test test_callback_outofplace(AB4(); dt = 0.1)
@test test_callback_outofplace(ABM43(); dt = 0.1)
@test test_callback_outofplace(AB5(); dt = 0.1)
@test test_callback_outofplace(ABM54(); dt = 0.1)
@test test_callback_outofplace(VCAB3())
@test test_callback_outofplace(VCAB4())
@test test_callback_outofplace(VCAB5())
@test test_callback_outofplace(VCABM3())
@test test_callback_outofplace(VCABM4())
@test test_callback_outofplace(VCABM5())

println("scalar")
@test test_callback_scalar(BS3())
@test test_callback_scalar(BS5())
@test test_callback_scalar(SSPRK43())
@test test_callback_scalar(SSPRK432())
@test test_callback_scalar(SSPRK932())
@test test_callback_scalar(OwrenZen3())
@test test_callback_scalar(OwrenZen4())
@test test_callback_scalar(OwrenZen5())
@test test_callback_scalar(DP5())
@test test_callback_scalar(DP8())
@test test_callback_scalar(Feagin10())
@test test_callback_scalar(Feagin12())
@test test_callback_scalar(Feagin14())
@test test_callback_scalar(TanYam7())
@test test_callback_scalar(Tsit5())
@test test_callback_scalar(TsitPap8())
@test test_callback_scalar(Vern6())
@test test_callback_scalar(Vern7())
@test test_callback_scalar(Vern8())
@test test_callback_scalar(Vern9())
@test test_callback_scalar(Rosenbrock23())
@test test_callback_scalar(Rosenbrock32())
@test test_callback_scalar(AB3(); dt = 0.1)
@test test_callback_scalar(ABM32(); dt = 0.1)
@test test_callback_scalar(AB4(); dt = 0.1)
@test test_callback_scalar(ABM43(); dt = 0.1)
@test test_callback_scalar(AB5(); dt = 0.1)
@test test_callback_scalar(ABM54(); dt = 0.1)
@test test_callback_scalar(VCAB3())
@test test_callback_scalar(VCAB4())
@test test_callback_scalar(VCAB5())
@test test_callback_scalar(VCABM3())
@test test_callback_scalar(VCABM4())
@test test_callback_scalar(VCABM5())

println("svector")
@test test_callback_svector(BS3())
@test test_callback_svector(BS5())
@test test_callback_svector(SSPRK43())
@test test_callback_svector(SSPRK432())
@test test_callback_svector(SSPRK932())
@test test_callback_svector(OwrenZen3())
@test test_callback_svector(OwrenZen4())
@test test_callback_svector(OwrenZen5())
@test test_callback_svector(DP5())
@test test_callback_svector(DP8())
@test test_callback_svector(Feagin10())
@test test_callback_svector(Feagin12())
@test test_callback_svector(Feagin14())
@test test_callback_svector(TanYam7())
@test test_callback_svector(Tsit5())
@test test_callback_svector(TsitPap8())
@test test_callback_svector(Vern6())
@test test_callback_svector(Vern7())
@test test_callback_svector(Vern8())
@test test_callback_svector(Vern9())
@test test_callback_svector(Rosenbrock23())
@test test_callback_svector(Rosenbrock32())
@test test_callback_svector(AB3(); dt = 0.1)
@test test_callback_svector(ABM32(); dt = 0.1)
@test test_callback_svector(AB4(); dt = 0.1)
@test test_callback_svector(ABM43(); dt = 0.1)
@test test_callback_svector(AB5(); dt = 0.1)
@test test_callback_svector(ABM54(); dt = 0.1)
@test test_callback_svector(VCAB3())
@test test_callback_svector(VCAB4())
@test test_callback_svector(VCAB5())
@test test_callback_svector(VCABM3())
@test test_callback_svector(VCABM4())
@test test_callback_svector(VCABM5())

print("mvector")
@test test_callback_mvector(BS3())
@test test_callback_mvector(BS5())
print(".")
@test test_callback_mvector(SSPRK43())
@test test_callback_mvector(SSPRK432())
@test test_callback_mvector(SSPRK932())
print(".")
@test test_callback_mvector(OwrenZen3())
@test test_callback_mvector(OwrenZen4())
print(".")
@test test_callback_mvector(OwrenZen5())
@test test_callback_mvector(DP5())
print(".")
@test test_callback_mvector(DP8())
@test test_callback_mvector(Feagin10())
print(".")
@test test_callback_mvector(Feagin12())
@test test_callback_mvector(Feagin14())
print(".")
@test test_callback_mvector(TanYam7())
@test test_callback_mvector(Tsit5())
print(".")
@test test_callback_mvector(TsitPap8())
@test test_callback_mvector(Vern6())
print(".")
@test test_callback_mvector(Vern7())
@test test_callback_mvector(Vern8())
print(".")
@test test_callback_mvector(Vern9())
@test test_callback_mvector(Rosenbrock23())
print(".")
@test test_callback_mvector(Rosenbrock32())
@test test_callback_mvector(AB3(); dt = 0.1)
print(".")
@test test_callback_mvector(ABM32(); dt = 0.1)
@test test_callback_mvector(AB4(); dt = 0.1)
print(".")
@test test_callback_mvector(ABM43(); dt = 0.1)
@test test_callback_mvector(AB5(); dt = 0.1)
print(".")
@test test_callback_mvector(ABM54(); dt = 0.1)
@test test_callback_mvector(VCAB3())
print(".")
@test test_callback_mvector(VCAB4())
@test test_callback_mvector(VCAB5())
print(".")
@test test_callback_mvector(VCABM3())
@test test_callback_mvector(VCABM4())
print(".")
@test test_callback_mvector(VCABM5())
println(".")

# Discrete adjoint tests with Mooncake
# Enzyme: skipped due to segfaults (see https://github.com/EnzymeAD/Enzyme.jl/issues/2699)
# Mooncake: all versions (currently broken)
# ForwardDiff: all versions (reference)

using OrdinaryDiffEqTsit5, StaticArrays, DiffEqBase, Test, ForwardDiff
using ADTypes
import DifferentiationInterface as DI
using Mooncake  # Load Mooncake after DI to ensure extension is loaded

function lorenz!(du, u, p, t)
    du[1] = 10.0(u[2] - u[1])
    du[2] = u[1] * (28.0 - u[3]) - u[2]
    return du[3] = u[1] * u[2] - (8 / 3) * u[3]
end

const _saveat = SA[0.0, 0.25, 0.5, 0.75, 1.0, 1.25, 1.5, 1.75, 2.0, 2.25, 2.5, 2.75, 3.0]

# Functions for jacobian tests (output array)
function f_dt(y::Array{Float64}, u0::Array{Float64})
    tspan = (0.0, 3.0)
    prob = ODEProblem{true, SciMLBase.FullSpecialize}(lorenz!, u0, tspan)
    sol = DiffEqBase.solve(prob, Tsit5(), saveat = _saveat, sensealg = DiffEqBase.SensitivityADPassThrough(), abstol = 1.0e-12, reltol = 1.0e-12)
    y .= sol[1, :]
    return nothing
end

function f_dt(u0)
    tspan = (0.0, 3.0)
    prob = ODEProblem{true, SciMLBase.FullSpecialize}(lorenz!, u0, tspan)
    sol = DiffEqBase.solve(prob, Tsit5(), saveat = _saveat, sensealg = DiffEqBase.SensitivityADPassThrough(), abstol = 1.0e-12, reltol = 1.0e-12)
    return sol[1, :]
end

# Function for gradient tests (scalar output)
function f_dt_sum(u0)
    tspan = (0.0, 3.0)
    prob = ODEProblem{true, SciMLBase.FullSpecialize}(lorenz!, u0, tspan)
    sol = DiffEqBase.solve(prob, Tsit5(), dt = 0.1, saveat = _saveat, sensealg = DiffEqBase.SensitivityADPassThrough(), abstol = 1.0e-12, reltol = 1.0e-12)
    return sum(sol[1, :])
end

u0 = [1.0; 0.0; 0.0]

# Reference jacobian and gradient using ForwardDiff
fdj = DI.jacobian(f_dt, AutoForwardDiff(), u0)
fdg = DI.gradient(f_dt_sum, AutoForwardDiff(), u0)

@testset "Discrete Adjoints" begin
    # Enzyme tests skipped - Enzyme segfaults on ODE solves which crashes the process
    # before @test_broken can catch it. See https://github.com/EnzymeAD/Enzyme.jl/issues/2699

    # Mooncake tests (all Julia versions)
    @testset "Mooncake" begin
        @testset "Gradient (Reverse mode)" begin
            # Mooncake is a reverse-mode AD, so we test gradients
            @test_broken begin
                mkg = DI.gradient(f_dt_sum, AutoMooncake(; config = nothing), u0)
                mkg ≈ fdg
            end
        end
    end
end

using OrdinaryDiffEq, Test, ADTypes
using OrdinaryDiffEqDifferentiation

const a = Float64[1.0]

function lorenz(u, p, t)
    du1 = 10.0(u[2] - u[1])
    a[1] = u[2]
    du2 = u[1] * (28.0 - u[3]) - u[2]
    du3 = u[1] * u[2] - (8 / 3) * u[3]
    [du1, du2, du3]
end
u0 = [1.0; 0.0; 0.0]
tspan = (0.0, 1.0)
prob = ODEProblem(lorenz, u0, tspan)
@test_throws OrdinaryDiffEqDifferentiation.FirstAutodiffJacError solve(prob, Rosenbrock23())

function lorenz(u, p, t)
    du1 = 10.0(u[2] - u[1])
    a[1] = t
    du2 = u[1] * (28.0 - u[3]) - u[2]
    du3 = u[1] * u[2] - (8 / 3) * u[3]
    [du1, du2, du3]
end
@test_throws OrdinaryDiffEqDifferentiation.FirstAutodiffTgradError solve(
    prob, Rosenbrock23())

function lorenz!(du, u, p, t)
    du[1] = 10.0(u[2] - u[1])
    a[1] = u[2]
    du[2] = u[1] * (28.0 - u[3]) - u[2]
    du[3] = u[1] * u[2] - (8 / 3) * u[3]
end
u0 = [1.0; 0.0; 0.0]
tspan = (0.0, 1.0)
prob = ODEProblem(lorenz!, u0, tspan)
@test_throws OrdinaryDiffEqDifferentiation.FirstAutodiffJacError solve(prob, Rosenbrock23())

function lorenz2!(du, u, p, t)
    du[1] = 10.0(u[2] - u[1])
    a[1] = t
    du[2] = u[1] * (28.0 - u[3]) - u[2]
    du[3] = u[1] * u[2] - (8 / 3) * u[3]
end
prob = ODEProblem(lorenz2!, u0, tspan)
@test_throws OrdinaryDiffEqDifferentiation.FirstAutodiffTgradError solve(
    prob, Rosenbrock23())

## Test that nothing is using duals when autodiff=AutoFiniteDiff()
## https://discourse.julialang.org/t/rodas4-using-dual-number-for-time-with-autodiff-false/98256

for alg in [
    Rosenbrock23(autodiff = AutoFiniteDiff()),
    Rodas4(autodiff = AutoFiniteDiff()),
    Rodas5(autodiff = AutoFiniteDiff()),
    QNDF(autodiff = AutoFiniteDiff()),
    TRBDF2(autodiff = AutoFiniteDiff()),
    KenCarp4(autodiff = AutoFiniteDiff())
]
    u = [0.0, 0.0]
    function f1(u, p, t)
        #display(typeof(t))
        du = zeros(2)
        du[1] = 0.1 * u[1] + 0.2 * u[2]
        du[2] = 0.1 * t
        return du
    end
    prob = ODEProblem(f1, u, (0.0, 1.0))
    sol = solve(prob, alg)

    function f2(du, u, p, t)
        #display(typeof(t))
        du2 = zeros(2)
        du2[1] = 0.1 * u[1] + 0.2 * u[2]
        du2[2] = 0.1 * t
        du .= du2
    end
    prob = ODEProblem(f2, u, (0.0, 1.0))
    sol = solve(prob, alg)
end

using OrdinaryDiffEq, Test, Statistics
import ODEProblemLibrary: prob_ode_2Dlinear, prob_ode_linear

@testset "Scalar Discrete Problem" begin
    prob = DiscreteProblem(0.5, (0.0, 1.0))
    sol = solve(prob, FunctionMap())
    @test sol.u[1] == sol.u[end]
    @test sol(0.5:0.1:0.7) == [sol.u[1], sol.u[1], sol.u[1]]

    sol = solve(prob_ode_linear, FunctionMap())
    @test sol.u[end] ≈ 0.505
    sol = solve(prob_ode_linear, FunctionMap(scale_by_time = true), dt = 1 / 4)
    sol2 = solve(prob_ode_linear, Euler(), dt = 1 / 4)
    @test sol.u[end] == sol2.u[end]
    @test sol(0.53) != sol2(0.53)
end

@testset "Array Discrete Problem" begin
    prob2 = DiscreteProblem(rand(4, 2), (0.0, 1.0))
    sol = solve(prob2, FunctionMap())
    @test sol[:, 1] == sol[:, end]
    @test sol(0.5) == sol[:, 1]

    @test_nowarn sol = solve(prob_ode_2Dlinear, FunctionMap())
    @test_nowarn sol2 = solve(prob_ode_2Dlinear, Euler(), dt = 1)
    sol = solve(prob_ode_2Dlinear, FunctionMap(scale_by_time = true), dt = 1 / 4)
    sol2 = solve(prob_ode_2Dlinear, Euler(), dt = 1 / 4)
    @test sol[:, end] == sol2[:, end]
    @test sol(0.35) != sol2(0.53)
end

@testset "Discrete Problem (Henon Map)" begin
    function henon_map!(u_next, u, _p, t)
        u_next[1] = 1 + u[2] - 1.4 * u[1]^2
        u_next[2] = 0.3 * u[1]
    end

    prob = DiscreteProblem(henon_map!, [0.5, 0.5], (0, 100)) # Integer time
    sol = solve(prob, FunctionMap())
    @test eltype(sol.t) <: Integer
end

@testset "DiscreteProblem in-place time definition" begin
    function f(un, p, t_np1)
        un + t_np1
    end

    prob2 = DiscreteProblem(f, 0, (0, 5))
    sol2 = solve(prob2, FunctionMap())

    @test sol2.u == [0, 1, 3, 6, 10, 15]

    function f!(u_np1, un, p, t_np1)
        u_np1[1] = un[1] + 1
        u_np1[2] = un[2] + t_np1
    end

    prob3 = DiscreteProblem(f!, [0, 0], (0, 5))
    sol3 = solve(prob3, FunctionMap())

    @test sol3.u == [[0, 0], [1, 1], [2, 3], [3, 6], [4, 10], [5, 15]]
end

using OrdinaryDiffEq, DiffEqDevTools, Test

import ODEProblemLibrary: prob_ode_2Dlinear, prob_ode_linear

prob = prob_ode_2Dlinear
sol = solve(prob, Rosenbrock32(), dt = 1 / 2^4)

sol = solve(prob, ExplicitRK(tableau = constructBogakiShampine3()))
val1 = maximum(abs.(sol.u[end] - sol.u_analytic[end]))

sol2 = solve(prob, ExplicitRK(tableau = constructDormandPrince()))
val2 = maximum(abs.(sol2.u[end] - sol2.u_analytic[end]))

sol3 = solve(prob, ExplicitRK(tableau = constructRKF8(Float64)))
val3 = maximum(abs.(sol3.u[end] - sol3.u_analytic[end]))

sol4 = solve(prob, Stepanov5())
val4 = maximum(abs.(sol3.u[end] - sol3.u_analytic[end]))

@test length(sol.t) > length(sol2.t) >= length(sol3.t)
@test SciMLBase.successful_retcode(sol)
@test SciMLBase.successful_retcode(sol2)
@test SciMLBase.successful_retcode(sol3)
@test max(val1, val2, val3, val4) < 2e-3

function lorenz(u, p, t)
    [10.0(u[2] - u[1])
     u[1] * (28.0 - u[3]) - u[2]
     u[1] * u[2] - (8 / 3) * u[3]]
end
u0 = [1.0; 0.0; 0.0]
tspan = (0.0, 100.0)
prob = ODEProblem{false}(lorenz, u0, tspan)
sol = solve(prob, QNDF())
@test length(sol.t) < 5000
@test SciMLBase.successful_retcode(sol)
sol = solve(prob, FBDF())
@test length(sol.t) < 6600
@test SciMLBase.successful_retcode(sol)

function lorenz(du, u, p, t)
    du[1] = 10.0(u[2] - u[1])
    du[2] = u[1] * (28.0 - u[3]) - u[2]
    du[3] = u[1] * u[2] - (8 / 3) * u[3]
end
u0 = [1.0; 0.0; 0.0]
tspan = (0.0, 100.0)
prob = ODEProblem{true}(lorenz, u0, tspan)
sol = solve(prob, QNDF())
@test length(sol.t) < 5000
@test SciMLBase.successful_retcode(sol)
sol = solve(prob, FBDF())
@test length(sol.t) < 6600
@test SciMLBase.successful_retcode(sol)

function lorenz(out, du, u, p, t)
    out[1] = 10.0(u[2] - u[1]) - du[1]
    out[2] = u[1] * (28.0 - u[3]) - u[2] - du[2]
    out[3] = u[1] * u[2] - (8 / 3) * u[3] - du[3]
end
u0 = [1.0; 0.0; 0.0]
du0 = [0.0; 0.0; 0.0]
tspan = (0.0, 100.0)
differential_vars = [true, true, true]
prob = DAEProblem(lorenz, du0, u0, tspan, differential_vars = differential_vars)
sol = solve(prob, DFBDF())
@test length(sol.t) < 6600
@test SciMLBase.successful_retcode(sol)

function lorenz(du, u, p, t)
    [10.0(u[2] - u[1]) - du[1]
     u[1] * (28.0 - u[3]) - u[2] - du[2]
     u[1] * u[2] - (8 / 3) * u[3] - du[3]]
end
u0 = [1.0; 0.0; 0.0]
du0 = [0.0; 0.0; 0.0]
tspan = (0.0, 100.0)
differential_vars = [true, true, true]
prob = DAEProblem{false}(lorenz, du0, u0, tspan, differential_vars = differential_vars)
sol = solve(prob, DFBDF())
@test length(sol.t) < 6600
@test SciMLBase.successful_retcode(sol)

rr(x1, x2) = (x1 * (-2.1474936f0 * (x2 + x1)))
possibly_singular(u, p, t) = [-rr(u...), rr(u...)]
tspan = (1.6078221f0, 2.0f0)
initial_condition = [2.1349438f6, -2.1349438f6]
prob = ODEProblem(possibly_singular, initial_condition, tspan)
for alg in [
    Rosenbrock23(),
    Rosenbrock32(),
    Rodas3(),
    Rodas4(),
    Rodas4P(),
    Rodas5(),
    Rodas5P()
]
    sol = solve(prob, alg)
    @test sol.retcode == ReturnCode.Success
end

# test problems with zero-length vectors
ode = ODEProblem((du, u, semi, t) -> du .= u, Float64[], (0.0, 1.0))
@test_nowarn solve(ode, Tsit5())

# test if the early exit in ode_determine_initdt doesn't hit in the case of
# zero-length vectors, see https://github.com/SciML/OrdinaryDiffEq.jl/pull/1865
integrator = init(ode, Tsit5())
@test integrator.dt ≈ 1.0e-6

# Adaptivity regression tests for ESDIRK

prob_linear = prob_ode_linear

prob_lorenz = ODEProblem{true}(lorenz, u0, tspan)

# ESDIRK436L2SA2

sol_linear = solve(prob_linear, ESDIRK436L2SA2())
@test length(sol_linear.u) < 10
@test SciMLBase.successful_retcode(sol_linear)

sol_lorenz = solve(prob_lorenz, ESDIRK436L2SA2())
@test length(sol_lorenz.u) < 1500
@test SciMLBase.successful_retcode(sol_lorenz)

# ESDIRK437L2SA

sol_linear = solve(prob_linear, ESDIRK437L2SA())
@test length(sol_linear.u) < 10
@test SciMLBase.successful_retcode(sol_linear)

sol_lorenz = solve(prob_lorenz, ESDIRK437L2SA())
@test length(sol_lorenz.u) < 1000
@test SciMLBase.successful_retcode(sol_lorenz)

# ESDIRK547L2SA2

sol_linear = solve(prob_linear, ESDIRK547L2SA2())
@test length(sol_linear.u) < 10
@test SciMLBase.successful_retcode(sol_linear)

sol_lorenz = solve(prob_lorenz, ESDIRK547L2SA2())
@test length(sol_lorenz.u) < 1000
@test SciMLBase.successful_retcode(sol_lorenz)

# ESDIRK659L2SA

sol_linear = solve(prob_linear, ESDIRK659L2SA())
@test_broken length(sol_linear.u) < 10
@test SciMLBase.successful_retcode(sol_linear)

sol_lorenz = solve(prob_lorenz, ESDIRK659L2SA())
@test length(sol_lorenz.u) < 1000
@test SciMLBase.successful_retcode(sol_lorenz)

# Adaptivity tests for Alshina2, 3

for prob in [prob_ode_2Dlinear, prob_ode_linear]
    sol = solve(prob, Alshina2())
    val = maximum(abs.(sol.u[end] - sol.u_analytic[end]))
    @test val < 1e-6

    sol = solve(prob, Alshina3())
    val = maximum(abs.(sol.u[end] - sol.u_analytic[end]))
    @test val < 1e-6
end

using OrdinaryDiffEqCore
using OrdinaryDiffEqCore: DEVerbosity
using OrdinaryDiffEq
using OrdinaryDiffEqNonlinearSolve: NonlinearSolveAlg
using ODEProblemLibrary: prob_ode_vanderpol_stiff
using Test
import OrdinaryDiffEqCore.SciMLLogging as SciMLLogging
using LinearSolve: LinearVerbosity
using NonlinearSolve: NonlinearVerbosity

@testset "DEVerbosity Tests" begin
    @testset "Default constructor" begin
        v1 = DEVerbosity()
        @test v1 isa DEVerbosity

        # Test solver verbosity
        @test v1.linear_verbosity isa SciMLLogging.Minimal
        @test v1.nonlinear_verbosity isa SciMLLogging.Minimal

        # Test error control group (default: WarnLevel except newton_convergence, step_rejected, step_accepted, convergence_limit)
        @test v1.dt_NaN isa SciMLLogging.WarnLevel
        @test v1.init_NaN isa SciMLLogging.WarnLevel
        @test v1.dense_output_saveat isa SciMLLogging.WarnLevel
        @test v1.max_iters isa SciMLLogging.WarnLevel
        @test v1.dt_min_unstable isa SciMLLogging.WarnLevel
        @test v1.instability isa SciMLLogging.WarnLevel
        @test v1.newton_convergence isa SciMLLogging.Silent
        @test v1.step_rejected isa SciMLLogging.Silent
        @test v1.step_accepted isa SciMLLogging.Silent
        @test v1.convergence_limit isa SciMLLogging.Silent

        # Test performance group (default: Silent except mismatched_input_output_type)
        @test v1.alg_switch isa SciMLLogging.Silent
        @test v1.stiff_detection isa SciMLLogging.Silent
        @test v1.mismatched_input_output_type isa SciMLLogging.WarnLevel
        @test v1.jacobian_update isa SciMLLogging.Silent
        @test v1.w_factorization isa SciMLLogging.Silent
        @test v1.newton_iterations isa SciMLLogging.Silent

        # Test numerical group (default: WarnLevel except shampine_dt, dt_epsilon, stability_check)
        @test v1.rosenbrock_no_differential_states isa SciMLLogging.WarnLevel
        @test v1.shampine_dt isa SciMLLogging.Silent
        @test v1.unlimited_dt isa SciMLLogging.WarnLevel
        @test v1.dt_epsilon isa SciMLLogging.Silent
        @test v1.stability_check isa SciMLLogging.Silent
        @test v1.near_singular isa SciMLLogging.Silent
    end

    @testset "DEVerbosity preset constructors" begin
        v_none = DEVerbosity(SciMLLogging.None())
        v_minimal = DEVerbosity(SciMLLogging.Minimal())
        v_standard = DEVerbosity(SciMLLogging.Standard())
        v_detailed = DEVerbosity(SciMLLogging.Detailed())
        v_all = DEVerbosity(SciMLLogging.All())

        # Test None - everything Silent
        @test v_none.linear_verbosity isa SciMLLogging.None
        @test v_none.nonlinear_verbosity isa SciMLLogging.None
        @test v_none.dt_NaN isa SciMLLogging.Silent
        @test v_none.init_NaN isa SciMLLogging.Silent
        @test v_none.alg_switch isa SciMLLogging.Silent
        @test v_none.rosenbrock_no_differential_states isa SciMLLogging.Silent

        # Test Minimal - only critical errors
        @test v_minimal.linear_verbosity isa SciMLLogging.Minimal
        @test v_minimal.nonlinear_verbosity isa SciMLLogging.Minimal
        @test v_minimal.dt_NaN isa SciMLLogging.WarnLevel
        @test v_minimal.init_NaN isa SciMLLogging.WarnLevel
        @test v_minimal.max_iters isa SciMLLogging.WarnLevel
        @test v_minimal.newton_convergence isa SciMLLogging.WarnLevel
        @test v_minimal.near_singular isa SciMLLogging.WarnLevel
        @test v_minimal.alg_switch isa SciMLLogging.Silent
        @test v_minimal.dense_output_saveat isa SciMLLogging.Silent
        @test v_minimal.mismatched_input_output_type isa SciMLLogging.Silent

        # Test Standard - same as default
        @test v_standard.dt_NaN isa SciMLLogging.WarnLevel
        @test v_standard.init_NaN isa SciMLLogging.WarnLevel
        @test v_standard.alg_switch isa SciMLLogging.Silent
        @test v_standard.dense_output_saveat isa SciMLLogging.WarnLevel
        @test v_standard.mismatched_input_output_type isa SciMLLogging.WarnLevel

        # Test Detailed - includes debugging info
        @test v_detailed.linear_verbosity isa SciMLLogging.Detailed
        @test v_detailed.nonlinear_verbosity isa SciMLLogging.Detailed
        @test v_detailed.alg_switch isa SciMLLogging.InfoLevel
        @test v_detailed.dense_output_saveat isa SciMLLogging.InfoLevel
        @test v_detailed.shampine_dt isa SciMLLogging.InfoLevel
        @test v_detailed.jacobian_update isa SciMLLogging.InfoLevel
        @test v_detailed.w_factorization isa SciMLLogging.InfoLevel
        @test v_detailed.convergence_limit isa SciMLLogging.InfoLevel

        # Test All - maximum verbosity
        @test v_all.linear_verbosity isa SciMLLogging.All
        @test v_all.nonlinear_verbosity isa SciMLLogging.All
        @test v_all.alg_switch isa SciMLLogging.InfoLevel
        @test v_all.shampine_dt isa SciMLLogging.InfoLevel
        @test v_all.dense_output_saveat isa SciMLLogging.InfoLevel
        @test v_all.step_rejected isa SciMLLogging.InfoLevel
        @test v_all.step_accepted isa SciMLLogging.InfoLevel
        @test v_all.stiff_detection isa SciMLLogging.InfoLevel
    end

    @testset "Group-level keyword constructors" begin
        v_error = DEVerbosity(error_control = SciMLLogging.ErrorLevel())
        # Test all error_control fields
        @test v_error.dt_NaN isa SciMLLogging.ErrorLevel
        @test v_error.init_NaN isa SciMLLogging.ErrorLevel
        @test v_error.dense_output_saveat isa SciMLLogging.ErrorLevel
        @test v_error.max_iters isa SciMLLogging.ErrorLevel
        @test v_error.dt_min_unstable isa SciMLLogging.ErrorLevel
        @test v_error.instability isa SciMLLogging.ErrorLevel
        @test v_error.newton_convergence isa SciMLLogging.ErrorLevel
        @test v_error.step_rejected isa SciMLLogging.ErrorLevel
        @test v_error.step_accepted isa SciMLLogging.ErrorLevel
        @test v_error.convergence_limit isa SciMLLogging.ErrorLevel

        v_numerical = DEVerbosity(numerical = SciMLLogging.Silent())
        # Test all numerical fields
        @test v_numerical.rosenbrock_no_differential_states isa SciMLLogging.Silent
        @test v_numerical.shampine_dt isa SciMLLogging.Silent
        @test v_numerical.unlimited_dt isa SciMLLogging.Silent
        @test v_numerical.dt_epsilon isa SciMLLogging.Silent
        @test v_numerical.stability_check isa SciMLLogging.Silent
        @test v_numerical.near_singular isa SciMLLogging.Silent

        v_performance = DEVerbosity(performance = SciMLLogging.InfoLevel())
        # Test all performance fields
        @test v_performance.alg_switch isa SciMLLogging.InfoLevel
        @test v_performance.stiff_detection isa SciMLLogging.InfoLevel
        @test v_performance.mismatched_input_output_type isa SciMLLogging.InfoLevel
        @test v_performance.jacobian_update isa SciMLLogging.InfoLevel
        @test v_performance.w_factorization isa SciMLLogging.InfoLevel
        @test v_performance.newton_iterations isa SciMLLogging.InfoLevel
    end

    @testset "Mixed group and individual settings" begin
        v_mixed = DEVerbosity(
            numerical = SciMLLogging.Silent(),
            shampine_dt = SciMLLogging.WarnLevel(),
            performance = SciMLLogging.InfoLevel()
        )
        # Individual override should take precedence
        @test v_mixed.shampine_dt isa SciMLLogging.WarnLevel
        # Other numerical options should use group setting
        @test v_mixed.rosenbrock_no_differential_states isa SciMLLogging.Silent
        @test v_mixed.unlimited_dt isa SciMLLogging.Silent
        # Performance group setting should apply
        @test v_mixed.alg_switch isa SciMLLogging.InfoLevel
        @test v_mixed.mismatched_input_output_type isa SciMLLogging.InfoLevel
    end

    @testset "Individual keyword arguments" begin
        v_individual = DEVerbosity(
            dt_NaN = SciMLLogging.ErrorLevel(),
            alg_switch = SciMLLogging.InfoLevel(),
            shampine_dt = SciMLLogging.Silent()
        )
        @test v_individual.dt_NaN isa SciMLLogging.ErrorLevel
        @test v_individual.alg_switch isa SciMLLogging.InfoLevel
        @test v_individual.shampine_dt isa SciMLLogging.Silent
        # Unspecified options should use defaults
        @test v_individual.init_NaN isa SciMLLogging.WarnLevel
        @test v_individual.unlimited_dt isa SciMLLogging.WarnLevel
    end

    @testset "Linear and nonlinear verbosity passthrough" begin
        v_with_solvers = DEVerbosity(
            linear_verbosity = SciMLLogging.Detailed(),
            nonlinear_verbosity = SciMLLogging.Minimal()
        )
        @test v_with_solvers.linear_verbosity isa SciMLLogging.Detailed
        @test v_with_solvers.nonlinear_verbosity isa SciMLLogging.Minimal

        v_with_solvers2 = DEVerbosity(
            linear_verbosity = SciMLLogging.None(),
            nonlinear_verbosity = SciMLLogging.All()
        )
        @test v_with_solvers2.linear_verbosity isa SciMLLogging.None
        @test v_with_solvers2.nonlinear_verbosity isa SciMLLogging.All
    end

    @testset "Validation tests" begin
        # Test that invalid group arguments throw errors
        @test_throws ArgumentError DEVerbosity(error_control = "invalid")
        @test_throws ArgumentError DEVerbosity(performance = 123)
        @test_throws ArgumentError DEVerbosity(numerical = :wrong)

        # Test that invalid individual fields throw errors
        @test_throws ArgumentError DEVerbosity(dt_NaN = "invalid")
        @test_throws ArgumentError DEVerbosity(unknown_field = SciMLLogging.InfoLevel())
    end

    @testset "Multiple group settings" begin
        v = DEVerbosity(
            error_control = SciMLLogging.ErrorLevel(),
            performance = SciMLLogging.InfoLevel(),
            numerical = SciMLLogging.Silent()
        )
        @test v.dt_NaN isa SciMLLogging.ErrorLevel
        @test v.alg_switch isa SciMLLogging.InfoLevel
        @test v.shampine_dt isa SciMLLogging.Silent
    end

    @testset "Complex mixed settings" begin
        v = DEVerbosity(
            error_control = SciMLLogging.WarnLevel(),
            performance = SciMLLogging.InfoLevel(),
            numerical = SciMLLogging.Silent(),
            linear_verbosity = SciMLLogging.Detailed(),
            nonlinear_verbosity = SciMLLogging.Minimal(),
            dt_NaN = SciMLLogging.ErrorLevel(),  # Override specific error_control field
            shampine_dt = SciMLLogging.WarnLevel()  # Override specific numerical field
        )
        # Check overrides took precedence
        @test v.dt_NaN isa SciMLLogging.ErrorLevel
        @test v.shampine_dt isa SciMLLogging.WarnLevel
        # Check other fields follow group settings
        @test v.init_NaN isa SciMLLogging.WarnLevel
        @test v.alg_switch isa SciMLLogging.InfoLevel
        @test v.unlimited_dt isa SciMLLogging.Silent
        # Check solver verbosity
        @test v.linear_verbosity isa SciMLLogging.Detailed
        @test v.nonlinear_verbosity isa SciMLLogging.Minimal
    end

    @testset "Stiff Switching Message" begin
        verb = DEVerbosity(alg_switch = SciMLLogging.InfoLevel())
        solve(prob_ode_vanderpol_stiff, AutoTsit5(Rodas5()), verbose = verb)
    end

    @testset "Linear Verbosity Passthrough to Caches" begin
        # Define a simple stiff test problem
        function rober(du, u, p, t)
            y₁, y₂, y₃ = u
            k₁, k₂, k₃ = p
            du[1] = -k₁ * y₁ + k₃ * y₂ * y₃
            du[2] = k₁ * y₁ - k₃ * y₂ * y₃ - k₂ * y₂^2
            du[3] = y₁ + y₂ + y₃ - 1
            nothing
        end
        u0 = [1.0, 0.0, 0.0]
        tspan = (0.0, 1.0e-1)
        p = [0.04, 3.0e7, 1.0e4]
        prob = ODEProblem(rober, u0, tspan, p)

        @testset "Rosenbrock Solvers" begin
            @testset "Rosenbrock23 with Detailed LinearVerbosity" begin
                verbose = DEVerbosity(linear_verbosity = SciMLLogging.Detailed())
                integrator = init(prob, Rosenbrock23(), verbose = verbose, dt = 1.0e-3)

                # Check that the cache has a linsolve field
                @test hasproperty(integrator.cache, :linsolve)

                # Check that the linear solver cache has verbose field
                @test hasproperty(integrator.cache.linsolve, :verbose)

                # Verify the verbosity was passed through correctly
                @test integrator.cache.linsolve.verbose == LinearVerbosity(SciMLLogging.Detailed())
            end

            @testset "Rosenbrock23 with Minimal LinearVerbosity" begin
                verbose = DEVerbosity(linear_verbosity = SciMLLogging.Minimal())
                integrator = init(prob, Rosenbrock23(), verbose = verbose, dt = 1.0e-3)

                @test integrator.cache.linsolve.verbose == LinearVerbosity(SciMLLogging.Minimal())
            end

            @testset "Rosenbrock23 with None LinearVerbosity" begin
                verbose = DEVerbosity(linear_verbosity = SciMLLogging.None())
                integrator = init(prob, Rosenbrock23(), verbose = verbose, dt = 1.0e-3)

                @test integrator.cache.linsolve.verbose == LinearVerbosity(SciMLLogging.None())
            end

            @testset "Rosenbrock32 with Detailed LinearVerbosity" begin
                verbose = DEVerbosity(linear_verbosity = SciMLLogging.Detailed())
                integrator = init(prob, Rosenbrock32(), verbose = verbose, dt = 1.0e-3)

                @test integrator.cache.linsolve.verbose == LinearVerbosity(SciMLLogging.Detailed())
            end

            @testset "Rodas4 with All LinearVerbosity" begin
                verbose = DEVerbosity(linear_verbosity = SciMLLogging.All())
                integrator = init(prob, Rodas4(), verbose = verbose, dt = 1.0e-3)

                @test integrator.cache.linsolve.verbose == LinearVerbosity(SciMLLogging.All())
            end
        end

        @testset "FIRK Solvers (Radau Methods)" begin
            @testset "RadauIIA3 with Detailed LinearVerbosity" begin
                verbose = DEVerbosity(linear_verbosity = SciMLLogging.Detailed())
                integrator = init(prob, RadauIIA3(), verbose = verbose, dt = 1.0e-3)

                # RadauIIA3 has a linsolve field
                @test integrator.cache.linsolve.verbose == LinearVerbosity(SciMLLogging.Detailed())
            end

            @testset "RadauIIA3 with Minimal LinearVerbosity" begin
                verbose = DEVerbosity(linear_verbosity = SciMLLogging.Minimal())
                integrator = init(prob, RadauIIA3(), verbose = verbose, dt = 1.0e-3)

                @test integrator.cache.linsolve.verbose == LinearVerbosity(SciMLLogging.Minimal())
            end

            @testset "RadauIIA5 with Detailed LinearVerbosity (two linear solvers)" begin
                verbose = DEVerbosity(linear_verbosity = SciMLLogging.Detailed())
                integrator = init(prob, RadauIIA5(), verbose = verbose, dt = 1.0e-3)

                @test integrator.cache.linsolve1.verbose == LinearVerbosity(SciMLLogging.Detailed())
                @test integrator.cache.linsolve2.verbose == LinearVerbosity(SciMLLogging.Detailed())
            end

            @testset "RadauIIA5 with None LinearVerbosity" begin
                verbose = DEVerbosity(linear_verbosity = SciMLLogging.None())
                integrator = init(prob, RadauIIA5(), verbose = verbose, dt = 1.0e-3)

                @test integrator.cache.linsolve1.verbose == LinearVerbosity(SciMLLogging.None())
                @test integrator.cache.linsolve2.verbose == LinearVerbosity(SciMLLogging.None())
            end

            @testset "RadauIIA9 with All LinearVerbosity (three linear solvers)" begin
                verbose = DEVerbosity(linear_verbosity = SciMLLogging.All())
                integrator = init(prob, RadauIIA9(), verbose = verbose, dt = 1.0e-3)

                # Check all three linear solvers have the correct verbosity
                @test integrator.cache.linsolve1.verbose == LinearVerbosity(SciMLLogging.All())
                @test integrator.cache.linsolve2.verbose ==
                    LinearVerbosity(SciMLLogging.All())
                @test integrator.cache.linsolve3.verbose ==
                    LinearVerbosity(SciMLLogging.All())
            end
        end

        @testset "Extrapolation Solvers" begin
            @testset "ImplicitEulerExtrapolation with Detailed LinearVerbosity" begin
                verbose = DEVerbosity(linear_verbosity = SciMLLogging.Detailed())
                integrator = init(prob, ImplicitEulerExtrapolation(), verbose = verbose, dt = 1.0e-3)

                # Check that all linear solvers in the array have the correct verbosity
                for ls in integrator.cache.linsolve
                    @test ls.verbose == LinearVerbosity(SciMLLogging.Detailed())
                end
            end

            @testset "ImplicitEulerExtrapolation with Minimal LinearVerbosity" begin
                verbose = DEVerbosity(linear_verbosity = SciMLLogging.Minimal())
                integrator = init(prob, ImplicitEulerExtrapolation(), verbose = verbose, dt = 1.0e-3)

                for ls in integrator.cache.linsolve
                    @test ls.verbose == LinearVerbosity(SciMLLogging.Minimal())
                end
            end

            @testset "ImplicitDeuflhardExtrapolation with None LinearVerbosity" begin
                verbose = DEVerbosity(linear_verbosity = SciMLLogging.None())
                integrator = init(prob, ImplicitDeuflhardExtrapolation(), verbose = verbose, dt = 1.0e-3)

                for ls in integrator.cache.linsolve
                    @test ls.verbose == LinearVerbosity(SciMLLogging.None())
                end
            end

            @testset "ImplicitHairerWannerExtrapolation with All LinearVerbosity" begin
                verbose = DEVerbosity(linear_verbosity = SciMLLogging.All())
                integrator = init(prob, ImplicitHairerWannerExtrapolation(), verbose = verbose, dt = 1.0e-3)

                for ls in integrator.cache.linsolve
                    @test ls.verbose == LinearVerbosity(SciMLLogging.All())
                end
            end
        end

        @testset "Preset Verbosity Levels" begin
            @testset "Rosenbrock23 with Standard() preset (default linear_verbosity = Minimal)" begin
                verbose = DEVerbosity(SciMLLogging.Standard())
                integrator = init(prob, Rosenbrock23(), verbose = verbose, dt = 1.0e-3)

                # Standard() uses Minimal() for linear_verbosity
                @test integrator.cache.linsolve.verbose == LinearVerbosity(SciMLLogging.Minimal())
            end

            @testset "RadauIIA3 with Detailed() preset" begin
                verbose = DEVerbosity(SciMLLogging.Detailed())
                integrator = init(prob, RadauIIA3(), verbose = verbose, dt = 1.0e-3)

                # Detailed() uses Detailed() for linear_verbosity
                @test integrator.cache.linsolve.verbose == LinearVerbosity(SciMLLogging.Detailed())
            end

        end
    end

    @testset "Nonlinear Verbosity Passthrough to Caches" begin
        # Define a simple stiff test problem
        function rober(du, u, p, t)
            y₁, y₂, y₃ = u
            k₁, k₂, k₃ = p
            du[1] = -k₁ * y₁ + k₃ * y₂ * y₃
            du[2] = k₁ * y₁ - k₃ * y₂ * y₃ - k₂ * y₂^2
            du[3] = y₁ + y₂ + y₃ - 1
            nothing
        end
        u0 = [1.0, 0.0, 0.0]
        tspan = (0.0, 1.0e-1)
        p = [0.04, 3.0e7, 1.0e4]
        prob = ODEProblem(rober, u0, tspan, p)

        @testset "ImplicitEuler with Detailed NonlinearVerbosity" begin
            verbose = DEVerbosity(nonlinear_verbosity = SciMLLogging.Detailed())
            integrator = init(prob, ImplicitEuler(nlsolve = NonlinearSolveAlg()), verbose = verbose, dt = 1.0e-3)

            # Check that the cache has an nlsolver field
            @test hasproperty(integrator.cache, :nlsolver)

            # Check that the nlsolver has a cache field
            @test hasproperty(integrator.cache.nlsolver, :cache)

            # Verify the verbosity was passed through correctly
            @test integrator.cache.nlsolver.cache.cache.verbose == NonlinearVerbosity(SciMLLogging.Detailed())
        end

    end
end

using OrdinaryDiffEq

function SinCosDiffEqToSolve!(ddu, du, u, p, t)
    ddu[1] = -u[1]
end

prob = SecondOrderODEProblem(SinCosDiffEqToSolve!, [2.0], [3.0], (0.0, 1.0))
sol = solve(prob, Tsit5())
sol = solve(prob, Vern9())
sol = solve(prob, ROCK4())
sol = solve(prob, Rodas4())
sol = solve(prob, AutoVern9(Rodas4()))
sol = solve(prob, TRBDF2())

using OrdinaryDiffEqRosenbrock
using OrdinaryDiffEqNonlinearSolve
using CUDA
using LinearAlgebra
using Adapt
using SparseArrays
using Test

#=
du[1] = -u[1]
du[2] = -0.5*u[2]
    0 =  u[1] + u[2] - u[3]
    0 = -u[1] + u[2] - u[4]
=#

function dae!(du, u, p, t)
    mul!(du, p, u)
end

p = [-1 0 0 0
     1 -0.5 0 0
     1 1 -1 0
     -1 1 0 -1]

# mass_matrix = [1 0 0 0
#                0 1 0 0
#                0 0 0 0
#                0 0 0 0]
mass_matrix = Diagonal([1, 1, 0, 0])
jac_prototype = sparse(map(x -> iszero(x) ? 0.0 : 1.0, p))

u0 = [1.0, 1.0, 0.5, 0.5] # force init
odef = ODEFunction(dae!, mass_matrix = mass_matrix, jac_prototype = jac_prototype)

tspan = (0.0, 5.0)
prob = ODEProblem(odef, u0, tspan, p)
sol = solve(prob, Rodas5P())

# gpu version
mass_matrix_d = adapt(CuArray, mass_matrix)

# TODO: jac_prototype fails
# jac_prototype_d = adapt(CuArray, jac_prototype)
# jac_prototype_d = CUDA.CUSPARSE.CuSparseMatrixCSR(jac_prototype)
jac_prototype_d = nothing

u0_d = adapt(CuArray, u0)
p_d = adapt(CuArray, p)
odef_d = ODEFunction(dae!, mass_matrix = mass_matrix_d, jac_prototype = jac_prototype_d)
prob_d = ODEProblem(odef_d, u0_d, tspan, p_d)
sol_d = solve(prob_d, Rodas5P())

@testset "Test constraints in GPU sol" begin
    for t in sol_d.t
        u = Vector(sol_d(t))
        @test isapprox(u[1] + u[2], u[3]; atol = 1e-6)
        @test isapprox(-u[1] + u[2], u[4]; atol = 1e-6)
    end
end

@testset "Compare GPU to CPU solution" begin
    for t in tspan[begin]:0.1:tspan[end]
        @test Vector(sol_d(t)) ≈ sol(t)
    end
end

using OrdinaryDiffEqBDF, OrdinaryDiffEqRosenbrock, LinearAlgebra, ForwardDiff, Test
using OrdinaryDiffEqCore

function rober(du, u, p, t)
    y₁, y₂, y₃ = u
    k₁, k₂, k₃ = p
    du[1] = -k₁ * y₁ + k₃ * y₂ * y₃
    du[2] = k₁ * y₁ - k₃ * y₂ * y₃ - k₂ * y₂^2
    du[3] = y₁ + y₂ + y₃ - 1
    nothing
end
function rober(u, p, t)
    y₁, y₂, y₃ = u
    k₁, k₂, k₃ = p
    [-k₁ * y₁ + k₃ * y₂ * y₃,
        k₁ * y₁ - k₃ * y₂ * y₃ - k₂ * y₂^2,
        y₁ + y₂ + y₃ - 1]
end
M = [1.0 0 0
     0 1.0 0
     0 0 0]
roberf = ODEFunction(rober, mass_matrix = M)
roberf_oop = ODEFunction{false}(rober, mass_matrix = M)
prob_mm = ODEProblem(roberf, [1.0, 0.0, 0.2], (0.0, 1e5), (0.04, 3e7, 1e4))
prob_mm_oop = ODEProblem(roberf_oop, [1.0, 0.0, 0.2], (0.0, 1e5), (0.04, 3e7, 1e4))

@test_throws SciMLBase.CheckInitFailureError solve(
    prob_mm, Rodas5P(), reltol = 1e-8, abstol = 1e-8, initializealg = SciMLBase.CheckInit())
@test_throws SciMLBase.CheckInitFailureError solve(
    prob_mm_oop, Rodas5P(), reltol = 1e-8, abstol = 1e-8,
    initializealg = SciMLBase.CheckInit())

f_oop = function (du, u, p, t)
    out1 = -0.04u[1] + 1e4 * u[2] * u[3] - du[1]
    out2 = +0.04u[1] - 3e7 * u[2]^2 - 1e4 * u[2] * u[3] - du[2]
    out3 = u[1] + u[2] + u[3] - 1.0
    [out1, out2, out3]
end

f = function (resid, du, u, p, t)
    resid[1] = -0.04u[1] + 1e4 * u[2] * u[3] - du[1]
    resid[2] = +0.04u[1] - 3e7 * u[2]^2 - 1e4 * u[2] * u[3] - du[2]
    resid[3] = u[1] + u[2] + u[3] - 1.0
end

u₀ = [1.0, 0, 0.2]
du₀ = [0.0, 0.0, 0.0]
tspan = (0.0, 100000.0)
differential_vars = [true, true, false]
prob = DAEProblem(f, du₀, u₀, tspan, differential_vars = differential_vars)
prob_oop = DAEProblem(f_oop, du₀, u₀, tspan, differential_vars = differential_vars)
@test_throws SciMLBase.CheckInitFailureError solve(
    prob, DFBDF(), reltol = 1e-8, abstol = 1e-8, initializealg = SciMLBase.CheckInit())
@test_throws SciMLBase.CheckInitFailureError solve(
    prob_oop, DFBDF(), reltol = 1e-8, abstol = 1e-8, initializealg = SciMLBase.CheckInit())

using OrdinaryDiffEq, JLArrays, LinearAlgebra, Test, ADTypes

@testset "GPU AutoDiff with JLArrays" begin
    function f(u, p, t)
        A = jl(-ones(3, 3))
        return A*u
    end
    function f!(du, u, p, t)
        A = jl(-ones(3, 3))
        return mul!(du, A, u)
    end

    u0 = jl([1.0; 0.0; 0.0])
    tspan = (0.0f0, 100.0f0)
    prob = ODEProblem{false}(f, u0, tspan)
    solve(prob, TRBDF2())
    solve(prob, Rodas5P())

    prob2 = ODEProblem(f!, u0, tspan)
    solve(prob, TRBDF2())
    solve(prob, Rodas5P())
end

using Pkg
using SafeTestsets, Test
const LONGER_TESTS = false

const GROUP = get(ENV, "GROUP", "All")
const is_APPVEYOR = Sys.iswindows() && haskey(ENV, "APPVEYOR")

function activate_downstream_env()
    Pkg.activate("downstream")
    Pkg.develop(PackageSpec(path = dirname(@__DIR__)))
    Pkg.instantiate()
end

function activate_gpu_env()
    Pkg.activate("gpu")
    Pkg.develop(PackageSpec(path = dirname(@__DIR__)))
    Pkg.instantiate()
end

function activate_odeinterface_env()
    Pkg.activate("odeinterface")
    Pkg.develop(PackageSpec(path = dirname(@__DIR__)))
    Pkg.instantiate()
end

function activate_enzyme_env()
    Pkg.activate("enzyme")
    Pkg.develop(PackageSpec(path = dirname(@__DIR__)))
    Pkg.instantiate()
end

function activate_modelingtoolkit_env()
    Pkg.activate("modelingtoolkit")
    Pkg.develop(PackageSpec(path = dirname(@__DIR__)))
    Pkg.instantiate()
end

#Start Test Script

@time begin
    if contains(GROUP, "OrdinaryDiffEq") || GROUP == "ImplicitDiscreteSolve" || GROUP == "SimpleImplicitDiscreteSolve"
        Pkg.activate(joinpath(dirname(@__DIR__), "lib", GROUP))
        Pkg.test(GROUP, julia_args=["--check-bounds=auto", "--compiled-modules=yes", "--depwarn=yes"], force_latest_compatible_version=false, allow_reresolve=true)
    elseif GROUP == "All" || GROUP == "InterfaceI" || GROUP == "Interface"
        @time @safetestset "Discrete Algorithm Tests" include("interface/discrete_algorithm_test.jl")
        @time @safetestset "Tstops Tests" include("interface/ode_tstops_tests.jl")
        @time @safetestset "Backwards Tests" include("interface/ode_backwards_test.jl")
        @time @safetestset "Initdt Tests" include("interface/ode_initdt_tests.jl")
        @time @safetestset "Linear Tests" include("interface/ode_twodimlinear_tests.jl")
        @time @safetestset "Differentiation Trait Tests" include("interface/differentiation_traits_tests.jl")
        @time @safetestset "Inf Tests" include("interface/inf_handling.jl")
        @time @safetestset "saveat Tests" include("interface/ode_saveat_tests.jl")
        @time @safetestset "save_idxs Tests" include("interface/ode_saveidxs_tests.jl")
        @time @safetestset "Scalar Handling Tests" include("interface/scalar_handling_tests.jl")
        @time @safetestset "Static Array Tests" include("interface/static_array_tests.jl")
        @time @safetestset "u_modified Tests" include("interface/umodified_test.jl")
        @time @safetestset "Composite Algorithm Tests" include("interface/composite_algorithm_test.jl")
        @time @safetestset "Complex Tests" include("interface/complex_tests.jl")
        @time @safetestset "Ndim Complex Tests" include("interface/ode_ndim_complex_tests.jl")
        @time @safetestset "Number Type Tests" include("interface/ode_numbertype_tests.jl")
        @time @safetestset "Interpolation Output Type Tests" include("interface/interpolation_output_types.jl")
        @time @safetestset "Stiffness Detection Tests" include("interface/stiffness_detection_test.jl")
        @time @safetestset "Composite Interpolation Tests" include("interface/composite_interpolation.jl")
        @time @safetestset "Export tests" include("interface/export_tests.jl")
        @time @safetestset "Type Handling Tests" include("interface/type_handling.jl")
        @time @safetestset "Controller Tests" include("interface/controllers.jl")
        @time @safetestset "Inplace Interpolation Tests" include("interface/inplace_interpolation.jl")
        @time @safetestset "Algebraic Interpolation Tests" include("interface/algebraic_interpolation.jl")
        @time @safetestset "Interpolation and Cache Stripping Tests" include("interface/ode_strip_test.jl")
        @time @safetestset "Aliasing Tests" include("interface/aliasing_tests.jl")
    end

    if !is_APPVEYOR && (GROUP == "All" || GROUP == "InterfaceII" || GROUP == "Interface")
        #@time @safetestset "No Recompile Tests" include("interface/norecompile.jl") # doesn't work on CI?
        @time @safetestset "Linear Nonlinear Solver Tests" include("interface/linear_nonlinear_tests.jl")
        @time @safetestset "Linear Solver Tests" include("interface/linear_solver_test.jl")
        @time @safetestset "Linear Solver Split ODE Tests" include("interface/linear_solver_split_ode_test.jl")
        @time @safetestset "AutoSparse Detection Tests" include("interface/autosparse_detection_tests.jl")
        @time @safetestset "Enum Tests" include("interface/enums.jl")
        @time @safetestset "CheckInit Tests" include("interface/checkinit_tests.jl")
        @time @safetestset "Get du Tests" include("interface/get_du.jl")
        @time @safetestset "Mass Matrix Tests" include("interface/mass_matrix_tests.jl")
        @time @safetestset "W-Operator prototype tests" include("interface/wprototype_tests.jl")
    end

    if !is_APPVEYOR && (GROUP == "All" || GROUP == "InterfaceIII" || GROUP == "Interface")
        @time @safetestset "Derivative Utilities Tests" include("interface/utility_tests.jl")
        @time @safetestset "stats Tests" include("interface/stats_tests.jl")
        @time @safetestset "No Index Tests" include("interface/noindex_tests.jl")
        @time @safetestset "Events + DAE addsteps Tests" include("interface/event_dae_addsteps.jl")
        @time @safetestset "No Jac Tests" include("interface/nojac.jl")
        @time @safetestset "Units Tests" include("interface/units_tests.jl")
        @time @safetestset "Non-Full Diagonal Sparsity Tests" include("interface/nonfulldiagonal_sparse.jl")
    end

    if !is_APPVEYOR && (GROUP == "All" || GROUP == "InterfaceIV" || GROUP == "Interface")
        @time @safetestset "Autodiff Error Tests" include("interface/autodiff_error_tests.jl")
        @time @safetestset "Ambiguity Tests" include("interface/ambiguity_tests.jl")
        @time @safetestset "Precision Mixing Tests" include("interface/precision_mixing.jl")
        @time @safetestset "Sized Matrix Tests" include("interface/sized_matrix_tests.jl")
        @time @safetestset "Second Order with First Order Solver Tests" include("interface/second_order_with_first_order_solvers.jl")
    end

    if !is_APPVEYOR && (GROUP == "All" || GROUP == "InterfaceV" || GROUP == "Interface")
        @time @safetestset "Interpolation Derivative Error Tests" include("interface/interpolation_derivative_error_tests.jl")
        @time @safetestset "AD Tests" include("interface/ad_tests.jl")
        @time @safetestset "GPU AutoDiff Interface Tests" include("interface/gpu_autodiff_interface_tests.jl")
        @time @safetestset "DAE Initialization Tests" include("interface/dae_initialization_tests.jl")
    end

    if !is_APPVEYOR &&
       (GROUP == "All" || GROUP == "Integrators_I" || GROUP == "Integrators")
        @time @safetestset "Reinit Tests" include("integrators/reinit_test.jl")
        @time @safetestset "Events Tests" include("integrators/ode_event_tests.jl")
        @time @safetestset "Alg Events Tests" include("integrators/alg_events_tests.jl")
        @time @safetestset "Discrete Callback Dual Tests" include("integrators/discrete_callback_dual_test.jl")
        @time @safetestset "Callback Allocation Tests" include("integrators/callback_allocation_tests.jl")
        @time @safetestset "Iterator Tests" include("integrators/iterator_tests.jl")
        @time @safetestset "Integrator Interface Tests" include("integrators/integrator_interface_tests.jl")
        @time @safetestset "Error Check Tests" include("integrators/check_error.jl")
        @time @safetestset "Event Detection Tests" include("integrators/event_detection_tests.jl")
        @time @safetestset "Event Repetition Detection Tests" include("integrators/event_repeat_tests.jl")
        @time @safetestset "Step Limiter Tests" include("integrators/step_limiter_test.jl")
    end

    if !is_APPVEYOR &&
       (GROUP == "All" || GROUP == "Integrators_II" || GROUP == "Integrators")
        @time @safetestset "Reverse Directioned Event Tests" include("integrators/rev_events_tests.jl")
        @time @safetestset "Differentiation Direction Tests" include("integrators/diffdir_tests.jl")
        @time @safetestset "Resize Tests" include("integrators/resize_tests.jl")
        @time @safetestset "Cache Tests" include("integrators/ode_cache_tests.jl")
        @time @safetestset "Add Steps Tests" include("integrators/ode_add_steps_tests.jl")
        @time @safetestset "IMEX Split Function Tests" include("integrators/split_ode_tests.jl")
    end

    if !is_APPVEYOR && (GROUP == "All" || GROUP == "Regression_I" || GROUP == "Regression")
        @time @safetestset "Dense Tests" include("regression/ode_dense_tests.jl")
        @time @safetestset "Special Interp Tests" include("regression/special_interps.jl")
        @time @safetestset "Inplace Tests" include("regression/ode_inplace_tests.jl")
        @time @safetestset "Adaptive Tests" include("regression/ode_adaptive_tests.jl")
        @time @safetestset "Hard DAE Tests" include("regression/hard_dae.jl")
    end

    if !is_APPVEYOR && (GROUP == "All" || GROUP == "Regression_II" || GROUP == "Regression")
        @time @safetestset "PSOS Energy Conservation Tests" include("regression/psos_and_energy_conservation.jl")
        @time @safetestset "Unrolled Tests" include("regression/ode_unrolled_comparison_tests.jl")
        @time @safetestset "IIP vs OOP Tests" include("regression/iipvsoop_tests.jl")
        @time @safetestset "Inference Tests" include("regression/inference.jl")
    end

    if !is_APPVEYOR && GROUP == "AlgConvergence_I"
        @time @safetestset "Non-autonomous Convergence Tests" include("algconvergence/non-autonomous_convergence_tests.jl")
    end

    if !is_APPVEYOR && GROUP == "AlgConvergence_III"
        @time @safetestset "Split Methods Tests" include("algconvergence/split_methods_tests.jl")
    end

    if !is_APPVEYOR && GROUP == "ModelingToolkit"
        activate_modelingtoolkit_env()
        @time @safetestset "NLStep Tests" include("modelingtoolkit/nlstep_tests.jl")
        @time @safetestset "Jacobian Tests" include("modelingtoolkit/jacobian_tests.jl")
        @time @safetestset "Preconditioner Tests" include("modelingtoolkit/preconditioners.jl")
        @time @safetestset "DAE Initialize Integration" include("modelingtoolkit/dae_initialize_integration.jl")
    end

    if !is_APPVEYOR && GROUP == "Downstream"
        activate_downstream_env()
        @time @safetestset "DelayDiffEq Tests" include("downstream/delaydiffeq.jl")
        @time @safetestset "Measurements Tests" include("downstream/measurements.jl")
        if VERSION >= v"1.11" && isempty(VERSION.prerelease)
            @time @safetestset "Mooncake Tests" include("downstream/mooncake.jl")
        end
        @time @safetestset "Sparse Diff Tests" include("downstream/sparsediff_tests.jl")
        @time @safetestset "Time derivative Tests" include("downstream/time_derivative_test.jl")
    end

    # Don't run Enzyme tests on prerelease
    if !is_APPVEYOR && GROUP == "Enzyme" && isempty(VERSION.prerelease)
        activate_enzyme_env()
        @time @safetestset "Autodiff Events Tests" include("enzyme/autodiff_events.jl")
        @time @safetestset "Discrete Adjoint Tests" include("enzyme/discrete_adjoints.jl")
    end

    # Don't run ODEInterface tests on prerelease
    if !is_APPVEYOR && GROUP == "ODEInterfaceRegression" && isempty(VERSION.prerelease)
        activate_odeinterface_env()
        @time @safetestset "Init dt vs dorpri tests" include("odeinterface/init_dt_vs_dopri_tests.jl")
        @time @safetestset "ODEInterface Regression Tests" include("odeinterface/odeinterface_regression.jl")
    end

    if !is_APPVEYOR && GROUP == "Multithreading"
        @time @safetestset "Extrapolation Tests" include("multithreading/ode_extrapolation_tests.jl")
    end

    if !is_APPVEYOR && GROUP == "GPU"
        activate_gpu_env()
        @time @safetestset "Simple GPU" begin
            import OrdinaryDiffEqCore
            include(joinpath(dirname(pathof(OrdinaryDiffEqCore.DiffEqBase)), "..",
                "test/gpu/simple_gpu.jl"))
        end
        @time @safetestset "Autoswitch GPU" include("gpu/autoswitch.jl")
        @time @safetestset "Linear LSRK GPU" include("gpu/linear_lsrk.jl")
        @time @safetestset "Linear Exponential GPU" include("gpu/linear_exp.jl")
        @time @safetestset "Reaction-Diffusion Stiff Solver GPU" include("gpu/reaction_diffusion_stiff.jl")
        @time @safetestset "Scalar indexing bug bypass" include("gpu/hermite_test.jl")
        @time @safetestset "RKIP Semilinear PDE GPU" include("gpu/rkip_semilinear_pde.jl")
        @time @safetestset "simple dae on GPU" include("gpu/simple_dae.jl")
    end

    if !is_APPVEYOR && GROUP == "QA"
        @time @safetestset "Quality Assurance Tests" include("qa/qa_tests.jl")
    end
end # @time

using Documenter, OrdinaryDiffEq

cp("./docs/Manifest.toml", "./docs/src/assets/Manifest.toml", force = true)
cp("./docs/Project.toml", "./docs/src/assets/Project.toml", force = true)

# Keep pages.jl separate for the DiffEqDocs.jl build
include("pages.jl")

makedocs(sitename = "OrdinaryDiffEq.jl",
    authors = "Chris Rackauckas et al.",
    clean = true,
    doctest = false,
    modules = [OrdinaryDiffEq,
        OrdinaryDiffEq.OrdinaryDiffEqAdamsBashforthMoulton,
        OrdinaryDiffEq.OrdinaryDiffEqBDF,
        OrdinaryDiffEq.OrdinaryDiffEqDefault,
        OrdinaryDiffEq.OrdinaryDiffEqExplicitRK,
        OrdinaryDiffEq.OrdinaryDiffEqExponentialRK,
        OrdinaryDiffEq.OrdinaryDiffEqExtrapolation,
        OrdinaryDiffEq.OrdinaryDiffEqFeagin,
        OrdinaryDiffEq.OrdinaryDiffEqFIRK,
        OrdinaryDiffEq.OrdinaryDiffEqHighOrderRK,
        OrdinaryDiffEq.OrdinaryDiffEqIMEXMultistep,
        OrdinaryDiffEq.OrdinaryDiffEqLinear,
        OrdinaryDiffEq.OrdinaryDiffEqLowOrderRK,
        OrdinaryDiffEq.OrdinaryDiffEqLowStorageRK,
        OrdinaryDiffEq.OrdinaryDiffEqNordsieck,
        OrdinaryDiffEq.OrdinaryDiffEqPDIRK,
        OrdinaryDiffEq.OrdinaryDiffEqPRK,
        OrdinaryDiffEq.OrdinaryDiffEqQPRK,
        OrdinaryDiffEq.OrdinaryDiffEqRKN,
        OrdinaryDiffEq.OrdinaryDiffEqRosenbrock,
        OrdinaryDiffEq.OrdinaryDiffEqSDIRK,
        OrdinaryDiffEq.OrdinaryDiffEqSSPRK,
        OrdinaryDiffEq.OrdinaryDiffEqStabilizedIRK,
        OrdinaryDiffEq.OrdinaryDiffEqStabilizedRK,
        OrdinaryDiffEq.OrdinaryDiffEqSymplecticRK,
        OrdinaryDiffEq.OrdinaryDiffEqTsit5,
        OrdinaryDiffEq.OrdinaryDiffEqVerner
    ],
    warnonly = [:docs_block, :missing_docs, :eval_block],
    format = Documenter.HTML(analytics = "UA-90474609-3",
        assets = ["assets/favicon.ico"],
        canonical = "https://ordinarydiffeq.sciml.ai/stable/",
        size_threshold_ignore = [joinpath("semiimplicit", "Rosenbrock.md"),
            joinpath("massmatrixdae", "Rosenbrock.md")]),
    pages = pages)

deploydocs(repo = "github.com/SciML/OrdinaryDiffEq.jl";
    push_preview = true)

using OrdinaryDiffEq, Test, Random, LinearAlgebra, LinearSolve, ADTypes
Random.seed!(123)

A = 0.01 * rand(3, 3)
rn = (du, u, p, t) -> begin
    mul!(du, A, u)
end
u0 = rand(3)
prob = ODEProblem(rn, u0, (0, 50.0))

function precsl(W, du, u, p, t, newW, Plprev, Prprev, solverdata)
    if newW === nothing || newW
        Pl = lu(convert(AbstractMatrix, W), check = false)
    else
        Pl = Plprev
    end
    Pl, nothing
end

function precsr(W, du, u, p, t, newW, Plprev, Prprev, solverdata)
    if newW === nothing || newW
        Pr = lu(convert(AbstractMatrix, W), check = false)
    else
        Pr = Prprev
    end
    nothing, Pr
end

function precslr(W, du, u, p, t, newW, Plprev, Prprev, solverdata)
    if newW === nothing || newW
        Pr = lu(convert(AbstractMatrix, W), check = false)
    else
        Pr = Prprev
    end
    Pr, Pr
end

sol = @test_nowarn solve(prob, TRBDF2(autodiff = AutoFiniteDiff()));
@test length(sol.t) < 20
sol = @test_nowarn solve(prob,
    TRBDF2(autodiff = AutoFiniteDiff(), linsolve = KrylovJL_GMRES()));
@test length(sol.t) < 20
solref = @test_nowarn solve(prob,
    TRBDF2(autodiff = AutoFiniteDiff(), linsolve = KrylovJL_GMRES(),
        smooth_est = false));
@test length(sol.t) < 20
sol = @test_nowarn solve(prob,
    TRBDF2(autodiff = AutoFiniteDiff(), linsolve = KrylovJL_GMRES(),
        precs = precsl, smooth_est = false, concrete_jac = true));
@test length(sol.t) < 20
sol = @test_nowarn solve(prob,
    TRBDF2(autodiff = AutoFiniteDiff(), linsolve = KrylovJL_GMRES(),
        precs = precsr, smooth_est = false, concrete_jac = true));
@test length(sol.t) < 20
sol = @test_nowarn solve(prob,
    TRBDF2(autodiff = AutoFiniteDiff(), linsolve = KrylovJL_GMRES(),
        precs = precslr, smooth_est = false, concrete_jac = true));
@test length(sol.t) < 20
sol = @test_nowarn solve(prob,
    QNDF(autodiff = AutoFiniteDiff(), linsolve = KrylovJL_GMRES(),
        concrete_jac = true));
@test length(sol.t) < 25
sol = @test_nowarn solve(prob,
    Rosenbrock23(autodiff = AutoFiniteDiff(),
        linsolve = KrylovJL_GMRES(),
        precs = precslr, concrete_jac = true));
@test length(sol.t) < 20
sol = @test_nowarn solve(prob,
    Rodas4(autodiff = AutoFiniteDiff(), linsolve = KrylovJL_GMRES(),
        precs = precslr, concrete_jac = true));
@test length(sol.t) < 20

sol = @test_nowarn solve(prob, TRBDF2(autodiff = AutoFiniteDiff()));
@test length(sol.t) < 20
sol = @test_nowarn solve(
    prob, TRBDF2(autodiff = AutoFiniteDiff(), linsolve = KrylovJL_GMRES()));
@test length(sol.t) < 20
sol = @test_nowarn solve(prob,
    TRBDF2(autodiff = AutoFiniteDiff(), linsolve = KrylovJL_GMRES(),
        smooth_est = false));
@test length(sol.t) < 20
sol = @test_nowarn solve(prob,
    TRBDF2(autodiff = AutoFiniteDiff(), linsolve = KrylovJL_GMRES(),
        precs = precsl, smooth_est = false, concrete_jac = true));
@test length(sol.t) < 20
sol = @test_nowarn solve(prob,
    TRBDF2(autodiff = AutoFiniteDiff(), linsolve = KrylovJL_GMRES(),
        precs = precsr, smooth_est = false, concrete_jac = true));
@test length(sol.t) < 20
sol = @test_nowarn solve(prob,
    TRBDF2(autodiff = AutoFiniteDiff(), linsolve = KrylovJL_GMRES(),
        precs = precslr, smooth_est = false, concrete_jac = true));
@test length(sol.t) < 20
sol = @test_nowarn solve(prob,
    QNDF(autodiff = AutoFiniteDiff(), linsolve = KrylovJL_GMRES(),
        concrete_jac = true));
@test length(sol.t) < 25
sol = @test_nowarn solve(prob,
    Rosenbrock23(autodiff = AutoFiniteDiff(), linsolve = KrylovJL_GMRES(),
        precs = precslr, concrete_jac = true));
@test length(sol.t) < 20
sol = @test_nowarn solve(prob,
    Rodas4(autodiff = AutoFiniteDiff(), linsolve = KrylovJL_GMRES(),
        precs = precslr, concrete_jac = true));
@test length(sol.t) < 20

using OrdinaryDiffEq, Test
import ODEProblemLibrary: prob_ode_linear,
                          linear, f_2dlinear

# scalar, not in-place
prob = prob_ode_linear
sol = solve(prob, DP5(); save_idxs = 1)
sol(0.5) # test interpolation

# vector, not in-place
prob2 = ODEProblem(linear, [0.5], (0.0, 1.0), 1.01)
sol2 = solve(prob2, DP5(); save_idxs = 1)
@test sol.t ≈ sol2.t && sol.u ≈ sol2.u
sol2(0.5)

sol2b = solve(prob2, DP5(); save_idxs = [1])
@test sol.t ≈ sol2b.t && sol.u ≈ [u[1] for u in sol2b.u]
sol2b(0.5)

# vector, in-place
prob3 = ODEProblem(f_2dlinear, [0.5], (0.0, 1.0), 1.01)
sol3 = solve(prob3, DP5(); save_idxs = 1)
@test sol.t ≈ sol3.t && sol.u ≈ sol3.u
sol3(0.5)

sol3b = solve(prob3, DP5(); save_idxs = [1])
@test sol.t ≈ sol3b.t && sol2b.u ≈ sol3b.u
sol3b(0.5)

using OrdinaryDiffEq, CUDA, Test
CUDA.allowscalar(false)

# https://github.com/SciML/OrdinaryDiffEq.jl/issues/1614
function f(du, u, p, t)
    @. du = u
end

problem = ODEProblem(f, CUDA.ones(1), (0.0, 1.0))
stiffalg = Rosenbrock23()
for alg in (AutoDP5, AutoTsit5, AutoVern6, AutoVern7, AutoVern8, AutoVern9)
    @test_nowarn solve(problem, alg(stiffalg), save_everystep = false, save_start = false)
end

using OrdinaryDiffEq, RecursiveArrayTools
prob = ODEProblem((u, p, t) -> -u, BigFloat(1.0), (0.0, 1.0))
solve(prob, Tsit5())
solve(prob, KenCarp4())

# Function initial condition
f(u, p, t) = u
u0(p, t0) = ones(2)
prob = ODEProblem(f, u0, (0.0, 1.0))
sol = solve(prob, Tsit5())

# Test array partition outside of symplectic

u02 = fill(0.0, 2)
v02 = ones(2)

function f_ap(du, u, p, t)
    du.x[1] .= -2u.x[2]
    du.x[2] .= u.x[1]
end

u = ArrayPartition((u02, v02))

prob = ODEProblem(f_ap, u, (0.0, 5.0))
sol = solve(prob, Euler(), dt = 1 / 100)

using DiffEqBase: set_t!, set_u!, set_ut!
using OrdinaryDiffEq

println("First")
# set_X!(integrator, integrator.X) should not change the result.
@testset "Trivial $setter ($alg, inplace=$iip)" for alg in [RK4, Trapezoid],
    setter in [set_t!, set_u!, set_ut!],
    iip in [false, true]

    if iip
        f = (du, u, p, t) -> (du .= 2u)
        prob = ODEProblem{iip}(f, [1 / 2], (0.0, 2.0))
    else
        f = (u, p, t) -> (2u)
        prob = ODEProblem{iip}(f, 1 / 2, (0.0, 2.0))
    end
    t_half = 1.0

    integrator1 = init(prob, alg(); save_everystep = false)
    integrator2 = init(prob, alg(); save_everystep = false)

    step!(integrator1, t_half)  # "inexact" stepping w/o tstops
    if setter === set_t!
        set_t!(integrator1, integrator1.t)
    elseif setter === set_u!
        set_u!(integrator1, integrator1.u)
    else
        set_ut!(integrator1, integrator1.u, integrator1.t)
    end
    solve!(integrator1)

    solve!(integrator2)

    @test integrator1.t == integrator2.t
    if alg === Trapezoid
        rtol = integrator1.opts.reltol * 100
        atol = integrator1.opts.abstol
        @test integrator1.u≈integrator2.u rtol=rtol atol=atol
    else
        @test integrator1.u == integrator2.u
    end
end

println("Second")

@testset "Resolve with $setter ($alg, inplace=$iip)" for alg in [RK4, Trapezoid],
    setter in [set_t!, set_ut!],
    iip in [false, true]

    if iip
        f = (du, u, p, t) -> (du .= 2u * cos(2π * t))
        prob1 = ODEProblem{iip}(f, [1 / 2], (0.0, 1.0))
    else
        f = (u, p, t) -> (2u * cos(2π * t))
        prob1 = ODEProblem{iip}(f, 1 / 2, (0.0, 1.0))
    end
    prob2 = remake(prob1; tspan = (0.0, 2.0))
    integrator1 = init(prob1, alg(); save_everystep = false)
    integrator2 = init(prob2, alg(); save_everystep = false)

    solve!(integrator1)
    if setter === set_t!
        set_t!(integrator1, 0)
    else
        set_ut!(integrator1, integrator1.u, 0)
    end
    solve!(integrator1)

    solve!(integrator2)

    rtol = integrator1.opts.reltol
    atol = integrator1.opts.abstol
    if alg === Trapezoid
        rtol *= 100
    end
    @test integrator1.u≈integrator2.u rtol=rtol atol=atol
end

@testset "set_proposed_dt!" begin
    # 1) Setup problem
    f = (du, u, p, t) -> (du[1] = p)
    u0 = [1.0]
    tspan = (0.0, 5.0)
    p = -1
    prob = ODEProblem(f, u0, tspan, p)

    # 2) Setup callback
    condition(u, t, integrator) = u[1] <= 0.0
    # function that sets dt that works with adaptive solvers:
    function affect!(integrator)
        integrator.p = 1
        set_proposed_dt!(integrator, 0.5)
    end
    cb = DiscreteCallback(condition, affect!; save_positions = (true, true))

    sol = solve(prob, RK4(), dt = 0.1, adaptive = false, callback = cb)
    @test diff(sol.t)[1] == 0.1
    @test diff(sol.t)[13] == 0.5

    sol = solve(prob, RK4(), dt = 0.1, adaptive = true, callback = cb)
    @test diff(sol.t)[1] == 0.1
    @test diff(sol.t)[4] == 0.5
end

using Test
using OrdinaryDiffEq, OrdinaryDiffEqCore, ForwardDiff, FiniteDiff, LinearAlgebra, ADTypes, DifferentiationInterface

function f(du, u, p, t)
    du[1] = -p[1]
    du[2] = p[2]
end

for x in 0:0.001:5
    called = false
    if x in [1.0, 2.0, 3.0, 4.0, 5.0]
        print("AD Ping $x")
    end
    function test_f(p)
        cb = ContinuousCallback((u, t, i) -> u[1],
            (integrator) -> (called = true; integrator.p[2] = zero(integrator.p[2])))
        prob = ODEProblem(f, eltype(p).([1.0, 0.0]), eltype(p).((0.0, 1.0)), copy(p))
        integrator = init(prob, Tsit5(), abstol = 1e-14, reltol = 1e-14, callback = cb)
        step!(integrator)
        solve!(integrator).u[end]
    end
    p = [2.0, x]
    called = false
    findiff = FiniteDiff.finite_difference_jacobian(test_f, p)
    @test called
    called = false
    fordiff = ForwardDiff.jacobian(test_f, p)
    @test called
    @test findiff ≈ fordiff rtol=1e-5
end

function f2(du, u, p, t)
    du[1] = -u[2]
    du[2] = p[2]
end

for x in 2.1:0.001:5
    called = false
    if x in [3.0, 4.0, 5.0]
        print("AD Ping $x")
    end
    function test_f2(p)
        cb = ContinuousCallback((u, t, i) -> u[1],
            (integrator) -> (called = true; integrator.p[2] = zero(integrator.p[2])))
        prob = ODEProblem(f2, eltype(p).([1.0, 0.0]), eltype(p).((0.0, 1.0)), copy(p))
        integrator = init(prob, Tsit5(), abstol = 1e-12, reltol = 1e-12, callback = cb)
        step!(integrator)
        solve!(integrator).u[end]
    end
    p = [2.0, x]
    findiff = FiniteDiff.finite_difference_jacobian(test_f2, p)
    @test called
    called = false
    fordiff = ForwardDiff.jacobian(test_f2, p)
    @test called
    @test findiff ≈ fordiff rtol=1e-5
end

#=
#x = 2.0 is an interesting case

x = 2.0

function test_f2(p)
  cb = ContinuousCallback((u,t,i) -> u[1], (integrator)->(@show(x,integrator.t);called=true;integrator.p[2]=zero(integrator.p[2])))
  prob = ODEProblem(f2,eltype(p).([1.0,0.0]),eltype(p).((0.0,1.0)),copy(p))
  integrator = init(prob,Tsit5(),abstol=1e-12,reltol=1e-12,callback=cb)
  step!(integrator)
  solve!(integrator).u[end]
end

p = [2.0, x]
findiff = FiniteDiff.finite_difference_jacobian(test_f2,p)
@test called
called = false
fordiff = ForwardDiff.jacobian(test_f2,p)
@test called

# At that value, it shouldn't be called, but a small perturbation will make it called, so finite difference is wrong!
=#

for x in 1.0:0.001:2.5
    if x in [1.5, 2.0, 2.5]
        print("AD Ping $x")
    end
    function lotka_volterra(du, u, p, t)
        x, y = u
        α, β, δ, γ = p
        du[1] = dx = α * x - β * x * y
        du[2] = dy = -δ * y + γ * x * y
    end
    u0 = [1.0, 1.0]
    tspan = (0.0, 10.0)
    p = [x, 1.0, 3.0, 1.0]
    prob = ODEProblem(lotka_volterra, u0, tspan, p)
    sol = solve(prob, Tsit5())

    called = false
    function test_lotka(p)
        cb = ContinuousCallback((u, t, i) -> u[1] - 2.5,
            (integrator) -> (called = true; integrator.p[4] = 1.5))
        prob = ODEProblem(lotka_volterra, eltype(p).([1.0, 1.0]), eltype(p).((0.0, 10.0)),
            copy(p))
        integrator = init(prob, Tsit5(), abstol = 1e-12, reltol = 1e-12, callback = cb)
        step!(integrator)
        solve!(integrator).u[end]
    end

    findiff = FiniteDiff.finite_difference_jacobian(test_lotka, p)
    @test called
    called = false
    fordiff = ForwardDiff.jacobian(test_lotka, p)
    @test called
    @test findiff ≈ fordiff rtol=1e-5
end

# Gradients and Hessians

function myobj(θ)
    f(u, p, t) = -θ[1] * u
    u0, _ = promote(10.0, θ[1])
    prob = ODEProblem(f, u0, (0.0, 1.0))
    sol = solve(prob, Tsit5())
    diff = sol.u - 10 * exp.(-sol.t)
    return diff'diff
end

ForwardDiff.gradient(myobj, [1.0])
ForwardDiff.hessian(myobj, [1.0])

function myobj2(θ)
    f(du, u, p, t) = (du[1] = -θ[1] * u[1])
    u0, _ = promote(10.0, θ[1])
    prob = ODEProblem(f, [u0], (0.0, 1.0))
    sol = solve(prob, Tsit5())
    diff = sol[:, 1] .- 10 .* exp.(-sol.t)
    return diff'diff
end

ForwardDiff.gradient(myobj2, [1.0])
ForwardDiff.hessian(myobj2, [1.0])

function myobj3(θ)
    f(u, p, t) = -θ[1] * u
    u0, _ = promote(10.0, θ[1])
    tspan_end, _ = promote(1.0, θ[1])
    prob = ODEProblem(f, u0, (0.0, tspan_end))
    sol = solve(prob, Tsit5())
    diff = sol.u - 10 * exp.(-sol.t)
    return diff'diff
end

ForwardDiff.gradient(myobj3, [1.0])
ForwardDiff.hessian(myobj3, [1.0])

function myobj4(θ)
    f(du, u, p, t) = (du[1] = -θ[1] * u[1])
    u0, _ = promote(10.0, θ[1])
    tspan_end, _ = promote(1.0, θ[1])
    prob = ODEProblem(f, [u0], (0.0, tspan_end))
    sol = solve(prob, Tsit5())
    diff = sol[:, 1] .- 10 .* exp.(-sol.t)
    return diff'diff
end

ForwardDiff.gradient(myobj4, [1.0])
ForwardDiff.hessian(myobj4, [1.0])

f1s = function (du, u, p, t)
    du[1] = p[2] * u[1]
    du[2] = p[3] * u[2]
    du[3] = p[4] * u[3]
    du[4] = p[5] * u[4]
    nothing
end
f2s = function (du, u, p, t)
    du[1] = p[1] * u[2]
    du[2] = p[1] * u[3]
    du[3] = p[1] * u[4]
    du[4] = p[1] * u[1]
    nothing
end
u0 = [3.4, 3.3, 3.2, 3.1]
params = [0.002, -0.005, -0.004, -0.003, -0.002]
tspan = (7.0, 84.0)
times = collect(minimum(tspan):0.5:maximum(tspan))
prob = SplitODEProblem(f1s, f2s, u0, tspan, params)
sol2 = solve(prob, KenCarp4(); dt = 0.5, saveat = times)

function difffunc(p)
    tmp_prob = remake(prob, p = p)
    vec(solve(tmp_prob, KenCarp4(), saveat = times))
end
ForwardDiff.jacobian(difffunc, ones(5))

# https://github.com/SciML/OrdinaryDiffEq.jl/issues/1221

f_a = function (du, u, p, t)
    du[1] = -p[1] * u[1] + exp(-t)
end

of_a = p -> begin
    u0 = [0.0]
    tspan = (0.0, 5.0)
    prob = ODEProblem(f_a, u0, tspan, p)
    # sol = solve(prob, Tsit5())                      # works
    # sol = solve(prob, Rodas5(autodiff=false))       # works
    sol = solve(prob, Rodas5(autodiff = AutoForwardDiff()), abstol = 1e-14, reltol = 1e-14)          # fails
    return sum(t -> abs2(t[1]), sol([1.0, 2.0, 3.0]))
end

@test !iszero(ForwardDiff.gradient(t -> of_a(t), [1.0]))
@test ForwardDiff.gradient(t -> of_a(t),
    [1.0])≈FiniteDiff.finite_difference_gradient(t -> of_a(t), [1.0]) rtol=1e-5

SOLVERS_FOR_AD = ((BS3, 1e-12),
    (Tsit5, 1e-12),
    (KenCarp4, 1e-11),
    (KenCarp47, 1e-11),
    (KenCarp5, 1e-11),
    (KenCarp58, 1e-12),
    (TRBDF2, 1e-07),
    (Rodas4, 1e-12),
    (Rodas5, 1e-12),
    (Rosenbrock23, 1e-10),
    (Rosenbrock32, 1e-11),
    (Vern6, 1e-11),
    (Vern7, 1e-11),
    (RadauIIA3, 1e-04),
    (RadauIIA5, 1e-12))

@testset "$alg can handle ForwardDiff.Dual in u0 with rtol=$rtol when iip=$iip" for (alg, rtol) in SOLVERS_FOR_AD,
    iip in (true,
        false)

    if iip
        f = (du, u, p, t) -> du .= -0.5 * u
    else
        f = (u, p, t) -> -0.5 * u
    end

    g = u0 -> begin
        tspan = (0.0, 1.0)
        prob = ODEProblem(f,
            u0,
            tspan)
        solve(prob, alg(), abstol = 1e-14, reltol = 1e-14)(last(tspan))[1]
    end
    @test ForwardDiff.gradient(g, [10.0])[1]≈exp(-0.5) rtol=rtol
end

@testset "$alg can handle ForwardDiff.Dual in t0 with rtol=$rtol when iip=$iip" for (alg, rtol) in SOLVERS_FOR_AD,
    iip in (true,
        false)

    if iip
        f = (du, u, p, t) -> du .= -0.5 * u
    else
        f = (u, p, t) -> -0.5 * u
    end

    _u0 = 10.0
    g = t0 -> begin
        tspan = (t0, 1.0)
        u0 = typeof(t0)[_u0]
        prob = ODEProblem(f,
            u0,
            tspan)
        solve(prob, alg(), abstol = 1e-14, reltol = 1e-14)(last(tspan))[1]
    end
    @test ForwardDiff.derivative(g, 0.0)≈_u0 / 2 * exp(-0.5) rtol=rtol
end

# https://github.com/SciML/DifferentialEquations.jl/issues/903

#ode function
function foo!(du, u, p, t)
    du .= p .* u
    nothing
end

#least squares objective function
function objfun(x, prob, data, solver, reltol, abstol)
    prob = remake(prob, p = x)
    sol = solve(prob, solver, reltol = reltol, abstol = abstol)
    ofv = 0.0
    if any((s.retcode != ReturnCode.Success for s in sol))
        ofv = 1e12
    else
        ofv = sum((sol .- data) .^ 2)
    end
    return ofv
end

p0 = [1.1, 1.2, 1.3, 1.4]
tspan = (0.0, 1.0)
u0 = 2 * ones(4)
saveat = 0.0:0.01:1.0
reltol = 1e-14
abstol = 1e-14
prob = ODEProblem{true}(foo!, u0, tspan, p0, saveat = saveat)
data = solve(prob, Tsit5(), reltol = reltol, abstol = abstol)
fn(x, solver) = objfun(x, prob, data, solver, reltol, abstol)

@test norm(ForwardDiff.gradient(x -> fn(x, Tsit5()), p0)) < 1e-9
@test norm(ForwardDiff.gradient(x -> fn(x, Vern7()), p0)) < 1e-9
@test norm(ForwardDiff.gradient(x -> fn(x, Rodas4()), p0)) < 1e-9
@test norm(ForwardDiff.gradient(x -> fn(x, Rosenbrock23()), p0)) < 1e-6
@test norm(ForwardDiff.gradient(x -> fn(x, AutoTsit5(Rosenbrock23())), p0)) < 1e-9
@test norm(ForwardDiff.gradient(x -> fn(x, AutoVern9(Rodas4())), p0)) < 1e-9

# test AD with LinearExponential()
function f(x)
    K = MatrixOperator(x)
    u0 = eltype(x).([1.0, 0.0])
    prob = ODEProblem(K, u0, (0.0, 10.0))
    sol = solve(prob, LinearExponential(), tstops = [0.0, 10.0])[2, :]
end
K_ = [-1.0 0.0; 1.0 -1.0]
@test isapprox(ForwardDiff.jacobian(f, K_)[2], 0.00226999, atol = 1e-6)

implicit_algs = [FBDF,
    Rosenbrock23,
    TRBDF2]

@testset "deprecated AD keyword arguments still work with $alg" for alg in implicit_algs
    f = (du, u, p, t) -> du .= -0.5 * u
    alg1 = alg(autodiff = AutoForwardDiff())
    alg2 = alg(autodiff = true)

    alg3 = alg(autodiff = AutoFiniteDiff())
    alg4 = alg(autodiff = false)

    alg5 = alg(autodiff = AutoForwardDiff(chunksize = 5))
    alg6 = alg(autodiff = true, chunk_size = 5)

    alg7 = alg(autodiff = AutoFiniteDiff(fdtype = Val(:central)))
    alg8 = alg(autodiff = false, diff_type = Val(:central))

    alg9 = alg(autodiff = AutoForwardDiff(chunksize = 1))
    alg10 = alg(chunk_size = 1)

    @test OrdinaryDiffEqCore.alg_autodiff(alg1) == OrdinaryDiffEqCore.alg_autodiff(alg2)
    @test OrdinaryDiffEqCore.alg_autodiff(alg3) == OrdinaryDiffEqCore.alg_autodiff(alg4)
    @test OrdinaryDiffEqCore.alg_autodiff(alg5) == OrdinaryDiffEqCore.alg_autodiff(alg6)
    @test OrdinaryDiffEqCore.alg_autodiff(alg7) == OrdinaryDiffEqCore.alg_autodiff(alg8)
    @test OrdinaryDiffEqCore.alg_autodiff(alg9) == OrdinaryDiffEqCore.alg_autodiff(alg10)
end

# https://github.com/SciML/OrdinaryDiffEq.jl/issues/2675
x0 = [0.1]
DifferentiationInterface.gradient(AutoForwardDiff(), x0) do x
    prob = ODEProblem{true}((du, u, p, t) -> (du[1] = -u[1]), x, (0.0, 1.0),)
    sol = solve(prob, DefaultODEAlgorithm(), reltol = 1e-6)
    sum(sol)
end ≈ [6.765310476296564]

using ComponentArrays, CUDA, Adapt, RecursiveArrayTools, FastBroadcast, FillArrays,
      OrdinaryDiffEq, Test
using OrdinaryDiffEqCore

a = ComponentArray((a = rand(Float32, 5, 5), b = rand(Float32, 5, 5)))
a = adapt(CuArray, a)
pa = ArrayPartition(a)
pb = deepcopy(pa)
pc = deepcopy(pa)
pd = deepcopy(pa)
pe = deepcopy(pa)
k = [pd, pe]
t = FillArrays.Trues(length(pa))

OrdinaryDiffEqCore.hermite_interpolant!(pa, 0.1, 0.2, pb, pc, k, nothing, Val{0}, t) # if this doesn't error we're good

@test pa.x[1] != pb.x[1]

using Test
using OrdinaryDiffEq, OrdinaryDiffEqCore, ForwardDiff, FiniteDiff, LinearAlgebra, ADTypes,
    StaticArrays
import DifferentiationInterface as DI

# Version-dependent AD backend selection via DifferentiationInterface
# Zygote: Julia <= 1.11 only
# Enzyme: Julia <= 1.11 only (see https://github.com/EnzymeAD/Enzyme.jl/issues/2699)
# Mooncake: all versions
# ForwardDiff: all versions

# Define which backends are available based on Julia version
const JULIA_VERSION_ALLOWS_ENZYME_ZYGOTE = VERSION < v"1.12" && isempty(VERSION.prerelease)
# Enzyme segfaults on Julia 1.10 (compiler bug), but throws catchable errors on 1.11+
# Use this for @test_broken tests that would segfault on 1.10
const JULIA_VERSION_ENZYME_NO_SEGFAULT = VERSION >= v"1.11" && VERSION < v"1.12" && isempty(VERSION.prerelease)

# Load version-dependent packages and define helpers
# Note: Mooncake gradient support for ODE solves is currently broken (see discrete_adjoints.jl)
# Note: Enzyme requires set_runtime_activity for functions with internal closures that capture
# external variables (throws EnzymeRuntimeActivityError otherwise)
if JULIA_VERSION_ALLOWS_ENZYME_ZYGOTE
    using Enzyme
    get_gradient_backends() = [AutoForwardDiff(), AutoEnzyme(mode = Enzyme.set_runtime_activity(Enzyme.Reverse))]
    get_jacobian_backends() = [AutoForwardDiff(), AutoEnzyme(mode = Enzyme.set_runtime_activity(Enzyme.Forward))]
else
    get_gradient_backends() = [AutoForwardDiff()]
    get_jacobian_backends() = [AutoForwardDiff()]
end

function f(du, u, p, t)
    du[1] = -p[1]
    return du[2] = p[2]
end

# Callback tests with mutable closures
# These tests capture and mutate a `called` variable in the callback affect function.
# Enzyme cannot differentiate mutable closures (throws EnzymeMutabilityException).
# ForwardDiff works because it doesn't trace through closure mutation.
for x in 0:0.001:5
    called = false
    if x in [1.0, 2.0, 3.0, 4.0, 5.0]
        print("AD Ping $x")
    end
    function test_f(p)
        cb = ContinuousCallback(
            (u, t, i) -> u[1],
            (integrator) -> (called = true; integrator.p[2] = zero(integrator.p[2]))
        )
        prob = ODEProblem(f, eltype(p).([1.0, 0.0]), eltype(p).((0.0, 1.0)), copy(p))
        integrator = init(prob, Tsit5(), abstol = 1.0e-14, reltol = 1.0e-14, callback = cb)
        step!(integrator)
        return solve!(integrator).u[end]
    end
    p = [2.0, x]
    called = false
    findiff = FiniteDiff.finite_difference_jacobian(test_f, p)
    @test called
    called = false
    dijac = DI.jacobian(test_f, AutoForwardDiff(), p)
    @test called
    @test findiff ≈ dijac rtol = 1.0e-5
end

# Enzyme broken test for mutable closure callbacks (representative case)
# Enzyme throws EnzymeMutabilityException on mutable closures
# Note: On Julia 1.10, Enzyme segfaults instead of throwing, so we skip entirely
if JULIA_VERSION_ENZYME_NO_SEGFAULT
    @testset "Enzyme mutable closure limitation" begin
        called = false
        function test_f_enzyme(p)
            cb = ContinuousCallback(
                (u, t, i) -> u[1],
                (integrator) -> (called = true; integrator.p[2] = zero(integrator.p[2]))
            )
            prob = ODEProblem(f, eltype(p).([1.0, 0.0]), eltype(p).((0.0, 1.0)), copy(p))
            integrator = init(prob, Tsit5(), abstol = 1.0e-14, reltol = 1.0e-14, callback = cb)
            step!(integrator)
            return solve!(integrator).u[end]
        end
        p = [2.0, 3.0]
        findiff = FiniteDiff.finite_difference_jacobian(test_f_enzyme, p)
        # EnzymeMutabilityException: Cannot differentiate mutable closures
        @test_broken (
            dijac = DI.jacobian(test_f_enzyme, AutoEnzyme(mode = Enzyme.set_runtime_activity(Enzyme.Forward)), p);
            isapprox(dijac, findiff, rtol = 1.0e-5)
        )
    end
end

function f2(du, u, p, t)
    du[1] = -u[2]
    return du[2] = p[2]
end

# Callback tests with mutable closures (f2 variant)
# Same limitation as above: Enzyme cannot differentiate mutable closures.
for x in 2.1:0.001:5
    called = false
    if x in [3.0, 4.0, 5.0]
        print("AD Ping $x")
    end
    function test_f2(p)
        cb = ContinuousCallback(
            (u, t, i) -> u[1],
            (integrator) -> (called = true; integrator.p[2] = zero(integrator.p[2]))
        )
        prob = ODEProblem(f2, eltype(p).([1.0, 0.0]), eltype(p).((0.0, 1.0)), copy(p))
        integrator = init(prob, Tsit5(), abstol = 1.0e-12, reltol = 1.0e-12, callback = cb)
        step!(integrator)
        return solve!(integrator).u[end]
    end
    p = [2.0, x]
    findiff = FiniteDiff.finite_difference_jacobian(test_f2, p)
    @test called
    called = false
    dijac = DI.jacobian(test_f2, AutoForwardDiff(), p)
    @test called
    @test findiff ≈ dijac rtol = 1.0e-5
end

#=
#x = 2.0 is an interesting case

x = 2.0

function test_f2(p)
  cb = ContinuousCallback((u,t,i) -> u[1], (integrator)->(@show(x,integrator.t);called=true;integrator.p[2]=zero(integrator.p[2])))
  prob = ODEProblem(f2,eltype(p).([1.0,0.0]),eltype(p).((0.0,1.0)),copy(p))
  integrator = init(prob,Tsit5(),abstol=1e-12,reltol=1e-12,callback=cb)
  step!(integrator)
  solve!(integrator).u[end]
end

p = [2.0, x]
findiff = FiniteDiff.finite_difference_jacobian(test_f2,p)
@test called
called = false
fordiff = ForwardDiff.jacobian(test_f2,p)
@test called

# At that value, it shouldn't be called, but a small perturbation will make it called, so finite difference is wrong!
=#

# Lotka-Volterra callback tests with mutable closures
# Same limitation as above: Enzyme cannot differentiate mutable closures.
for x in 1.0:0.001:2.5
    if x in [1.5, 2.0, 2.5]
        print("AD Ping $x")
    end
    function lotka_volterra(du, u, p, t)
        x, y = u
        α, β, δ, γ = p
        du[1] = dx = α * x - β * x * y
        return du[2] = dy = -δ * y + γ * x * y
    end
    u0 = [1.0, 1.0]
    tspan = (0.0, 10.0)
    p = [x, 1.0, 3.0, 1.0]
    prob = ODEProblem(lotka_volterra, u0, tspan, p)
    sol = solve(prob, Tsit5())

    called = false
    function test_lotka(p)
        cb = ContinuousCallback(
            (u, t, i) -> u[1] - 2.5,
            (integrator) -> (called = true; integrator.p[4] = 1.5)
        )
        prob = ODEProblem(
            lotka_volterra, eltype(p).([1.0, 1.0]), eltype(p).((0.0, 10.0)),
            copy(p)
        )
        integrator = init(prob, Tsit5(), abstol = 1.0e-12, reltol = 1.0e-12, callback = cb)
        step!(integrator)
        return solve!(integrator).u[end]
    end

    findiff = FiniteDiff.finite_difference_jacobian(test_lotka, p)
    @test called
    called = false
    dijac = DI.jacobian(test_lotka, AutoForwardDiff(), p)
    @test called
    @test findiff ≈ dijac rtol = 1.0e-5
end

# Gradients and Hessians
# Note: These functions create ODEProblem inside the differentiated function.
# Enzyme fails on SciML's type introspection code (isinplace, num_types_in_tuple).
# ForwardDiff works, so we use that and mark Enzyme as @test_broken.

function myobj(θ)
    f(u, p, t) = -θ[1] * u
    u0, _ = promote(10.0, θ[1])
    prob = ODEProblem(f, u0, (0.0, 1.0))
    sol = solve(prob, Tsit5())
    diff = sol.u - 10 * exp.(-sol.t)
    return diff'diff
end

function myobj2(θ)
    f(du, u, p, t) = (du[1] = -θ[1] * u[1])
    u0, _ = promote(10.0, θ[1])
    prob = ODEProblem(f, [u0], (0.0, 1.0))
    sol = solve(prob, Tsit5())
    diff = sol[:, 1] .- 10 .* exp.(-sol.t)
    return diff'diff
end

function myobj3(θ)
    f(u, p, t) = -θ[1] * u
    u0, _ = promote(10.0, θ[1])
    tspan_end, _ = promote(1.0, θ[1])
    prob = ODEProblem(f, u0, (0.0, tspan_end))
    sol = solve(prob, Tsit5())
    diff = sol.u - 10 * exp.(-sol.t)
    return diff'diff
end

function myobj4(θ)
    f(du, u, p, t) = (du[1] = -θ[1] * u[1])
    u0, _ = promote(10.0, θ[1])
    tspan_end, _ = promote(1.0, θ[1])
    prob = ODEProblem(f, [u0], (0.0, tspan_end))
    sol = solve(prob, Tsit5())
    diff = sol[:, 1] .- 10 .* exp.(-sol.t)
    return diff'diff
end

# ForwardDiff gradient tests (these work)
DI.gradient(myobj, AutoForwardDiff(), [1.0])
DI.gradient(myobj2, AutoForwardDiff(), [1.0])
DI.gradient(myobj3, AutoForwardDiff(), [1.0])
DI.gradient(myobj4, AutoForwardDiff(), [1.0])

# Hessian tests
DI.hessian(myobj, AutoForwardDiff(), [1.0])
DI.hessian(myobj2, AutoForwardDiff(), [1.0])
DI.hessian(myobj3, AutoForwardDiff(), [1.0])
DI.hessian(myobj4, AutoForwardDiff(), [1.0])

# Enzyme fails on these due to SciML type introspection (isinplace, num_types_in_tuple)
# Note: On Julia 1.10, Enzyme segfaults instead of throwing, so we skip entirely
if JULIA_VERSION_ENZYME_NO_SEGFAULT
    @testset "Enzyme ODEProblem construction limitation" begin
        # Enzyme has trouble differentiating through ODEProblem constructor
        # due to SciML's type introspection code
        @test_broken (DI.gradient(myobj, AutoEnzyme(mode = Enzyme.set_runtime_activity(Enzyme.Reverse)), [1.0]); true)
    end
end

f1s = function (du, u, p, t)
    du[1] = p[2] * u[1]
    du[2] = p[3] * u[2]
    du[3] = p[4] * u[3]
    du[4] = p[5] * u[4]
    return nothing
end
f2s = function (du, u, p, t)
    du[1] = p[1] * u[2]
    du[2] = p[1] * u[3]
    du[3] = p[1] * u[4]
    du[4] = p[1] * u[1]
    return nothing
end
u0 = [3.4, 3.3, 3.2, 3.1]
params = [0.002, -0.005, -0.004, -0.003, -0.002]
tspan = (7.0, 84.0)
times = collect(minimum(tspan):0.5:maximum(tspan))
prob = SplitODEProblem(f1s, f2s, u0, tspan, params)
sol2 = solve(prob, KenCarp4(); dt = 0.5, saveat = times)

# Enzyme fails on SplitODEProblem jacobians (mixed activity for jl_new_struct)
function difffunc(p)
    tmp_prob = remake(prob, p = p)
    return vec(solve(tmp_prob, KenCarp4(), saveat = times))
end
DI.jacobian(difffunc, AutoForwardDiff(), ones(5))

# https://github.com/SciML/OrdinaryDiffEq.jl/issues/1221

f_a = function (du, u, p, t)
    return du[1] = -p[1] * u[1] + exp(-t)
end

# Enzyme fails on this due to ODEProblem construction inside differentiated function
of_a = p -> begin
    u0 = [0.0]
    tspan = (0.0, 5.0)
    prob = ODEProblem(f_a, u0, tspan, p)
    # sol = solve(prob, Tsit5())                      # works
    # sol = solve(prob, Rodas5(autodiff=false))       # works
    sol = solve(prob, Rodas5(autodiff = AutoForwardDiff()), abstol = 1.0e-14, reltol = 1.0e-14)          # fails
    return sum(t -> abs2(t[1]), sol([1.0, 2.0, 3.0]))
end

@test !iszero(DI.gradient(of_a, AutoForwardDiff(), [1.0]))
@test DI.gradient(of_a, AutoForwardDiff(), [1.0]) ≈
    FiniteDiff.finite_difference_gradient(t -> of_a(t), [1.0]) rtol = 1.0e-5

SOLVERS_FOR_AD = (
    (BS3, 1.0e-12),
    (Tsit5, 1.0e-12),
    (KenCarp4, 1.0e-11),
    (KenCarp47, 1.0e-11),
    (KenCarp5, 1.0e-11),
    (KenCarp58, 1.0e-12),
    (TRBDF2, 1.0e-7),
    (Rodas4, 1.0e-12),
    (Rodas5, 1.0e-12),
    (Rosenbrock23, 1.0e-10),
    (Rosenbrock32, 1.0e-11),
    (Vern6, 1.0e-11),
    (Vern7, 1.0e-11),
    (RadauIIA3, 1.0e-4),
    (RadauIIA5, 1.0e-12),
)

@testset "$alg can handle ForwardDiff.Dual in u0 with rtol=$rtol when iip=$iip" for (alg, rtol) in SOLVERS_FOR_AD,
        iip in (
            true,
            false,
        )

    if iip
        f = (du, u, p, t) -> du .= -0.5 * u
    else
        f = (u, p, t) -> -0.5 * u
    end

    g = u0 -> begin
        tspan = (0.0, 1.0)
        prob = ODEProblem(
            f,
            u0,
            tspan
        )
        solve(prob, alg(), abstol = 1.0e-14, reltol = 1.0e-14)(last(tspan))[1]
    end
    @test DI.gradient(g, AutoForwardDiff(), [10.0])[1] ≈ exp(-0.5) rtol = rtol
end

@testset "$alg can handle ForwardDiff.Dual in t0 with rtol=$rtol when iip=$iip" for (alg, rtol) in SOLVERS_FOR_AD,
        iip in (
            true,
            false,
        )

    if iip
        f = (du, u, p, t) -> du .= -0.5 * u
    else
        f = (u, p, t) -> -0.5 * u
    end

    _u0 = 10.0
    g = t0 -> begin
        tspan = (t0, 1.0)
        u0 = typeof(t0)[_u0]
        prob = ODEProblem(
            f,
            u0,
            tspan
        )
        solve(prob, alg(), abstol = 1.0e-14, reltol = 1.0e-14)(last(tspan))[1]
    end
    @test DI.derivative(g, AutoForwardDiff(), 0.0) ≈ _u0 / 2 * exp(-0.5) rtol = rtol
end

# https://github.com/SciML/DifferentialEquations.jl/issues/903

#ode function
function foo!(du, u, p, t)
    du .= p .* u
    return nothing
end

#least squares objective function
function objfun(x, prob, data, solver, reltol, abstol)
    prob = remake(prob, p = x)
    sol = solve(prob, solver, reltol = reltol, abstol = abstol)
    ofv = 0.0
    if any((s.retcode != ReturnCode.Success for s in sol))
        ofv = 1.0e12
    else
        ofv = sum((sol .- data) .^ 2)
    end
    return ofv
end

p0 = [1.1, 1.2, 1.3, 1.4]
tspan = (0.0, 1.0)
u0 = 2 * ones(4)
saveat = 0.0:0.01:1.0
reltol = 1.0e-14
abstol = 1.0e-14
prob = ODEProblem{true}(foo!, u0, tspan, p0, saveat = saveat)
data = solve(prob, Tsit5(), reltol = reltol, abstol = abstol)
fn(x, solver) = objfun(x, prob, data, solver, reltol, abstol)

@test norm(DI.gradient(x -> fn(x, Tsit5()), AutoForwardDiff(), p0)) < 1.0e-9
@test norm(DI.gradient(x -> fn(x, Vern7()), AutoForwardDiff(), p0)) < 1.0e-9
@test norm(DI.gradient(x -> fn(x, Rodas4()), AutoForwardDiff(), p0)) < 1.0e-9
@test norm(DI.gradient(x -> fn(x, Rosenbrock23()), AutoForwardDiff(), p0)) < 1.0e-6
@test norm(DI.gradient(x -> fn(x, AutoTsit5(Rosenbrock23())), AutoForwardDiff(), p0)) < 1.0e-9
@test norm(DI.gradient(x -> fn(x, AutoVern9(Rodas4())), AutoForwardDiff(), p0)) < 1.0e-9

# test AD with LinearExponential()
function f_linexp(x)
    K = MatrixOperator(x)
    u0 = eltype(x).([1.0, 0.0])
    prob = ODEProblem(K, u0, (0.0, 10.0))
    return sol = solve(prob, LinearExponential(), tstops = [0.0, 10.0])[2, :]
end
K_ = [-1.0 0.0; 1.0 -1.0]
@test isapprox(DI.jacobian(f_linexp, AutoForwardDiff(), K_)[2], 0.00226999, atol = 1.0e-6)

implicit_algs = [
    FBDF,
    Rosenbrock23,
    TRBDF2,
]

@testset "deprecated AD keyword arguments still work with $alg" for alg in implicit_algs
    f = (du, u, p, t) -> du .= -0.5 * u
    alg1 = alg(autodiff = AutoForwardDiff())
    alg2 = @test_deprecated alg(autodiff = true)

    alg3 = alg(autodiff = AutoFiniteDiff())
    alg4 = @test_deprecated alg(autodiff = false)

    alg5 = alg(autodiff = AutoForwardDiff(chunksize = 5))
    alg6 = @test_deprecated alg(autodiff = true, chunk_size = 5)

    alg7 = alg(autodiff = AutoFiniteDiff(fdtype = Val(:central)))
    alg8 = @test_deprecated alg(autodiff = false, diff_type = Val(:central))

    alg9 = alg(autodiff = AutoForwardDiff(chunksize = 1))
    alg10 = @test_deprecated alg(chunk_size = 1)

    @test OrdinaryDiffEqCore.alg_autodiff(alg1) == OrdinaryDiffEqCore.alg_autodiff(alg2)
    @test OrdinaryDiffEqCore.alg_autodiff(alg3) == OrdinaryDiffEqCore.alg_autodiff(alg4)
    @test OrdinaryDiffEqCore.alg_autodiff(alg5) == OrdinaryDiffEqCore.alg_autodiff(alg6)
    @test OrdinaryDiffEqCore.alg_autodiff(alg7) == OrdinaryDiffEqCore.alg_autodiff(alg8)
    @test OrdinaryDiffEqCore.alg_autodiff(alg9) == OrdinaryDiffEqCore.alg_autodiff(alg10)
end

# https://github.com/SciML/OrdinaryDiffEq.jl/issues/2675
x0 = [0.1]
DI.gradient(AutoForwardDiff(), x0) do x
    prob = ODEProblem{true}((du, u, p, t) -> (du[1] = -u[1]), x, (0.0, 1.0))
    sol = solve(prob, DefaultODEAlgorithm(), reltol = 1.0e-6)
    sum(sum, sol.u)
end ≈ [6.765310476296564]

# Test with multiple AD backends
# Note: Enzyme reverse mode through ODE solve requires SciMLSensitivity for adjoint methods.
# ForwardDiff works without SciMLSensitivity, so we only test ForwardDiff here.
@testset "DifferentiationInterface multi-backend tests" begin
    # Simple ODE for testing
    function simple_ode!(du, u, p, t)
        du[1] = -p[1] * u[1]
        return nothing
    end

    function loss_fn(p)
        prob = ODEProblem(simple_ode!, [1.0], (0.0, 1.0), p)
        sol = solve(prob, Tsit5(), abstol = 1.0e-12, reltol = 1.0e-12)
        return sum(sol.u[end])
    end

    p_test = [0.5]
    ref_grad = FiniteDiff.finite_difference_gradient(loss_fn, p_test)

    # ForwardDiff works without SciMLSensitivity
    grad = DI.gradient(loss_fn, AutoForwardDiff(), p_test)
    @test grad ≈ ref_grad rtol = 1.0e-6
end

# Tests migrated from DiffEqBase downstream to cover complex numbers, StaticArrays,
# and ensemble AD scenarios (previously tested via SciMLSensitivity integration).

@testset "Complex number ODE AD" begin
    # Complex ODE: verify ForwardDiff gradient through complex-valued solve matches
    # the same problem reformulated in reals.
    pd = 3
    H0 = rand(ComplexF64, pd, pd)
    A = rand(ComplexF64, pd, pd)
    function f_complex!(du, u, p, t)
        a, b, c = p
        du .= (A * u) * (a * cos(b * t + c))
        du .+= H0 * u
        return nothing
    end
    u0_c = hcat(normalize(rand(ComplexF64, pd)), normalize(rand(pd)))
    prob_c = ODEProblem(
        f_complex!, u0_c, (0.0, 1.0), rand(3);
        saveat = range(0.0, 1.0, length = 3), reltol = 1.0e-6, alg = Tsit5()
    )
    cost_c(u) = abs2(tr(first(u)' * u[2])) - abs2(tr(first(u)' * last(u)))

    function loss_complex(p)
        prob = remake(prob_c; p)
        sol = solve(prob)
        return cost_c(sol.u) + sum(p) / 10
    end

    # Same problem via reals
    function real_f!(du, u, p, t)
        complex_u = complex.(selectdim(u, 3, 1), selectdim(u, 3, 2))
        complex_du = copy(complex_u)
        prob_c.f(complex_du, complex_u, p, t)
        selectdim(du, 3, 1) .= real(complex_du)
        selectdim(du, 3, 2) .= imag(complex_du)
        return nothing
    end
    prob_real = remake(
        prob_c; f = real_f!,
        u0 = cat(real(prob_c.u0), imag(prob_c.u0); dims = 3)
    )

    function loss_real(p)
        prob = remake(prob_real; p)
        sol = solve(prob)
        u = [complex.(selectdim(u, 3, 1), selectdim(u, 3, 2)) for u in sol.u]
        return cost_c(u) + sum(p) / 10
    end

    p0 = rand(3)
    grad_real = DI.gradient(loss_real, AutoForwardDiff(), p0)
    grad_complex = DI.gradient(loss_complex, AutoForwardDiff(), p0)
    @test all(isfinite, grad_complex)
    @test grad_complex ≈ grad_real rtol = 1.0e-4
end

@testset "StaticArrays AD through solve" begin
    f_sa(u, p, t) = copy(u)

    du1 = DI.derivative(AutoForwardDiff(), 5.0) do x
        prob = ODEProblem(f_sa, [x], (0.0, 1.0), nothing)
        sol = solve(prob, Tsit5())
        sol.u[end][1]
    end

    du2 = DI.derivative(AutoForwardDiff(), 5.0) do x
        prob = ODEProblem(f_sa, SVector(x), (0.0, 1.0), nothing)
        sol = solve(prob, Tsit5())
        sol.u[end][1]
    end

    @test du1 ≈ du2
end

@testset "Ensemble AD" begin
    function lv!(du, u, p, t)
        du[1] = p[1] * u[1] - p[2] * u[1] * u[2]
        return du[2] = -p[3] * u[2] + p[4] * u[1] * u[2]
    end

    p_lv = [1.5, 1.0, 3.0, 1.0]
    u0_lv = [1.0, 1.0]
    prob_lv = ODEProblem(lv!, u0_lv, (0.0, 10.0), p_lv)

    function sum_of_solution_ens(x)
        _prob = remake(prob_lv, u0 = x[1:2], p = x[3:end])
        return sum(solve(_prob, Tsit5(), saveat = 0.1))
    end

    gs = DI.gradient(sum_of_solution_ens, AutoForwardDiff(), [u0_lv; p_lv])
    ref = FiniteDiff.finite_difference_gradient(sum_of_solution_ens, [u0_lv; p_lv])
    # Finite differences lose accuracy over long integrations; ForwardDiff is exact.
    @test gs ≈ ref rtol = 0.1
end

# stats.nf tests
using OrdinaryDiffEq, Test, ADTypes
x = Ref(0)
function f(u, p, t)
    x[] += 1
    return 5 * u
end
function g(du, u, p, t)
    x[] += 1
    @. du = 5 * u
end

u0 = [1.0, 1.0]
tspan = (0.0, 1.0)
probop = ODEProblem(f, u0, tspan)
probip = ODEProblem(g, u0, tspan)

@testset "stats_tests" begin
    @testset "$prob" for prob in [probop, probip]
        @testset "$alg" for alg in [BS3, Tsit5, Vern7, Vern9, ROCK4]
            x[] = 0
            sol = solve(prob, alg())
            @test x[] == sol.stats.nf
        end
        @testset "$alg" for alg in [Rodas5P, KenCarp4]
            @testset "$kwargs" for kwargs in [(autodiff = AutoForwardDiff(),)]
                                              #(autodiff = AutoFiniteDiff(fdtype = Val{:forward}()),),
                                              #(autodiff = AutoFiniteDiff(fdtype = Val{:central}()),),
                                              #(autodiff = AutoFiniteDiff(fdtype = Val{:complex}()),)]
                x[] = 0
                sol = solve(prob, alg(; kwargs...))
                @test x[] == sol.stats.nf
            end
        end
    end
end

using OrdinaryDiffEq, Test

# Test that solution arrays release excess allocated memory after solve
# (https://github.com/SciML/DiffEqBase.jl/issues/1289)
@testset "Solution memory release after solve" begin
    function lorenz!(du, u, p, t)
        du[1] = 10.0 * (u[2] - u[1])
        du[2] = u[1] * (28.0 - u[3]) - u[2]
        du[3] = u[1] * u[2] - (8 / 3) * u[3]
    end

    u0 = [1.0, 0.0, 0.0]
    tspan = (0.0, 100.0)
    prob = ODEProblem(lorenz!, u0, tspan)
    sol = solve(prob, Tsit5())

    n = length(sol.t)
    # After solve, allocated memory should be close to actual data size.
    # sizehint! in postamble! releases excess capacity from array growth during integration.
    t_data_size = n * sizeof(eltype(sol.t)) + sizeof(sol.t)
    @test Base.summarysize(sol.t) < 1.5 * t_data_size
end

# RKIP semilinear PDE tests on GPU with CUDA
import LinearAlgebra
using CUDA
using FFTW
using Test

using OrdinaryDiffEqRKIP: RKIP
using SciMLBase: SplitODEProblem, SplitFunction, solve
using SciMLOperators: AbstractSciMLOperator

struct DiagonalFourierOperator{T, uType <: AbstractVector{T}, fftType, ifftType} <:
       AbstractSciMLOperator{T}
    diag::uType
    plan_fft!::fftType
    plan_ifft!::ifftType
    tmp::uType
end

function DiagonalFourierOperator(diag, plan_fft!_prototype, plan_ifft!_prototype)
    tmp = similar(diag)
    return DiagonalFourierOperator(
        diag, plan_fft!_prototype(tmp), plan_ifft!_prototype(tmp), tmp)
end

function DiagonalFourierOperator(diag::Vector{T}) where {T <: Complex}
    DiagonalFourierOperator(diag, FFTW.plan_fft!, FFTW.plan_ifft!)
end
function DiagonalFourierOperator(diag::CuArray{T, 1}) where {T <: Complex}
    DiagonalFourierOperator(diag, CUDA.CUFFT.plan_fft!, CUDA.CUFFT.plan_ifft!)
end

function LinearAlgebra.exp(D::DiagonalFourierOperator, t)
    exp_kernel = similar(D.diag)
    D.tmp .= D.diag
    D.tmp .*= t
    exp_kernel .= exp.(D.tmp)
    DiagonalFourierOperator(exp_kernel, D.plan_fft!, D.plan_ifft!, D.tmp)
end

@inline @fastmath function apply_kernel!(du, u, tmp, kernel, op_fft!, op_ifft!)
    copyto!(tmp, u)
    op_fft! * tmp
    tmp .*= kernel
    op_ifft! * tmp
    copyto!(du, tmp)
end

function (D::DiagonalFourierOperator)(du, u, _, _, _)
    apply_kernel!(du, u, D.tmp, D.diag, D.plan_fft!, D.plan_ifft!)
end

gpu_init(u0::CuArray, ::Vector{T}) where {T <: Real} = u0
gpu_init(u0::Vector, ::Vector{T}) where {T <: Real} = CuArray{Complex{T}, 1}(u0)
gpu_init(u0::Function, τ::Vector{T}) where {T <: Real} = CuArray{Complex{T}, 1}(u0.(τ))

function create_semilinear_problem(
        nb_pts::Int,
        dτ::T,
        integration_limit::T,
        u0,
        semilinear_fourier_part::Function,
        nonlinear_part!::Function
) where {T <: Real}
    domain_size = dτ * nb_pts
    τ = Vector{T}(range(-domain_size / 2.0, domain_size / 2.0, nb_pts))

    u0_good_type = gpu_init(u0, τ)

    ω = 2π .* Vector{T}(FFTW.fftfreq(nb_pts, nb_pts / domain_size))
    diag = typeof(u0_good_type)(semilinear_fourier_part.(ω))

    D̂ = DiagonalFourierOperator(diag)
    N̂ = (du, u, _, t) -> nonlinear_part!(du, u, t)

    splfc = SplitFunction{true}(D̂, N̂)
    return SplitODEProblem(splfc, u0_good_type, (0.0, integration_limit))
end

@inline @fastmath function nlse_non_linpart(res, u)
    res .= u
    res .= abs2.(res)
    res .*= u
    res .*= 1im
end

@inline @fastmath function lle_non_linpart!(res, u, Δ, S)
    nlse_non_linpart(res, u)
    LinearAlgebra.axpby!(-1im * Δ, u, 1, res)
    res .+= S
end

function create_nlse(
        nb_pts::Int, dτ::T, integration_limit::T, u0) where {T <: Real}
    create_semilinear_problem(nb_pts, dτ, integration_limit, u0, ω -> -0.5im * ω^2,
        (du, u, t) -> nlse_non_linpart(du, u))
end

function create_lle_scan(nb_pts::Int, dτ::T, scan_time::T, u0,
        Δ_min::T, Δ_max::T, S::T) where {T <: Real}
    create_semilinear_problem(nb_pts, dτ, scan_time, u0, ω -> -1 - 1im * ω^2,
        (du, u, t) -> lle_non_linpart!(du, u, Δ_min + (Δ_max - Δ_min) * t / scan_time, S))
end

function nlse_test(
        ::Type{T}; B = 5.0, nb_pts = 512, dτ = 5e-3, propag_dist = 10.0,
        save_everystep = false, reltol = 1e-6) where {T <: Real}
    B = T(B)

    problem = create_nlse(
        nb_pts,
        T(dτ),
        T(propag_dist),
        τ -> B * sech(B * τ)
    )
    return solve(problem, RKIP(T(1e-4), T(1.0)); save_everystep, reltol = T(reltol))
end

function lle_scan_test(
        ::Type{T}; nb_pts = 1024, dτ = 5e-2, save_everystep = false,
        reltol = 1e-6, S = 3, Δ_min = -2.0, Δ_max = 12.0, t_max = 10) where {T <: Real}
    problem = create_lle_scan(
        nb_pts,
        T(dτ),
        T(t_max),
        1e-1 * exp.(2im * π * rand(T, nb_pts)),
        T(Δ_min),
        T(Δ_max),
        T(S)
    )
    return solve(problem, RKIP(T(1e-4), T(1.0)); save_everystep, reltol = T(reltol))
end

CUDA.allowscalar(false) # ensure no scalar indexing is used (for performance)

@testset "Lugiato-Lefever equation test on GPU with CUDA - Float64" begin
    @test !isnothing(lle_scan_test(Float64))
end

@testset "Lugiato-Lefever equation test on GPU with CUDA - Float32" begin
    @test !isnothing(lle_scan_test(Float32))
end

@testset "NLSE test on GPU with CUDA - Float64" begin
    sol = nlse_test(Float64)

    # NLSE Soliton solution, only the phase change
    p1 = abs2.(sol.u[1])
    p2 = abs2.(sol.u[end])

    @test LinearAlgebra.norm(p1 .- p2) / LinearAlgebra.norm(p1) < 1.5e-2
end

@testset "NLSE test on GPU with CUDA - Float32" begin
    sol = nlse_test(Float32)

    # NLSE Soliton solution, only the phase change
    p1 = abs2.(sol.u[1])
    p2 = abs2.(sol.u[end])

    @test LinearAlgebra.norm(p1 .- p2) / LinearAlgebra.norm(p1) < 1.5e-2
end

using OrdinaryDiffEq, DiffEqDevTools, Test,
      ODEInterface, ODEInterfaceDiffEq

import ODEProblemLibrary: prob_ode_2Dlinear, prob_ode_linear

prob = prob_ode_linear
sol = solve(prob, DP5())

sol2 = solve(prob, dopri5())
@test sol.t[2] ≈ sol2.t[2]

prob = prob_ode_2Dlinear
sol = solve(prob, DP5(), internalnorm = (u, t) -> sqrt(sum(abs2, u)))

# Change the norm due to error in dopri5.f
sol2 = solve(prob, dopri5())
@test sol.t[2] ≈ sol2.t[2]

prob = deepcopy(prob_ode_linear)
prob2 = ODEProblem(prob.f, prob.u0, (1.0, 0.0), 1.01)
sol = solve(prob2, DP5())

sol2 = solve(prob2, dopri5())
@test sol.t[2] ≈ sol2.t[2]

prob = deepcopy(prob_ode_2Dlinear)
prob2 = ODEProblem(prob.f, prob.u0, (1.0, 0.0), 1.01)
sol = solve(prob2, DP5(), internalnorm = (u, t) -> sqrt(sum(abs2, u)))

# Change the norm due to error in dopri5.f
sol2 = solve(prob2, dopri5())
@test sol.t[2] ≈ sol2.t[2]

using OrdinaryDiffEq
using LinearAlgebra
using NLsolve
using Test

p_inv = [500.0
         0.084
         4.69
         2.0
         400.0
         20.0
         0.2
         1000.0
         0.59
         736.0
         0.0
         0.0
         0.2
         1.27
         14.3
         0.0
         50.0
         0.2
         0.08
         0.003
         0.074
         0.2
         0.01 # Matt
         1.0  # V_ref
         1.0  # ω ref
         0.7  # Pref
         0    # Q_ref
         0.5  #Xtrans
         0.0  # Rtrans
         1.01 #Vm
         0.0] # Vθ

function vsm(dx, x, p, t)
    #PARAMETERS
    ω_lp = p[1]
    kp_pll = p[2]
    ki_pll = p[3]
    Ta = p[4]
    kd = p[5]
    kω = p[6]
    kq = p[7]
    ωf = p[8]
    kpv = p[9]
    kiv = p[10]
    kffv = p[11]
    rv = p[12]
    lv = p[13]
    kpc = p[14]
    kic = p[15]
    kffi = p[16]
    ωad = p[17]
    kad = p[18]
    lf = p[19]
    rf = p[20]
    cf = p[21]
    lg = p[22]
    rg = p[23]
    Vref = p[24]
    ωref = p[25]
    Pref = p[26]
    Qref = p[27]
    Xtrans = p[28]
    Rtrans = p[29]
    Vm = p[30]
    Vθ = p[31]

    #STATE INDEX AND STATES
    i__vi_filter, vi_filter = 1, x[1]
    i__γd_ic, γd_ic = 2, x[2]
    i__vq_pll, vq_pll = 3, x[3]
    i__γq_ic, γq_ic = 4, x[4]
    i__ir_filter, ir_filter = 5, x[5]
    i__ξd_ic, ξd_ic = 6, x[6]
    i__ϕd_ic, ϕd_ic = 7, x[7]
    i__ε_pll, ε_pll = 8, x[8]
    i__ir_cnv, ir_cnv = 9, x[9]
    i__vr_filter, vr_filter = 10, x[10]
    i__ω_oc, ω_oc = 11, x[11]
    i__ξq_ic, ξq_ic = 12, x[12]
    i__vd_pll, vd_pll = 13, x[13]
    i__q_oc, q_oc = 14, x[14]
    i__ϕq_ic, ϕq_ic = 15, x[15]
    i__θ_pll, θ_pll = 16, x[16]
    i__θ_oc, θ_oc = 17, x[17]
    i__ii_cnv, ii_cnv = 18, x[18]
    i__ii_filter, ii_filter = 19, x[19]
    i__ir_source, ir_source = 20, x[20]
    i__ii_source, ii_source = 21, x[21]

    ω_base = 60.0 * 2 * pi
    ω_sys = 1.0

    #PLL
    δω_pll = kp_pll * atan(vq_pll / vd_pll) + ki_pll * ε_pll
    ω_pll = δω_pll + ω_sys
    vd_filt_pll = sin(θ_pll + pi / 2) * vr_filter - cos(θ_pll + pi / 2) * vi_filter
    vq_filt_pll = cos(θ_pll + pi / 2) * vr_filter + sin(θ_pll + pi / 2) * vi_filter

    dx[i__vd_pll] = ω_lp * (vd_filt_pll - vd_pll)                                 #docs:(1a)
    dx[i__vq_pll] = ω_lp * (vq_filt_pll - vq_pll)                                 #docs:(1b)
    dx[i__ε_pll] = atan(vq_pll / vd_pll)                                         #docs:(1c)
    dx[i__θ_pll] = ω_base * δω_pll                                             #docs:(1d)

    #OUTER LOOP CONTROL
    pe = vr_filter * ir_filter + vi_filter * ii_filter                              #docs:(2d)
    qe = vi_filter * ir_filter - vr_filter * ii_filter                              #docs:(2e)
    v_ref_olc = Vref + kq * (Qref - q_oc)

    dx[i__ω_oc] = (Pref - pe - kd * (ω_oc - ω_pll) - kω * (ω_oc - ωref)) / Ta        #docs:(2a)
    dx[i__θ_oc] = ω_base * (ω_oc - ω_sys)                                            #docs:(2b)
    dx[i__q_oc] = ωf * (qe - q_oc)                                               #docs:(2c)

    #INNER LOOP CONTROL
    #reference transformations
    vd_filt_olc = sin(θ_oc + pi / 2) * vr_filter - cos(θ_oc + pi / 2) * vi_filter
    vq_filt_olc = cos(θ_oc + pi / 2) * vr_filter + sin(θ_oc + pi / 2) * vi_filter
    id_filt_olc = sin(θ_oc + pi / 2) * ir_filter - cos(θ_oc + pi / 2) * ii_filter
    iq_filt_olc = cos(θ_oc + pi / 2) * ir_filter + sin(θ_oc + pi / 2) * ii_filter
    id_cnv_olc = sin(θ_oc + pi / 2) * ir_cnv - cos(θ_oc + pi / 2) * ii_cnv
    iq_cnv_olc = cos(θ_oc + pi / 2) * ir_cnv + sin(θ_oc + pi / 2) * ii_cnv

    #Voltage control equations
    Vd_filter_ref = v_ref_olc - rv * id_filt_olc + ω_oc * lv * iq_filt_olc      #docs:(3g)
    Vq_filter_ref = -rv * iq_filt_olc - ω_oc * lv * id_filt_olc                 #docs:(3h)
    dx[i__ξd_ic] = Vd_filter_ref - vd_filt_olc                                 #docs:(3a)
    dx[i__ξq_ic] = Vq_filter_ref - vq_filt_olc                                 #docs:(3b)

    #current control equations
    Id_cnv_ref = (kpv * (Vd_filter_ref - vd_filt_olc) + kiv * ξd_ic -                           #docs:(3i)
                  cf * ω_oc * vq_filt_olc + kffi * id_filt_olc)
    Iq_cnv_ref = (kpv * (Vq_filter_ref - vq_filt_olc) +
                  kiv * ξq_ic +                           #docs:(3j)
                  cf * ω_oc * vd_filt_olc +
                  kffi * iq_filt_olc)
    dx[i__γd_ic] = Id_cnv_ref - id_cnv_olc                                      #docs:(3c)
    dx[i__γq_ic] = Iq_cnv_ref - iq_cnv_olc                                      #docs:(3d)

    #active damping equations
    Vd_cnv_ref = (kpc * (Id_cnv_ref - id_cnv_olc) + kic * γd_ic - lf * ω_oc * iq_cnv_olc +          #docs:(3k)
                  kffv * vd_filt_olc - kad * (vd_filt_olc - ϕd_ic))
    Vq_cnv_ref = (kpc * (Iq_cnv_ref - iq_cnv_olc) +
                  kic * γq_ic +
                  lf * ω_oc * id_cnv_olc +          #docs:(3l)
                  kffv * vq_filt_olc - kad * (vq_filt_olc - ϕq_ic))
    dx[i__ϕd_ic] = ωad * (vd_filt_olc - ϕd_ic)                                 #docs:(3e)
    dx[i__ϕq_ic] = ωad * (vq_filt_olc - ϕq_ic)                                  #docs:(3f)

    #LCL FILTER
    #reference transformations
    Vr_cnv = sin(θ_oc + pi / 2) * Vd_cnv_ref + cos(θ_oc + pi / 2) * Vq_cnv_ref
    Vi_cnv = -cos(θ_oc + pi / 2) * Vd_cnv_ref + sin(θ_oc + pi / 2) * Vq_cnv_ref

    Vr_pcc = Vm * cos(Vθ)
    Vi_pcc = Vm * sin(Vθ)

    dx[i__ir_cnv] = (ω_base / lf) *                                                #docs:(5a)
                    (Vr_cnv - vr_filter - rf * ir_cnv + ω_sys * lf * ii_cnv)
    dx[i__ii_cnv] = (ω_base / lf) *                                                #docs:(5b)
                    (Vi_cnv - vi_filter - rf * ii_cnv - ω_sys * lf * ir_cnv)
    dx[i__vr_filter] = (ω_base / cf) *                                             #docs:(5c)
                       (ir_cnv - ir_filter + ω_sys * cf * vi_filter)
    dx[i__vi_filter] = (ω_base / cf) *                                             #docs:(5d)
                       (ii_cnv - ii_filter - ω_sys * cf * vr_filter)
    dx[i__ir_filter] = (ω_base / lg) *                                             #docs:(5e)
                       (vr_filter - Vr_pcc - rg * ir_filter + ω_sys * lg * ii_filter)
    dx[i__ii_filter] = +(ω_base / lg) *                                            #docs:(5f)
                       (vi_filter - Vi_pcc - rg * ii_filter - ω_sys * lg * ir_filter)

    # Network interface algebraic equations 0 = I - YV
    line_currents = ((Vr_cnv + Vi_cnv * 1im) - (Vr_pcc + Vi_pcc * 1im)) /
                    (Rtrans + Xtrans * 1im)
    dx[i__ii_source] = ii_source - imag(line_currents)
    dx[i__ir_source] = ir_source - real(line_currents)
    return
end

u0 = [0.0,
    0.01,
    0.01,
    0.01,
    0.01,
    0.01,
    0.01,
    0.01,
    1.0,
    1.0,
    0.0,
    0.01,
    0.01,
    0.01,
    0.01,
    0.01,
    0.01,
    0.01,
    0.0,
    1.0,
    0.0
]
init_f! = (dx, x) -> vsm(dx, x, p_inv, 0)
res = nlsolve(init_f!, u0)

M = diagm(ones(21))
#Last 2 equations are algebraic
M[20, 20] = M[21, 21] = 0.0

f = ODEFunction(vsm, mass_matrix = M)

condition(u, t, integrator) = t == 1.0
affect!(integrator) = integrator.p[28] += 0.2
cb = DiscreteCallback(condition, affect!)

prob = ODEProblem(f, deepcopy(res.zero), (0, 20.0), deepcopy(p_inv))
refsol = solve(prob, Rodas4(), saveat = 0.1, callback = cb, tstops = [1.0], reltol = 1e-12,
    abstol = 1e-17)

for solver in (Rodas4, Rodas4P, Rodas5, Rodas5P, FBDF, QNDF)
    @show solver
    prob = ODEProblem(f, deepcopy(res.zero), (0, 20.0), deepcopy(p_inv))
    sol = solve(
        prob, solver(), saveat = 0.1, callback = cb, tstops = [1.0], reltol = 1e-14,
        abstol = 1e-14)
    @test sol.retcode == ReturnCode.Success
    @test sol.t[end] == 20.0
    @test maximum(sol - refsol) < 1e-11
end

function hardstop!(du, u, p, t)
    pm, pg = p
    y, f_wall, dy = u
    du[1] = dy
    du[2] = ifelse(y <= 0, y, f_wall)
    du[3] = (-ifelse(t < 2, -pg * pm, pg * pm) - f_wall) / (-pm)
end

hardstop!(u, p, t) = (du = similar(u); hardstop!(du, u, p, t); du)

fun = ODEFunction(hardstop!, mass_matrix = Diagonal([1, 0, 1]))
prob1 = ODEProblem(fun, [5, 0, 0.0], (0, 4.0), [100, 10.0])
prob2 = ODEProblem(fun, [5, 0, 0.0], (0, 4.0), [100, 10.0])
for prob in [prob1, prob2]
    @test solve(prob, ImplicitEuler(), dt = 1 / 2^10, adaptive = false).retcode ==
          ReturnCode.ConvergenceFailure
end

condition2 = (u, t, integrator) -> t == 2
affect2! = integrator -> integrator.u[1] = 1e-6
cb = DiscreteCallback(condition2, affect2!)

@isdefined(N_FAILS) || const N_FAILS = Ref(0)
function choice_function(integrator)
    integrator.do_error_check = false
    if integrator.force_stepfail
        N_FAILS[] += 1
    else
        N_FAILS[] = 0
    end

    (N_FAILS[] > 3) + 1
end
simple_implicit_euler = ImplicitEuler(nlsolve = NLNewton(check_div = false,
    always_new = true))
alg_switch = CompositeAlgorithm((ImplicitEuler(), simple_implicit_euler), choice_function)

for prob in [prob1, prob2], alg in [simple_implicit_euler, alg_switch]
    sol = solve(prob, alg, callback = cb, dt = 1 / 2^10, adaptive = false)
    @test sol.retcode == ReturnCode.Success
    @test sol(0, idxs = 1) == 5
    @test abs(sol(2-2^-10, idxs = 1)) <= 1e-4
    @test sol(4, idxs = 1) > 10
end

# Skip Enzyme tests on Julia 1.12+ prerelease versions
if !isempty(VERSION.prerelease)
    @warn "Skipping Enzyme tests on Julia prerelease version $(VERSION)"
    exit(0)
end

using SciMLSensitivity
using OrdinaryDiffEq, OrdinaryDiffEqCore, FiniteDiff, Test
using Zygote

function f(du, u, p, t)
    du[1] = u[2]
    du[2] = -p[1]
end

function condition(u, t, integrator) # Event when event_f(u,t) == 0
    u[1]
end

function affect!(integrator)
    @show integrator.t
    println("bounced.")
    integrator.u[2] = -integrator.p[2] * integrator.u[2]
end

cb = ContinuousCallback(condition, affect!)
p = [9.8, 0.8]
prob = ODEProblem(f, eltype(p).([1.0, 0.0]), eltype(p).((0.0, 1.0)), copy(p))

function test_f(p)
    _prob = remake(prob, p = p)
    solve(_prob, Tsit5(), abstol = 1e-14, reltol = 1e-14, callback = cb,
    save_everystep = false).u[end]
end
findiff = FiniteDiff.finite_difference_jacobian(test_f, p)
findiff

using ForwardDiff
ad = ForwardDiff.jacobian(test_f, p)
ad

@test ad ≈ findiff

function test_f2(p, sensealg = ForwardDiffSensitivity(), controller = nothing,
        alg = Tsit5())
    _prob = remake(prob, p = p)
    u = solve(_prob, alg, sensealg = sensealg, controller = controller,
        abstol = 1e-14, reltol = 1e-14, callback = cb, save_everystep = false)
    u[end][end]
end

@test test_f2(p) == test_f(p)[end]

g1 = Zygote.gradient(θ -> test_f2(θ, ForwardDiffSensitivity()), p)
g2 = Zygote.gradient(θ -> test_f2(θ, ReverseDiffAdjoint()), p)
g3 = Zygote.gradient(θ -> test_f2(θ, ReverseDiffAdjoint(), IController()), p)
g4 = Zygote.gradient(θ -> test_f2(θ, ReverseDiffAdjoint(), PIController(7 // 50, 2 // 25)),
    p)
@test_broken g5 = Zygote.gradient(
    θ -> test_f2(θ, ReverseDiffAdjoint(),
        PIDController(1 / 18.0, 1 / 9.0, 1 / 18.0)),
    p)
g6 = Zygote.gradient(
    θ -> test_f2(θ, ForwardDiffSensitivity(),
        OrdinaryDiffEqCore.PredictiveController(), TRBDF2()),
    p)
@test_broken g7 = Zygote.gradient(
    θ -> test_f2(θ, ReverseDiffAdjoint(),
        OrdinaryDiffEqCore.PredictiveController(),
        TRBDF2()),
    p)

@test g1[1] ≈ findiff[2, 1:2]
@test g2[1] ≈ findiff[2, 1:2]
@test g3[1] ≈ findiff[2, 1:2]
@test g4[1] ≈ findiff[2, 1:2]
@test_broken g5[1] ≈ findiff[2, 1:2]
@test g6[1] ≈ findiff[2, 1:2]
@test_broken g7[1] ≈ findiff[2, 1:2]

# Tests for solving ODEProblems with null u0 and callbacks
# https://github.com/SciML/ModelingToolkit.jl/issues/4078

using OrdinaryDiffEq, DiffEqCallbacks, Test

@testset "Null u0 with callbacks" begin
    @testset "Explicit solvers" begin
        for (name, alg, kwargs) in [
                ("FunctionMap", FunctionMap(), (dt = 0.1,)),
                ("Euler", Euler(), (dt = 0.1,)),
                ("RK4", RK4(), (dt = 0.1,)),
                ("Tsit5", Tsit5(), ()),
            ]
            @testset "$name" begin
                counter = Ref(0)
                cb = PresetTimeCallback([0.5], integrator -> (counter[] += 1))
                prob = ODEProblem(Returns(nothing), nothing, (0.0, 1.0))

                sol = solve(prob, alg; callback = cb, kwargs...)

                @test sol.retcode == ReturnCode.Success
                @test counter[] == 1  # Callback triggered once at t=0.5
                @test 0.5 in sol.t    # Solution includes callback time
            end
        end
    end

    @testset "Implicit solvers" begin
        for (name, alg) in [
                ("Rosenbrock23", Rosenbrock23()),
                ("Rodas5P", Rodas5P()),
                ("TRBDF2", TRBDF2()),
                ("ImplicitEuler", ImplicitEuler()),
                ("QNDF", QNDF()),
            ]
            @testset "$name" begin
                counter = Ref(0)
                cb = PresetTimeCallback([0.5], integrator -> (counter[] += 1))
                prob = ODEProblem(Returns(nothing), nothing, (0.0, 1.0))

                sol = solve(prob, alg; callback = cb)

                @test sol.retcode == ReturnCode.Success
                @test counter[] == 1  # Callback triggered once at t=0.5
                @test 0.5 in sol.t    # Solution includes callback time
            end
        end
    end

    @testset "Multiple callbacks" begin
        counter = Ref(0)
        cb = PresetTimeCallback([0.25, 0.5, 0.75], integrator -> (counter[] += 1))
        prob = ODEProblem(Returns(nothing), nothing, (0.0, 1.0))

        sol = solve(prob, Tsit5(); callback = cb)

        @test sol.retcode == ReturnCode.Success
        @test counter[] == 3
    end

    @testset "DiscreteCallback with condition" begin
        counter = Ref(0)
        cb = DiscreteCallback(
            (u, t, integrator) -> t >= 0.5 && counter[] == 0,
            integrator -> (counter[] += 1)
        )
        prob = ODEProblem(Returns(nothing), nothing, (0.0, 1.0))

        sol = solve(prob, Tsit5(); callback = cb)

        @test sol.retcode == ReturnCode.Success
        @test counter[] == 1
    end

    @testset "Solution structure with null u0" begin
        prob = ODEProblem(Returns(nothing), nothing, (0.0, 1.0))
        sol = solve(prob, Tsit5())

        @test sol.retcode == ReturnCode.Success
        @test all(u -> u == Float64[], sol.u)  # All states are empty arrays
        @test sol.t[1] == 0.0
        @test sol.t[end] == 1.0
    end
end

using DelayDiffEq, DDEProblemLibrary, ADTypes
using Test

@testset "Constant delays" begin
    prob = DDEProblemLibrary.prob_dde_constant_2delays_ip
    prob_scalar = DDEProblemLibrary.prob_dde_constant_2delays_scalar
    # disable reuse
    nlsolve = nlsolve = NLNewton(fast_convergence_cutoff = 0)

    algdict = Dict(BS3() => 2.4e-6,
        Tsit5() => 4.5e-3,
        RK4() => 1.1e-4,
        Vern6() => 1.0e-3,
        SDIRK2(nlsolve = nlsolve) => 2.3e-1,
        TRBDF2(nlsolve = nlsolve) => 6.2e-2,
        KenCarp4(nlsolve = nlsolve) => 5.6e-2,
        Rosenbrock23() => 6.5e-4,
        Rodas4() => 5.4e-4)

    for (alg, error) in algdict
        ddealg = MethodOfSteps(alg)

        sol = solve(prob, ddealg)
        @test sol.errors[:l∞] < error

        sol_scalar = solve(prob_scalar, ddealg)
        @test sol.t≈sol_scalar.t atol=1e-3
        @test sol[1, :]≈sol_scalar.u atol=1e-3
    end
end

function lotka_volterra!(du, u, h, p, t)
    🐰, 🐺 = u
    α, β, γ, δ, τ = p
    🕥🐰 = h(p, t - τ; idxs = 1)
    du[1] = d🐰 = α * 🕥🐰 - β * 🐺 * 🐰
    du[2] = d🐺 = γ * 🐺 * 🐰 - δ * 🐺
    nothing
end
uₒ = [1.0, 1.0]
tspan = (0.0, 10.0)
h(p, t) = [1.0, 1.0]
h(p, t; idxs = 1) = 1.0
p = [1.5, 1.0, 3.0, 1.0, 1.0]
prob = DDEProblem(lotka_volterra!, uₒ, h, tspan, p, constant_lags = (p[end],))
sol = solve(prob, MethodOfSteps(AutoTsit5(Rosenbrock23(autodiff = AutoFiniteDiff()))))

using OrdinaryDiffEq, CUDA, Test
CUDA.allowscalar(false)
N = 256
# Define the initial condition as normal arrays
u0 = zeros(N, N, 3)
u0 .= 1.0
gu0 = CuArray(Float32.(u0))

# Define the discretized PDE as an ODE function
function f(du, u, p, t)
    @. du = u
end
prob = ODEProblem{true, SciMLBase.FullSpecialize}(f, u0, (0.0f0, 10.0f0))
prob2 = ODEProblem{true, SciMLBase.FullSpecialize}(f, gu0, (0.0f0, 10.0f0))

algs = [ORK256(), CarpenterKennedy2N54(), SHLDDRK64(), DGLDDRK73_C()]

for alg in algs
    # CPU warmup
    solve(prob, alg, save_everystep = false, save_start = false, dt = 0.01)
    solve(prob, alg, save_everystep = false, save_start = false, dt = 0.01)
    solve(prob, alg, save_everystep = false, save_start = false, dt = 0.01)
    println("CPU Times for $alg")
    @time sol = solve(prob, alg, save_everystep = false, save_start = false, dt = 0.01)

    # GPU warmup
    solve(prob2, alg, save_everystep = false, save_start = false, dt = 0.01)
    solve(prob2, alg, save_everystep = false, save_start = false, dt = 0.01)
    solve(prob2, alg, save_everystep = false, save_start = false, dt = 0.01)
    println("GPU Times for $alg")
    @time sol2 = solve(prob2, alg, save_everystep = false, save_start = false, dt = 0.01)

    @test sol[end] ≈ Array(sol2[end])
end

using OrdinaryDiffEq, RecursiveArrayTools, LinearAlgebra, Test

# Define the constants for the PDE
const α₂ = 1.0
const α₃ = 1.0
const β₁ = 1.0
const β₂ = 1.0
const β₃ = 1.0
const r₁ = 1.0
const r₂ = 1.0
const D = 100.0
const γ₁ = 0.1
const γ₂ = 0.1
const γ₃ = 0.1
const N = 256
const X = reshape([i for i in 1:N for j in 1:N], N, N)
const Y = reshape([j for i in 1:N for j in 1:N], N, N)
const α₁ = 1.0 .* (X .>= 4 * N / 5)

const Mx = Tridiagonal([1.0 for i in 1:(N - 1)], [-2.0 for i in 1:N],
    [1.0 for i in 1:(N - 1)])
const My = copy(Mx)
Mx[2, 1] = 2.0
Mx[end - 1, end] = 2.0
My[1, 2] = 2.0
My[end, end - 1] = 2.0

# Define the initial condition as normal arrays
u0 = zeros(N, N, 3)

const MyA = zeros(N, N);
const AMx = zeros(N, N);
const DA = zeros(N, N);
# Define the discretized PDE as an ODE function
function f(du, u, p, t)
    A = @view u[:, :, 1]
    B = @view u[:, :, 2]
    C = @view u[:, :, 3]
    dA = @view du[:, :, 1]
    dB = @view du[:, :, 2]
    dC = @view du[:, :, 3]
    mul!(MyA, My, A)
    mul!(AMx, A, Mx)
    @. DA = D * (MyA + AMx)
    @. dA = DA + α₁ - β₁ * A - r₁ * A * B + r₂ * C
    @. dB = α₂ - β₂ * B - r₁ * A * B + r₂ * C
    @. dC = α₃ - β₃ * C + r₁ * A * B - r₂ * C
end

# Solve the ODE
prob = ODEProblem(f, u0, (0.0, 100.0))
sol = solve(prob, BS3(), progress = true, save_everystep = false, save_start = false)
sol = solve(prob, ROCK2(), progress = true, save_everystep = false, save_start = false)

println("CPU Times")
println("BS3")
@time sol = solve(prob, BS3(), progress = true, save_everystep = false, save_start = false)
println("ROCK2")
@time sol = solve(prob, ROCK2(), progress = true, save_everystep = false,
    save_start = false)

using CUDA
gu0 = CuArray(Float32.(u0))
const gMx = CuArray(Float32.(Mx))
const gMy = CuArray(Float32.(My))
const gα₁ = CuArray(Float32.(α₁))

const gMyA = CuArray(zeros(Float32, N, N))
const gAMx = CuArray(zeros(Float32, N, N))
const gDA = CuArray(zeros(Float32, N, N))

function gf(du, u, p, t)
    A = @view u[:, :, 1]
    B = @view u[:, :, 2]
    C = @view u[:, :, 3]
    dA = @view du[:, :, 1]
    dB = @view du[:, :, 2]
    dC = @view du[:, :, 3]
    mul!(gMyA, gMy, A)
    mul!(gAMx, A, gMx)
    @. gDA = D * (gMyA + gAMx)
    @. dA = gDA + gα₁ - β₁ * A - r₁ * A * B + r₂ * C
    @. dB = α₂ - β₂ * B - r₁ * A * B + r₂ * C
    @. dC = α₃ - β₃ * C + r₁ * A * B - r₂ * C
end

prob2 = ODEProblem(gf, gu0, (0.0f0, 100.0f0))
CUDA.allowscalar(false)
sol = solve(prob2, BS3(), save_everystep = false, save_start = false)
sol = solve(prob2, ROCK2(), save_everystep = false, save_start = false)
@test sol.t[end] == 100.0

println("GPU Times")
println("BS3")
@time sol = solve(prob2, BS3(), progress = true, save_everystep = false, save_start = false)
println("ROCK2")
@time sol = solve(prob2, ROCK2(), progress = true, save_everystep = false,
    save_start = false)

using OrdinaryDiffEq, DiffEqCallbacks, Test
import ODEProblemLibrary: prob_ode_2Dlinear

prob = prob_ode_2Dlinear

integrator = init(prob, Tsit5(); dt = 1 // 2^(4))
dt = integrator.dt
solve!(integrator)

u = copy(integrator.sol.u)
t = copy(integrator.sol.t)

reinit!(integrator)
integrator.dt = dt
solve!(integrator)

@test u == integrator.sol.u
@test t == integrator.sol.t

# Implicitly test if dt resets
integrator = init(prob, Tsit5())
dt = integrator.dt
solve!(integrator)

u = copy(integrator.sol.u)
t = copy(integrator.sol.t)

reinit!(integrator)
integrator.dt
solve!(integrator)

@test u == integrator.sol.u
@test t == integrator.sol.t

integrator = init(prob, Tsit5(); dt = 1 // 2^(4), tstops = [1 // 2], saveat = [1 // 4])
dt = integrator.dt
solve!(integrator)

u = copy(integrator.sol.u)
t = copy(integrator.sol.t)

reinit!(integrator)
integrator.dt = dt
solve!(integrator)

@test u == integrator.sol.u
@test t == integrator.sol.t

#callback test
g(u, p, t) = 2.0 * t - 2.0
u0 = 0.0
tspan = (0.0, 4.0)
prob = ODEProblem(g, u0, tspan)
saved_values = SavedValues(Float64, Float64)
cb = SavingCallback((u, t, integrator) -> u, saved_values)
integrator = init(prob, Tsit5(); dt = 1 // 2^(4), callback = cb)
dt = integrator.dt
solve!(integrator)

u = saved_values.saveval
t = saved_values.t
resize!(saved_values.t, 0)
resize!(saved_values.saveval, 0)
reinit!(integrator)
integrator.dt = dt
solve!(integrator)

@test u == saved_values.saveval
@test t == saved_values.t

@testset "set u0" begin
    prob = prob_ode_2Dlinear
    integrator = init(prob, Tsit5())
    u0 = prob.u0 .+ 1  # just make it different
    @test u0 != prob.u0
    reinit!(integrator, u0)
    @test integrator.u == u0
    @test integrator.sol.u[1] == u0
    @test integrator.sol.interp.timeseries[1] == u0
end

@testset "set u0 with save_idxs" begin
    save_idxs = [1]
    prob = prob_ode_2Dlinear
    integrator = init(prob, Tsit5(); save_idxs = save_idxs)
    u0 = prob.u0 .+ 1  # just make it different
    @test u0 != prob.u0
    reinit!(integrator, u0)
    @test integrator.u == u0
    @test integrator.sol.u[1] == u0[save_idxs]
    @test integrator.sol.interp.timeseries[1] == u0[save_idxs]
end

@testset "set t0" begin
    prob = prob_ode_2Dlinear
    integrator = init(prob, Tsit5())
    t0 = prob.tspan[1] - 1  # just make it different
    @test t0 != prob.tspan[1]
    reinit!(integrator; t0 = t0)
    @test integrator.t == t0
    @test integrator.sol.t[1] == t0
    @test integrator.sol.interp.ts[1] == t0
end

using ExplicitImports, OrdinaryDiffEq
using Test

@testset "ExplicitImports" begin
    @test check_no_implicit_imports(
        OrdinaryDiffEq; skip = (Base, Core, SciMLBase)
    ) === nothing

    @test check_no_stale_explicit_imports(OrdinaryDiffEq) === nothing

    @test check_all_qualified_accesses_via_owners(OrdinaryDiffEq) === nothing
end

using OrdinaryDiffEq, Test

import ODEProblemLibrary: prob_ode_linear

# Test that ODEAliasSpecifier works for alias_u0
u0_alias_sol = solve(
    prob_ode_linear, Tsit5(), alias = ODEAliasSpecifier(alias_u0 = true)
)
u0_no_alias_sol = solve(prob_ode_linear, Tsit5())

@test u0_alias_sol.u == u0_no_alias_sol.u

# Solve the Landau-Zener problem i ψ' = H(t) ψ, with H(t) = [t 1;1 -t]

using Test
using StaticArrays, LinearAlgebra
using OrdinaryDiffEq, DiffEqBase, ADTypes

H(t) = -im * (@SMatrix [t 1; 1 -t])

fun(ψ, p, t) = oftype(ψ, H(t) * ψ)
fun_inplace(dψ, ψ, p, t) = (dψ .= H(t) * ψ)

T = 0.1
tspan = (0, T)
explicit = [Midpoint, RK4, DP5, Tsit5, Vern7]
implicit = [ImplicitEuler, Trapezoid, Kvaerno3, Rosenbrock23]

@testset "Complex Tests on Explicit Methods. alg=$alg" for alg in explicit
    for f in (fun, fun_inplace)
        ψ0 = [1.0 + 0.0im; 0.0]
        prob = ODEProblem(f, ψ0, (-T, T))
        sol = solve(prob, alg())
        @test norm(sol(T))≈1 atol=1e-2
    end
    ψ0 = @SArray [1.0 + 0.0im; 0.0]
    prob = ODEProblem(fun, ψ0, (-T, T))
    sol = solve(prob, alg())
    @test norm(sol(T))≈1 atol=1e-2
end

@testset "Complex Tests on Implicit Autodiff Methods. alg=$alg" for alg in implicit
    @test_broken begin
        for f in (fun, fun_inplace)
            ψ0 = [1.0 + 0.0im; 0.0]
            prob = ODEProblem(f, ψ0, (-T, T))
            sol = solve(prob, alg())
            @test norm(sol(T))≈1 atol=1e-2
        end
        ψ0 = @SArray [1.0 + 0.0im; 0.0]
        prob = ODEProblem(fun, ψ0, (-T, T))
        sol = solve(prob, alg())
        @test norm(sol(T))≈1 atol=1e-2
    end
end

@testset "Complex Tests on Implicit Finite Diff Methods. alg=$alg" for alg in implicit
    ψ0 = [1.0 + 0.0im; 0.0]
    prob = ODEProblem(fun_inplace, ψ0, (-T, T))
    sol = solve(prob, alg(autodiff = AutoFiniteDiff()))
    @test norm(sol(T))≈1 atol=1e-2
end

@testset "Complex Tests on Implicit Finite Diff Out-of-place Methods. alg=$alg" for alg in implicit
    ψ0 = [1.0 + 0.0im; 0.0]
    prob = ODEProblem(fun, ψ0, (-T, T))
    sol = solve(prob, alg(autodiff = AutoFiniteDiff()))
    @test norm(sol(T))≈1 atol=1e-2
end

@testset "Complex Tests on Implicit Finite Diff Out-of-place Methods SArray. alg=$alg" for alg in implicit
    ψ0 = @SArray [1.0 + 0.0im; 0.0]
    prob = ODEProblem(fun, ψ0, (-T, T))
    sol = solve(prob, alg(autodiff = AutoFiniteDiff()))
    @test norm(sol(T))≈1 atol=1e-2
end

using OrdinaryDiffEq, Test

import ODEProblemLibrary: prob_ode_2Dlinear,
                          prob_ode_large2Dlinear,
                          prob_ode_linear,
                          prob_ode_2Dlinear_notinplace

u0 = rand(300, 20) .* ones(300, 20) / 2
prob = prob_ode_2Dlinear_notinplace
prob2 = prob_ode_2Dlinear

sol = solve(prob, Euler(), dt = 1 // 2^(4), save_everystep = false)
sol = solve(prob2, Euler(), dt = 1 // 2^(4), save_everystep = false)

alloc1 = @allocated sol = solve(prob, Euler(), dt = 1 // 2^(6), save_everystep = false)
alloc2 = @allocated sol2 = solve(prob2, Euler(), dt = 1 // 2^(6), save_everystep = false)

alloc1 = @allocated sol = solve(prob, Euler(), dt = 1 // 2^(6), save_everystep = false)
alloc2 = @allocated sol2 = solve(prob2, Euler(), dt = 1 // 2^(6), save_everystep = false)

@test alloc2 <= alloc1

sol = solve(prob_ode_linear, Euler(), dt = 1 // 2^(6), save_everystep = true)
sol2 = solve(prob_ode_linear, Euler(), sol[:], sol.t, sol.k; dt = 1 // 2^(8),
    save_everystep = true)

sol = solve(prob_ode_large2Dlinear, Euler(), dt = 1 // 2^(6), save_everystep = true)
sol2 = solve(prob_ode_large2Dlinear, Euler(), sol[:], sol.t, sol.k; dt = 1 // 2^(8),
    save_everystep = true)

sol = solve(prob_ode_large2Dlinear, Euler(), dt = 1 // 2^(6), save_everystep = true)
alloc1 = @allocated sol = solve(prob_ode_large2Dlinear, Euler(), dt = 1 // 2^(8),
    save_everystep = true)
alloc2 = @allocated sol2 = solve(prob_ode_large2Dlinear, Euler(), sol[:], sol.t, sol.k;
    dt = 1 // 2^(8), save_everystep = true)

@test alloc2 <= alloc1

sol = solve(prob, Tsit5())

using Test, OrdinaryDiffEq

using SparseArrays, LinearSolve
using LinearAlgebra, Random
N = 30
AA = sprand(MersenneTwister(12), N, N, 0.5)
mm = sprand(MersenneTwister(123), N, N, 0.5)
A = MatrixOperator(AA)
M = MatrixOperator(mm'mm)
u0 = ones(N)
prob = ODEProblem(ODEFunction(A; mass_matrix = M), u0, (0.0, 1.0))

for alg in [Rosenbrock23(), Rosenbrock23(linsolve = KLUFactorization())]
    sol = solve(prob, alg)
    @test sol.stats.njacs == 0
    @test sol.stats.nw == 1
end

## OOP

foop(u, p, t) = jac(u, p, t) * u
jac(u, p, t) = spdiagm(0 => p)
paramjac(u, p, t) = SparseArrays.spdiagm(0 => u)

n = 2
p = collect(1.0:n)
u0 = ones(n)
tspan = [0.0, 1]
odef = ODEFunction(foop; jac = jac, jac_prototype = jac(u0, p, 0.0), paramjac = paramjac)

function g_helper(p; alg = Rosenbrock23(linsolve = LUFactorization()))
    prob = ODEProblem(odef, u0, tspan, p)
    soln = Array(solve(prob, alg; u0 = prob.u0, p = prob.p, abstol = 1e-4, reltol = 1e-4))[
    :, end]
    return soln
end
function g(p; kwargs...)
    soln = g_helper(p; kwargs...)
    return sum(soln)
end

@test isapprox(exp.(p), g_helper(p; alg = Rosenbrock23(linsolve = KLUFactorization()));
    atol = 1e-3, rtol = 1e-3)
@test isapprox(exp.(p), g_helper(p; alg = Rosenbrock23(linsolve = UMFPACKFactorization()));
    atol = 1e-1, rtol = 1e-1)
@test isapprox(exp.(p), g_helper(p; alg = Rosenbrock23(linsolve = KrylovJL_GMRES()));
    atol = 1e-1, rtol = 1e-1)

@test isapprox(exp.(p), g_helper(p; alg = Rodas4(linsolve = KLUFactorization()));
    atol = 1e-3, rtol = 1e-3)
@test isapprox(exp.(p), g_helper(p; alg = Rodas4(linsolve = UMFPACKFactorization()));
    atol = 1e-1, rtol = 1e-1)
@test isapprox(
    exp.(p), g_helper(p; alg = Rodas4(linsolve = KrylovJL_GMRES())); atol = 1e-1,
    rtol = 1e-1)

@test isapprox(exp.(p), g_helper(p; alg = Rodas5(linsolve = KLUFactorization()));
    atol = 1e-3, rtol = 1e-3)
@test isapprox(exp.(p), g_helper(p; alg = Rodas5(linsolve = UMFPACKFactorization()));
    atol = 1e-1, rtol = 1e-1)
@test isapprox(
    exp.(p), g_helper(p; alg = Rodas5(linsolve = KrylovJL_GMRES())); atol = 1e-1,
    rtol = 1e-1)

@test isapprox(exp.(p), g_helper(p; alg = ImplicitEuler(linsolve = KLUFactorization()));
    atol = 1e-1, rtol = 1e-1)
@test isapprox(
    exp.(p), g_helper(p; alg = ImplicitEuler(linsolve = UMFPACKFactorization()));
    atol = 1e-1, rtol = 1e-1)
@test isapprox(exp.(p), g_helper(p; alg = ImplicitEuler(linsolve = KrylovJL_GMRES()));
    atol = 1e-1, rtol = 1e-1)

@test isapprox(exp.(p), g_helper(p; alg = TRBDF2(linsolve = KLUFactorization()));
    atol = 1e-1, rtol = 1e-1)
@test isapprox(exp.(p), g_helper(p; alg = TRBDF2(linsolve = UMFPACKFactorization()));
    atol = 1e-1, rtol = 1e-1)
@test isapprox(
    exp.(p), g_helper(p; alg = TRBDF2(linsolve = KrylovJL_GMRES())); atol = 1e-1,
    rtol = 1e-1)

@test isapprox(exp.(p), g_helper(p; alg = KenCarp47(linsolve = KLUFactorization()));
    atol = 1e-1, rtol = 1e-1)
@test isapprox(exp.(p), g_helper(p; alg = KenCarp47(linsolve = UMFPACKFactorization()));
    atol = 1e-1, rtol = 1e-1)
@test isapprox(exp.(p), g_helper(p; alg = KenCarp47(linsolve = KrylovJL_GMRES()));
    atol = 1e-1, rtol = 1e-1)

@test isapprox(exp.(p), g_helper(p; alg = FBDF(linsolve = KrylovJL_GMRES()));
    atol = 1e-1, rtol = 1e-1)

## IIP

fiip(du, u, p, t) = du .= jac(u, p, t) * u
jac(du, u, p, t) = du .= spdiagm(0 => p)
paramjac(du, u, p, t) = du .= SparseArrays.spdiagm(0 => u)

n = 2
p = collect(1.0:n)
u0 = ones(n)
tspan = [0.0, 1]
odef = ODEFunction{true}(fiip; jac = jac, jac_prototype = jac(u0, p, 0.0),
    paramjac = paramjac)

function g_helper(p; alg = Rosenbrock23(linsolve = LUFactorization()))
    prob = ODEProblem(odef, u0, tspan, p)
    soln = Array(solve(prob, alg; u0 = prob.u0, p = prob.p, abstol = 1e-4, reltol = 1e-4))[
    :, end]
    return soln
end
function g(p; kwargs...)
    soln = g_helper(p; kwargs...)
    return sum(soln)
end

@test isapprox(exp.(p), g_helper(p; alg = Rosenbrock23(linsolve = KLUFactorization()));
    atol = 1e-3, rtol = 1e-3)
@test isapprox(exp.(p), g_helper(p; alg = Rosenbrock23(linsolve = UMFPACKFactorization()));
    atol = 1e-1, rtol = 1e-1)
@test isapprox(exp.(p), g_helper(p; alg = Rosenbrock23(linsolve = KrylovJL_GMRES()));
    atol = 1e-1, rtol = 1e-1)

@test isapprox(exp.(p), g_helper(p; alg = Rodas4(linsolve = KLUFactorization()));
    atol = 1e-3, rtol = 1e-3)
@test isapprox(exp.(p), g_helper(p; alg = Rodas4(linsolve = UMFPACKFactorization()));
    atol = 1e-1, rtol = 1e-1)
@test isapprox(
    exp.(p), g_helper(p; alg = Rodas4(linsolve = KrylovJL_GMRES())); atol = 1e-1,
    rtol = 1e-1)

@test isapprox(exp.(p), g_helper(p; alg = Rodas5(linsolve = KLUFactorization()));
    atol = 1e-3, rtol = 1e-3)
@test isapprox(exp.(p), g_helper(p; alg = Rodas5(linsolve = UMFPACKFactorization()));
    atol = 1e-1, rtol = 1e-1)
@test isapprox(
    exp.(p), g_helper(p; alg = Rodas5(linsolve = KrylovJL_GMRES())); atol = 1e-1,
    rtol = 1e-1)

@test isapprox(exp.(p), g_helper(p; alg = ImplicitEuler(linsolve = KLUFactorization()));
    atol = 1e-1, rtol = 1e-1)
@test isapprox(
    exp.(p), g_helper(p; alg = ImplicitEuler(linsolve = UMFPACKFactorization()));
    atol = 1e-1, rtol = 1e-1)
@test isapprox(exp.(p), g_helper(p; alg = ImplicitEuler(linsolve = KrylovJL_GMRES()));
    atol = 1e-1, rtol = 1e-1)

@test isapprox(exp.(p), g_helper(p; alg = TRBDF2(linsolve = KLUFactorization()));
    atol = 1e-1, rtol = 1e-1)
@test isapprox(exp.(p), g_helper(p; alg = TRBDF2(linsolve = UMFPACKFactorization()));
    atol = 1e-1, rtol = 1e-1)
@test isapprox(
    exp.(p), g_helper(p; alg = TRBDF2(linsolve = KrylovJL_GMRES())); atol = 1e-1,
    rtol = 1e-1)

@test isapprox(exp.(p), g_helper(p; alg = KenCarp47(linsolve = KLUFactorization()));
    atol = 1e-1, rtol = 1e-1)
@test isapprox(exp.(p), g_helper(p; alg = KenCarp47(linsolve = UMFPACKFactorization()));
    atol = 1e-1, rtol = 1e-1)
@test isapprox(exp.(p), g_helper(p; alg = KenCarp47(linsolve = KrylovJL_GMRES()));
    atol = 1e-1, rtol = 1e-1)

using OrdinaryDiffEq, StaticArrays, LinearSolve

# In-place version
function hires!(du, u, p, t)
    T = eltype(u)
    du[1] = T(-1.71) * u[1] + T(0.43) * u[2] + T(8.32) * u[3] + T(0.0007) + T(1.0e-18) * t
    du[2] = T(1.71) * u[1] - T(8.75) * u[2]
    du[3] = T(-10.03) * u[3] + T(0.43) * u[4] + T(0.035) * u[5]
    du[4] = T(8.32) * u[2] + T(1.71) * u[3] - T(1.12) * u[4]
    du[5] = T(-1.745) * u[5] + T(0.43) * u[6] + T(0.43) * u[7]
    du[6] = T(-280.0) * u[6] * u[8] + T(0.69) * u[4] + T(1.71) * u[5] - T(0.43) * u[6] +
            T(0.69) * u[7]
    du[7] = T(280.0) * u[6] * u[8] - T(1.81) * u[7]
    du[8] = T(-280.0) * u[6] * u[8] + T(1.81) * u[7]
end

# Out-of-place version
function hires(u, p, t)
    T = eltype(u)
    du1 = T(-1.71) * u[1] + T(0.43) * u[2] + T(8.32) * u[3] + T(0.0007) + T(1.0e-18) * t
    du2 = T(1.71) * u[1] - T(8.75) * u[2]
    du3 = T(-10.03) * u[3] + T(0.43) * u[4] + T(0.035) * u[5]
    du4 = T(8.32) * u[2] + T(1.71) * u[3] - T(1.12) * u[4]
    du5 = T(-1.745) * u[5] + T(0.43) * u[6] + T(0.43) * u[7]
    du6 = T(-280.0) * u[6] * u[8] + T(0.69) * u[4] + T(1.71) * u[5] - T(0.43) * u[6] +
          T(0.69) * u[7]
    du7 = T(280.0) * u[6] * u[8] - T(1.81) * u[7]
    du8 = T(-280.0) * u[6] * u[8] + T(1.81) * u[7]

    if u isa SVector
        return SVector(du1, du2, du3, du4, du5, du6, du7, du8)
    else
        return [du1, du2, du3, du4, du5, du6, du7, du8]
    end
end

u0 = zeros(8)
u0[1] = 1
u0[8] = 0.0057

probiip = ODEProblem{true}(hires!, u0, (0.0, 10.0))
proboop = ODEProblem{false}(hires, u0, (0.0, 10.0))
probstatic = ODEProblem{false}(hires, SVector{8}(u0), (0.0, 10.0))
probiipf32 = ODEProblem{true}(hires!, Float32.(u0), (0.0f0, 10.0f0))
proboopf32 = ODEProblem{false}(hires, Float32.(u0), (0.0f0, 10.0f0))
probstaticf32 = ODEProblem{false}(hires, SVector{8}(Float32.(u0)), (0.0f0, 10.0f0))
probs = (; probiip, proboop, probstatic)
probsf32 = (; probiipf32, proboopf32, probstaticf32)
qndf = QNDF()
krylov_qndf = QNDF(linsolve = KrylovJL_GMRES())
fbdf = FBDF()
krylov_fbdf = FBDF(linsolve = KrylovJL_GMRES())
rodas = Rodas5P()
krylov_rodas = Rodas5P(linsolve = KrylovJL_GMRES())
solvers = (; qndf, krylov_qndf, rodas, krylov_rodas, fbdf, krylov_fbdf)

refsol = solve(probiip, FBDF(), abstol = 1e-12, reltol = 1e-12)
@testset "Hires calc_W tests" begin
    @testset "$probname" for (probname, prob) in pairs(probs)
        @testset "$solname" for (solname, solver) in pairs(solvers)
            sol = solve(prob, solver, abstol = 1e-12, reltol = 1e-12, maxiters = 2e4)
            @test sol.retcode == ReturnCode.Success
            @test isapprox(sol.u[end], refsol.u[end], rtol = 1e-8, atol = 1e-10)
        end
    end
end

@testset "Hires Float32 calc_W tests" begin
    @testset "$probname" for (probname, prob) in pairs(probsf32)
        @testset "$solname" for (solname, solver) in pairs(solvers)
            sol = solve(prob, solver, maxiters = 2e4)
            @test sol.retcode == ReturnCode.Success
            @test isapprox(sol.u[end], refsol.u[end], rtol = 2e-3, atol = 1e-6)
        end
    end
end

using OrdinaryDiffEq, OrdinaryDiffEqCore
function lorenz!(du, u, p, t)
    du[1] = 10.0(u[2] - u[1])
    du[2] = u[1] * (28.0 - u[3]) - u[2]
    du[3] = u[1] * u[2] - (8 / 3) * u[3]
end
u0 = [1.0; 0.0; 0.0]
tspan = (0.0, 100.0)
prob = ODEProblem(lorenz!, u0, tspan)

out = rand(3)

for alg in [Rosenbrock23(), Rodas4(), Rodas5P(), Tsit5(), DP5(),
    BS5(), OwrenZen3(), OwrenZen4(), OwrenZen5(),
    Vern6(), Vern7(), Vern8(), Vern9(), BS3()]
    @show alg
    sol = solve(prob, alg)
    @test_throws OrdinaryDiffEqCore.DerivativeOrderNotPossibleError sol(0.5, Val{10})
    @test_throws OrdinaryDiffEqCore.DerivativeOrderNotPossibleError sol(out, 0.5, Val{10})
end

using OrdinaryDiffEq, RecursiveArrayTools, Test

# in terms of the voltage across all three elements
rlc1!(v′, v, (R, L, C), t) = -(v′ / R + v / L) / C
identity_f(v, u, p, t) = v # needed to form second order dynamical ODE

function setup_rlc(R, L, C; v_init = 0.0, v′_init = 0.0, tspan = (0.0, 50.0))
    DynamicalODEProblem{false}(rlc1!, identity_f, v′_init, v_init, tspan, (R, L, C))
end

# simulate voltage impulse
R, L, C = 10, 0.3, 2

prob = setup_rlc(R, L, C, v_init = 2.0)

res1 = solve(prob, Vern8(), dt = 1 / 10, saveat = 1 / 10)
res3 = solve(prob, CalvoSanz4(), dt = 1 / 10, saveat = 1 / 10)

sol = solve(prob, CalvoSanz4(), dt = 1 / 10)
@test sol(0.32) isa RecursiveArrayTools.ArrayPartition
@test sol(0.32, Val{1}) isa RecursiveArrayTools.ArrayPartition
@test sol(0.32, Val{2}) isa RecursiveArrayTools.ArrayPartition
@test sol(0.32, Val{3}) isa RecursiveArrayTools.ArrayPartition

function f(du, u, p, t)
    du .= u
    nothing
end
dprob = DiscreteProblem(f, [1, 2, 3], (0, 100))
sol = solve(dprob, FunctionMap())
@test sol(0:0.1:100; idxs = 1) isa DiffEqArray
@test length(sol(0:0.1:100; idxs = 1)) == length(0:0.1:100)
@test length(sol(0:0.1:100; idxs = 1).u[1]) == 1
sol(0:0.1:100; idxs = [1, 2])

@test sol(0:0.1:100; idxs = [1, 2]) isa DiffEqArray
@test length(sol(0:0.1:100; idxs = [1, 2])) == length(0:0.1:100)
@test length(sol(0:0.1:100; idxs = [1, 2]).u[1]) == 2

@test sol(0:0.1:100) isa DiffEqArray
@test length(sol(0:0.1:100)) == length(0:0.1:100)
@test length(sol(0:0.1:100).u[1]) == 3

## Test DPRKN Interpolation

#Parameters
ω = 1

#Initial Conditions
x₀ = [0.0]
dx₀ = [π / 2]
tspan = (0.0, 2π)

ϕ = atan((dx₀[1] / ω) / x₀[1])
A = √(x₀[1]^2 + dx₀[1]^2)

function harmonicoscillator(ddu, du, u, ω, t)
    ddu .= -ω^2 * u
end

prob = SecondOrderODEProblem(harmonicoscillator, dx₀, x₀, tspan, ω)
sol = solve(prob, DPRKN6())
@test sol(0.5) isa RecursiveArrayTools.ArrayPartition
@test sol(0.5; idxs = 1) isa Number
@test sol(0.5; idxs = [1]) isa Vector
@test sol(0.5; idxs = [1, 2]) isa Vector
@test Vector(sol(0.5)) == sol(0.5; idxs = [1, 2])
@test reverse(Vector(sol(0.5))) == sol(0.5; idxs = [2, 1])
@test Vector(sol(0.5)) == [sol(0.5; idxs = 1); sol(0.5; idxs = 2)]

using OrdinaryDiffEq
function ODE(du, u, t, R, K)
    du .= u
end
params = BigFloat[1.0 0.91758707304098; 1.48439909482661 1.0]
u0 = BigFloat[0.1, 0.1]
tspan = (1.0, 31.0)
R = BigFloat[0.443280390004304303, 1.172917082211452]
K = BigFloat[13.470600276901400604, 12.52980757005]
ODE_ = (du, u, params, t) -> ODE(du, u, t, R, K)
odeProblem = ODEProblem(ODE_, u0, tspan, params)
for alg in [AutoVern8(Rodas5(), nonstifftol = 11 / 10)
            FBDF()
            QNDF()
            Tsit5()
            Rodas5P()
            TRBDF2()
            KenCarp4()
            RadauIIA5()]
    Solution = solve(odeProblem, alg, saveat = 1, abstol = 1.e-12, reltol = 1.e-6)
end

using Measurements, OrdinaryDiffEq, StaticArrays

function lorenz_rule(u, p, t)
    σ, ρ, β = p
    x, y, z = u
    dx = σ * (y - x)
    dy = x * (ρ - z) - y
    dz = x * y - β * z
    return SVector(dx, dy, dz)
end

u₀ = SVector(10.0, 10.0, 10.0)
p₀ = [10, 28, 8 / 3]

prob = ODEProblem(lorenz_rule, u₀, (0.0, 100.0), p₀)
alg = Vern9() # 9-th order adaptive solver
sol = solve(prob; alg = alg) # works

uunc = SVector(10.0 ± 0.1, 10.0 ± 0.1, 10.0 ± 0.1)
probunc = ODEProblem(lorenz_rule, uunc, (0.0, 10.0), p₀)
solunc = solve(probunc; alg = alg) # does not work

import ODEProblemLibrary: prob_ode_vanderpol_stiff
using SciMLOperators
using OrdinaryDiffEq
using LinearAlgebra
using LinearSolve
using Test

for prob in (prob_ode_vanderpol_stiff,)
    # Ensure all solutions use the same linear solve for fair comparison.
    # TODO: in future, ensure and test that polyalg chooses the best linear solve when unspecified.
    for alg in (Rosenbrock23(linsolve = KrylovJL_GMRES()),
        FBDF(linsolve = KrylovJL_GMRES()))
        # Manually construct a custom W operator using the Jacobian 
        N = length(prob.u0)
        J_op = MatrixOperator(zeros(N, N); update_func! = prob.f.jac)
        gamma_op = ScalarOperator(0.0;
            update_func = (old_val, u, p, t; dtgamma) -> dtgamma,
            accepted_kwargs = Val((:dtgamma,)))
        transform_op = ScalarOperator(0.0;
            update_func = (old_op, u, p, t; dtgamma) -> inv(dtgamma),
            accepted_kwargs = Val((:dtgamma,)))
        W_op = -(I - gamma_op * J_op) * transform_op

        # Make problem with custom MatrixOperator jac_prototype
        f_J = ODEFunction(prob.f.f; jac_prototype = J_op)
        prob_J = remake(prob; f = f_J)

        # Test that the custom jacobian is used
        integrator = init(prob_J, Rosenbrock23())
        @test integrator.cache.J isa typeof(J_op)

        # Make problem with custom SciMLOperator W_prototype 
        f_W = ODEFunction(prob.f.f; jac_prototype = J_op, W_prototype = W_op)
        prob_W = remake(prob; f = f_W)

        # Test that the custom W operator is used
        integrator = init(prob_W, alg)
        if hasproperty(integrator.cache, :W)
            @test integrator.cache.W isa typeof(W_op)
        elseif hasproperty(integrator.cache.nlsolver.cache, :W)
            @test integrator.cache.nlsolver.cache.W isa typeof(W_op)
        else
            error("W-prototype test expected W in integrator.cache or integrator.cache.nlsolver.cache")
        end

        # Run solves
        sol = solve(prob, alg)
        sol_J = solve(prob_J, alg) # note: direct linsolve in this case is broken, see #1998
        sol_W = solve(prob_W, alg)

        rtol = 1e-2
        
        @test prob_J.f.sparsity.A == prob_W.f.sparsity.A

        @test all(isapprox.(sol_J.t, sol_W.t; rtol))
        @test all(isapprox.(sol_J.u, sol_W.u; rtol))

        @test all(isapprox.(sol_J.t, sol.t; rtol))
        @test all(isapprox.(sol_J.u, sol.u; rtol))
        @test all(isapprox.(sol_W.t, sol.t; rtol))
        @test all(isapprox.(sol_W.u, sol.u; rtol))
    end
end

using OrdinaryDiffEq, OrdinaryDiffEqCore, Test, LinearAlgebra
import ODEProblemLibrary: prob_ode_linear, prob_ode_2Dlinear
using DiffEqDevTools, ADTypes

prob = prob_ode_2Dlinear
choice_function(integrator) = (Int(integrator.t < 0.5) + 1)
alg_double = CompositeAlgorithm((Tsit5(), Tsit5()), choice_function)
alg_double2 = CompositeAlgorithm((Vern6(), Vern6()), choice_function)
alg_switch = CompositeAlgorithm((Tsit5(), Vern7()), choice_function)

@time sol1 = solve(prob_ode_linear, alg_double)
@time sol2 = solve(prob_ode_linear, Tsit5())
@test sol1.t == sol2.t
@test sol1(0.8) == sol2(0.8)

alg_double_erk = CompositeAlgorithm((ExplicitRK(), ExplicitRK()), choice_function)
@time sol1 = solve(prob_ode_linear, alg_double_erk)
@time sol2 = solve(prob_ode_linear, ExplicitRK())
@test sol1.t == sol2.t
@test sol1(0.8) == sol2(0.8)

integrator1 = init(prob, alg_double2)
integrator2 = init(prob, Vern6())
solve!(integrator1)
solve!(integrator2)

@test integrator1.sol.t == integrator2.sol.t

sol = solve(prob, alg_switch)
@inferred SciMLBase.__init(prob, alg_switch)
v = @inferred OrdinaryDiffEqCore.ode_interpolant(
    1.0, integrator1, integrator1.opts.save_idxs,
    Val{0})
@inferred OrdinaryDiffEqCore.ode_interpolant!(
    v, 1.0, integrator1, integrator1.opts.save_idxs,
    Val{0})
v = @inferred OrdinaryDiffEqCore.ode_extrapolant(
    1.0, integrator1, integrator1.opts.save_idxs,
    Val{0})
@inferred OrdinaryDiffEqCore.ode_extrapolant!(
    v, 1.0, integrator1, integrator1.opts.save_idxs,
    Val{0})

@testset "Mixed adaptivity" begin
    reverse_choice(integrator) = (Int(integrator.t > 0.5) + 1)
    alg_mixed = CompositeAlgorithm((Tsit5(), ABM54()), choice_function)
    alg_mixed_r = CompositeAlgorithm((ABM54(), Tsit5()), reverse_choice)
    alg_mixed2 = CompositeAlgorithm((Tsit5(), ABM54()), reverse_choice)

    @test_throws ArgumentError solve(prob_ode_linear, alg_mixed)
    sol2 = solve(prob_ode_linear, Tsit5())
    sol3 = solve(prob_ode_linear, alg_mixed; dt = 0.05, adaptive = false)
    sol4 = solve(prob_ode_linear, alg_mixed_r; dt = 0.05, adaptive = false)
    sol5 = solve(prob_ode_linear, alg_mixed2; dt = 0.05, adaptive = false)
    @test sol3.t == sol4.t && sol3.u == sol4.u
    @test sol3(0.8)≈sol2(0.8) atol=1e-4
    @test sol5(0.8)≈sol2(0.8) atol=1e-4
end

condition(u, t, integrator) = t == 192.0
function affect!(integrator)
    integrator.u[1] += 14000
    integrator.u[2] += 14000
end
A = [-0.027671669470584172 -0.0 -0.0 -0.0 -0.0 -0.0;
     -0.0 -0.05540281553537378 -0.0 -0.0 -0.0 -0.0;
     0.011534597161021629 0.011933539591245327 -0.24891886153387743 0.023054812171672122 0.0 0.0;
     0.0 0.0 0.17011732278405356 -0.023054812171672122 0.0 0.0;
     0.01613707230956254 0.04346927594412846 0.03148193084515083 0.0 -1.5621055510998967e9 7.293040577236404;
     0.0 0.0 0.0 0.0 1.559509231932001e9 -7.293040577236404]
prob = ODEProblem((du, u, p, t) -> mul!(du, A, u), zeros(6), (0.0, 1000), tstops = [192],
    callback = DiscreteCallback(condition, affect!));
sol = solve(prob, alg = AutoVern7(Rodas5()))
@test sol.t[end] == 1000.0

sol = solve(prob,
    alg = OrdinaryDiffEqCore.AutoAlgSwitch(ExplicitRK(constructVerner7()), Rodas5()))
@test sol.t[end] == 1000.0

prob = remake(prob_ode_2Dlinear, u0 = rand(ComplexF64, 2, 2))
sol = solve(prob, AutoTsit5(Rosenbrock23(autodiff = AutoFiniteDiff()))) # Complex and AD don't mix
@test sol.retcode == ReturnCode.Success

# https://github.com/SciML/ModelingToolkit.jl/issues/3043
function rober(du, u, p, t)
    y₁, y₂, y₃ = u
    k₁, k₂, k₃ = p
    du[1] = -k₁ * y₁ + k₃ * y₂ * y₃
    du[2] = k₁ * y₁ - k₃ * y₂ * y₃ - k₂ * y₂^2
    du[3] = y₁ + y₂ + y₃ - 1
    nothing
end
M = [1.0 0 0
     0 1.0 0
     0 0 0]
f = ODEFunction(rober, mass_matrix = M)
prob_mm = ODEProblem(f, [1.0, 0.0, 0.0], (0.0, 1e5), (0.04, 3e7, 1e4))
cb = DiscreteCallback(
    (u, t, integrator) -> true, (integrator) -> u_modified!(integrator, true))
sol = solve(prob_mm, DefaultODEAlgorithm(), callback = cb)

#fixing gpu tolerances
using OrdinaryDiffEqBDF, CUDA, Test
CUDA.allowscalar(false)

function f_gpu!(du, u, p, t)
    @. du = p * u
    return nothing
end

u0_cpu = [1.0, 2.0]
p_cpu = [-0.5, -1.5]
u0_gpu = CuArray(u0_cpu)
p_gpu = CuArray(p_cpu)
tspan = (0.0, 1.0)

prob_cpu = ODEProblem(f_gpu!, copy(u0_cpu), tspan, p_cpu)
prob_gpu = ODEProblem(f_gpu!, copy(u0_gpu), tspan, p_gpu)

@testset "QNDF GPU" begin
    sol_cpu = solve(prob_cpu, QNDF(), abstol = 1.0e-6, reltol = 1.0e-6)
    sol_gpu = solve(prob_gpu, QNDF(), abstol = 1.0e-6, reltol = 1.0e-6)
    @test sol_gpu.u[end] isa CuArray
    @test isapprox(Array(sol_gpu.u[end]), sol_cpu.u[end], rtol = 1.0e-3)
end

# FBDF GPU - scalar indexing in _bdf_active_order fixed via _is_all_zero helper
@testset "FBDF GPU" begin
    sol_cpu = solve(prob_cpu, FBDF(), abstol = 1.0e-6, reltol = 1.0e-6)
    sol_gpu = solve(prob_gpu, FBDF(), abstol = 1.0e-6, reltol = 1.0e-6)
    @test sol_gpu.u[end] isa CuArray
    @test isapprox(Array(sol_gpu.u[end]), sol_cpu.u[end], rtol = 1.0e-3)
end

using OrdinaryDiffEq, Test
f(u, p, t) = 1.01 * u
u0 = 1 / 2
tspan = (0.0, Inf)
prob = ODEProblem(f, u0, tspan)

# Shouldn't error, but should go unstable and abort
sol = solve(prob, Tsit5(), reltol = 1e-8, abstol = 1e-8, adaptive = false, dt = 0.1)
@test sol.retcode == ReturnCode.Unstable

```@meta
CollapsedDocStrings = true
```

# OrdinaryDiffEqExponentialRK

Methods for semi-linear differential equations.

## Installation

To be able to access the solvers in `OrdinaryDiffEqLinear`, you must first install them use the Julia package manager:

```julia
using Pkg
Pkg.add("OrdinaryDiffEqExponentialRK")
```

This will only install the solvers listed at the bottom of this page.
If you want to explore other solvers for your problem,
you will need to install some of the other libraries listed in the navigation bar on the left.

## Example usage

```julia
using OrdinaryDiffEqExponentialRK, SciMLOperators
A = [2.0 -1.0; -1.0 2.0]
linnonlin_f1 = MatrixOperator(A)
linnonlin_f2 = (du, u, p, t) -> du .= 1.01 .* u
linnonlin_fun_iip = SplitFunction(linnonlin_f1, linnonlin_f2)
tspan = (0.0, 1.0)
u0 = [0.1, 0.1]
prob = SplitODEProblem(linnonlin_fun_iip, u0, tspan)
sol = solve(prob, ETDRK4(), dt = 1 / 4)
```

## Full list of solvers

```@docs
LawsonEuler
NorsettEuler
ETD2
ETDRK2
ETDRK3
ETDRK4
HochOst4
```

# ODE Tableaus

### Explicit Runge-Kutta Methods

  - `constructEuler` - Euler's 1st order method.
  - `constructHeun()` Heun's order 2 method.
  - `constructRalston()` - Ralston's order 2 method.
  - `constructSSPRK22()` - Explicit SSP method of order 2 using 2 stages.
  - `constructKutta3` - Kutta's classic 3rd order method.
  - `constructSSPRK33()` - Explicit SSP method of order 3 using 3 stages.
  - `constructSSPRK43()` - Explicit SSP method of order 3 using 4 stages.
  - `constructRK4` - The classic 4th order "Runge-Kutta" method.
  - `constructRK438Rule` - The classic 4th order "3/8th's Rule" method.
  - `constructSSPRK104()` - Explicit SSP method of order 4 using 10 stages.
  - `constructBogakiShampine3()` - Bogakai-Shampine's 2/3 method.
  - `constructRKF4()` - Runge-Kutta-Fehlberg 3/4.
  - `constructRKF5()` - Runge-Kutta-Fehlberg 4/5.
  - `constructRungeFirst5()` - Runge's first 5th order method.
  - `constructCassity5()` - Cassity's 5th order method.
  - `constructLawson5()` - Lawson's 5th order method.
  - `constructLutherKonen5` - Luther-Konen's first 5th order method.
  - `constructLutherKonen52()` - Luther-Konen's second 5th order method.
  - `constructLutherKonen53()` - Luther-Konen's third 5th order method.
  - `constructPapakostasPapaGeorgiou5()` - Papakostas and PapaGeorgiou more stable order 5 method.
  - `constructPapakostasPapaGeorgiou52()` - Papakostas and PapaGeorgiou more efficient order 5 method.
  - `constructTsitouras5()` - Tsitouras's order 5 method.
  - `constructBogakiShampine5()` - Bogaki and Shampine's Order 5 method.
  - `constructSharpSmart5()` - Sharp and Smart's Order 5 method.
  - `constructCashKarp()` - Cash-Karp method 4/5.
  - `constructDormandPrince()` - Dormand-Prince 4/5.
  - `constructButcher6()` - Butcher's first order 6 method.
  - `constructButcher62()` - Butcher's second order 6 method.
  - `constructButcher63()` - Butcher's third order 6 method.
  - `constructDormandPrince6()` - Dormand-Prince's 5/6 method.
  - `constructSharpVerner6()` Sharp-Verner's 5/6 method.
  - `constructVerner916()` - Verner's more efficient order 6 method (1991).
  - `constructVerner9162()` - Verner's second more efficient order 6 method (1991).
  - `constructVernerRobust6()` - Verner's "most robust" order 6 method.
  - `constructVernerEfficient6()` - Verner's "most efficient" order 6 method.
  - `constructPapakostas6()` - Papakostas's order 6 method.
  - `constructLawson6()` - Lawson's order 6 method.
  - `constructTsitourasPapakostas6()` - Tsitouras and Papakostas's order 6 method.
  - `constructDormandLockyerMcCorriganPrince6()` - the Dormand-Lockyer-McCorrigan-Prince order 6 method.
  - `constructTanakaKasugaYamashitaYazaki6A()` - Tanaka-Kasuga-Yamashita-Yazaki order 6 method A.
  - `constructTanakaKasugaYamashitaYazaki6B()` - Tanaka-Kasuga-Yamashita-Yazaki order 6 method B.
  - `constructTanakaKasugaYamashitaYazaki6C()` - Tanaka-Kasuga-Yamashita-Yazaki order 6 method C.
  - `constructTanakaKasugaYamashitaYazaki6D()` - Tanaka-Kasuga-Yamashita-Yazaki order 6 method D.
  - `constructMikkawyEisa()` - Mikkawy and Eisa's order 6 method.
  - `constructChummund6()` - Chummund's first order 6 method.
  - `constructChummund62()` - Chummund's second order 6 method.
  - `constructHuta6()` - Huta's first order 6 method.
  - `constructHuta62()` - Huta's second order 6 method.
  - `constructVerner6()` - An old order 6 method attributed to Verner.
  - `constructDverk()` - The classic DVERK algorithm attributed to Verner.
  - `constructClassicVerner6()` - A classic Verner order 6 algorithm (1978).
  - `constructButcher7()` - Butcher's order 7 algorithm.
  - `constructClassicVerner7()`- A classic Verner order 7 algorithm (1978).
  - `constructVernerRobust7()` - Verner's "most robust" order 7 algorithm.
  - `constructTanakaYamashitaStable7()` - Tanaka-Yamashita more stable order 7 algorithm.
  - `constructTanakaYamashitaEfficient7()` - Tanaka-Yamashita more efficient order 7 algorithm.
  - `constructSharpSmart7()` - Sharp-Smart's order 7 algorithm.
  - `constructSharpVerner7()` - Sharp-Verner's order 7 algorithm.
  - `constructVerner7()` - Verner's "most efficient" order 7 algorithm.
  - `constructVernerEfficient7()` - Verner's "most efficient" order 7 algorithm.
  - `constructClassicVerner8()` - A classic Verner order 8 algorithm (1978).
  - `constructCooperVerner8()` - Cooper-Verner's first order 8 algorithm.
  - `constructCooperVerner82()` - Cooper-Verner's second order 8 algorithm.
  - `constructTsitourasPapakostas8()` - Tsitouras-Papakostas order 8 algorithm.
  - `constructdverk78()` - The classic order 8 DVERK algorithm.
  - `constructEnrightVerner8()` - Enright-Verner order 8 algorithm.
  - `constructCurtis8()` - Curtis' order 8 algorithm.
  - `constructVerner8()` - Verner's "most efficient" order 8 algorithm.
  - `constructRKF8()` - Runge-Kutta-Fehlberg Order 7/8 method.
  - `constructDormandPrice8()` - Dormand-Prince Order 7/8 method.
  - `constructDormandPrince8_64bit()` - Dormand-Prince Order 7/8 method.
    Coefficients are rational approximations good for 64 bits.
  - `constructVernerRobust9()` - Verner's "most robust" order 9 method.
  - `constructVernerEfficient9()` - Verner's "most efficient" order 9 method.
  - `constructSharp9()` - Sharp's order 9 method.
  - `constructTsitouras9()` - Tsitouras's first order 9 method.
  - `constructTsitouras92()` - Tsitouras's second order 9 method.
  - `constructCurtis10()` - Curtis' order 10 method.
  - `constructOno10()` - Ono's order 10 method.
  - `constructFeagin10Tableau()` - Feagin's order 10 method.
  - `constructCurtis10()` - Curtis' order 10 method.
  - `constructBaker10()` - Baker's order 10 method.
  - `constructHairer10()` Hairer's order 10 method.
  - `constructFeagin12Tableau()` - Feagin's order 12 method.
  - `constructOno12()` - Ono's order 12 method.
  - `constructFeagin14Tableau()` Feagin's order 14 method.

### Implicit Runge-Kutta Methods

  - `constructImplicitEuler` - The 1st order Implicit Euler method.
  - `constructMidpointRule` - The 2nd order Midpoint method.
  - `constructTrapezoidalRule` - The 2nd order Trapezoidal rule (2nd order LobattoIIIA)
  - `constructLobattoIIIA4` - The 4th order LobattoIIIA
  - `constructLobattoIIIB2` - The 2nd order LobattoIIIB
  - `constructLobattoIIIB4` - The 4th order LobattoIIIB
  - `constructLobattoIIIC2` - The 2nd order LobattoIIIC
  - `constructLobattoIIIC4` - The 4th order LobattoIIIC
  - `constructLobattoIIICStar2` - The 2nd order LobattoIIIC*
  - `constructLobattoIIICStar4` - The 4th order LobattoIIIC*
  - `constructLobattoIIID2` - The 2nd order LobattoIIID
  - `constructLobattoIIID4` - The 4th order LobattoIIID
  - `constructRadauIA3` - The 3rd order RadauIA
  - `constructRadauIA5` - The 5th order RadauIA
  - `constructRadauIIA3` - The 3rd order RadauIIA
  - `constructRadauIIA5` - The 5th order RadauIIA

## Tableau Methods

```@docs
DiffEqDevTools.stability_region
OrdinaryDiffEq.ODE_DEFAULT_TABLEAU
```

## Explicit Tableaus

```@docs
DiffEqDevTools.constructEuler
DiffEqDevTools.constructRalston
DiffEqDevTools.constructHeun
DiffEqDevTools.constructKutta3
OrdinaryDiffEq.constructBS3
DiffEqDevTools.constructBogakiShampine3
DiffEqDevTools.constructRK4
DiffEqDevTools.constructRK438Rule
DiffEqDevTools.constructRKF4
DiffEqDevTools.constructRKF5
DiffEqDevTools.constructCashKarp
DiffEqDevTools.constructDormandPrince
OrdinaryDiffEq.constructBS5
DiffEqDevTools.constructPapakostasPapaGeorgiou5
DiffEqDevTools.constructPapakostasPapaGeorgiou52
DiffEqDevTools.constructTsitouras5
DiffEqDevTools.constructLutherKonen5
DiffEqDevTools.constructLutherKonen52
DiffEqDevTools.constructLutherKonen53
DiffEqDevTools.constructRungeFirst5
DiffEqDevTools.constructLawson5
DiffEqDevTools.constructSharpSmart5
DiffEqDevTools.constructBogakiShampine5
DiffEqDevTools.constructCassity5
DiffEqDevTools.constructButcher6
DiffEqDevTools.constructButcher62
DiffEqDevTools.constructButcher63
DiffEqDevTools.constructVernerRobust6
DiffEqDevTools.constructTanakaKasugaYamashitaYazaki6A
DiffEqDevTools.constructTanakaKasugaYamashitaYazaki6B
DiffEqDevTools.constructTanakaKasugaYamashitaYazaki6C
DiffEqDevTools.constructTanakaKasugaYamashitaYazaki6D
DiffEqDevTools.constructHuta6
DiffEqDevTools.constructHuta62
DiffEqDevTools.constructVerner6
DiffEqDevTools.constructDormandPrince6
DiffEqDevTools.constructSharpVerner6
DiffEqDevTools.constructVern6
DiffEqDevTools.constructClassicVerner6
DiffEqDevTools.constructChummund6
DiffEqDevTools.constructChummund62
DiffEqDevTools.constructPapakostas6
DiffEqDevTools.constructLawson6
DiffEqDevTools.constructTsitourasPapakostas6
DiffEqDevTools.constructDormandLockyerMcCorriganPrince6
DiffEqDevTools.constructVernerEfficient6
DiffEqDevTools.constructMikkawyEisa
DiffEqDevTools.constructVernerEfficient7
DiffEqDevTools.constructClassicVerner7
DiffEqDevTools.constructSharpVerner7
DiffEqDevTools.constructTanakaYamashitaStable7
DiffEqDevTools.constructSharpSmart7
DiffEqDevTools.constructTanakaYamashitaEfficient7
DiffEqDevTools.constructVernerRobust7
OrdinaryDiffEq.constructTanYam7
DiffEqDevTools.constructEnrightVerner7
DiffEqDevTools.constructDormandPrince8
DiffEqDevTools.constructRKF8
DiffEqDevTools.constructCooperVerner8
DiffEqDevTools.constructCooperVerner82
DiffEqDevTools.constructTsitourasPapakostas8
DiffEqDevTools.constructEnrightVerner8
DiffEqDevTools.constructdverk78
DiffEqDevTools.constructClassicVerner8
DiffEqDevTools.constructDormandPrince8_64bit
DiffEqDevTools.constructCurtis8
OrdinaryDiffEq.constructTsitPap8
DiffEqDevTools.constructSharp9
DiffEqDevTools.constructTsitouras9
DiffEqDevTools.constructTsitouras92
DiffEqDevTools.constructVernerEfficient9
OrdinaryDiffEq.constructVern9
DiffEqDevTools.constructVerner916
DiffEqDevTools.constructVerner9162
DiffEqDevTools.constructVernerRobust9
DiffEqDevTools.constructFeagin10
DiffEqDevTools.constructFeagin10Tableau
DiffEqDevTools.constructOno10
DiffEqDevTools.constructCurtis10
DiffEqDevTools.constructHairer10
DiffEqDevTools.constructBaker10
DiffEqDevTools.constructFeagin12
DiffEqDevTools.constructOno12
DiffEqDevTools.constructFeagin12Tableau
DiffEqDevTools.constructFeagin14
DiffEqDevTools.constructFeagin14Tableau
```

## Implicit Tableaus

```@docs
DiffEqDevTools.constructImplicitEuler
DiffEqDevTools.constructMidpointRule
DiffEqDevTools.constructTrapezoidalRule
DiffEqDevTools.constructLobattoIIIA4
DiffEqDevTools.constructLobattoIIIB2
DiffEqDevTools.constructLobattoIIIB4
DiffEqDevTools.constructLobattoIIIC2
DiffEqDevTools.constructLobattoIIIC4
DiffEqDevTools.constructLobattoIIICStar2
DiffEqDevTools.constructLobattoIIICStar4
DiffEqDevTools.constructLobattoIIID2
DiffEqDevTools.constructLobattoIIID4
DiffEqDevTools.constructGL2
DiffEqDevTools.constructGL4
DiffEqDevTools.constructGL6
DiffEqDevTools.constructRadauIA3
DiffEqDevTools.constructRadauIA5
DiffEqDevTools.constructRadauIIA3
DiffEqDevTools.constructRadauIIA5
```

```@meta
CollapsedDocStrings = true
```

# OrdinaryDiffEqNordsieck

Nordsieck form multistep methods represent an alternative approach to traditional multistep algorithms. Instead of storing past solution values, these methods maintain a vector of scaled derivatives (similar to Taylor series coefficients) to advance the solution. This representation was pioneered in classic codes like LSODE, VODE, and CVODE.

!!! warning "Research and Development"
    
    These methods are currently in research and development and not intended for general use.

## Key Properties

Nordsieck methods provide:

  - **Derivative-based representation** instead of solution history
  - **Improved restartability** after discontinuities using derivative information
  - **Variable order and stepsize** capabilities
  - **Alternative to history-based** multistep methods
  - **Research and experimental** implementations

## When to Use Nordsieck Methods

These methods are recommended for:

  - **Research applications** exploring alternative multistep representations
  - **Problems with discontinuities** where restartability is important
  - **Experimental comparisons** with traditional multistep methods
  - **Development of discontinuity-aware** algorithms

## Important Limitations

### Experimental Status

  - **Considered experimental** and inferior to modern BDF implementations
  - **Generally recommend FBDF instead** for production use
  - **Maintained for research purposes** and future development
  - **Numerical instabilities** can arise from higher derivative representations

### Performance Considerations

  - **Less robust** than fixed-leading coefficient BDF methods
  - **Higher computational overhead** for derivative maintenance
  - **Potential stability issues** with derivative representations

## Mathematical Background

The Nordsieck form represents the solution using scaled derivatives:
`y_n = [y, h*y', h²*y''/2!, h³*y'''/3!, ...]`

This representation allows reconstruction of the solution and its derivatives, enabling restarts after discontinuities without losing accuracy.

## Solver Selection Guide

### Nordsieck implementations

  - **`AN5`**: Fifth-order Adams method with fixed leading coefficient
  - **`JVODE`**: Variable order Adams/BDF method (experimental LSODE-style)
  - **`JVODE_Adams`**: JVODE configured for Adams methods
  - **`JVODE_BDF`**: JVODE configured for BDF methods

### Recommended alternatives

  - **For most applications**: Use `QNDF` or `FBDF` instead
  - **For stiff problems**: Prefer modern BDF implementations
  - **For research**: These methods are appropriate for experimental work

## Research and Development

These implementations serve as:

  - **Experimental testbed** for Nordsieck form algorithms
  - **Research platform** for discontinuity-aware methods
  - **Development basis** for future improved BDF implementations
  - **Educational examples** of alternative multistep representations

## Usage Guidelines

  - **Not recommended** for production applications
  - **Use FBDF or QNDF** for reliable multistep integration
  - **Consider these methods** only for research or experimental purposes
  - **Expect potentially lower performance** compared to modern alternatives

```@eval
first_steps = evalfile("./common_first_steps.jl")
first_steps("OrdinaryDiffEqNordsieck", "AN5")
```

## Full list of solvers

```@docs
AN5
JVODE
JVODE_Adams
JVODE_BDF
```

```@meta
CollapsedDocStrings = true
```

# [OrdinaryDiffEqExtrapolation](@id StiffExtrapolation)

Solvers based on within method parallelism.
These solvers perform well for medium sized systems of ordinary differential equations, of about 20 to 500 equations,
at low tolerances.

```@eval
first_steps = evalfile("./common_first_steps.jl")
first_steps("OrdinaryDiffEqExtrapolation", "ImplicitEulerBarycentricExtrapolation")
```

## Full list of solvers

```@docs
ImplicitEulerExtrapolation
ImplicitDeuflhardExtrapolation
ImplicitHairerWannerExtrapolation
ImplicitEulerBarycentricExtrapolation
```

# Developing A New Problem

New problems should be defined for new types of differential equations, new partial
differential equations, and special subclasses of differential equations for which
solvers can dispatch on for better performance.

To develop a new problem, you need to make a new `DEProblem` and a new `DESolution`.
These types belong in DiffEqBase and should be exported.
The `DEProblem` type should hold all of the mathematical information about the
problem (including all of the meshing information in both space and time),
and the `DESolution` should hold all of the information for the solution.
Then all that is required is to define a `__solve(::DEProblem,alg;kwargs)`
which takes in the problem and returns a solution.

Then to check that the algorithm works, add a dispatch for `test_convergence`
which makes a `ConvergenceSimulation` type. This type already has a plot recipe, so
plotting functionality will already be embedded. This requires that your
problem can take in a true solution, and has a field `errors` which is a
dictionary of symbols for the different error estimates (L2,L infinity, etc.)

After these steps, update the documentation to include the new problem types and
the new associated solvers.

```@meta
CollapsedDocStrings = true
```

# OrdinaryDiffEqBDF

BDF (Backward Differentiation Formula) methods for fully implicit differential-algebraic equations (DAEs) in the form F(du/dt, u, t) = 0. These methods provide robust integration for index-1 DAE systems with fully implicit formulations.

!!! warn "Performance Consideration"
    
    DFBDF and family have not been made fully efficient yet, and thus Sundials.jl IDA is recommended for production use.

## Key Properties

Fully implicit DAE BDF methods provide:

  - **General DAE capability** for F(du/dt, u, t) = 0 formulations
  - **Index-1 DAE support** for properly formulated DAE systems
  - **Robust nonlinear solver integration** for implicit equation systems
  - **High-order accuracy** with excellent stability properties
  - **Large stiff system capability** with efficient linear algebra

## When to Use Fully Implicit DAE BDF Methods

These methods are recommended for:

  - **Fully implicit DAE systems** where F(du/dt, u, t) = 0 cannot be easily rearranged
  - **Index-1 DAE problems** that cannot be easily rearranged to semi-explicit form
  - **Multibody dynamics** with complex kinematic constraints
  - **Electrical circuits** with ideal components and algebraic loops
  - **Chemical engineering** with equilibrium and conservation constraints
  - **Large-scale DAE systems** requiring robust implicit integration

## Mathematical Background

Fully implicit DAEs have the general form:
F(du/dt, u, t) = 0

Unlike semi-explicit forms, these cannot be written as du/dt = f(u,t) even after constraint elimination. BDF methods discretize the time derivative using backward differences and solve the resulting nonlinear system at each timestep.

## Problem Formulation

Use `DAEProblem` with implicit function specification:

```julia
function f2(out, du, u, p, t)
    out[1] = -0.04u[1] + 1e4 * u[2] * u[3] - du[1]
    out[2] = +0.04u[1] - 3e7 * u[2]^2 - 1e4 * u[2] * u[3] - du[2]
    out[3] = u[1] + u[2] + u[3] - 1.0
end
u₀ = [1.0, 0, 0]
du₀ = [-0.04, 0.04, 0.0]
tspan = (0.0, 100000.0)
differential_vars = [true, true, false]
prob = DAEProblem(f2, du₀, u₀, tspan, differential_vars = differential_vars)
sol = solve(prob, DFBDF())
```

## Solver Selection Guide

### Recommended DAE Methods

  - **`DFBDF`**: **Recommended** - Variable-order BDF for general DAE systems
  - **`DImplicitEuler`**: For non-smooth problems with discontinuities

### Method characteristics

  - **`DFBDF`**: Most robust and efficient for general smooth DAE problems
  - **`DImplicitEuler`**: Best choice for problems with discontinuities, events, or non-smooth behavior

## Performance Guidelines

### When fully implicit DAE BDF methods excel

  - **Index-1 DAE systems** with complex implicit structure
  - **Complex constraint structures** with multiple algebraic relationships
  - **Large-scale problems** where specialized DAE methods are essential
  - **Multiphysics simulations** with mixed differential-algebraic structure
  - **Problems where semi-explicit formulation is impractical**

### Index considerations

  - **Index-1 formulation required**: Problems should be written in index-1 form
  - **Compare with mass matrix methods**: For some index-1 problems, mass matrix formulation may be more efficient
  - **Higher-index problems**: Should be reduced to index-1 form before using these methods

## Important DAE Requirements

### Initial conditions

  - **Both u₀ and du₀** must be provided and consistent with constraints
  - **differential_vars** specification helps identify algebraic variables
  - **Consistent initialization** is crucial for index-1 DAE problems

### Function specification

  - **Residual form**: F(du/dt, u, t) = 0 with F returning zero for satisfied equations
  - **Proper scaling**: Ensure equations are well-conditioned numerically
  - **Jacobian availability**: Analytical Jacobians improve performance when available

## Alternative Approaches

Consider these alternatives:

  - **Mass matrix DAE methods** for index-1 problems with M du/dt = f(u,t) structure
  - **Index reduction techniques** using [ModelingToolkit.jl](https://docs.sciml.ai/ModelingToolkit/stable/) to convert problems to index-1 form if needed
  - **Constraint stabilization** methods for drift control
  - **Projection methods** for manifold preservation

For more details on DAE formulations and alternative approaches, see [this blog post on Neural DAEs](https://www.stochasticlifestyle.com/machine-learning-with-hard-constraints-neural-differential-algebraic-equations-daes-as-a-general-formalism/).

```@eval
first_steps = evalfile("./common_first_steps.jl")
first_steps("OrdinaryDiffEqBDF", "DFBDF")
```

## Full list of solvers

### DAE

```@docs
DImplicitEuler
DABDF2
DFBDF
```

# Test Problems

For every problem, one can turn it into a test problem by adding `analytical`
to the `DEFunction`.

## No Analytical Solution

However, in many cases the analytical solution cannot be found, and therefore
one uses a low-tolerance calculation as a stand-in for a solution. The JuliaDiffEq
ecosystem supports this through the `TestSolution` type in DiffEqDevTools. There
are three constructors. The code is simple, so here it is:

```julia
mutable struct TestSolution <: DESolution
    t::Any
    u::Any
    interp::Any
    dense::Any
end
(T::TestSolution)(t) = T.interp(t)
TestSolution(t, u) = TestSolution(t, u, nothing, false)
TestSolution(t, u, interp) = TestSolution(t, u, interp, true)
TestSolution(interp::DESolution) = TestSolution(nothing, nothing, interp, true)
```

This acts like a solution. When used in conjunction with `apprxtrue`:

```julia
appxtrue(sol::AbstractODESolution, sol2::TestSolution)
```

you can use it to build a `TestSolution` from a problem (like `ODETestSolution`)
which holds the errors  If you only give it `t` and `u`, then it can only calculate
the final error. If the `TestSolution` has an interpolation, it will define
timeseries and dense errors.

(Note: I would like it so that way the timeseries
error will be calculated on the times of `sol.t in sol2.t` which would act nicely
with `tstops` and when interpolations don't exist, but haven't gotten to it!)

These can then be passed to other functionality. For example, the benchmarking
functions allow one to set `appxsol` which is a `TestSolution` for the benchmark
solution to calculate errors against, and `error_estimate` allows one to choose
which error estimate to use in the benchmarking (defaults to `:final`).

## Related Functions

```@docs
DiffEqDevTools.appxtrue
```

```@meta
CollapsedDocStrings = true
```

# OrdinaryDiffEqExponentialRK

Exponential Runge-Kutta methods are specialized integrators for semi-linear differential equations of the form `du/dt = Au + f(u,t)`, where `A` is a linear operator (often representing diffusion or dispersion) and `f` represents nonlinear terms. These methods are particularly effective for stiff linear parts combined with non-stiff nonlinear terms. **Important**: The nonlinear term `f(u,t)` must be non-stiff for these methods to be effective.

## Key Properties

Exponential RK methods provide:

  - **Exact treatment of linear parts** using matrix exponential functions
  - **High-order accuracy** for both linear and nonlinear components
  - **Excellent stability properties** for problems with stiff linear operators
  - **Efficient handling of semi-linear PDEs** after spatial discretization
  - **Reduced timestep restrictions** compared to traditional explicit methods
  - **Preservation of qualitative behavior** for many physical systems

## When to Use Exponential RK Methods

These methods are recommended for:

  - **Semi-linear PDEs** with stiff diffusion/dispersion and moderate **non-stiff** nonlinearity
  - **Reaction-diffusion systems** with fast diffusion and slower **non-stiff** reactions
  - **Nonlinear Schrödinger equations** and other dispersive wave equations with **non-stiff** nonlinear terms
  - **Pattern formation problems** (Turing patterns, phase field models) where nonlinearity is **non-stiff**
  - **Quantum dynamics** with linear Hamiltonian and **non-stiff** nonlinear interactions
  - **Problems with strong linear damping** or oscillatory linear parts combined with **non-stiff** nonlinear terms
  - **Spatially discretized PDEs** where the linear part dominates stiffness but the nonlinear part remains **non-stiff**

## Mathematical Background

For problems `du/dt = Au + f(u,t)`, exponential methods compute the exact solution of the linear part `Au` using `exp(A*dt)` and treat the nonlinear part `f(u,t)` with Runge-Kutta-like stages. This approach is particularly effective when `A` represents well-understood physics (diffusion, dispersion, linear oscillations).

## Solver Selection Guide

### Basic exponential time differencing (ETD)

  - **`LawsonEuler`**: First-order exponential Euler method
  - **`NorsettEuler`** / **`ETD1`**: Alternative first-order scheme
  - **`ETDRK2`**: Second-order exponential RK
  - **`ETDRK3`**: Third-order exponential RK
  - **`ETDRK4`**: Fourth-order exponential RK, popular choice
  - **`ETD2`**: Second-order exponential time differencing (in development)

### High-order specialized methods

  - **`HochOst4`**: Fourth-order exponential RK with enhanced stability
  - **`Exp4`**: Fourth-order EPIRK scheme

### Adaptive exponential Rosenbrock

  - **`Exprb32`**: Third-order adaptive method with error control
  - **`Exprb43`**: Fourth-order adaptive method

### EPIRK (Exponential Propagation Iterative RK) methods

  - **`EPIRK4s3A`**: Fourth-order with stiff order 4
  - **`EPIRK4s3B`**: Alternative fourth-order variant
  - **`EPIRK5s3`**: Fifth-order method (note: marked as broken)
  - **`EXPRB53s3`**: Fifth-order with stiff order 5
  - **`EPIRK5P1`**, **`EPIRK5P2`**: Fifth-order variants

## Performance Recommendations

  - **For most semi-linear problems**: `ETDRK4`
  - **For adaptive stepsize**: `Exprb43`
  - **For high stiffness in linear part**: `EPIRK4s3A` or `EPIRK4s3B`
  - **For maximum accuracy**: `EXPRB53s3`

## Implementation Requirements

These methods require:

  - **Computation of matrix exponentials** `exp(A*dt)` and related functions
  - **Krylov subspace methods** for large systems (automatic in most cases)
  - **Proper problem formulation** with identified linear and nonlinear parts

## Installation

To be able to access the solvers in `OrdinaryDiffEqLinear`, you must first install them use the Julia package manager:

```julia
using Pkg
Pkg.add("OrdinaryDiffEqExponentialRK")
```

This will only install the solvers listed at the bottom of this page.
If you want to explore other solvers for your problem,
you will need to install some of the other libraries listed in the navigation bar on the left.

## Example usage

```@eval
first_steps = evalfile("./common_first_steps.jl")
first_steps("OrdinaryDiffEqExponentialRK", "EPIRK5s3")
```

## Full list of solvers

```@docs; canonical=false
LawsonEuler
NorsettEuler
ETD2
ETDRK2
ETDRK3
ETDRK4
HochOst4
```

### Adaptive Exponential Rosenbrock Methods

```@docs
Exprb32
Exprb43
```

### Exponential Propagation Iterative Runge-Kutta Methods (EPIRK)

```@docs
Exp4
EPIRK4s3A
EPIRK4s3B
EPIRK5s3
EXPRB53s3
EPIRK5P1
EPIRK5P2
```

```@meta
CollapsedDocStrings = true
```

# OrdinaryDiffEqIMEXMultistep

Standard low-order IMEX (Implicit-Explicit) multistep methods for problems that can be split into stiff and non-stiff components. These are widely used classical methods in partial differential equation applications, providing simple and reliable IMEX integration with moderate accuracy requirements.

## Key Properties

IMEX Multistep methods provide:

  - **Standard IMEX formulations** commonly used in PDE applications
  - **Low-order accuracy** (typically 2nd order) with good stability
  - **Simple implementation** and well-understood behavior
  - **Explicit treatment** of non-stiff terms with implicit handling of stiff components
  - **Fixed timestep requirements** due to multistep nature
  - **Efficient for large-scale problems** where splitting is natural

## When to Use IMEX Multistep Methods

These methods are recommended for:

  - **Classical PDE applications** where standard IMEX methods are established
  - **Reaction-diffusion systems** with natural explicit/implicit splitting
  - **Convection-diffusion problems** where convection is explicit and diffusion implicit
  - **Large-scale spatial discretizations** where simple, efficient methods are preferred
  - **Applications prioritizing robustness** over high-order accuracy
  - **Problems with natural operator splitting** methodology

## Mathematical Background

IMEX multistep methods treat the split system:
`du/dt = f₁(u,t) + f₂(u,t)`

using:

  - **Implicit multistep schemes** (like Crank-Nicolson) for stiff terms f₁
  - **Explicit multistep schemes** (like Adams-Bashforth) for non-stiff terms f₂

This combination provides stability for stiff components while maintaining efficiency for non-stiff parts.

## Problem Splitting Requirements

These methods require a `SplitODEProblem` where:

  - **First function** `f₁` contains stiff terms requiring implicit treatment
  - **Second function** `f₂` contains non-stiff terms suitable for explicit treatment
  - **Splitting should align** with the natural time scale separation
  - **Linear stiff terms** work particularly well with these methods

## Solver Selection Guide

### Available Methods

  - **`CNAB2`**: **Recommended** - Crank-Nicolson Adams-Bashforth 2nd order method
  - **`CNLF2`**: Crank-Nicolson Leap-Frog 2nd order method

### Method characteristics

  - **`CNAB2`**: Most commonly used, good stability and accuracy balance
  - **`CNLF2`**: Alternative formulation, may have different stability properties

## Performance Guidelines

### When IMEX Multistep methods excel

  - **PDE problems** with established IMEX splitting practices
  - **Large spatial discretizations** where method efficiency matters more than high accuracy
  - **Problems with linear stiff terms** that are efficiently handled implicitly
  - **Applications requiring consistent timesteps** (no adaptive timestepping)
  - **Well-conditioned problems** where simple methods suffice

### Splitting strategy considerations

  - **Linear diffusion terms** → implicit component (f₁)
  - **Nonlinear convection/reaction** → explicit component (f₂) if not too stiff
  - **Source terms** → choose based on stiffness characteristics
  - **Boundary conditions** → often naturally handled in implicit component

## Limitations and Considerations

### Method limitations

  - **Fixed timestep required** - no adaptive timestepping capabilities
  - **Low order only** - maximum 2nd order accuracy
  - **Startup procedures** needed for multistep methods
  - **Limited stability analysis** compared to modern IMEX-RK methods

### When to consider alternatives

  - **Higher accuracy needs**: Use IMEX-RK or higher-order IMEX methods
  - **Adaptive timestepping**: Use IMEX-RK or ARK methods
  - **Complex stability requirements**: Use more sophisticated IMEX schemes
  - **Very stiff problems**: Consider fully implicit methods

## Alternative Approaches

Consider these alternatives:

  - **IMEX Runge-Kutta** methods for adaptive timestepping and higher order
  - **IMEX BDF methods** for better stability properties and higher accuracy
  - **Fully implicit methods** if splitting is not beneficial
  - **Exponential integrators** for linear stiff problems

## Classical Applications

These methods are standard in:

  - **Computational fluid dynamics** for incompressible Navier-Stokes equations
  - **Atmospheric modeling** for advection-diffusion-reaction systems
  - **Ocean modeling** for transport equations with diffusion
  - **Astrophysical simulations** for multiphysics problems

```@eval
imex_first_steps = evalfile("./common_imex_first_steps.jl")
imex_first_steps("OrdinaryDiffEqIMEXMultistep", "CNAB2")
```

## Full list of solvers

```@docs
CNAB2
CNLF2
```

# Benchmark Suite

DifferentialEquations.jl provides a benchmarking suite to be able to test the
difference in error, speed, and efficiency between algorithms. DifferentialEquations.jl includes current benchmarking notebooks to help users
understand the performance of the methods. These benchmarking notebooks use the included benchmarking suite. There are two parts to the benchmarking suite: shootouts and work-precision. The `Shootout` tests methods head-to-head for timing and error on the same problem. A `WorkPrecision` draws a work-precision diagram
for the algorithms in question on the chosen problem.

### Rendered Benchmarks

The rendered SciML Benchmarks can be found at [benchmarks.sciml.ai](https://benchmarks.sciml.ai/stable/). The source code
for the benchmarks can be found at [https://github.com/SciML/SciMLBenchmarks.jl](https://github.com/SciML/SciMLBenchmarks.jl).

### Shootout

A
shootout is where you compare between algorithms. For example, to see how
different Runge-Kutta algorithms fair against each other, one can define a setup
which is a dictionary of Symbols to Any, where the symbol is the keyword argument.
Then you call `Shootout` on that setup. The code is as follows:

```julia
using OrdinaryDiffEq, DiffEqProblemLibrary.ODEProblemLibrary, DiffEqDevTools, ODE,
      ODEInterface, ODEInterfaceDiffEq

ODEProblemLibrary.importodeproblems()
prob = ODEProblemLibrary.prob_ode_2Dlinear
setups = [Dict(:alg => DP5())
          Dict(:abstol => 1e-3, :reltol => 1e-6, :alg => ode45()) # Fix ODE to be normal
          Dict(:alg => dopri5())]
names = ["DifferentialEquations"; "ODE"; "ODEInterface"]
shoot = Shootout(prob, setups; dt = 1 / 2^(10), names = names)
```

Note that keyword arguments applied to `Shootout` are applied to every run, so
in this example every run has the same starting timestep.  Here we explicitly chose names.
If you don't, then the algorithm name is the default.
This returns a Shootout type which holds the times it took for each algorithm
and the errors. Using these, it calculates the efficiency defined as
1/(error*time), i.e. if the error is low or the run was quick then
it's efficient. `print(shoot)` will show all of this information,
and `plot(shoot)` will show the efficiencies of the algorithms
in comparison to each other.

For every benchmark function there is a special keyword `numruns` which controls
the number of runs used in the time estimate. To be more precise, these functions
by default run the algorithm 20 times on the problem and take the average time.
This amount can be increased and decreased as needed.

The keyword `appxsol` allows for specifying a reference against which the error is computed.
The method of error computation can be specified by the keyword `error_estimate` with values `:L2` for the L2 error over the solution time interval, `:l2` calculates the l2 error at the actual steps and the default `:final` only compares the endpoints.

A ShootoutSet is a where you define a vector of probs and tspans and run a shootout
on each of these values.

### WorkPrecision

A WorkPrecision calculates the necessary componnets of a work-precision plot. This
shows how time scales with the user chosen tolerances on a given problem. To make
a WorkPrecision, you give it a vector of absolute and relative tolerances:

```julia
abstols = 1 ./ 10 .^ (3:10)
reltols = 1 ./ 10 .^ (3:10)
wp = WorkPrecision(prob, DP5(), abstols, reltols; name = "Dormand-Prince 4/5")
```

If we want to plot many WorkPrecisions together in order to compare between
algorithms, you can make a WorkPrecisionSet. To do so, you pass the setups
into the function as well:

```julia
wp_set = WorkPrecisionSet(prob, tspan, abstols, reltols, setups; numruns = 2)
setups = [Dict(:alg => RK4()); Dict(:alg => Euler()); Dict(:alg => BS3());
          Dict(:alg => Midpoint()); Dict(:alg => BS5()); Dict(:alg => DP5())]
wp_set = WorkPrecisionSet(prob, abstols, reltols, setups; dt = 1 / 2^4, numruns = 2)
```

Both of these types have a plot recipe to produce a work-precision diagram,
and a print which will show some relevant information.

```@meta
CollapsedDocStrings = true
```

# OrdinaryDiffEqLinear

Specialized methods for linear and semi-linear differential equations where the system can be written in matrix form `du/dt = A(t,u) * u` or `du/dt = A(t) * u`. These methods exploit the linear structure to provide exact solutions or highly accurate integration.

## Key Properties

Linear ODE methods provide:

  - **Exact solutions** for time-independent linear systems
  - **Geometric integration** preserving Lie group structure
  - **High-order Magnus expansions** for time-dependent linear systems
  - **Lie group methods** for matrix differential equations
  - **Excellent stability** for a wide range of linear systems
  - **Specialized algorithms** for different types of linear operators

## When to Use Linear Methods

These methods are essential for:

  - **Linear systems** `du/dt = A * u` with constant or time-dependent matrices
  - **Matrix differential equations** on Lie groups (rotation matrices, etc.)
  - **Quantum dynamics** with Hamiltonian evolution
  - **Linear oscillators** and harmonic systems
  - **Time-dependent linear systems** with periodic or smooth coefficients
  - **Geometric mechanics** requiring preservation of group structure

## Mathematical Background

For linear systems `du/dt = A(t) * u`, the exact solution is `u(t) = exp(∫A(s)ds) * u₀`. Linear methods approximate this matrix exponential using various mathematical techniques like Magnus expansions, Lie group integrators, and specialized exponential methods.

## Solver Selection Guide

### Time and state-independent (constant A)

  - **`LinearExponential`**: Exact solution for `du/dt = A * u` with constant matrix A

### Time-dependent, state-independent (A(t))

  - **`MagnusMidpoint`**: Second-order Magnus method
  - **`MagnusLeapfrog`**: Second-order Magnus leapfrog scheme
  - **`MagnusGauss4`**: Fourth-order with Gauss quadrature
  - **`MagnusGL4`**: Fourth-order Gauss-Legendre Magnus method
  - **`MagnusGL6`**: Sixth-order Gauss-Legendre Magnus method
  - **`MagnusGL8`**: Eighth-order Gauss-Legendre Magnus method
  - **`MagnusNC6`**: Sixth-order Newton-Cotes Magnus method
  - **`MagnusNC8`**: Eighth-order Newton-Cotes Magnus method

### State-dependent (A(u))

  - **`LieEuler`**: First-order Lie group method
  - **`RKMK2`**: Second-order Runge-Kutta-Munthe-Kaas method
  - **`RKMK4`**: Fourth-order Runge-Kutta-Munthe-Kaas method
  - **`LieRK4`**: Fourth-order Lie Runge-Kutta method
  - **`CG2`**: Second-order Crouch-Grossman method
  - **`CG4a`**: Fourth-order Crouch-Grossman method
  - **`CayleyEuler`**: First-order method using Cayley transformations

### Adaptive methods

  - **`MagnusAdapt4`**: Fourth-order adaptive Magnus method

### Time and state-dependent (A(t,u))

  - **`CG3`**: Third-order Crouch-Grossman method for most general case

## Method Selection Guidelines

  - **For constant linear systems**: `LinearExponential` (exact)
  - **For time-dependent systems**: Magnus methods based on desired order
  - **For matrix Lie groups**: Lie group methods (RKMK, LieRK4, CG)
  - **For high accuracy**: Higher-order Magnus methods (GL6, GL8)
  - **For adaptive integration**: `MagnusAdapt4`

## Special Considerations

These methods require:

  - **Proper problem formulation** with identified linear structure
  - **Matrix operator interface** for operator-based problems
  - **Understanding of Lie group structure** for geometric problems

## Installation

To be able to access the solvers in `OrdinaryDiffEqLinear`, you must first install them use the Julia package manager:

```julia
using Pkg
Pkg.add("OrdinaryDiffEqLinear")
```

This will only install the solvers listed at the bottom of this page.
If you want to explore other solvers for your problem,
you will need to install some of the other libraries listed in the navigation bar on the left.

## Example usage

```julia
using OrdinaryDiffEqLinear, SciMLOperators
function update_func!(A, u, p, t)
    A[1, 1] = 0
    A[2, 1] = sin(u[1])
    A[1, 2] = -1
    A[2, 2] = 0
end
A0 = ones(2, 2)
A = MatrixOperator(A0, update_func! = update_func!)
u0 = ones(2)
tspan = (0.0, 30.0)
prob = ODEProblem(A, u0, tspan)
sol = solve(prob, LieRK4(), dt = 1 / 4)
```

## Full list of solvers

### Time and State-Independent Solvers

```@docs
LinearExponential
```

### Time-Dependent and State-Independent Solvers

```@docs
MagnusMidpoint
MagnusLeapfrog
MagnusGauss4
MagnusNC6
MagnusGL6
MagnusGL8
MagnusNC8
MagnusGL4
```

### State-Dependent Solvers

```@docs
LieEuler
RKMK2
RKMK4
LieRK4
CG2
CG4a
MagnusAdapt4
CayleyEuler
```

### Time and State-Dependent Operators

```@docs
CG3
```

```@meta
CollapsedDocStrings = true
```

# [OrdinaryDiffEqVerner](@id OrdinaryDiffEqVerner)

Verner methods are high-order explicit Runge-Kutta methods designed for high-accuracy integration of non-stiff differential equations. These are the preferred solvers when very low tolerances are required.

## Key Properties

Verner methods provide:

  - **High-order accuracy** (6th through 9th order) for precise integration
  - **Excellent efficiency** at low tolerances (1e-8 to 1e-15)
  - **Robust error estimation** with embedded error control
  - **Dense output capability** with high-quality interpolation

## When to Use Verner Methods

Verner methods are recommended for:

  - **High-accuracy requirements** with tolerances between 1e-8 and 1e-15
  - **Smooth non-stiff problems** where high precision is critical
  - **Long-time integration** where error accumulation must be minimized
  - **Problems requiring dense output** with high interpolation accuracy
  - **Orbit computation, molecular dynamics,** and other precision-critical applications

## Solver Selection Guide

### Medium-low tolerance (1e-6 to 1e-8)

  - **`Vern6`**: Sixth-order method, good balance of efficiency and accuracy
  - **`AutoVern6`**: Automatic switching version for mixed stiffness

### Low tolerance (1e-8 to 1e-12) with Float64

  - **`Vern7`**: Seventh-order method, excellent for most high-precision needs
  - **`Vern8`**: Eighth-order method, best efficiency at very low tolerances
  - **`AutoVern7`**, **`AutoVern8`**: Automatic switching versions

### Very low tolerance (<1e-12)

  - **`Vern9`**: Ninth-order method for extreme precision requirements
  - **Recommended with `BigFloat`** for tolerances below 1e-15
  - **`AutoVern9`**: Automatic switching version for mixed problems

## Performance Notes

  - **Vern6**: Most efficient for tolerances around 1e-6 to 1e-8
  - **Vern7**: Sweet spot for tolerances around 1e-8 to 1e-10
  - **Vern8**: Best for tolerances around 1e-10 to 1e-12
  - **Vern9**: For tolerances below 1e-12, especially with arbitrary precision

The `Auto*` variants automatically switch to stiff solvers when stiffness is detected, making them robust for problems of unknown character.

```@eval
first_steps = evalfile("./common_first_steps.jl")
first_steps("OrdinaryDiffEqVerner", "Vern6")
```

## Full list of solvers

```@docs
Vern6
Vern7
Vern8
Vern9
```

```@docs
AutoVern6
AutoVern7
AutoVern8
AutoVern9
```

# Adding a new package to the common interface

DiffEq's distributed infrastructure allows anyone to add new packages to the
common interface. This set of the documentation explains how this is done.
An example package is [DASRK.jl](https://github.com/JuliaDiffEq/DASKR.jl/blob/master/src/common.jl)
whose full common interface bindings are contained in `common.jl`.

## Defining the types

You should start by defining a common supertype for all your algorithm types.
DASKR has DAE algorithms, so it defines

```julia
abstract type DASKRDAEAlgorithm{LinearSolver} <: DiffEqBase.AbstractDAEAlgorithm end
```

that its algorithms are all `AbstractDAEAlgorithm`s and gives them a possible
type parameter as well. Then the concrete algorithms are specified. Special
options (i.e. non-common interface options) for the algorithm go in this type.
Here there is a choice for a linear solver internally, so we allow the user
to set this:

```julia
struct daskr{LinearSolver} <: DASKRDAEAlgorithm{LinearSolver} end
daskr(; linear_solver = :Dense) = daskr{linear_solver}()
```

In many (most?) cases, no extra constructor is needed since there are no
extra options.

## Defining the overloads

Now you need to add DiffEqBase. The package should reexport `DiffEqBase.jl` to
make using it alone act naturally, and this is done by:

```julia
using Reexport
@reexport using DiffEqBase
```

now we overload `__solve` from `DiffEqBase.jl` to act on our algorithm. Here's a
possible signature:

```julia
function DiffEqBase.__solve{uType, duType, tType, isinplace, LinearSolver}(
        prob::AbstractDAEProblem{uType, duType, tType, isinplace},
        alg::DASKRDAEAlgorithm{LinearSolver},
        timeseries = [], ts = [], ks = []; verbose = true,
        callback = nothing, abstol = 1 / 10^6, reltol = 1 / 10^3,
        saveat = Float64[], adaptive = true, maxiters = Int(1e5),
        timeseries_errors = true, save_everystep = isempty(saveat), dense = save_everystep,
        save_start = true, save_timeseries = nothing,
        userdata = nothing,
        kwargs...)
    # do something
end
```

Basically you just dispatch on your algorithm supertype (and refine the `Problem`
choice as well so it errors on the wrong problem types), then list the common
interface options. `timeseries = [], ts = [], ks = [];` are for pre-allocation
of arrays, and this may change in the near future but you can use this to pre-allocate
the `t`, `u`, and `k` arrays (`k` being internal steps if saved).

## Defining the solution

In `solve` you do option handling and call your solver. At the end, you return
the solution via:

```julia
build_solution(prob, alg, ts, timeseries,
    du = dures,
    dense = dense,
    timeseries_errors = timeseries_errors,
    retcode = :Success)
```

Giving `du` is only currently allowed for DAEs and is optional. The errors
flags (`timeseries_errors` and `dense_errors`) are flags for allowing the solution
to calculate errors which should be passed through the `solve` function if
applicable. A proper `retcode` should be placed or it will default to `:Default`.

```@meta
CollapsedDocStrings = true
```

# OrdinaryDiffEqStabilizedIRK

Stabilized Implicit Runge-Kutta (IMEX) methods combine the benefits of stabilized explicit methods with implicit treatment of problematic eigenvalues. These IMEX schemes are designed for problems where the Jacobian has both large real eigenvalues (suitable for explicit stabilized methods) and large complex eigenvalues (requiring implicit treatment).

## Key Properties

Stabilized IRK methods provide:

  - **IMEX formulation** treating different stiffness components appropriately
  - **Large stability regions** for real eigenvalues via explicit stabilized schemes
  - **Implicit treatment** of complex eigenvalues for unconditional stability
  - **Efficient handling** of mixed stiffness characteristics
  - **Splitting-based approach** requiring `SplitODEProblem` formulation

## When to Use Stabilized IRK Methods

These methods are recommended for:

  - **Mixed stiffness problems** with both real and complex eigenvalues
  - **Parabolic PDEs with convection** where diffusion and advection have different scales
  - **Reaction-diffusion systems** with stiff reactions and moderate diffusion
  - **Problems where pure explicit stabilized methods fail** due to complex eigenvalues
  - **Large-scale systems** where full implicit methods are too expensive

## Mathematical Background

Standard stabilized explicit methods (like RKC, ROCK) achieve large stability regions along the negative real axis but struggle with complex eigenvalues. Stabilized IRK methods address this by:

 1. **Explicit stabilized treatment** for large real eigenvalues
 2. **Implicit treatment** for complex eigenvalues
 3. **IMEX coupling** to maintain overall stability and accuracy

## Problem Splitting Requirements

These methods require a `SplitODEProblem` where:

  - **First component** contains terms with large real eigenvalues (explicit treatment)
  - **Second component** contains terms with complex eigenvalues (implicit treatment)
  - **Splitting design** is crucial for method performance

## Spectral Radius Estimation

Users can supply an upper bound on the spectral radius:

```julia
eigen_est = (integrator) -> integrator.eigen_est = upper_bound
```

This bound applies to the explicit component of the split problem.

## Solver Selection Guide

### Available methods

  - **`IRKC`**: Implicit Runge-Kutta-Chebyshev method for mixed stiffness problems

### Usage considerations

  - **Requires careful splitting** of the problem components
  - **Spectral radius estimation** needed for explicit component
  - **Test splitting strategies** for optimal performance
  - **Compare with pure implicit** or explicit stabilized alternatives

## Performance Guidelines

### When IMEX stabilized methods excel

  - **Mixed eigenvalue distribution** (both real and complex)
  - **Moderate to large systems** where splitting is natural
  - **Problems where neither pure explicit nor implicit** methods are ideal

### Splitting strategy considerations

  - **Identify dominant eigenvalue types** in different terms
  - **Real-dominated terms** → explicit component
  - **Complex-dominated terms** → implicit component
  - **Test different splittings** for best performance

## Alternative Approaches

Consider these alternatives:

  - **Pure implicit methods** (BDF, SDIRK, Rosenbrock) for highly stiff problems
  - **Explicit stabilized methods** (ROCK, RKC) if complex eigenvalues are small
  - **Standard IMEX methods** for natural explicit/implicit splitting

```@eval
imex_first_steps = evalfile("./common_imex_first_steps.jl")
imex_first_steps("OrdinaryDiffEqStabilizedIRK", "IRKC")
```

## Full list of solvers

```@docs
IRKC
```

```@meta
CollapsedDocStrings = true
```

# OrdinaryDiffEqAdamsBashforthMoulton

Adams-Bashforth and Adams-Moulton multistep methods for non-stiff differential equations. **Note that Runge-Kutta methods generally come out as more efficient in benchmarks, except when the ODE function `f` is expensive to evaluate or the problem is very smooth.** These methods can achieve high accuracy with fewer function evaluations per step than Runge-Kutta methods in those specific cases.

## Key Properties

Adams-Bashforth-Moulton methods provide:

  - **Reduced function evaluations** compared to Runge-Kutta methods
  - **High efficiency** for expensive-to-evaluate functions
  - **Multistep structure** using information from previous timesteps
  - **Variable step and order** capabilities for adaptive integration
  - **Predictor-corrector variants** for enhanced accuracy and stability
  - **Good stability properties** for non-stiff problems

## When to Use Adams-Bashforth-Moulton Methods

These methods are recommended for:

  - **Expensive function evaluations** where minimizing calls to `f` is critical
  - **Non-stiff smooth problems** with regular solution behavior
  - **Long-time integration** where efficiency over many steps matters
  - **Problems with expensive Jacobian computations** that cannot use implicit methods efficiently
  - **Scientific computing applications** with computationally intensive right-hand sides
  - **Systems where startup cost** of multistep methods is amortized over long integration

## Method Types

### Explicit Adams-Bashforth (AB)

Pure explicit multistep methods using only past information:

  - **Lower computational cost** per step
  - **Less stability** than predictor-corrector variants
  - **Good for mildly stiff** problems

### Predictor-Corrector Adams-Bashforth-Moulton (ABM)

Implicit corrector step for enhanced accuracy:

  - **Better accuracy** than pure explicit methods
  - **Improved stability** properties
  - **Slightly higher cost** but often worth it

## Solver Selection Guide

### Primary recommendation

  - **`VCABM`**: **Main recommendation** - adaptive order variable-step Adams-Bashforth-Moulton, best overall choice for Adams methods

### Variable-step predictor-corrector methods

  - **`VCABM3`**: Third-order variable-step Adams-Bashforth-Moulton
  - **`VCABM4`**: Fourth-order variable-step Adams-Bashforth-Moulton
  - **`VCABM5`**: Fifth-order variable-step Adams-Bashforth-Moulton

### Variable-step Adams-Bashforth methods

  - **`VCAB3`**: Third-order variable-step Adams-Bashforth
  - **`VCAB4`**: Fourth-order variable-step Adams-Bashforth
  - **`VCAB5`**: Fifth-order variable-step Adams-Bashforth

### Fixed-step predictor-corrector methods

  - **`ABM32`**: Third-order Adams-Bashforth-Moulton
  - **`ABM43`**: Fourth-order Adams-Bashforth-Moulton
  - **`ABM54`**: Fifth-order Adams-Bashforth-Moulton

### Fixed-step explicit methods

  - **`AB3`**: Third-order Adams-Bashforth
  - **`AB4`**: Fourth-order Adams-Bashforth
  - **`AB5`**: Fifth-order Adams-Bashforth

## Performance Considerations

  - **Most efficient** when function evaluation dominates computational cost
  - **Startup phase** requires initial steps from single-step method
  - **Memory efficient** compared to high-order Runge-Kutta methods
  - **Best for smooth problems** - avoid for problems with discontinuities

```@eval
first_steps = evalfile("./common_first_steps.jl")
first_steps("OrdinaryDiffEqAdamsBashforthMoulton", "VCABM")
```

## Full list of solvers

### Explicit Multistep Methods

```@docs
AB3
AB4
AB5
```

### Predictor-Corrector Methods

```@docs
ABM32
ABM43
ABM54
VCAB3
VCAB4
VCAB5
VCABM3
VCABM4
VCABM5
VCABM
```

```@meta
CollapsedDocStrings = true
```

# OrdinaryDiffEqFIRK

Fully Implicit Runge-Kutta (FIRK) methods for stiff differential equations requiring very high accuracy. These methods solve a fully coupled implicit system at each timestep, providing superior accuracy and stability compared to diagonally implicit methods.

!!! warning "Real Numbers Only"
    
    FIRK methods should only be used for problems defined on real numbers, not complex numbers.

## Key Properties

FIRK methods provide:

  - **Highest-order implicit methods** (excluding extrapolation)
  - **Superior accuracy** for very low tolerance requirements (≤ 1e-9)
  - **A-stable and L-stable** behavior for stiff problems
  - **Higher order per stage** than SDIRK methods (order 2s+1 for s stages)
  - **Special geometric properties** (some methods are symplectic)
  - **Excellent for small to medium systems** with high accuracy requirements

## When to Use FIRK Methods

These methods are recommended for:

  - **Very low tolerance problems** (1e-9 and below) where accuracy is paramount
  - **Small to medium stiff systems** (< 200 equations)
  - **Problems requiring highest possible accuracy** for implicit methods
  - **Stiff problems** where SDIRK order limitations (max order 5) are insufficient
  - **Applications where computational cost is acceptable** for maximum accuracy

## Mathematical Background

RadauIIA methods are based on Gaussian collocation and achieve order 2s+1 for s stages, making them among the highest-order implicit methods available. They represent the ODE analog of Gaussian quadrature. For more details on recent advances in FIRK methods, see our paper: [High-Order Adaptive Time Stepping for the Incompressible Navier-Stokes Equations](https://arxiv.org/abs/2412.14362).

## Computational Considerations

### Advantages

  - **Higher accuracy per stage** than diagonal methods
  - **Better multithreading** for small systems due to larger linear algebra operations
  - **No order restrictions** like SDIRK methods (which max out at order 5)

### Disadvantages

  - **Limited to real-valued problems** - cannot be used for complex number systems
  - **Higher implementation complexity** compared to SDIRK methods

## Solver Selection Guide

### High accuracy requirements

  - **`AdaptiveRadau`**: **Recommended** - adaptive order method that automatically selects optimal order
  - **`RadauIIA5`**: 5th-order method, good balance of accuracy and efficiency
  - **`RadauIIA9`**: 9th-order method for extremely high accuracy requirements
  - **`RadauIIA3`**: 3rd-order method for moderate accuracy needs

### System size considerations

  - **Systems < 200**: FIRK methods are competitive due to better multithreading
  - **Systems > 200**: Consider SDIRK or BDF methods instead

## Performance Guidelines

  - **Best for tolerances ≤ 1e-9** where high accuracy justifies the cost
  - **Most efficient on small to medium systems** where linear algebra cost is manageable
  - **Should be tested against** parallel implicit extrapolation methods which specialize in similar regimes
  - **Compare with** high-order SDIRK methods for borderline cases

```@eval
first_steps = evalfile("./common_first_steps.jl")
first_steps("OrdinaryDiffEqFIRK", "RadauIIA5")
```

## Full list of solvers

```@docs
RadauIIA3
RadauIIA5
RadauIIA9
```

```@meta
CollapsedDocStrings = true
```

# OrdinaryDiffEqBDF

IMEX BDF (Implicit-Explicit Backward Differentiation Formula) methods for stiff differential equations that can be split into stiff and non-stiff components. These methods apply implicit BDF schemes to the stiff part while treating the non-stiff part explicitly, providing efficient handling of problems with mixed stiffness characteristics.

## Key Properties

IMEX BDF methods provide:

  - **Implicit-explicit splitting** for mixed stiffness problems
  - **BDF stability** for the stiff component with A-stable and L-stable behavior
  - **Explicit treatment** of non-stiff terms avoiding unnecessary computational cost
  - **High-order accuracy** up to 4th order for both components
  - **Efficient for large systems** where full implicit treatment is expensive
  - **Natural for operator splitting** problems

## When to Use IMEX BDF Methods

These methods are recommended for:

  - **Reaction-diffusion systems** where reaction terms are stiff and diffusion is moderate
  - **Convection-diffusion problems** with stiff source terms and explicit convection
  - **Parabolic PDEs** where diffusion operators are naturally split from other terms
  - **Problems with natural stiffness separation** where some terms require implicit treatment
  - **Large-scale systems** where full implicit methods are computationally prohibitive
  - **Applications requiring operator splitting** methodology

## Mathematical Background

IMEX BDF methods split the ODE system `du/dt = f(u,t)` into:
`du/dt = f₁(u,t) + f₂(u,t)`

where:

  - `f₁(u,t)` contains stiff terms (treated implicitly with BDF)
  - `f₂(u,t)` contains non-stiff terms (treated explicitly)

This splitting must be chosen carefully to ensure both stability and efficiency.

## Problem Splitting Requirements

These methods require a `SplitODEProblem` formulation where:

  - **First function** `f₁` should contain stiff, implicit terms
  - **Second function** `f₂` should contain non-stiff, explicit terms
  - **Splitting strategy** significantly affects method performance
  - **Stiffness characteristics** should align with implicit/explicit treatment

## Solver Selection Guide

### IMEX Multistep Methods

  - **`SBDF2`**: **Recommended** - Second-order IMEX BDF method, good balance of accuracy and stability
  - **`SBDF3`**: Third-order method for higher accuracy requirements
  - **`SBDF4`**: Fourth-order method for maximum accuracy in IMEX BDF family
  - **`SBDF`**: Adaptive order method (experimental)

### IMEX SDIRK Methods

  - **`IMEXEuler`**: First-order method for simple problems or debugging
  - **`IMEXEulerARK`**: Alternative first-order formulation

## Performance Guidelines

### When IMEX BDF methods excel

  - **Natural stiffness separation** where splitting is obvious
  - **Large systems** where full implicit treatment is expensive
  - **Parabolic PDEs** with natural operator splitting
  - **Reaction-diffusion problems** with well-separated timescales
  - **Problems where implicit component** has efficient linear algebra

### Splitting strategy considerations

  - **Identify stiff vs non-stiff terms** based on eigenvalue analysis
  - **Linear stiff terms** work well in implicit component
  - **Nonlinear non-stiff terms** are suitable for explicit treatment
  - **Test different splittings** to optimize performance

## Alternative Approaches

Consider these alternatives:

  - **Full implicit methods** (BDF, SDIRK) if splitting is unclear or ineffective
  - **Standard IMEX Runge-Kutta** methods for different accuracy/efficiency trade-offs
  - **Exponential integrators** for linear stiff problems with nonlinear non-stiff terms
  - **Rosenbrock methods** for moderately stiff problems without natural splitting

## Usage Considerations

  - **Careful splitting design** is crucial for method effectiveness
  - **Stability analysis** should verify that explicit treatment doesn't introduce instabilities
  - **Timestep restrictions** may apply to the explicit component
  - **Linear algebra efficiency** in the implicit component affects overall performance

```@eval
imex_first_steps = evalfile("./common_imex_first_steps.jl")
imex_first_steps("OrdinaryDiffEqBDF", "SBDF2")
```

## Full list of solvers

### IMEX Multistep

```@docs
SBDF
SBDF2
SBDF3
SBDF4
```

### IMEX SDIRK

Note that Implicit Euler is the 1st order BDF method, and is thus implemented here using
the same machinery.

```@docs
IMEXEuler
IMEXEulerARK
```

```@meta
CollapsedDocStrings = true
```

# OrdinaryDiffEqPRK

Parallel Runge-Kutta (PRK) methods are explicit solvers specifically designed to exploit parallelism by making multiple independent evaluations of the ODE function `f` simultaneously. These methods are optimized for parallel computing environments where function evaluations can be distributed across multiple processors.

!!! warning "Research and Development"
    
    These methods are currently in research and development and not intended for general use.

## Key Properties

PRK methods provide:

  - **Explicit parallelism** in function evaluations within each timestep
  - **Fixed processor count optimization** for specific parallel architectures
  - **Independent stage evaluations** that can run simultaneously
  - **Maintained accuracy** while achieving parallel speedup
  - **Specialized tableaus** designed for parallel efficiency

## When to Use PRK Methods

These methods are recommended for:

  - **Parallel computing environments** with multiple processors available
  - **Expensive function evaluations** that benefit from parallelization
  - **Systems where function evaluation dominates** computational cost
  - **Applications with fixed parallel architecture** (e.g., exactly 2 or 5 processors)
  - **Problems where parallel speedup** outweighs method overhead

## Important Considerations

### Parallel Requirements

  - **Requires multiple processors** to achieve benefits
  - **Function evaluations must be parallelizable** (no data dependencies)
  - **Parallel overhead** must be less than speedup gains
  - **Fixed processor count** optimization may not match available hardware

### When NOT to Use

  - **Sequential computing** environments
  - **Cheap function evaluations** where parallel overhead dominates
  - **Memory-bound problems** where parallelism doesn't help
  - **Variable processor availability** scenarios
  - **Large systems** where LU factorization of implicit steps parallelizes efficiently (around 200×200 matrices and larger on modern processors)

## Mathematical Background

PRK methods rearrange traditional Runge-Kutta tableaus to allow stage evaluations to be computed independently and simultaneously. The specific processor count determines the tableau structure and achievable parallelism.

## Solver Selection Guide

### Available methods

  - **`KuttaPRK2p5`**: Fifth-order method optimized for 2 processors

### Usage considerations

  - **Best with exactly 2 processors** for KuttaPRK2p5
  - **Function evaluation must support** parallel execution
  - **Test parallel efficiency** against sequential high-order methods
  - **Consider problem-specific** parallel architecture

## Performance Guidelines

  - **Measure actual speedup** vs sequential methods on target hardware
  - **Account for parallel overhead** in performance comparisons
  - **Consider memory bandwidth** limitations in parallel environments
  - **Compare against** other parallelization strategies (e.g., spatial domain decomposition)

## Alternative Parallelization Approaches

For most problems, consider these alternatives:

  - **Spatial domain decomposition** for PDE problems
  - **Multiple trajectory parallelism** for Monte Carlo simulations
  - **Vectorized operations** within function evaluations
  - **High-order sequential methods** with better single-thread performance

```@eval
first_steps = evalfile("./common_first_steps.jl")
first_steps("OrdinaryDiffEqPRK", "KuttaPRK2p5")
```

## Full list of solvers

```@docs
KuttaPRK2p5
```

```@meta
CollapsedDocStrings = true
```

# [OrdinaryDiffEqTsit5](@id OrdinaryDiffEqTsit5)

The Tsitouras 5/4 method is the **recommended default solver** for most non-stiff differential equation problems. This method provides an excellent balance of efficiency, reliability, and accuracy.

## Key Properties

Tsit5 offers:

  - **Fifth-order accuracy** with embedded fourth-order error estimation
  - **Excellent efficiency** at default tolerances (1e-6 to 1e-3)
  - **FSAL (First Same As Last)** property for computational efficiency
  - **High-quality interpolation** for dense output
  - **Robust performance** across a wide range of problem types
  - **Optimized coefficients** for minimal error in practical applications

## When to Use Tsit5

Tsit5 is recommended for:

  - **Most non-stiff problems** as the first choice solver
  - **Default and higher tolerances** (1e-3 to 1e-6)
  - **General-purpose integration** when problem characteristics are unknown
  - **Educational and research applications** as a reliable baseline
  - **Real-time applications** requiring predictable performance
  - **Problems where simplicity and reliability** are preferred over maximum efficiency

## Solver Selection Guide

### Primary recommendation

  - **`Tsit5`**: Use as the default choice for non-stiff problems at standard tolerances

### Automatic switching

  - **`AutoTsit5`**: Automatically switches to a stiff solver when stiffness is detected, making it robust for problems of unknown character

## When to Consider Alternatives

Consider other solvers when:

  - **Higher accuracy needed**: Use Verner methods (Vern6, Vern7, Vern8, Vern9) for tolerances below 1e-6
  - **Higher tolerances**: Use BS3 or OwrenZen3 for tolerances above 1e-3
  - **Robust error control needed**: Use BS5 when Tsit5 struggles with error estimation
  - **Equation is stiff**: Use implicit methods (SDIRK, BDF) or semi-implicit methods (Rosenbrock) for stiff problems
  - **Special properties required**: Use specialized methods (SSP, symplectic, etc.) for specific problem types

```@eval
first_steps = evalfile("./common_first_steps.jl")
first_steps("OrdinaryDiffEqTsit5", "Tsit5")
```

## Full list of solvers

```@docs
Tsit5
AutoTsit5
```

# Usage

OrdinaryDiffEq.jl is part of the SciML common interface, but can be used independently of DifferentialEquations.jl. The only requirement is that the user passes an OrdinaryDiffEq.jl algorithm to `solve`. For example, we can solve the [ODE tutorial from the docs](https://docs.sciml.ai/DiffEqDocs/dev/getting_started/) using the `Tsit5()` algorithm:

```julia
using OrdinaryDiffEq
f(u, p, t) = 1.01 * u
u0 = 1 / 2
tspan = (0.0, 1.0)
prob = ODEProblem(f, u0, tspan)
sol = solve(prob, Tsit5(), reltol = 1e-8, abstol = 1e-8)
using Plots
plot(sol, linewidth = 5, title = "Solution to the linear ODE with a thick line",
    xaxis = "Time (t)", yaxis = "u(t) (in μm)", label = "My Thick Line!") # legend=false
plot!(sol.t, t -> 0.5 * exp(1.01t), lw = 3, ls = :dash, label = "True Solution!")
```

That example uses the out-of-place syntax `f(u,p,t)`, while the inplace syntax (more efficient for systems of equations) is shown in the Lorenz example:

```julia
using OrdinaryDiffEq
function lorenz(du, u, p, t)
    du[1] = 10.0(u[2] - u[1])
    du[2] = u[1] * (28.0 - u[3]) - u[2]
    du[3] = u[1] * u[2] - (8 / 3) * u[3]
end
u0 = [1.0; 0.0; 0.0]
tspan = (0.0, 100.0)
prob = ODEProblem(lorenz, u0, tspan)
sol = solve(prob, Tsit5())
using Plots;
plot(sol, vars = (1, 2, 3));
```

Very fast static array versions can be specifically compiled to the size of your model. For example:

```julia
using OrdinaryDiffEq, StaticArrays
function lorenz(u, p, t)
    SA[10.0(u[2] - u[1]), u[1] * (28.0 - u[3]) - u[2], u[1] * u[2] - (8 / 3) * u[3]]
end
u0 = SA[1.0; 0.0; 0.0]
tspan = (0.0, 100.0)
prob = ODEProblem(lorenz, u0, tspan)
sol = solve(prob, Tsit5())
```

For “refined ODEs”, like dynamical equations and `SecondOrderODEProblem`s, refer to the [DiffEqDocs](https://diffeq.sciml.ai/dev/types/ode_types/). For example, in [DiffEqTutorials.jl](https://github.com/SciML/SciMLTutorials.jl) we show how to solve equations of motion using symplectic methods:

```julia
function HH_acceleration(dv, v, u, p, t)
    x, y = u
    dx, dy = dv
    dv[1] = -x - 2x * y
    dv[2] = y^2 - y - x^2
end
initial_positions = [0.0, 0.1]
initial_velocities = [0.5, 0.0]
prob = SecondOrderODEProblem(HH_acceleration, initial_velocities, initial_positions, tspan)
sol2 = solve(prob, KahanLi8(), dt = 1 / 10);
```

Other refined forms are IMEX and semi-linear ODEs (for exponential integrators).

## Available Solvers

For the list of available solvers, please refer to the [DifferentialEquations.jl ODE Solvers](https://diffeq.sciml.ai/dev/solvers/ode_solve/), [Dynamical ODE Solvers](https://diffeq.sciml.ai/dev/solvers/dynamical_solve/), and the [Split ODE Solvers](https://diffeq.sciml.ai/dev/solvers/split_ode_solve/) pages.

```@meta
CollapsedDocStrings = true
```

# OrdinaryDiffEqBDF

Backward Differentiation Formula (BDF) methods are multistep implicit methods specifically designed for solving large stiff systems of differential equations. They are the preferred choice for very large systems (>1000 equations) where other implicit methods become computationally expensive.

## Key Properties

BDF methods offer:

  - **Excellent efficiency for large systems** (>1000 ODEs)
  - **L-stable behavior** for orders 1 and 2 only
  - **Adaptive order and stepsize** control for optimal performance
  - **Alpha-stability** for higher orders (but less stable than L-stable methods for problems with large complex eigenvalues)

## When to Use BDF Methods

BDF methods are recommended for:

  - **Large stiff systems** with more than 1000 equations
  - **Very stiff problems** where other implicit methods struggle
  - **Long-time integration** of stiff systems
  - **Parabolic PDEs** after spatial discretization
  - **Reaction-diffusion systems** and chemical kinetics
  - **Circuit simulation** and other engineering applications with large stiff systems

## Solver Selection Guide

### Recommended methods

  - **`QNDF`**: Adaptive order quasi-constant timestep BDF, best general choice for large systems
  - **`FBDF`**: Fixed-leading coefficient BDF, often more efficient than QNDF

## Performance Characteristics

  - **Most efficient for systems with >1000 equations**
  - **Outperform Runge-Kutta methods** on very large stiff systems
  - **Memory efficient** due to multistep structure
  - **Excel at very low tolerances** (1e-9 and below)
  - **Particularly effective** for problems arising from PDE discretizations

## Comparison with Other Methods

Choose BDF methods over:

  - **Rosenbrock methods**: When system size > 1000 equations
  - **SDIRK methods**: For very large stiff systems where RK methods become expensive
  - **Explicit methods**: For any stiff problem

Choose other methods over BDF when:

  - **System size < 100**: Rosenbrock or SDIRK methods often more efficient
  - **Problems with large complex eigenvalues**: Rosenbrock and L-stable SDIRK methods are more stable due to BDF methods only being alpha-stable
  - **Moderate stiffness**: SDIRK methods may be more robust
  - **Non-stiff problems**: Use explicit methods like Tsit5

```@eval
first_steps = evalfile("./common_first_steps.jl")
first_steps("OrdinaryDiffEqBDF", "QNDF")
```

## Full list of solvers

```@docs
ABDF2
QNDF
QNDF1
QNDF2
QBDF
QBDF1
QBDF2
MEBDF2
FBDF
```

```@meta
CollapsedDocStrings = true
```

# OrdinaryDiffEqStabilizedRK

Stabilized Runge-Kutta methods are explicit schemes designed to handle moderately stiff problems by extending the stability region through careful tableau construction. These methods use an upper bound on the spectral radius of the Jacobian to achieve much larger stable timesteps than conventional explicit methods. **These methods are good for large real eigenvalue problems, but not for problems where the complex eigenvalues are large.**

## Key Properties

Stabilized RK methods provide:

  - **Extended stability regions** for moderately stiff problems
  - **Explicit formulation** avoiding nonlinear solvers
  - **Large stable timestep sizes** compared to standard explicit methods
  - **Automatic spectral radius estimation** or user-supplied bounds
  - **Efficient for parabolic PDEs** with moderate stiffness
  - **Good performance** on problems with well-separated timescales

## When to Use Stabilized RK Methods

These methods are recommended for:

  - **Moderately stiff problems** where implicit methods are overkill
  - **Parabolic PDEs** with diffusion-dominated behavior
  - **Problems with large spatial grids** where implicit methods become expensive
  - **Systems with well-separated timescales** but not extreme stiffness
  - **Cases where explicit is preferred** but standard methods are unstable
  - **Large-scale problems** where linear algebra cost of implicit methods is prohibitive

## Mathematical Background

Stabilized methods achieve extended stability by constructing tableaus with enlarged stability regions, often using Chebyshev polynomials or orthogonal polynomial techniques. The stable timestep is determined by the spectral radius bound rather than the CFL condition. **Important**: These methods extend stability primarily along the negative real axis, making them effective for large real eigenvalues but ineffective when complex eigenvalues dominate the stiffness.

## Spectral Radius Estimation

Users can supply an upper bound on the spectral radius using:

```julia
eigen_est = (integrator) -> integrator.eigen_est = upper_bound
```

If not provided, the methods include automatic estimation procedures.

## Solver Selection Guide

### Recommended stabilized methods

  - **`ROCK2`**: Second-order ROW-type stabilized method with extended stability
  - **`ROCK4`**: Fourth-order stabilized method for higher accuracy requirements

## Performance Guidelines

### When stabilized methods excel

  - **Large real eigenvalue problems** where stiffness comes from real eigenvalues
  - **Moderate stiffness ratio** (10³ to 10⁶) dominated by real eigenvalues
  - **Large spatial discretizations** where implicit solver cost is high
  - **Very large systems** where stabilized RK methods are more efficient than BDF methods due to no linear algebra requirements
  - **Parabolic PDEs** with diffusion-dominated (real eigenvalue) stiffness
  - **Problems where spectral radius** can be estimated reliably

### When to use alternatives

  - **Complex eigenvalue dominated problems**: Use implicit methods (BDF, SDIRK, Rosenbrock)
  - **Non-stiff problems**: Use standard explicit methods (Tsit5, Verner)

## Usage Considerations

  - **Spectral radius estimation** is crucial for performance
  - **Method efficiency** depends on stiffness ratio
  - **Test against implicit methods** for highly stiff problems
  - **Consider adaptive spectral radius** estimation for varying stiffness

```@eval
first_steps = evalfile("./common_first_steps.jl")
first_steps("OrdinaryDiffEqStabilizedRK", "ROCK4")
```

## Full list of solvers

```@docs
ROCK2 
ROCK4 
RKC
SERK2
ESERK4
ESERK5
```

```@meta
CollapsedDocStrings = true
```

# OrdinaryDiffEqSymplecticRK

Symplectic integrators are specialized methods for solving Hamiltonian systems and second-order differential equations that preserve important geometric properties of the phase space. These methods are essential for long-time integration of conservative mechanical systems.

## Key Properties

Symplectic integrators provide:

  - **Exact conservation of symplectic structure** in phase space
  - **Bounded energy error** over long time periods
  - **Excellent long-time stability** without secular drift
  - **Preservation of periodic orbits** and other geometric structures
  - **Linear energy drift** instead of quadratic (much better than standard methods)

## When to Use Symplectic Methods

Symplectic integrators are essential for:

  - **Hamiltonian systems** and conservative mechanical problems
  - **Molecular dynamics** and N-body simulations
  - **Celestial mechanics** and orbital computations
  - **Plasma physics** and charged particle dynamics
  - **Long-time integration** where energy conservation is critical
  - **Oscillatory problems** requiring preservation of periodic structure
  - **Classical mechanics problems** with known analytical properties

## Mathematical Background

For a Hamiltonian system with energy `H(p,q)`, symplectic integrators preserve the symplectic structure `dp ∧ dq`. While standard integrators have energy error growing quadratically over time, symplectic methods maintain bounded energy with only linear drift, making them superior for long-time integration.

## Solver Selection Guide

### First-order methods

  - **`SymplecticEuler`**: First-order, simplest symplectic method. Only recommended when the dynamics function `f` is not differentiable.

### Second-order methods

  - **`McAte2`**: Optimized second-order McLachlan-Atela method, **recommended for most applications**
  - **`VelocityVerlet`**: Second-order, common choice for molecular dynamics but less efficient in terms of accuracy than McAte2
  - **`VerletLeapfrog`**: Second-order, kick-drift-kick formulation
  - **`LeapfrogDriftKickDrift`**: Alternative second-order leapfrog
  - **`PseudoVerletLeapfrog`**: Modified Verlet scheme

### Third-order methods

  - **`Ruth3`**: Third-order method
  - **`McAte3`**: Optimized third-order McLachlan-Atela method

### Fourth-order methods

  - **`CandyRoz4`**: Fourth-order method
  - **`McAte4`**: Fourth-order McLachlan-Atela (requires quadratic kinetic energy)
  - **`CalvoSanz4`**: Optimized fourth-order method
  - **`McAte42`**: Alternative fourth-order method (BROKEN)

### Higher-order methods

  - **`McAte5`**: Fifth-order McLachlan-Atela method
  - **`Yoshida6`**: Sixth-order method
  - **`KahanLi6`**: Optimized sixth-order method
  - **`McAte8`**: Eighth-order McLachlan-Atela method
  - **`KahanLi8`**: Optimized eighth-order method
  - **`SofSpa10`**: Tenth-order method for highest precision

## Method Selection Guidelines

  - **For most applications**: `McAte2` (second-order, optimal efficiency)
  - **For molecular dynamics (common choice)**: `VelocityVerlet` (less efficient than McAte2 but widely used)
  - **For non-differentiable dynamics**: `SymplecticEuler` (first-order, only when necessary)
  - **For computational efficiency**: `McAte2` or `McAte3`

### Important Note on Chaotic Systems

Most N-body problems (molecular dynamics, astrophysics) are chaotic systems where solutions diverge onto shadow trajectories. In such cases, **higher-order methods provide no practical advantage** because the true error remains O(1) for sufficiently long integrations - exactly the scenarios where symplectic methods are most needed. The geometric properties preserved by symplectic integrators are more important than high-order accuracy for chaotic systems.

For more information on chaos and accuracy in numerical integration, see: [How Chaotic is Chaos? How Some AI for Science (SciML) Papers are Overstating Accuracy Claims](https://www.stochasticlifestyle.com/how-chaotic-is-chaos-how-some-ai-for-science-sciml-papers-are-overstating-accuracy-claims/)

## Installation

To be able to access the solvers in `OrdinaryDiffEqSymplecticRK`, you must first install them use the Julia package manager:

```julia
using Pkg
Pkg.add("OrdinaryDiffEqSymplecticRK")
```

This will only install the solvers listed at the bottom of this page.
If you want to explore other solvers for your problem,
you will need to install some of the other libraries listed in the navigation bar on the left.

## Example usage

```julia
using OrdinaryDiffEqSymplecticRK
function HH_acceleration!(dv, v, u, p, t)
    x, y = u
    dx, dy = dv
    dv[1] = -x - 2x * y
    dv[2] = y^2 - y - x^2
end
initial_positions = [0.0, 0.1]
initial_velocities = [0.5, 0.0]
tspan = (0.0, 1.0)
prob = SecondOrderODEProblem(HH_acceleration!, initial_velocities, initial_positions, tspan)
sol = solve(prob, KahanLi8(), dt = 1 / 10)
```

## Full list of solvers

```@docs
SymplecticEuler
VelocityVerlet
VerletLeapfrog
LeapfrogDriftKickDrift
PseudoVerletLeapfrog
McAte2
Ruth3
McAte3
CandyRoz4
McAte4
CalvoSanz4
McAte42
McAte5
Yoshida6
KahanLi6
McAte8
KahanLi8
SofSpa10
```

```@meta
CollapsedDocStrings = true
```

# OrdinaryDiffEqSSPRK

Strong Stability Preserving Runge-Kutta (SSPRK) methods are specialized explicit Runge-Kutta methods designed to preserve important stability properties of the underlying spatial discretization when applied to hyperbolic partial differential equations and conservation laws.

## Key Properties

SSPRK methods provide:

  - **Strong stability preservation** for convex functionals (total variation, maximum norm, entropy)
  - **Optimal SSP coefficients** allowing larger stable timesteps
  - **Non-oscillatory behavior** crucial for hyperbolic PDEs and conservation laws
  - **High-order accuracy** while maintaining monotonicity properties
  - **Specialized variants** for different orders and storage requirements

## When to Use SSPRK Methods

SSPRK methods are essential for:

  - **Hyperbolic partial differential equations** (Euler equations, shallow water, etc.)
  - **Conservation laws** where preserving physical bounds is critical
  - **Discontinuous Galerkin methods** and other high-order spatial discretizations
  - **Problems requiring monotonicity preservation** or total variation stability
  - **Shock-capturing schemes** where spurious oscillations must be avoided
  - **Astrophysical simulations** and computational fluid dynamics

## SSP Coefficient and CFL Conditions

The SSP coefficient determines the maximum allowable timestep for stability preservation. Use `OrdinaryDiffEqCore.ssp_coefficient(alg)` to query this value for step size calculations. The timestep must satisfy `dt ≤ CFL * dx / max_wavespeed` where CFL ≤ SSP coefficient.

## Solver Selection Guide

### Second-order methods

  - **`SSPRK22`**: Two-stage, second-order (SSP coefficient = 1)
  - **`SSPRKMSVS32`**: Three-step multistep variant

### Third-order methods

  - **`SSPRK33`**: Three-stage, third-order, optimal (SSP coefficient = 1)
  - **`SSPRK53`**: Five-stage, third-order, higher SSP coefficient
  - **`SSPRK63`**, **`SSPRK73`**, **`SSPRK83`**: More stages for larger SSP coefficients
  - **`SSPRK43`**: Four-stage with embedded error estimation
  - **`SSPRK432`**: Low-storage variant

### Fourth-order methods

  - **`SSPRK54`**: Five-stage, fourth-order
  - **`SSPRK104`**: Ten-stage, fourth-order, large SSP coefficient

### Low-storage variants

  - **`SSPRK53_2N1`**, **`SSPRK53_2N2`**, **`SSPRK53_H`**: Two-register storage schemes

### Discontinuous Galerkin optimized

  - **`KYKSSPRK42`**: Optimized for DG spatial discretizations
  - **`KYK2014DGSSPRK_3S2`**: Specialized DG method

### Adaptive methods

  - **`SSPRK432`**: Third-order with error control
  - **`SSPRK932`**: High-stage adaptive method
  - **`SSPRKMSVS43`**: Multistep adaptive variant

```@eval
first_steps = evalfile("./common_first_steps.jl")
first_steps("OrdinaryDiffEqSSPRK", "SSPRK22")
```

## Full list of solvers

```@docs
SSPRK22
SSPRK33
SSPRK53
KYKSSPRK42
KYK2014DGSSPRK_3S2
SSPRK53_2N1
SSPRK53_2N2
SSPRK53_H
SSPRK63
SSPRK73
SSPRK83
SSPRK43
SSPRK432
SSPRKMSVS43
SSPRKMSVS32
SSPRK932
SSPRK54
SSPRK104
```

```@meta
CollapsedDocStrings = true
```

# OrdinaryDiffEqSDIRK

Singly Diagonally Implicit Runge-Kutta (SDIRK) methods are a family of implicit Runge-Kutta methods designed for solving stiff ordinary differential equations. These methods are particularly effective for problems where explicit methods become unstable due to stiffness.

## Key Properties

SDIRK methods have several important characteristics:

  - **A-stable and L-stable**: Can handle highly stiff problems without numerical instability
  - **Stiffly accurate**: Many SDIRK methods provide additional numerical stability for stiff problems
  - **Diagonally implicit structure**: The implicit system only requires solving a sequence of nonlinear equations rather than a large coupled system
  - **Good for moderate to large systems**: More efficient than fully implicit RK methods for many problems

## When to Use SDIRK Methods

SDIRK methods are recommended for:

  - **Stiff differential equations** where explicit methods fail or require very small timesteps
  - **Problems requiring good stability properties** at moderate to high tolerances
  - **Systems where Rosenbrock methods** (which require Jacobians) are not suitable or available
  - **IMEX problems** using the KenCarp family, which can split stiff and non-stiff terms

## Solver Selection Guide

### High tolerance (>1e-2)

  - **`TRBDF2`**: Second-order A-B-L-S-stable method, good for oscillatory problems

### Medium tolerance (1e-8 to 1e-2)

  - **`KenCarp4`**: Fourth-order method with excellent stability, good all-around choice
  - **`KenCarp47`**: Seventh-stage fourth-order method, enhanced stability
  - **`Kvaerno4`** or **`Kvaerno5`**: High-order stiffly accurate methods

### Low tolerance (<1e-8)

  - **`Kvaerno5`**: Fifth-order stiffly accurate method for high accuracy
  - **`KenCarp5`**: Fifth-order method with splitting capabilities

### Special Cases

  - **`ImplicitEuler`**: First-order method, only recommended for problems with discontinuities or when `f` is not differentiable
  - **`Trapezoid`**: Second-order symmetric method, reversible but not symplectic. Good for eliminating damping often seen with L-stable methods
  - **`ImplicitMidpoint`**: Second-order A-stable symplectic method for energy-preserving systems
  - **`SSPSDIRK2`**: Strong stability preserving variant for problems requiring monotonicity preservation

```@eval
first_steps = evalfile("./common_first_steps.jl")
first_steps("OrdinaryDiffEqSDIRK", "KenCarp4")
```

## Full list of solvers

```@docs
ImplicitEuler
ImplicitMidpoint
Trapezoid
TRBDF2
SDIRK2
SDIRK22
SSPSDIRK2
Kvaerno3
KenCarp3
CFNLIRK3
Cash4
SFSDIRK4
SFSDIRK5
SFSDIRK6
SFSDIRK7
SFSDIRK8
Hairer4
Hairer42
Kvaerno4
Kvaerno5
```

### IMEX SDIRK

```@docs
KenCarp4
KenCarp47
KenCarp5
KenCarp58
ESDIRK54I8L2SA
ESDIRK436L2SA2
ESDIRK437L2SA
ESDIRK547L2SA2
ESDIRK659L2SA
```

```@meta
CollapsedDocStrings = true
```

# OrdinaryDiffEqBDF

BDF (Backward Differentiation Formula) methods for mass matrix differential-algebraic equations (DAEs) and stiff ODEs with singular mass matrices. These methods provide robust, high-order integration for systems with algebraic constraints and mixed differential-algebraic structure.

## Key Properties

Mass matrix BDF methods provide:

  - **DAE capability** for index-1 differential-algebraic equations
  - **Mass matrix support** for singular and non-diagonal mass matrices
  - **High-order accuracy** up to 5th order with good stability
  - **L-stable behavior** for stiff problems with excellent damping
  - **Automatic differentiation** for efficient Jacobian computation
  - **Variable order and stepsize** adaptation for efficiency

## When to Use Mass Matrix BDF Methods

These methods are recommended for:

  - **Differential-algebraic equations (DAEs)** with index-1 structure
  - **Constrained mechanical systems** with holonomic constraints
  - **Electrical circuit simulation** with algebraic loop equations
  - **Chemical reaction networks** with conservation constraints
  - **Multibody dynamics** with kinematic constraints
  - **Semi-explicit DAEs** arising from spatial discretizations

## Mathematical Background

Mass matrix DAEs have the form:
`M du/dt = f(u,t)`

where M is a potentially singular mass matrix. When M is singular, some equations become algebraic constraints rather than differential equations, leading to a DAE system.

## Problem Formulation

Use `ODEFunction` with a `mass_matrix`:

```julia
using LinearAlgebra: Diagonal
function rober(du, u, p, t)
    y₁, y₂, y₃ = u
    k₁, k₂, k₃ = p
    du[1] = -k₁ * y₁ + k₃ * y₂ * y₃
    du[2] = k₁ * y₁ - k₃ * y₂ * y₃ - k₂ * y₂^2
    du[3] = y₁ + y₂ + y₃ - 1
    nothing
end
M = Diagonal([1.0, 1.0, 0])  # Singular mass matrix
f = ODEFunction(rober, mass_matrix = M)
prob_mm = ODEProblem(f, [1.0, 0.0, 0.0], (0.0, 1e5), (0.04, 3e7, 1e4))
sol = solve(prob_mm, FBDF(), reltol = 1e-8, abstol = 1e-8)
```

## Solver Selection Guide

### Recommended Methods

  - **`FBDF`**: **Recommended** - Fixed leading coefficient BDF with excellent stability
  - **`QNDF`**: Quasi-constant stepsize Nordsieck BDF with good efficiency
  - **`QBDF`**: Alternative quasi-constant stepsize BDF formulation

### Specific order methods

  - **`QNDF1`**: First-order method for simple problems
  - **`QNDF2`**: Second-order method balancing accuracy and stability
  - **`QBDF1`**, **`QBDF2`**: Alternative second-order formulations
  - **`ABDF2`**: Adams-type BDF for specific applications
  - **`MEBDF2`**: Modified extended BDF for enhanced stability

## Performance Guidelines

### When mass matrix BDF methods excel

  - **Index-1 DAE systems** with well-separated differential and algebraic variables
  - **Large stiff systems** with algebraic constraints
  - **Problems with conservation laws** naturally expressed as constraints
  - **Multiphysics simulations** combining differential and algebraic equations
  - **Systems where constraints are essential** to the physics

### Mass matrix considerations

  - **Singular mass matrices** require consistent initial conditions
  - **Index determination** affects solver performance and stability
  - **Constraint violations** may accumulate and require projection
  - **Well-conditioned problems** generally perform better

## Important Considerations

### Initial conditions

  - **Must be consistent** with algebraic constraints
  - **Use initialization procedures** if constraints are not satisfied initially
  - **Index-1 assumption** requires that constraints uniquely determine algebraic variables

### Numerical challenges

  - **Constraint drift** may occur over long integrations
  - **Index higher than 1** not directly supported
  - **Ill-conditioned mass matrices** can cause numerical difficulties
  - **Discontinuities** in constraints require special handling

## Alternative Approaches

Consider these alternatives:

  - **Implicit Runge-Kutta methods** for higher accuracy requirements
  - **Rosenbrock methods** for moderately stiff DAEs
  - **Projection methods** for constraint preservation
  - **Index reduction techniques** for higher-index DAEs

```@eval
first_steps = evalfile("./common_first_steps.jl")
first_steps("OrdinaryDiffEqBDF", "FBDF")
```

## Full list of solvers

```@docs; canonical=false
ABDF2
QNDF
QNDF1
QNDF2
QBDF
QBDF1
QBDF2
MEBDF2
FBDF
```

# SciML Scientific Machine Learning Developer Documentation

This is the developer documentation and Contributor's Guide for the SciML ecosystem. It explains the common
interface and some the package internals to help developers contribute.

If you have any questions, or just want to chat about solvers/using the package, please feel free to use the [Gitter channel](https://gitter.im/JuliaDiffEq/Lobby). For bug reports, feature requests, etc., please submit an issue.

### Overview

The SciML ecosystem is built around the common interface. The common interface
is a type-based interface where users define problems as a type, and solvers
plug into the ecosystem by defining an algorithm to give a new dispatch to

```julia
__solve(prob, alg; kwargs...)
__init(prob, alg; kwargs...)
```

There is a top level `solve` and `init` function which is
in DiffEqBase.jl that handles distribution and function input
(along with extra warnings) before sending the problems
to the packages.

There is then an ecosystem of add-on components which use the
common solver interface to add analysis tools for differential
equations.

### Contributing to the Ecosystem

There are many ways to help the ecosystem. One way you can contribute is to give
pull requests (PRs) to existing packages. Another way to contribute is to add your
own package to the ecosystem. Adding your own package to the ecosystem allows
you to keep executive control and licensing over your methods,
but allows users of DifferentialEquations.jl to use your methods via the common
interface, and makes your package compatible with the add-on tools (sensitivity
analysis, parameter estimation, etc). Note that, in order for the method to be
used as a default, one is required to move their
package to the SciML organization so that way common maintenance (such
as fixing deprecation warnings, updating tests to newer versions, and emergency
fixes / disabling) can be allowed by SciML members. However, the lead developer
of the package maintains administrative control, and thus any change to the core
algorithms by other SciML members will only be given through PRs.

Even if you don't have the time to contribute new solver algorithms or add-on tools,
there's always ways to help! Improved plot recipes and new series recipes are
always nice to add more default plots. It is always helpful to have benchmarks
between different algorithms to see "which is best". Adding examples IJulia
notebooks to DiffEqTutorials.jl is a good way to share knowledge about DifferentialEquations.jl.
Also, please feel free to comb through the solvers and look for ways to make them
more efficient. Lastly, the documentation could always use improvements. If you
have any questions on how to help, just ask them in the Gitter!

### Code of Conduct

All contributors must adhere to the [NumFOCUS Code of Conduct](https://numfocus.org/code-of-conduct).
Treat everyone with respect. Failure to comply will result in individuals being banned from the community.

### Contributor Guide

```@contents
Pages = [
  "contributing/ecosystem_overview.md",
  "contributing/adding_packages.md",
  "contributing/adding_algorithms.md",
  "contributing/defining_problems.md",
  "contributing/diffeq_internals.md",
  "contributing/type_traits.md"
]
Depth = 2
```

### Algorithm Development Tools

The following algorithm development tools are provided by DiffEqDevTools.jl

```@contents
Pages = [
  "alg_dev/test_problems.md",
  "alg_dev/convergence.md",
  "alg_dev/benchmarks.md"
]
Depth = 2
```

### Internal Documentation

```@contents
Pages = [
  "internals/fem_tools.md",
  "internals/notes_on_algorithms.md",
  "internals/tableaus.md"
]
Depth = 2
```

## Reproducibility

```@raw html
<details><summary>The documentation of this SciML package was built using these direct dependencies,</summary>
```

```@example
using Pkg # hide
Pkg.status() # hide
```

```@raw html
</details>
```

```@raw html
<details><summary>and using this machine and Julia version.</summary>
```

```@example
using InteractiveUtils # hide
versioninfo() # hide
```

```@raw html
</details>
```

```@raw html
<details><summary>A more complete overview of all dependencies and their versions is also provided.</summary>
```

```@example
using Pkg # hide
Pkg.status(; mode = PKGMODE_MANIFEST) # hide
```

```@raw html
</details>
```

```@raw html
You can also download the 
<a href="
```

```@eval
using TOML
version = TOML.parse(read("../../Project.toml", String))["version"]
name = TOML.parse(read("../../Project.toml", String))["name"]
link = "https://github.com/SciML/" * name * ".jl/tree/gh-pages/v" * version *
       "/assets/Manifest.toml"
```

```@raw html
">manifest</a> file and the
<a href="
```

```@eval
using TOML
version = TOML.parse(read("../../Project.toml", String))["version"]
name = TOML.parse(read("../../Project.toml", String))["name"]
link = "https://github.com/SciML/" * name * ".jl/tree/gh-pages/v" * version *
       "/assets/Project.toml"
```

```@raw html
">project</a> file.
```

```@meta
CollapsedDocStrings = true
```

# OrdinaryDiffEqQPRK

Quadruple-precision parallel Runge-Kutta (QPRK) methods are high-order explicit solvers specifically designed for ultra-high precision computations using quad-precision arithmetic (`Float128`). These methods combine parallel evaluation capabilities with coefficients optimized for extended precision arithmetic. **Note: These methods are still under-benchmarked and need more research.**

## Key Properties

QPRK methods provide:

  - **Ultra-high-order accuracy** (9th order) for maximum precision
  - **Quadruple-precision optimization** specifically designed for `Float128`
  - **Parallel function evaluations** for computational efficiency
  - **Extreme precision capabilities** for very demanding applications
  - **Optimized coefficients** for extended precision arithmetic

## When to Use QPRK Methods

These methods are recommended for:

  - **Ultra-high precision requirements** demanding `Float128` arithmetic
  - **Extremely low tolerances** (< 1e-20) where standard precision fails
  - **Scientific applications** requiring maximum possible accuracy
  - **Parallel computing environments** with quad-precision support
  - **Research applications** exploring limits of numerical precision
  - **Long-time integration** where error accumulation must be minimized to extreme levels

## Important Requirements

### Precision Requirements

  - **Must use `Float128`** or higher precision number types
  - **All problem components** should support extended precision
  - **Tolerances should match** the precision capabilities (< 1e-20)

### Computational Considerations

  - **Slower** than standard precision methods due to extended precision arithmetic
  - **Higher memory usage** due to extended precision
  - **Limited hardware support** for quad-precision operations

## Mathematical Background

QPRK methods use tableaus with coefficients computed in extended precision to maintain accuracy throughout the ultra-high precision computation. The parallel structure allows independent function evaluations to be computed simultaneously.

## Solver Selection Guide

### Available methods

  - **`QPRK98`**: Ninth-order method optimized for quad-precision arithmetic with parallel evaluation

### Usage guidelines

  - **Essential to use `Float128`** for the state vector and parameters
  - **Consider [MultiFloats.jl](https://github.com/dzhang314/MultiFloats.jl)** for higher precision number types
  - **Set very low tolerances** (e.g., 1e-25) to utilize full precision
  - **Test against alternatives** like Feagin methods with `BigFloat`

## Performance Considerations

  - **Slower** than standard precision methods due to extended precision arithmetic
  - **Memory intensive** due to extended precision storage
  - **Hardware dependent** - some architectures lack efficient quad-precision support

## Alternative High-Precision Methods

For ultra-high precision, also consider:

  - **Feagin methods** with `BigFloat` for arbitrary precision
  - **Arbitrary precision extrapolation** methods
  - **Verner methods** with `BigFloat` for slightly lower but efficient precision
  - **Taylor series methods** with automatic differentiation for extreme precision

## Usage Example

```julia
using OrdinaryDiffEqQPRK
# Ensure using Float128 for ultra-high precision
u0 = Float128[1.0, 0.0]
tspan = (Float128(0.0), Float128(10.0))
prob = ODEProblem(f, u0, tspan)
sol = solve(prob, QPRK98(), abstol = 1e-25, reltol = 1e-25)
```

```@eval
first_steps = evalfile("./common_first_steps.jl")
first_steps("OrdinaryDiffEqQPRK", "QPRK98")
```

## Full list of solvers

```@docs
QPRK98
```

# OrdinaryDiffEq.jl

OrdinaryDiffEq.jl is a component package in the DifferentialEquations ecosystem.
It holds the core ordinary differential equation solvers and utilities. While completely independent and usable on its own, users interested in using this
functionality should check out
[DifferentialEquations.jl](https://github.com/SciML/DifferentialEquations.jl).

## Installation

Assuming that you already have Julia correctly installed, it suffices to import
OrdinaryDiffEq.jl in the standard way:

```julia
import Pkg;
Pkg.add("OrdinaryDiffEq");
```

```@meta
CollapsedDocStrings = true
```

# OrdinaryDiffEqLowStorageRK

Low-storage Runge-Kutta methods are specialized explicit schemes designed to minimize memory requirements while maintaining high-order accuracy. These methods are essential for large-scale computational fluid dynamics and wave propagation problems where memory constraints are critical.

## Key Properties

Low-storage RK methods provide:

  - **Drastically reduced memory usage** (typically 2-4 registers vs 7-10 for standard RK)
  - **High-order accuracy** comparable to standard RK methods
  - **Preservation of important stability properties** (low dissipation/dispersion)
  - **Scalability** to very large PDE discretizations

## When to Use Low-Storage RK Methods

These methods are recommended for:

  - **Large-scale PDE discretizations** where memory is the limiting factor
  - **Computational fluid dynamics** and wave propagation simulations
  - **High-performance computing** applications with memory constraints
  - **GPU computations** where memory bandwidth is critical
  - **Compressible flow simulations** and aerodynamics
  - **Seismic wave propagation** and acoustic simulations
  - **Problems with millions or billions of unknowns**

## Memory Efficiency Comparison

**Registers** refer to the number of copies of the `u0` vector that must be stored in memory during integration:

  - **Standard Tsit5**: ~9 registers (copies of the state vector)
  - **Low-storage methods**: 2-4 registers (copies of the state vector)
  - **Practical example**: If `u0` is from a PDE semi-discretization requiring 2 GB, then Tsit5 needs 18 GB of working memory, while a 2-register method only needs 4 GB and can achieve the same order
  - **Trade-off**: These methods achieve memory reduction by being less computationally efficient, trading compute performance for lower memory requirements

## Solver Selection Guide

### General-purpose low-storage

  - **`CarpenterKennedy2N54`**: Fourth-order, 5-stage, excellent general choice
  - **`RDPK3Sp510`**: Fifth-order with only 3 registers, very memory efficient

### Wave propagation optimized

  - **`ORK256`**: Second-order, 5-stage, optimized for wave equations
  - **`CFRLDDRK64`**: Low-dissipation and low-dispersion variant
  - **`TSLDDRK74`**: Seventh-order for high accuracy wave propagation

### Discontinuous Galerkin optimized

  - **`DGLDDRK73_C`**: Optimized for DG discretizations (constrained)
  - **`DGLDDRK84_C`**, **`DGLDDRK84_F`**: Fourth-order DG variants

### Specialized high-order

  - **`NDBLSRK124`**, **`NDBLSRK144`**: Multi-stage fourth-order methods
  - **`SHLDDRK64`**: Low dissipation and dispersion properties
  - **`RK46NL`**: Six-stage fourth-order method

### Computational fluid dynamics

  - **Carpenter-Kennedy-Lewis series** (`CKLLSRK*`): Optimized for Navier-Stokes equations
  - **Parsani-Ketcheson-Deconinck series** (`ParsaniKetcheson*`): CFD-optimized variants
  - **Ranocha-Dalcin-Parsani-Ketcheson series** (`RDPK*`): Modern CFD methods

## Performance Considerations

  - **Use only when memory-bound**: Standard RK methods are often more efficient when memory is not limiting
  - **Best for large systems**: Most beneficial for problems with >10⁶ unknowns
  - **GPU acceleration**: Particularly effective on memory-bandwidth limited hardware

```@eval
first_steps = evalfile("./common_first_steps.jl")
first_steps("OrdinaryDiffEqLowStorageRK", "CarpenterKennedy2N54")
```

## Full list of solvers

```@docs
ORK256
DGLDDRK73_C
CarpenterKennedy2N54
NDBLSRK124
NDBLSRK144
CFRLDDRK64
TSLDDRK74
DGLDDRK84_C
DGLDDRK84_F
SHLDDRK64
RK46NL
ParsaniKetchesonDeconinck3S32
ParsaniKetchesonDeconinck3S82
ParsaniKetchesonDeconinck3S53
ParsaniKetchesonDeconinck3S173
ParsaniKetchesonDeconinck3S94
ParsaniKetchesonDeconinck3S184
ParsaniKetchesonDeconinck3S105
ParsaniKetchesonDeconinck3S205
CKLLSRK43_2
CKLLSRK54_3C
CKLLSRK95_4S
CKLLSRK95_4C
CKLLSRK95_4M
CKLLSRK54_3C_3R
CKLLSRK54_3M_3R
CKLLSRK54_3N_3R
CKLLSRK85_4C_3R
CKLLSRK85_4M_3R
CKLLSRK85_4P_3R
CKLLSRK54_3N_4R
CKLLSRK54_3M_4R
CKLLSRK65_4M_4R
CKLLSRK85_4FM_4R
CKLLSRK75_4M_5R
RDPK3Sp35
RDPK3SpFSAL35
RDPK3Sp49
RDPK3SpFSAL49
RDPK3Sp510
RDPK3SpFSAL510
HSLDDRK64
NDBLSRK134
SHLDDRK_2N
SHLDDRK52
```

# Notes on Algorithms

This page is a supplemental page which details some facts about the chosen algorithms,
why some I took the time to make optimized versions for, and for others why they
were ignored.

## Explicit Runge-Kutta ODE Algorithms

From what I can tell, this is by far the most comprehensive comparison of
Explicit Runge-Kutta ODE algorithms that you'll find.

### Implementations

The different implementations have been benchmarked against each other. The efficiency
was calculated by weighing both the time and error on classic test problems.
To make clear distinctions, solver options were tweaked to many different settings,
including:

  - Matching errors
  - Matching runtimes
  - Matching settings
  - Low/High tolerance

The DifferentialEquations.jl implementations of the explicit Runge-Kutta solvers
are by a good margin the most efficient implementations of the given algorithms.
They utilize many extra tricks, nice caching, and threading if available, to
vastly outperform the other methods in terms of efficiency (even with threading
disabled). `:DP5` performs much better than `:dopri5`, which vastly outperform
`ode45` (whose stepsize algorithm tends to have issues on some quasi-stiff problems).
`:DP8` performs better than `dop853` in some cases, worse in others. Both vastly outperform `ode78`.

For this reason, the DifferentialEquations.jl non-stiff algorithms are the recommended
implementations. ODEInterface non-stiff algorithms are only recommended for historical
purposes (i.e. to match previous results) or to try `dop853` on a problem (work is being
to find out what the difference is and squash the competition here!). The ODE.jl algorithms are not recommended
for any serious use (the package is essentially deprecated: it's slow, gets high error,
the timestepping algorithm is not robust, and doesn't implement many methods).

### Order 4-

At this stage, coefficient of the truncation error seems to win out, or you are
willing to live with low tolerance anyways. Thus Bogacki-Shampine is the clear
winner in this category because at order 2/3 with FASL it has minimal numbers
of function evaluations but also is stable enough to step as needed. All other
methods don't compare because of the FASL property boosting the order and thus
the stability (for low orders, it pretty much holds that higher order = higher
stability (for optimal number of steps), which is not true as we go higher), making
it more stable and have less error for lower numbers of function evaluations than
the others in this category.

### Order 5

[Note that for all of these Peter Stone's modifications do not seem to be helpful since,
although they lower the truncation error, they also modify the stability region
in ways that can be worrisome (mostly they shrink the stability in the complex axis
near the origin, making the problems not as suitable for a "general purpose default"
like one would hope with a 4/5 solver)]

The "clear choice" is the Dormand-Prince 4/5 pair. This is the pair which is
used by default as ode45 in MATLAB, and serves similar functions in scipy,
ODE.jl, etc. The golden standard implementation is Hairer's DOPRI5 (offered
by ODEInterface.jl). After optimizations, DifferentialEquations.jl's native
DP5 solver is much more efficient (between 4x-400x) than DOPRI5's, with various design choices
factoring into this (which are documented in the benchmarks). This is pre-threading,
and within method threading will likely be at least doubled or tripled when
threading is enabled. Thus it's clear that the reference implementation to
try other methods against is the DifferentialEquations.jl DP5 method.

It's obvious that anything before Dormand-Prince 4/5's pair is simply not as
good because of the optimizations on the local truncation error coefficient
and the fact that FASL schemes essentially have one less function evaluation.
So the previous algorithms were implemented as tableaus for the historical
reasons but dealt with no further. These methods include the Runge, Cassity,
Butcher, Fehlburg, Lawson, Luther and Konen, and Kutta schemes.

The next set of schemes are the Papakostas-Papageorgiou schemes. The problem is
that they don't really get the much lower on the error than DP5, but also have
wacky stability near the origin.

Tsitouras's looks to be a good match against DP5 as a 6-stage scheme to take on
DP5. Its stability is similar to DP5 but its first error term is an order of magnitude
smaller. More tests will likely determine that this is much better than DP5 in
accordance with his paper.

Lastly, there are the 7-stage schemes. The more recent one is due to Sharp and Smart,
but I am ignoring this because its error term is almost an order of magnitude
larger than the BS pair, and its stability region is wonky near the origin.
Its only plus over the BS pair is that it has a slightly larger stability in the
real axis, which is not important when paired with adaptive stepping and for
use on non-stiff problems.

That leaves us with the Bogacki-Shampine pair. This pair gets more than an order
of magnitude lower truncation error, enhanced complex stability, and two error estimators
to make it more robust. In fact, this is the default which is chosen in
Mathematica. Its downside is that since it is an 8-stage scheme, it requires
an additional function evaluation.

Further tests will likely narrow this down to Tsitouras vs Bogacki-Shampine.
Who will come out on top? Who knows.

### Order 6

Sharp-Verner has bad complex stability near the origin. I don't like any of the
Peter Stone modifications here. Butcher and Chummund methods have stability issues near the
origin as well. Huta's method has too high of an error coefficient. Verner's 1991
has bad complex stability. Same as the most robust. The Verner "most efficient"
has really good stability and error coefficient. In fact, nothing is even
close except for Tsitouras' method. The DP method is two orders of magnitude
higher in error coefficient than Verner. The Luther methods have too much error.
Same as Tsitouras-Papakostas and  M. Tanaka, K. Kasuga, S. Yamashita and H. Yazaki.

Without a doubt the winner is the Verner "most efficient".

### Order 7

The Enright-Verner and other Verner methods all have stability issues near the
origin in the complex plane and higher error coefficients. Sharp and Smart
have higher error coefficients. Peter Stone's methods all have higher error.
It's very clear that the best here is the Tanaka-Yamashita (efficient, not the stable)
method by far.

### Order 8

The Cooper-Verner methods do not have an error estimate and so no adaptive
timestepping can be done. This is a deal-breaker. Going into this one would
think that the clear winner would be Dormand-Prince 8. But that's not the case.
However, that's comparing the classical 1981 DP87. Notice that the code for
Dop853 is based off of the 1989 paper which has different coefficients (and currently
I have no analysis for this).

The other methods include Verner's Maple dverk78 which is bested in both stability
and error coefficient by Enright-Verner which is bested by Tsitouras-Papakostas.

Thus the final showdown is between DP853 vs the Tsitouras-Papakostas pair.

### Order 9

The Tsitouras scheme and the Sharp scheme have funky stability near the origin.
Verner's schemes are much safer, and with similar error. They clearly
dominate this category.

### Order 10

Curtis' scheme has more function evaluations than needed, and Peter Stone's
modification reduces the truncation error by a lot but adds three more function
evaluations. Thus Hairer's 17 stage scheme (whose error and stability is similar
to Curtis') is clearly better. Once again Peter Stone's modification adds three
steps but does not reduce the truncation error here, so the unmodified version
does better.

Tom Baker's method increases the stability region to something which is more than
necessary but adds 4 function evaluations to do so (without lowering the error
very much). Ono's scheme minimizes the error more than Hairer's here, with
all else being basically the same. The Peter Stone methods add a lot of function
evaluations (5+) and so they would only be useful in the case where the function
evaluations are quick yet you still want really small error. Even then I'm not
convinced they are better than the other methods, or better than the higher order
methods which use less steps. The stability is only okay.

The Feagin scheme is fine, but with more error and less stability than the Hairer
scheme. Thus it seems clear that Hairer's method dominates this category. However,
that's only because it does not include an error estimate. Feagin's scheme is
close in error and stability, but includes an error estimate which can be used
for adaptivity, making it the choice in this category.

### Order 11

The order 11 schemes are due to Tom Baker at the University of Teeside. They
have a nice sparsity pattern and receive slightly lower truncation error coefficients
than the Feagin, but Feagin's dominates by being "almost order 13" anyways
so while a nice try the order 11 scheme is likely overwhelmed in any case where
it would be useful.

### Order 12

Here there are the Feagin schemes and Ono's scheme. Ono's scheme gets horrible
stability with more error and so it's not in the running. Peter Stone's modifications
do not make a substantive change, and where they do they get rid of the nice
property that the Feagin 12 method satisfies many of the higher order conditions
as well, making it look even higher order on some problems. Thus the standard
Feagin 12 seems to win out in this category.

### Order 14

In this category there is just the Feagin. Peter Stone's modification barely
changes anything in the analysis so I did not even attempt it.

```@meta
CollapsedDocStrings = true
```

# OrdinaryDiffEqFeagin

Ultra-high-order explicit Runge-Kutta methods for non-stiff problems at extremely low tolerances (< 1e-30). These methods are designed for applications requiring extreme precision, typically used with higher-precision number types like `BigFloat`.

## Key Properties

Feagin methods provide:

  - **Ultra-high-order accuracy** (10th, 12th, and 14th order)
  - **Extreme precision capabilities** for very low tolerance requirements
  - **Compatibility with arbitrary precision** arithmetic (`BigFloat`, `Float128`)
  - **Specialized for very demanding applications** requiring maximum accuracy

## When to Use Feagin Methods

These methods are recommended for:

  - **Extremely low tolerance problems** (< 1e-30)
  - **Arbitrary precision arithmetic** applications using `BigFloat` or `Float128`
  - **Ultra-high precision requirements** where standard methods are insufficient
  - **Research applications** requiring maximum possible accuracy
  - **Long-time integration** where error accumulation must be minimized to extreme levels

## Important Limitations

### Theoretical vs Practical Performance

  - **Very good theoretical efficiency** due to high order and optimized coefficients
  - **Poor practical performance** in benchmarks due to bad error estimators and adaptivity issues
  - **Generally recommend `Vern9` instead** as it tends to be more efficient in practice despite lower theoretical order

### Performance Considerations

  - **May be less efficient** than `Vern9` even for very low tolerance problems
  - **Outperformed by extrapolation methods** at extremely low tolerances due to adaptive order
  - **Potential efficiency for >128-bit numbers** but no practical cases found yet where this is actually true
  - **Should always be tested** against `Vern9` and extrapolation methods

## Solver Selection Guide

### Extreme precision (< 1e-30)

  - **`Feagin14`**: 14th-order method for maximum accuracy
  - **`Feagin12`**: 12th-order method, balance of accuracy and efficiency
  - **`Feagin10`**: 10th-order method for moderate extreme precision

### Strongly recommended alternatives

  - **For most very low tolerance problems**: Use `Vern9` first (more efficient in practice despite lower theoretical order)
  - **For extremely low tolerances**: Consider extrapolation methods for adaptive order
  - **For >128-bit precision**: These methods may be more efficient, but no practical cases found yet
  - **Always benchmark**: Compare performance with `Vern9` and extrapolation methods before choosing Feagin methods

## Usage Guidelines

  - **Best with `BigFloat`** or `Float128` number types
  - **Useful in Float128 precision range** but test against other algorithms
  - **Consider problem-specific characteristics** when choosing order level

```@eval
first_steps = evalfile("./common_first_steps.jl")
first_steps("OrdinaryDiffEqFeagin", "Feagin14")
```

## Full list of solvers

```@docs
Feagin10
Feagin12
Feagin14
```

```@meta
CollapsedDocStrings = true
```

# OrdinaryDiffEqPDIRK

PDIRK methods are parallel DIRK methods.
SDIRK methods, or singly-diagonally implicit methods,
have to build and solve a factorize a Jacobian of the form `W = I-gammaJ` where `gamma` is dependent on the chosen method.
PDIRK methods use multiple different choices of `gamma`, i.e. `W_i = I-gamma_iJ`,
which are all used in the update process.
There are some advantages to this,
as no SDIRK method can be a higher order than 5,
while DIRK methods generally can have arbitrarily high order and lower error coefficients,
leading to lower errors at larger dt sizes.
With the right construction of the tableau,
these matrices can be factorized and the underlying steps can be computed in parallel,
which is why these are the parallel DIRK methods.

!!! warning "Experimental"
    
    `OrdinaryDiffEqPDIRK` is experimental,
    as there are no parallel DIRK tableaus that achieve good performance in the literature.

```@eval
first_steps = evalfile("./common_first_steps.jl")
first_steps("OrdinaryDiffEqPDIRK", "PDIRK44")
```

## Full list of solvers

```@docs
PDIRK44
```

```@meta
CollapsedDocStrings = true
```

# OrdinaryDiffEqLowOrderRK

Low-order explicit Runge-Kutta methods for non-stiff differential equations. **Most of the time, you should use [`Tsit5`](@ref OrdinaryDiffEqTsit5)**, which is the most common and efficient low-order RK method. The alternative methods provided here are for special circumstances where Tsit5 is not suitable.

## Key Properties

Low-order explicit RK methods offer:

  - **Computational efficiency** at higher tolerances (>1e-6)
  - **Robust error control** for difficult non-stiff problems
  - **Specialized interpolation properties** for applications requiring dense output
  - **Lower-order derivatives** requirements for non-smooth functions
  - **Good performance** for specific problem types

## When to Use Alternative Low-Order RK Methods

Choose these methods instead of Tsit5 when:

  - **ODE function `f` is not differentiable to 5th order** - use lower-order methods (the more discontinuous, the lower the order needed)
  - **Heavy use of interpolations** - OwrenZen methods have superior interpolation convergence
  - **Delay differential equations** - OwrenZen methods are most efficient (see SciMLBenchmarks)
  - **Very high tolerances** (>1e-3) - BS3 is more efficient than Tsit5
  - **Quadratic polynomial ODEs** - SIR54 is optimized for these systems
  - **Educational purposes** - simpler methods for understanding algorithms

## Solver Selection Guide

### Primary recommendation

**For most problems, use [`Tsit5`](@ref OrdinaryDiffEqTsit5) instead of these methods.**

### High tolerances (>1e-3)

  - **`BS3`**: Third-order Bogacki-Shampine method, most efficient for very high tolerances

### Superior interpolation needs

  - **`OwrenZen3`**: Third-order with excellent interpolation convergence
  - **`OwrenZen5`**: Fifth-order with excellent interpolation, **optimal for DDEs**
  - **`OwrenZen4`**: Fourth-order interpolation-optimized method

### Non-smooth or discontinuous ODEs

  - **`BS3`**: Third-order for mildly non-smooth functions
  - **`Heun`**: Second-order for more discontinuous functions (not generally recommended)
  - **`Euler`**: First-order for highly discontinuous problems

### Robust error control alternatives

  - **`BS5`**: Fifth-order with very robust error estimation
  - **`DP5`**: Fifth-order Dormand-Prince method, classical alternative to Tsit5

### Specialized applications

  - **`RK4`**: Fourth-order with special residual error control, good for DDEs. **Note**: Uses adaptive timestepping by default - set `adaptive=false` in `solve()` for traditional fixed-step RK4
  - **`SIR54`**: Fifth-order optimized for ODEs defined by quadratic polynomials (e.g., SIR-type epidemiological models)
  - **`Stepanov5`**: Fifth-order method with enhanced stability properties and optimized error constants
  - **`Ralston`**: Second-order with optimized error constants

### Periodic and oscillatory problems

  - **`Anas5`**: Fifth-order optimized for periodic problems with minimal phase error
  - **`FRK65`**: Sixth-order zero dissipation method for oscillatory problems

### Advanced specialized methods

  - **`RKO65`**: Sixth-order optimized method
  - **`MSRK5`**, **`MSRK6`**: Multi-stage methods for specific applications
  - **`PSRK4p7q6`**, **`PSRK3p5q4`**, **`PSRK3p6q5`**: Pseudo-symplectic methods
  - **`Alshina2`**, **`Alshina3`**, **`Alshina6`**: Methods with optimized parameters

```@eval
first_steps = evalfile("./common_first_steps.jl")
first_steps("OrdinaryDiffEqLowOrderRK", "BS3")
```

## Full list of solvers

```@docs
Euler
Heun
Ralston
Midpoint
RK4
BS3
OwrenZen3
OwrenZen4
OwrenZen5
BS5
DP5
Anas5
RKO65
FRK65
RKM
MSRK5
MSRK6
PSRK4p7q6
PSRK3p5q4
PSRK3p6q5
Stepanov5
SIR54
Alshina2
Alshina3
Alshina6
```

```@meta
CollapsedDocStrings = true
```

# OrdinaryDiffEqExtrapolation

Explicit extrapolation methods that achieve high accuracy through Richardson extrapolation of basic integration schemes. These methods provide adaptive order capabilities and natural parallelism, though they are generally outclassed by modern Runge-Kutta methods for most non-stiff problems.

## Key Properties

Extrapolation methods provide:

  - **Adaptive order capability** allowing arbitrarily high orders
  - **Natural parallelism** across different substep sequences
  - **High accuracy potential** for very smooth problems
  - **Richardson extrapolation** to eliminate lower-order error terms
  - **Automatic stepsize and order control**
  - **Theoretical appeal** but often practical limitations

## When to Use Extrapolation Methods

These methods are recommended for:

  - **Very smooth problems** where high-order accuracy is beneficial
  - **Extremely low tolerance requirements** where adaptive order helps
  - **Parallel computing environments** that can exploit the natural parallelism
  - **Research applications** exploring adaptive order techniques
  - **Problems where other high-order methods struggle** with accuracy

## Important Limitations

  - **Generally outclassed** by modern explicit RK methods (Tsit5, Verner methods)
  - **Higher computational overhead** compared to optimized RK methods
  - **Best suited for very smooth functions** - poor performance on non-smooth problems
  - **Parallel efficiency gains** often don't compensate for increased work

## Mathematical Background

Extrapolation methods use sequences of basic integrators (like Euler or midpoint) with different stepsizes, then apply Richardson extrapolation to achieve higher-order accuracy. The adaptive order capability comes from using longer extrapolation sequences.

## Solver Selection Guide

### Explicit extrapolation methods

  - **`AitkenNeville`**: Euler extrapolation using Aitken-Neville algorithm
  - **`ExtrapolationMidpointDeuflhard`**: Midpoint extrapolation with barycentric coordinates
  - **`ExtrapolationMidpointHairerWanner`**: Midpoint extrapolation following ODEX algorithm

### When to consider these methods

  - **Very low tolerances** (< 1e-12) where adaptive order might help
  - **Extremely smooth problems** with analytic solutions
  - **Parallel computing** scenarios with many available cores
  - **Comparison studies** with other high-order methods

### Better alternatives for most problems

  - **For high accuracy**: Use Verner methods (Vern7, Vern8, Vern9)
  - **For general problems**: Use Tsit5 or appropriate RK method
  - **For stiff problems**: Consider [implicit extrapolation methods](@ref StiffExtrapolation)

## Performance Notes

  - **Consider stiff extrapolation** methods which can perform very well for sufficiently stiff problems
  - **Test against Verner methods** before choosing extrapolation for high accuracy
  - **Parallelism benefits** are problem and hardware dependent
  - **Most effective** on very smooth, well-behaved problems

```@eval
first_steps = evalfile("./common_first_steps.jl")
first_steps("OrdinaryDiffEqExtrapolation", "ExtrapolationMidpointDeuflhard")
```

## Full list of solvers

```@docs
AitkenNeville
ExtrapolationMidpointDeuflhard
ExtrapolationMidpointHairerWanner
```

```@meta
CollapsedDocStrings = true
```

# OrdinaryDiffEqRKN

Runge-Kutta-Nyström (RKN) methods for solving second-order differential equations of the form `d²u/dt² = f(u, du/dt, t)`. These methods are specifically designed for second-order ODEs and can be more efficient than converting to first-order systems when the problem has this natural structure.

## Key Properties

RKN methods provide:

  - **Direct integration** of second-order ODEs without conversion to first-order systems
  - **Efficient handling** of problems where velocity dependence is minimal or absent
  - **Specialized variants** for different types of second-order problems
  - **High-order accuracy** with methods up to 12th order available
  - **Trigonometrically-fitted variants** for oscillatory problems
  - **Improved efficiency** for second-order problems compared to first-order conversions

## When to Use RKN Methods

These methods are recommended for:

  - **Second-order differential equations** with natural `d²u/dt² = f(u, du/dt, t)` structure
  - **Classical mechanics problems** (Newton's equations of motion)
  - **Oscillatory second-order systems** (springs, pendulums, wave equations)
  - **Problems where velocity dependence is weak** or absent
  - **Celestial mechanics** and orbital dynamics
  - **Vibration analysis** and structural dynamics
  - **Wave propagation** problems in their natural second-order form

## Problem Types

### Velocity-independent problems: `d²u/dt² = f(u, t)`

When the acceleration depends only on position (and possibly time):

  - **More efficient specialized methods** available
  - **Classical examples**: gravitational problems, springs with `F = -kx`

### Velocity-dependent problems: `d²u/dt² = f(u, du/dt, t)`

When acceleration depends on both position and velocity:

  - **General RKN methods** handle the full dependence
  - **Examples**: damped oscillators, air resistance problems

## Solver Selection Guide

### General-purpose RKN methods

  - **`Nystrom4`**: Fourth-order method for general second-order ODEs
  - **`IRKN3`**, **`IRKN4`**: Improved Runge-Kutta-Nyström methods

### Velocity-independent specialized methods

  - **`Nystrom4VelocityIndependent`**: Fourth-order for `d²u/dt² = f(u, t)`
  - **`Nystrom5VelocityIndependent`**: Fifth-order for `d²u/dt² = f(u, t)`

### Velocity-dependent methods

  - **`FineRKN4`**: Fourth-order allowing velocity dependence
  - **`FineRKN5`**: Fifth-order allowing velocity dependence

### High-order Dormand-Prince variants

  - **`DPRKN4`**: Fourth-order Dormand-Prince RKN
  - **`DPRKN5`**: Fifth-order Dormand-Prince RKN
  - **`DPRKN6`**: Sixth-order with free interpolant
  - **`DPRKN6FM`**: Sixth-order with optimized error coefficients
  - **`DPRKN8`**: Eighth-order for high accuracy
  - **`DPRKN12`**: Twelfth-order for extreme precision

### Trigonometrically-fitted methods for oscillatory problems

  - **`ERKN4`**: Embedded 4(3) pair for periodic problems
  - **`ERKN5`**: Embedded 5(4) pair for periodic problems
  - **`ERKN7`**: Higher-order embedded pair for oscillatory systems

### Specialized methods

  - **`RKN4`**: Fourth-order for linear inhomogeneous second-order IVPs

## Advantages Over First-Order Conversion

  - **Natural problem structure**: Preserves the physical meaning of the equations
  - **Specialized optimizations**: Methods can exploit second-order structure

To be able to access the solvers in `OrdinaryDiffEqRKN`, you must first install them use the Julia package manager:

```julia
using Pkg
Pkg.add("OrdinaryDiffEqRKN")
```

This will only install the solvers listed at the bottom of this page.
If you want to explore other solvers for your problem,
you will need to install some of the other libraries listed in the navigation bar on the left.

## Example usage

```julia
using OrdinaryDiffEqOrdinaryDiffEqRKN
function HH_acceleration!(dv, v, u, p, t)
    x, y = u
    dx, dy = dv
    dv[1] = -x - 2x * y
    dv[2] = y^2 - y - x^2
end
initial_positions = [0.0, 0.1]
initial_velocities = [0.5, 0.0]
tspan = (0.0, 1.0)
prob = SecondOrderODEProblem(HH_acceleration!, initial_velocities, initial_positions, tspan)
sol = solve(prob, Nystrom4(), dt = 1 / 10)
```

## Full list of solvers

```@docs
IRKN3
IRKN4
Nystrom4
Nystrom4VelocityIndependent
Nystrom5VelocityIndependent
FineRKN4
FineRKN5
DPRKN4
DPRKN5
DPRKN6
DPRKN6FM
DPRKN8
DPRKN12
ERKN4
ERKN5
ERKN7
RKN4
```

# Type Traits

Many of the DiffEqBase abstract types have associated traits. These can be used
to check compatibility and apply separate code paths. For example, a parameter
estimation algorithm can set the default for using autodifferentiation by checking
if the algorithm is compatible with autodifferentiation.

Below are the abstract types along with the associated trait functions. These
are listed as:

```julia
f(x)
```

where `f` is the trait function and `x` is the any type which subtypes the abstract
type.

### AbstractODEProblem

  - `isinplace` : Returns true if the problem uses in-place functions

### AbstractRODEProblem

  - `is_diagonal_noise` : Returns true if the noise is diagonal.

### DEAlgorithm

  - `isautodifferentiable` : Returns true if the algorithm is autodifferentiable.

  - This repository follows the [SciMLStyle](https://github.com/SciML/SciMLStyle) and the SciML [ColPrac](https://github.com/SciML/ColPrac).
  - Please run `using JuliaFormatter, OrdinaryDiffEq; format(joinpath(dirname(pathof(OrdinaryDiffEq)), ".."))` before committing.
  - Add tests for any new features.
  - Additional help on contributing to the numerical solvers can be found at https://docs.sciml.ai/DiffEqDevDocs/stable/

## Developing Locally

OrdinaryDiffEq is a very large package and thus it uses a sublibrary approach to keep down
the total number of dependencies per solver. As a consequence, it requires a bit of special
handling compared to some other Julia packages. When running the full test suite, it's
recommended that one has dev'd all of the relevant packages. This can be done via:

```julia
using Pkg
pathtolibrary = Pkg.pkgdir(OrdinaryDiffEq)
sublibs = joinpath.(pathtolibrary, "lib", readdir(joinpath(pathtolibrary, "lib")))
Pkg.develop(map(name -> Pkg.PackageSpec.(; path = name), sublibs));
```

and then running `Pkg.test("OrdinaryDiffEq")` will run the global tests locally. Each of the
per-solver subtests, which includes convergence tests and other per-library handling,
is then ran by using a specific solver set, such as
`Pkg.test("OrdinaryDiffEqAdamsBashforthMoulton")`

## Dependency Structure

There is a tree dependency structure to the sublibraries of OrdinaryDiffEq. The core stepper
lives in OrdinaryDiffEqCore.jl. Explicit methods only require the core. Then on top of the
core is OrdinaryDiffEqDifferentiation.jl which defines the utilities used for differentiation
and Jacobian construction. This is used directly by methods like Rosenbrock and exponential
integrators, which use Jacobians but not implicit solvers. Finally there's
OrdinaryDiffEqNonlinearSolve, which is the largest set of dependencies and pulls in the
NonlinearSolve.jl stack for handling implicit equations, and is thus the core dependency
of the implicit integrators. OrdinaryDiffEqNonlinearSolve relies on OrdinaryDiffEqDifferentiation
which relies on OrdinaryDiffEqCore.

```@meta
CollapsedDocStrings = true
```

# OrdinaryDiffEqRosenbrock

Rosenbrock methods for mass matrix differential-algebraic equations (DAEs) and stiff ODEs with singular mass matrices. These methods provide efficient integration for moderately stiff systems with algebraic constraints, offering excellent performance for small to medium-sized DAE problems.

## Key Properties

Mass matrix Rosenbrock methods provide:

  - **DAE capability** for index-1 differential-algebraic equations
  - **W-method efficiency** using approximate Jacobians for computational savings
  - **Mass matrix support** for singular and non-diagonal mass matrices
  - **Moderate to high order accuracy** (2nd to 6th order available)
  - **Good stability properties** with stiffly accurate behavior
  - **Embedded error estimation** for adaptive timestepping

## When to Use Mass Matrix Rosenbrock Methods

These methods are recommended for:

  - **Index-1 DAE systems** with moderate stiffness
  - **Small to medium constrained systems** (< 1000 equations)
  - **Semi-explicit DAEs** arising from discretized PDEs
  - **Problems requiring good accuracy** with moderate computational cost
  - **DAEs with moderate nonlinearity** where W-methods are efficient
  - **Electrical circuits** and **mechanical systems** with constraints

!!! warn
    
    In order to use OrdinaryDiffEqRosenbrock with DAEs that require a non-trivial
    consistent initialization, a nonlinear solver is required and thus
    `using OrdinaryDiffEqNonlinearSolve` is required or you must pass an `initializealg`
    with a valid `nlsolve` choice.

## Mathematical Background

Mass matrix DAEs have the form:
`M du/dt = f(u,t)`

Rosenbrock methods linearize around the current solution and solve linear systems of the form:
`(M/γh - J) k_i = ...`

where J is the Jacobian of f and γ is a method parameter.

## Solver Selection Guide

### Recommended Methods by Tolerance

  - **High tolerances** (>1e-2): **`Rosenbrock23`** - efficient low-order method
  - **Medium tolerances** (1e-8 to 1e-2): **`Rodas5P`** - most efficient choice, or **`Rodas4P`** for higher reliability
  - **Low tolerances** (<1e-8): **`Rodas5Pe`** or higher-order alternatives

### Method families

  - **`Rodas5P`**: **Recommended** - Most efficient 5th-order method for general use
  - **`Rodas4P`**: More reliable 4th-order alternative
  - **`Rosenbrock23`**: Good for high tolerance problems
  - **`Rodas5`**: Standard 5th-order method without embedded pair optimization

## Performance Guidelines

### When mass matrix Rosenbrock methods excel

  - **Small to medium DAE systems** (< 1000 equations)
  - **Moderately stiff problems** where full BDF methods are overkill
  - **Problems with efficient Jacobian computation** or finite difference approximation
  - **Index-1 DAEs with well-conditioned mass matrices**
  - **Semi-explicit index-1 problems** from spatial discretizations

### System size considerations

  - **Small systems** (< 100): Rosenbrock methods often outperform multistep methods
  - **Medium systems** (100-1000): Good performance with proper linear algebra
  - **Large systems** (> 1000): Consider BDF methods instead

## Important DAE Considerations

### Initial conditions

  - **Must be consistent** with algebraic constraints
  - **Consistent initialization** may require nonlinear solver
  - **Index-1 assumption** for reliable performance

### Mass matrix requirements

  - **Index-1 DAE structure** for optimal performance
  - **Non-singular leading submatrix** for differential variables
  - **Well-conditioned constraint equations**

## Alternative Approaches

Consider these alternatives:

  - **Mass matrix BDF methods** for larger or highly stiff DAE systems
  - **Implicit Runge-Kutta methods** for higher accuracy requirements
  - **Standard Rosenbrock methods** for regular ODEs without constraints
  - **IMEX methods** if natural explicit/implicit splitting exists

## Example Usage

```julia
using LinearAlgebra: Diagonal
function rober(du, u, p, t)
    y₁, y₂, y₃ = u
    k₁, k₂, k₃ = p
    du[1] = -k₁ * y₁ + k₃ * y₂ * y₃
    du[2] = k₁ * y₁ - k₃ * y₂ * y₃ - k₂ * y₂^2
    du[3] = y₁ + y₂ + y₃ - 1
    nothing
end
M = Diagonal([1.0, 1.0, 0])  # Singular mass matrix
f = ODEFunction(rober, mass_matrix = M)
prob_mm = ODEProblem(f, [1.0, 0.0, 0.0], (0.0, 1e5), (0.04, 3e7, 1e4))
sol = solve(prob_mm, Rodas5(), reltol = 1e-8, abstol = 1e-8)
```

```@eval
first_steps = evalfile("./common_first_steps.jl")
first_steps("OrdinaryDiffEqRosenbrock", "Rodas5P")
```

## Full list of solvers

```@docs; canonical=false
Rosenbrock23
Rosenbrock32
ROS3P
Rodas3
Rodas23W
Rodas3P
Rodas4
Rodas42
Rodas4P
Rodas4P2
Rodas5
Rodas5P
Rodas5Pe
Rodas5Pr
RosenbrockW6S4OS
ROS2
ROS2PR
ROS2S
ROS3
ROS3PR
Scholz4_7
ROS34PW1a
ROS34PW1b
ROS34PW2
ROS34PW3
ROS34PRw
ROS3PRL
ROS3PRL2
ROK4a
RosShamp4
Veldd4
Velds4
GRK4T
GRK4A
Ros4LStab
```

```@meta
CollapsedDocStrings = true
```

# OrdinaryDiffEqHighOrderRK

High-order explicit Runge-Kutta methods for non-stiff differential equations requiring high accuracy. These methods provide alternatives to the Verner methods, though **[`OrdinaryDiffEqVerner`](@ref OrdinaryDiffEqVerner) methods generally perform better at low tolerances** and should be preferred in most cases.

## Key Properties

High-order RK methods provide:

  - **High-order accuracy** (7th and 8th order) for precise integration
  - **Specialized coefficients** for specific problem types
  - **Dense output capabilities** for some methods
  - **Alternative approaches** to the more commonly used Verner methods

## When to Use High-Order RK Methods

These methods are recommended when:

  - **Verner methods are not suitable** for specific problem characteristics
  - **Specialized properties** are needed (e.g., phase-fitted methods for oscillatory problems)
  - **Research or comparison purposes** require different high-order method families
  - **Specific applications** benefit from particular method properties

## Solver Selection Guide

### General high-order integration

  - **Use [`Vern7`](@ref OrdinaryDiffEqVerner) or [`Vern8`](@ref OrdinaryDiffEqVerner) instead** - they are generally more efficient

### Specialized cases where these methods may be preferred

  - **`TanYam7`**: Seventh-order Tanaka-Yamashita method
  - **`TsitPap8`**: Eighth-order Tsitouras-Papakostas method
  - **`DP8`**: Eighth-order Dormand-Prince method (Hairer's 8/5/3 implementation)
  - **`PFRK87`**: Phase-fitted eighth-order method for oscillatory problems

## Performance Notes

  - **Verner methods are generally more efficient** for most high-accuracy applications
  - **These methods are provided** for specialized use cases and research purposes
  - **Consider problem-specific properties** when choosing between different high-order families

```@eval
first_steps = evalfile("./common_first_steps.jl")
first_steps("OrdinaryDiffEqHighOrderRK", "DP8")
```

## Full list of solvers

```@docs
TanYam7
TsitPap8
DP8
PFRK87
```

```@meta
CollapsedDocStrings = true
```

# OrdinaryDiffEqTaylorSeries

Taylor series methods for ordinary differential equations using automatic differentiation. These methods achieve very high-order accuracy by computing Taylor expansions of the solution using automatic differentiation techniques through TaylorDiff.jl.

!!! warn "Development Status"
    
    These methods are still in development and may not be fully optimized or reliable for production use.

## Key Properties

Taylor series methods provide:

  - **Very high-order accuracy** with arbitrary order capability
  - **Automatic differentiation** for derivative computation
  - **Step size control** through Taylor series truncation
  - **Natural error estimation** from higher-order terms
  - **Excellent accuracy** for smooth problems
  - **Single-step methods** without requiring history

## When to Use Taylor Series Methods

These methods are recommended for:

  - **Ultra-high precision problems** where maximum accuracy is needed
  - **Smooth problems** with well-behaved derivatives
  - **Scientific computing** requiring very low error tolerances
  - **Problems with expensive function evaluations** where high-order methods reduce total steps

## Mathematical Background

Taylor series methods compute the solution using Taylor expansions:
`u(t + h) = u(t) + h*u'(t) + h²/2!*u''(t) + h³/3!*u'''(t) + ...`

The derivatives are computed automatically using automatic differentiation, allowing arbitrary-order methods without manual derivative computation.

## Solver Selection Guide

### Available Methods

  - **`ExplicitTaylor2`**: Second-order Taylor series method for moderate accuracy
  - **`ExplicitTaylor`**: Arbitrary-order Taylor series method (specify order with `order = Val{p}()`)

### Usage considerations

  - **Smooth problems only**: Methods assume the function has many continuous derivatives
  - **Computational cost**: Higher orders require more automatic differentiation computations
  - **Memory requirements**: Higher orders store more derivative information

## Performance Guidelines

### When Taylor series methods excel

  - **Very smooth problems** where high-order derivatives exist and are well-behaved
  - **High precision requirements** beyond standard double precision
  - **Long-time integration** where accumulated error matters
  - **Problems where function evaluations dominate** computational cost

### Problem characteristics

  - **Polynomial and analytic functions** work extremely well
  - **Smooth ODEs** from physics simulations
  - **Problems requiring** very low tolerances (< 1e-12)

## Limitations and Considerations

### Method limitations

  - **Requires smooth functions** - non-smooth problems may cause issues
  - **Memory overhead** for storing multiple derivatives
  - **Limited to problems** where high-order derivatives are meaningful
  - **Automatic differentiation compatibility** - requires functions compatible with TaylorDiff.jl and Symbolics.jl tracing
  - **Long compile times** due to automatic differentiation and symbolic processing overhead

### When to consider alternatives

  - **Non-smooth problems**: Use adaptive Runge-Kutta methods instead
  - **Stiff problems**: Taylor methods are explicit and may be inefficient
  - **Large systems**: Automatic differentiation cost may become prohibitive
  - **Standard accuracy needs**: Lower-order methods are often sufficient

## Alternative Approaches

Consider these alternatives:

  - **High-order Runge-Kutta** methods (Feagin, Verner) for good accuracy with less overhead
  - **Extrapolation methods** for high accuracy with standard function evaluations
  - **Adaptive methods** for problems with varying smoothness
  - **Implicit methods** for stiff problems requiring high accuracy

## Installation and Usage

Taylor series methods require explicit installation of the specialized library:

```julia
using Pkg
Pkg.add("OrdinaryDiffEqTaylorSeries")
```

Then use the methods with:

```julia
using OrdinaryDiffEqTaylorSeries

# Example: Second-order Taylor method
function f(u, p, t)
    σ, ρ, β = p
    du1 = σ * (u[2] - u[1])
    du2 = u[1] * (ρ - u[3]) - u[2]
    du3 = u[1] * u[2] - β * u[3]
    [du1, du2, du3]
end

u0 = [1.0, 0.0, 0.0]
tspan = (0.0, 10.0)
p = [10.0, 28.0, 8/3]
prob = ODEProblem(f, u0, tspan, p)

# Second-order Taylor method
sol = solve(prob, ExplicitTaylor2())

# Arbitrary-order Taylor method (e.g., 8th order)
sol = solve(prob, ExplicitTaylor(order = Val{8}()))
```

## Full list of solvers

```@docs
ExplicitTaylor2
ExplicitTaylor
```

```@meta
CollapsedDocStrings = true
```

# OrdinaryDiffEqRosenbrock

Rosenbrock methods are semi-implicit Runge-Kutta methods designed for small to medium-sized stiff systems of differential equations. These methods combine the stability properties of implicit methods with computational efficiency by using approximate Jacobians. They work particularly well for strict tolerance requirements.

## Key Properties

Rosenbrock methods provide:

  - **Excellent efficiency for small to medium systems** (<1000 ODEs)
  - **L-stable and A-stable variants** for stiff problems
  - **W-method structure** making them robust to inaccurate Jacobians
  - **Automatic differentiation compatibility** for Jacobian computation
  - **High-order accuracy** with embedded error estimation
  - **Excellent performance for strict tolerance requirements**
  - **Stiffly accurate variants** for enhanced stability

## When to Use Rosenbrock Methods

Rosenbrock methods are recommended for:

  - **Small to medium stiff systems** (10 to 1000 equations)
  - **Problems where Jacobians are available** or can be computed efficiently
  - **Medium tolerance requirements** (1e-8 to 1e-2)
  - **Stiff ODEs arising from reaction kinetics** and chemical systems
  - **Moderately stiff PDEs** after spatial discretization
  - **Problems requiring reliable error control** for stiff systems

## Solver Selection Guide

### Low tolerance (>1e-2)

  - **`Rosenbrock23`**: Second/third-order method, recommended for low tolerance requirements

### Medium tolerance (1e-8 to 1e-2)

  - **`Rodas5P`**: Fifth-order method, most efficient for many problems
  - **`Rodas4P`**: Fourth-order method, more reliable than Rodas5P
  - **`Rodas5Pe`**: Enhanced fifth-order variant with stiffly accurate embedded estimate for better adaptivity on highly stiff equations
  - **`Rodas5Pr`**: Fifth-order variant with residual test for robust error estimation that guarantees accuracy on interpolation

## Performance Guidelines

  - **Rodas5P**: Best overall efficiency at medium tolerances
  - **Rodas4P**: Most reliable when Rodas5P fails
  - **Rosenbrock23**: Fastest at high tolerances (>1e-2)

## When to Choose Alternatives

Consider other methods when:

  - **System size > 1000**: Use BDF methods (QNDF, FBDF)
  - **Matrix-free methods**: If using Krylov solvers for the linear solver (matrix-free methods), SDIRK or BDF methods are preferred

## Advantages of Rosenbrock Methods

  - **Very low tolerances**: Rosenbrock23 performs well even at very low tolerances
  - **Very high stiffness**: Rosenbrock methods are often more stable than SDIRK or BDF methods because other methods can diverge due to bad initial guesses for the Newton method (leading to nonlinear solver divergence)

```@eval
first_steps = evalfile("./common_first_steps.jl")
first_steps("OrdinaryDiffEqRosenbrock", "Rodas5P")
```

## Full list of solvers

```@docs
Rosenbrock23
Rosenbrock32
ROS3P
Rodas3
Rodas23W
Rodas3P
Rodas4
Rodas42
Rodas4P
Rodas4P2
Rodas5
Rodas5P
Rodas5Pe
Rodas5Pr
RosenbrockW6S4OS
ROS2
ROS2PR
ROS2S
ROS3
ROS3PR
Scholz4_7
ROS34PW1a
ROS34PW1b
ROS34PW2
ROS34PW3
ROS34PRw
ROS3PRL
ROS3PRL2
ROK4a
RosShamp4
Veldd4
Velds4
GRK4T
GRK4A
Ros4LStab
```

# Convergence Simulations

The convergence simulation type is useful for deriving order of convergence estimates
from a group of simulations. This object will automatically assemble error vectors
into a more useful manner and provide plotting functionality. Convergence estimates
are also given by pair-wise estimates.

One can automatically have DifferentialEquations.jl perform the error analysis by
passing a `ConvergenceSimulation` a vector of solutions, or using one of the provided
`test_convergence` functions. These will give order of convergence estimates and
provide plotting functionality. This requires that the true solution was provided
in the problem definition.

`ConvergenceSimulation`s can either be created by passing the constructor the
appropriate solution array or by using one of the provided `test_convergence` functions.

## The ConvergenceSimulation Type

A type which holds the data from a convergence simulation.

### Fields

  - `solutions::Array{<:DESolution}`: Holds all the PdeSolutions.

  - `errors`: Dictionary of the error calculations. Can contain:
    
      + `h1Errors`: Vector of the H1 errors.
      + `l2Errors`: Vector of the L2 errors.
      + `maxErrors`: Vector of the nodal maximum errors.
      + `node2Errors`: Vector of the nodal l2 errors.
  - `N`: The number of simulations.
  - `auxdata`: Auxiliary data of the convergence simulation. Entries can include:
    
      + `dts`: The dt's in the simulations.
      + `dxs`: The dx's in the simulations.
      + `μs`: The CFL μ's in the simulations.
      + `νs`: The CFL ν's in the simulations.
  - `𝒪est`: Dictionary of order estimates. Can contain:
    
      + `ConvEst_h1`: The H1 error order of convergence estimate for the convergence simulation.
        Generated via `log2(error[i+1]/error[i])`. Thus only valid if generated by halving/doubling
        the dt/dx. If alternate scaling, modify by dividing of log(base,ConvEst_h1)
      + `ConvEst_l2`: The L2 error order of convergence estimate for the convergence simulation.
        Generated via `log2(error[i+1]/error[i])`. Thus only valid if generated by halving/doubling
        the dt/dx. If alternate scaling, modify by dividing of log(base,ConvEst_l2)
      + `ConvEst_max`: The nodal maximum error order of convergence estimate for the convergence simulation.
        Generated via `log2(error[i+1]/error[i])`. Thus only valid if generated by halving/doubling
        the dt/dx. If alternate scaling, modify by dividing of log(base,ConvEst_max)
      + `ConvEst_node2`: The nodal l2 error order of convergence estimate for the convergence simulation.
        Generated via `log2(error[i+1]/error[i])`. Thus only valid if generated by halving/doubling
        the dt/dx. If alternate scaling, modify by dividing of log(base,ConvEst_node2)
  - `convergence_axis`: The axis along which convergence is calculated. For example, if
    we calculate the dt convergence, convergence_axis is the dts used in the calculation.

## Plot Functions

The plot functionality is provided by a Plots.jl recipe. What is plotted is a
line series for each calculated error along the convergence axis. To plot a
convergence simulation, simply use:

```julia
plot(sim::ConvergenceSimulation)
```

All of the functionality (keyword arguments) provided by Plots.jl are able to
be used in this command. Please see the Plots.jl documentation for more information.

## ODE

`test_convergence(dts::AbstractArray,prob::AbstractODEProblem)`

Tests the order of the time convergence of the given algorithm on the given problem
solved over the given dts. Keyword arguments are passed to the ODE solver.

## SDE

`test_convergence(dts::AbstractArray,prob::AbstractSDEProblem)`

Tests the strong order time convergence of the given algorithm on the given problem
solved over the given dts. Keyword arguments are passed to the ODE solver. Except:

  - `numMonte`: The number of simulations for each dt. Default is 10000.

### Order Estimation

`calc𝒪estimates(error::Vector{Number})``

Computes the pairwise convergence estimate for a convergence test done by
halving/doubling stepsizes via

log2(error[i+1]/error[i])

Returns the mean of the convergence estimates.

# Ecosystem Overview

So you're looking to help out DifferentialEquations.jl? We'd be happy to have
your help. It is recommended you first discuss with some of the developers
[on the Gitter channel](https://gitter.im/JuliaDiffEq/Lobby)
to make sure that you're up-to-date with current developments.

### The Common Interface

The DiffEq ecosystem is built around the common interface. This is the interface
for the solvers:

```julia
__solve(prob, alg; kwargs...)
__init(prob, alg; kwargs...)
```

and the standard methods for dealing with solutions. A higher level `solve` and
`init` is given by DiffEqBase.jl for functional and distributional inputs.
Users build problem
types for solvers to act on, and add-on components which use the solution types
for higher-level analysis like parameter estimation and sensitivity analysis.

One can add components at any of these levels to improve the functionality of
the system as a whole.

### Organizational Setup

JuliaDiffEq is setup in a distributed manner to allow developers to retain authoritative
control and licensing for their own packages/algorithms, yet contribute to the
greater ecosystem. This gives a way for researchers to target a wide audience
of users, but not have to fully contribute to public packages or be restricted in
licensing. At the center of the ecosystem is DiffEqBase which holds
the `Problem`, `Solution`, and `Algorithm` types (the algorithms are defined in
DiffEqBase to be accessible by the `default_algorithm` function. One can opt out
of this). Then there's the component solvers, which includes the `*DiffEq` packages
(OrdinaryDiffEq, StochasticDiffEq, etc.) which implement different methods for
`solve`. Then there are the add-on packages, such as the `DiffEq*` packages (DiffEqParamEstim,
DiffEqDevTools) which add functionality to the `Problem`+`solve` setup. Lastly,
there's DifferentialEquations.jl which is a metapackage which holds all of these
pieces together as one cohesive unit.

If one wants their package to officially join the ecosystem, it will need to be
moved to the JuliaDiffEq organization so that maintenance can occur (but the
core algorithms will only be managed by the package owners themselves). The `Algorithm`
types can then be moved to `DiffEqBase`, and after testing the package will be added to
the list packages exported by DifferentialEquations.jl and the corresponding documentation.

# Adding Algorithms

New algorithms can either be added by extending one of the current solver (or
add-on packages), or by contributing a new package to the organization. If
it's a new problem (a new PDE, a new type of differential equation, a new
subclass of problems for which special methods exist, etc.) then the problem
and solution types should be added to `DiffEqBase` first.

After the problem and solutions are defined, the `__solve` method should be implemented.
It should take in keyword arguments which match the common interface (implement
"as many as possible"). One should note and document the amount of compatibility
with the common interface and Julia-defined types. After that, testing should be
done using `DiffEqDevTools`. Convergence tests and benchmarks should be included
to show the effectiveness of the algorithm and the correctness. Do not worry if
the algorithm is not "effective": the implementation can improve over time and
some algorithms are useful just for the comparison they give!

After some development, one may want to document the algorithm in DiffEqBenchmarks
and DiffEqTutorials.

## Adding new algorithms to OrdinaryDiffEq

This recipe has been used to add the strong stability preserving Runge-Kutta methods
`SSPRK22`, `SSPRK33`, and `SSPRK104` to `OrdinaryDiffEq`. `SSPRK22` will be used
as an example.

  - To create a new solver, two (three) types have to be created.
    The first is the algorithm `SSPRK22` used for dispatch, the other ones are
    the corresponding caches `SSPRK22Cache` (for inplace updates) and
    `SSPRK22ConstantCache`.
  - The algorithm is defined in `algorithms.jl` as
    `struct SSPRK22 <: OrdinaryDiffEqAlgorithm end`.
    Although it does not have the FSAL property, this is set to true since the derivative
    at the start and the end of the interval are used for the Hermite interpolation,
    and so this is FSAL'd so that way only a single extra function evaluation occurs
    over the whole integration. This is done in `alg_utils.jl` via
    `isfsal(alg::SSPRK22) = true`. Additionally, the order is set in the same
    file via `alg_order(alg::SSPRK22) = 2`.
  - The algorithm `SSPRK22` is exported in `OrdinaryDiffEq.jl`.
  - In `caches.jl`, the two cache types `SSPRK22Cache` (for inplace updates) and
    `SSPRK22ConstantCache` are defined, similarly to the other ones.
    Note: `u_cache(c::SSPRK22Cache) = ()` and
    `du_cache(c::SSPRK22Cache) = (c.k,c.du,c.fsalfirst)` return the parts of the
    modifiable cache that are changed if the size of the ODE changes.
  - A new file `perform_step/ssprk_perform_step.jl` has been used for the new
    implementations. For both types of caches, the functions `initialize!`
    and `perform_step!` are defined there.
  - Finally, tests are added. A new file `test/ode/ode_ssprk_tests.jl` is created
    and included in `tests/runtests.jl` via
    `@time @testset "SSPRK Tests" begin include("ode/ode_ssprk_tests.jl") end`.
  - Additionally, regression tests for the dense output are added in
    `test/ode/ode_dense_tests.jl`.

For more details, refer to https://github.com/JuliaDiffEq/OrdinaryDiffEq.jl/pull/40

### Self-Contained Example

```julia
using OrdinaryDiffEq
import OrdinaryDiffEq:
                       OrdinaryDiffEqAlgorithm, OrdinaryDiffEqMutableCache,
                       OrdinaryDiffEqConstantCache,
                       alg_order, alg_cache, initialize!, perform_step!, trivial_limiter!,
                       constvalue,
                       @muladd, @unpack, @cache, @..

struct RK_ALG{StageLimiter, StepLimiter} <: OrdinaryDiffEq.OrdinaryDiffEqAlgorithm
    stage_limiter!::StageLimiter
    step_limiter!::StepLimiter
end
RK_ALG(stage_limiter! = trivial_limiter!) = RK_ALG(stage_limiter!, trivial_limiter!)
export RK_ALG
alg_order(alg::RK_ALG) = 3

@cache struct RK_ALGCache{uType, rateType, StageLimiter, StepLimiter, TabType} <:
              OrdinaryDiffEqMutableCache
    u::uType
    uprev::uType
    k::rateType
    tmp::uType
    u₂::uType
    fsalfirst::rateType
    stage_limiter!::StageLimiter
    step_limiter!::StepLimiter
    tab::TabType
end

struct RK_ALGConstantCache{T, T2} <: OrdinaryDiffEqConstantCache
    α40::T
    α41::T
    α43::T
    α62::T
    α65::T
    β10::T
    β21::T
    β32::T
    β43::T
    β54::T
    β65::T
    c1::T2
    c2::T2
    c3::T2
    c4::T2
    c5::T2
end

function RK_ALGConstantCache(T, T2)
    α40 = T(0.476769811285196)
    α41 = T(0.098511733286064)
    α43 = T(0.424718455428740)
    α62 = T(0.155221702560091)
    α65 = T(0.844778297439909)
    β10 = T(0.284220721334261)
    β21 = T(0.284220721334261)
    β32 = T(0.284220721334261)
    β43 = T(0.120713785765930)
    β54 = T(0.284220721334261)
    β65 = T(0.240103497065900)
    c1 = T2(0.284220721334261)
    c2 = T2(0.568441442668522)
    c3 = T2(0.852662164002783)
    c4 = T2(0.510854218958172)
    c5 = T2(0.795074940292433)

    RK_ALGConstantCache(
        α40, α41, α43, α62, α65, β10, β21, β32, β43, β54, β65, c1, c2, c3, c4, c5)
end

function alg_cache(alg::RK_ALG, u, rate_prototype, uEltypeNoUnits, uBottomEltypeNoUnits,
        tTypeNoUnits, uprev, uprev2, f, t, dt, reltol, p, calck, ::Val{true})
    tmp = similar(u)
    u₂ = similar(u)
    k = zero(rate_prototype)
    fsalfirst = zero(rate_prototype)
    tab = RK_ALGConstantCache(real(uBottomEltypeNoUnits), real(tTypeNoUnits))
    RK_ALGCache(u, uprev, k, tmp, u₂, fsalfirst, alg.stage_limiter!, alg.step_limiter!, tab)
end

function alg_cache(alg::RK_ALG, u, rate_prototype, uEltypeNoUnits, uBottomEltypeNoUnits,
        tTypeNoUnits, uprev, uprev2, f, t, dt, reltol, p, calck, ::Val{false})
    RK_ALGConstantCache(real(uBottomEltypeNoUnits), real(tTypeNoUnits))
end

function initialize!(integrator, cache::RK_ALGConstantCache)
    integrator.fsalfirst = integrator.f(integrator.uprev, integrator.p, integrator.t) # Pre-start fsal
    integrator.destats.nf += 1
    integrator.kshortsize = 1
    integrator.k = typeof(integrator.k)(undef, integrator.kshortsize)

    # Avoid undefined entries if k is an array of arrays
    integrator.fsallast = zero(integrator.fsalfirst)
    integrator.k[1] = integrator.fsalfirst
end

@muladd function perform_step!(integrator, cache::RK_ALGConstantCache, repeat_step = false)
    @unpack t, dt, uprev, u, f, p = integrator
    @unpack α40, α41, α43, α62, α65, β10, β21, β32, β43, β54, β65, c1, c2, c3, c4,
    c5 = cache

    # u1 -> stored as u
    u = uprev + β10 * dt * integrator.fsalfirst
    k = f(u, p, t + c1 * dt)
    # u2
    u₂ = u + β21 * dt * k
    k = f(u₂, p, t + c2 * dt)
    # u3
    tmp = u₂ + β32 * dt * k
    k = f(tmp, p, t + c3 * dt)
    # u4
    tmp = α40 * uprev + α41 * u + α43 * tmp + β43 * dt * k
    k = f(tmp, p, t + c4 * dt)
    # u5
    tmp = tmp + β54 * dt * k
    k = f(tmp, p, t + c5 * dt)
    # u
    u = α62 * u₂ + α65 * tmp + β65 * dt * k

    integrator.fsallast = f(u, p, t + dt) # For interpolation, then FSAL'd
    integrator.destats.nf += 6
    integrator.k[1] = integrator.fsalfirst
    integrator.u = u
end

function initialize!(integrator, cache::RK_ALGCache)
    @unpack k, fsalfirst = cache
    integrator.fsalfirst = fsalfirst
    integrator.fsallast = k
    integrator.kshortsize = 1
    resize!(integrator.k, integrator.kshortsize)
    integrator.k[1] = integrator.fsalfirst
    integrator.f(integrator.fsalfirst, integrator.uprev, integrator.p, integrator.t) # FSAL for interpolation
    integrator.destats.nf += 1
end

@muladd function perform_step!(integrator, cache::RK_ALGCache, repeat_step = false)
    @unpack t, dt, uprev, u, f, p = integrator
    @unpack k, tmp, u₂, fsalfirst, stage_limiter!, step_limiter! = cache
    @unpack α40, α41, α43, α62, α65, β10, β21, β32, β43, β54, β65, c1, c2, c3, c4,
    c5 = cache.tab

    # u1 -> stored as u
    @.. u = uprev + β10 * dt * integrator.fsalfirst
    stage_limiter!(u, f, p, t + c1 * dt)
    f(k, u, p, t + c1 * dt)
    # u2
    @.. u₂ = u + β21 * dt * k
    stage_limiter!(u₂, f, p, t + c2 * dt)
    f(k, u₂, p, t + c2 * dt)
    # u3
    @.. tmp = u₂ + β32 * dt * k
    stage_limiter!(tmp, f, p, t + c3 * dt)
    f(k, tmp, p, t + c3 * dt)
    # u4
    @.. tmp = α40 * uprev + α41 * u + α43 * tmp + β43 * dt * k
    stage_limiter!(tmp, f, p, t + c4 * dt)
    f(k, tmp, p, t + c4 * dt)
    # u5
    @.. tmp = tmp + β54 * dt * k
    stage_limiter!(tmp, f, p, t + c5 * dt)
    f(k, tmp, p, t + c5 * dt)
    # u
    @.. u = α62 * u₂ + α65 * tmp + β65 * dt * k
    stage_limiter!(u, f, p, t + dt)
    step_limiter!(u, f, p, t + dt)
    integrator.destats.nf += 6
    f(k, u, p, t + dt)
end

#oop test
f = ODEFunction((u, p, t) -> 1.01u,
    analytic = (u0, p, t) -> u0 * exp(1.01t))
prob = ODEProblem(f, 1.01, (0.0, 1.0))
sol = solve(prob, RK_ALG(), dt = 0.1)

using Plots
plot(sol)
plot(sol, denseplot = false, plot_analytic = true)

using DiffEqDevTools
dts = (1 / 2) .^ (8:-1:1)
sim = test_convergence(dts, prob, RK_ALG())
sim.𝒪est[:final]
plot(sim)

# Example of a good one!
sim = test_convergence(dts, prob, BS3())
sim.𝒪est[:final]
plot(sim)

#iip test
f = ODEFunction((du, u, p, t) -> (du .= 1.01 .* u),
    analytic = (u0, p, t) -> u0 * exp(1.01t))
prob = ODEProblem(f, [1.01], (0.0, 1.0))
sol = solve(prob, RK_ALG(), dt = 0.1)

plot(sol)
plot(sol, denseplot = false, plot_analytic = true)

dts = (1 / 2) .^ (8:-1:1)
sim = test_convergence(dts, prob, RK_ALG())
sim.𝒪est[:final]
plot(sim)

# Example of a good one!
sim = test_convergence(dts, prob, BS3())
sim.𝒪est[:final]
plot(sim)
```

### Adding new exponential algorithms

The exponential algorithms follow the same recipe as the general algorithms, but there
are automation utilities that make this easier. It is recommended that you refer to one
of the model algorithms for reference:

  - For traditional exponential Runge-Kutta type methods (that come with a corresponding
    Butcher table), refer to `ETDRK2`.
  - For adaptive exponential Rosenbrock type methods, refer to `Exprb32`.
  - For exponential propagation iterative Runge-Kutta methods (EPIRK), refer to `EPIRK5P1`.

The first two classes support two modes of operation: operator caching and Krylov
approximation. The `perform_step!` method in `perform_step/exponential_rk_perform_step.jl`,
as a result, is split into two branches depending on whether `alg.krylov` is true. The
caching branch utilizes precomputed operators, which are calculated by the `expRK_operators`
method in `caches/linear_nonlinear_caches.jl`. Both `expRK_operators` and the `arnoldi`/`phiv`
methods in `perform_step!` comes from the
[ExponentialUtilities](https://github.com/JuliaDiffEq/ExponentialUtilities.jl) package.

The EPIRK methods can only use Krylov approximation, and unlike the previous two they use
the timestepping variant `phiv_timestep`. The timestepping method follows the convention
of Neisen & Wright, and can be toggled to use adaptation by `alg.adaptive_krylov`.

Although the exponential integrators (especially the in-place version) can seem complex, they
share similar structures. The infrastructure for the existing exponential methods utilize the
fact to reduce boilerplate code. In particular, the cache construction code in
`caches/linear_nonlinear_caches.jl` and the `initialize!` method in
`perform_step/exponential_rk_perform_step.jl` can be mostly automated and only `perform_step!`
needs implementing.

Finally, to construct tests for the new exponential algorithm, append the new algorithm to
the corresponding algorithm class in `test/linear_nonlinear_convergence_tests.jl` and
`test/linear_nonlinear_krylov_tests.jl`.

# The DiffEq Internals

The DiffEq solvers, OrdinaryDiffEq, StochasticDiffEq, FiniteElementDiffEq, etc.
all follow a similar scheme which leads to rapid development and high performance.
This portion of the documentation explains how the algorithms are written.

## Developing New Solver Algorithms

The easiest way to get started would be to add new solver algorithms. This is a
pretty simple task as there are tools which put you right into the "hot loop".
For example, take a look at the ODE solver code. The mode `solve(::ODEProblem,::OrdinaryDiffEqAlgorithm)`
is glue code to a bunch of solver algorithms. The algorithms which are coded
in DifferentialEquations.jl can be found in src/integrators.jl. The actual step
is denoted by the `perform_step!(integrator)` function. For example,
take a look at the Midpoint method's implementation:

```julia
@inline function perform_step!(integrator, cache::MidpointConstantCache, f = integrator.f)
    @unpack t, dt, uprev, u, k = integrator
    halfdt = dt / 2
    k = integrator.fsalfirst
    k = f(t + halfdt, uprev + halfdt * k)
    u = uprev + dt * k
    integrator.fsallast = f(u, p, t + dt) # For interpolation, then FSAL'd
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast
    @pack integrator = t, dt, u
end
```

The available items are all unloaded from the `integrator` in the first line.
`fsalfirst` inherits the value of `fsallast` on the last line. The algorithm is
written in this form so that way the derivative of both endpoints is defined, allowing
the vector `integrator.k` to determine a  Hermite interpolation polynomial (in general,
the `k` values for each algorithm form the interpolating polynomial). Other than that,
the algorithm is as basic as it gets for the Midpoint method, making sure to set
`fsallast` at the last line. The results are then packaged back into the integrator
to mutate the state.

Note the name `ConstantCache`. In OrdinaryDiffEq.jl, the `Algorithm` types are used
for holding type information about which solver to choose, and its the "cache" types
which then hold the internal caches and state. `ConstantCache` types are for
non in-place calculations `f(u,p,t)` and `Cache` types (like `MidpointCache`) include
all of the internal arrays. Their constructor is specified in the `cache.jl` file.
The cache (and the first `fsalfirst`) is initialized in the `initialize!` function
next to the cache's `perform_step!` function.

The main inner loop can be summarized by the `solve!` command:

```julia
@inbounds while !isempty(integrator.opts.tstops)
    while integrator.tdir * integrator.t < integrator.tdir * top(integrator.opts.tstops)
        loopheader!(integrator)
        @ode_exit_conditions
        perform_step!(integrator, integrator.cache)
        loopfooter!(integrator)
        if isempty(integrator.opts.tstops)
            break
        end
    end
    handle_tstop!(integrator)
end
postamble!(integrator)
```

The algorithm runs until `tstop` is empty. It hits the `loopheader!` in order to
accept/reject the previous step and choose a new `dt`. This is done at the top
so that way the iterator interface happens "mid-step" instead of "post-step".
In here the algorithm is also chosen for the switching algorithms.

Then the `perform_step!` is called. (The exit conditions throw an error if necessary.)
Afterwards, the `loopfooter!` is used to calculate new timesteps, save, and apply the
callbacks. If a value of `tstops` is hit, the algorithm breaks out of the inner-most
loop to save the value.

Adding algorithms to the other problems is very similar, just in a different package.

## Extras

If the method is a FSAL method then it needs to be set via `isfsal` and `fsalfirst`
should be defined before the loop, with `fsallast` what's pushed up to `fsalfirst`
upon a successful step. See `:DP5` for an example.

If tests fail due to units (i.e. Unitful), don't worry. I would be willing to fix
that up. To do so, you have to make sure you keep separate your `rateType`s and
your `uType`s since the rates from `f` will have units of `u` but divided by
a unit of time. If you simply try to write these into `u`, the units part will
fail (normally you have to multiply by a ``dt``).

If you want to access the value of u at the second-last time point, you can use uprev2 value. But in order to copy uprev value to uprev2 after each timestep, you need to make `alg_extrapolates(alg::Your_Alg) = true` in the alg_utils.jl file.
